unit NEditKomponente;




interface


Uses Sysutils, Windows, Classes, Graphics, math, ExtCtrls, 
      Forms, grids, Controls,  Dialogs, StdCtrls;



Type TETypus = (etString, etInteger, etFloat);



     TGrenzen = Class (TPersistent)
                Private
                  Von_e       : Extended;
                  bis_e       : Extended;
                  Begrenzen_b : Boolean;
                Published
                  Property Begrenzen_b_Prop : Boolean Read  Begrenzen_b
                                                      Write Begrenzen_b;
                  Property Von_e_Prop : Extended Read Von_e Write Von_e;
                  Property Bis_e_Prop : Extended Read bis_e Write Bis_e;
                End;


     TNEdit = Class (TEdit)

              Protected

                Procedure KeyPress(Var Key : Char); Override;
                Procedure Change; Override;
                Procedure DoExit; Override;

                Private

                ETypus  : TETypus;

                Grenzen : TGrenzen;

                Procedure WriteStartwert(e : Extended);

                Procedure WriteETypus(GETypus : TETypus);

              Public

                Function FloatRead_e : Extended;
                Function IntRead_i   : Integer;
                Function StrRead_s   : String;

                Constructor Create(aOwner : TComponent); Override;
                Destructor Destroy; Override;

              Published

                Property ETypusProp : TETypus Read ETypus Write WriteETypus;

                Property Startwert_e_Prop : Extended Read  FloatRead_e
                                                     Write WriteStartwert;

                Property GrenzenProp : TGrenzen Read  Grenzen
                                                Write Grenzen;

              End;



Procedure Register;




implementation



procedure Register;
begin
  RegisterComponents('Wissenschaft', [TNEdit]);
end;



Function TNEdit.FloatRead_e;
Begin
  If Not(ETypus = etString) Then  //Falls auf nummerische Eingabe zu prfen ist
     Begin
       If Not(Text   = '')   And   //Diese Zeichen(kombinationen) werden nicht
          Not(Text   = '-')  And   //ohne Laufzeitfehler in Zahlenwerte konver-
          Not(Text   = ',')  And   //tiert, knnen jedoch als Null inter-
          Not(Text   = '-,') Then  //pretiert werden.
          Result := StrToFloat(Text)
          Else Result := 0;
       With Grenzen Do
            If Begrenzen_b_Prop And (von_e_Prop < bis_e_Prop) Then //Prfen, ob
                Begin      //der Definitionsbereich der Zahlen eingehalten wird
                  If Result > Bis_e_Prop Then Result := Bis_e_Prop;
                  If Result < Von_e_Prop Then Result := Von_e_Prop
                End
     End
End;



Function TNEdit.IntRead_i;
Begin
  Try Result := Round(FloatRead_e);  //berlaufprfung
  Except Result := 0
  End;
  {If Not(ETypus = etString) Then  //Falls auf nummerische Eingabe zu prfen ist
     Begin
       If Not(Text   = '')   And   //Diese Zeichen(kombinationen) werden nicht
          Not(Text   = '-')  And   //ohne Laufzeitfehler in Zahlenwerte konver-
          Not(Text   = ',')  And   //tiert, knnen jedoch als Null inter-
          Not(Text   = '-,') Then  //pretiert werden.
          Begin
            Try Result := Round(StrToInt(Text));
            Except Result := 0
            End
          End
          Else Result := 0;
       With Grenzen Do  //Prfen, ob der Definitionsbereich der Zahlen einge-
            If Begrenzen_b_Prop And (von_e_Prop < bis_e_Prop) Then //halten wird
               Begin
                 If Result > Bis_e_Prop Then Result := Round(Bis_e_Prop);
                 If Result < Von_e_Prop Then Result := Round(Von_e_Prop)
               End
     End
     Else Result := 0  }
End;



Function TNEdit.StrRead_s : String;
Begin
  If Not(ETypus = etString) Then  //Falls auf nummerische Eingabe zu prfen ist
     Begin
       If ETypus = etInteger Then
          Result := IntToStr(IntRead_i)
          Else
          Result := FloatToStr(FloatRead_e)
     End
     Else
     Result := Text
End;



Procedure TNEdit.WriteStartwert(e : Extended);
Begin
  If Not(ETypus = etString) Then
     If ETypus = etFloat Then Text := FloatToStr(e)
        Else
        Begin
          Try Text := IntToStr(Round(e)); //Hier darf es zu keinem Integer-
          Except Text := '0'              //berlauf kommen
          End
        End
End;



Procedure TNEdit.WriteETypus(GETypus : TETypus);
Begin
  If Not(GETypus = etString) Then //Wird auf nummerische Eingabe berprft
     Begin                        //(= nur Integer/Fliekommazahlen sind
       Try StrToFloat(Text);      //erlaubt), so darf kein nicht in Zahlen
       Except Text := '0';        //umwandelbarer Text in der Property "Text"
       End;                       //stehen.
       If GETypus = etInteger Then
          If Not(StrToFloat(Text) = Round(StrToFloat(Text))) Then
             Text := IntToStr(Round(StrToFloat(Text)))
     End;
  ETypus := GETypus
End;



Procedure TNEdit.Change;

Var wert_e   : Extended;

Begin
  If Not(ETypus = etString) And   //Falls auf nummerische Eingabe zu prfen ist
     Not(Text   = '')       And   //Diese Zeichen(kombinationen) werden nicht
     Not(Text   = '-')      And   //ohne Laufzeitfehler in Zahlenwerte konver-
     Not(Text   = ',')      And   //tiert, knnen jedoch als Null inter-
     Not(Text   = '-,')     Then  //pretiert werden.
     Begin
       //Integerberlauf abfangen
       If (ETypus = etInteger) Then
          Try StrToInt(Text);
          Except Text := '0';
          End;
       //Fliekommaberlauf abfangen
       If (ETypus = etFloat) Then
          Try StrToFloat(Text);
          Except Text := '0';
          End;
       //Zu kleine und zu groe Werte werden gem der gesetzen Grenzen abgefan-
       //gen
       If (Grenzen.Begrenzen_b_Prop) Then
          Begin
            wert_e := StrToFloat(Text);
            If (((Wert_e < Grenzen.Von_e) And (Wert_e < 0)) Or
                ((Wert_e > Grenzen.Bis_e) And (Wert_e > 0))   ) And
               (Grenzen.Von_e < Grenzen.Bis_e                 ) Then
               Begin
                If Wert_e < Grenzen.Von_e Then Wert_e := Grenzen.Von_e;
                If Wert_e > Grenzen.Bis_e Then Wert_e := Grenzen.bis_e;
                If ETypus = etInteger Then
                   Text := IntToStr(Round(wert_e))
                   Else
                   Text := FloatToStr(wert_e)
               End
          End
     End;
  Inherited Change
End;



Procedure TNEdit.KeyPress(Var Key : Char);

Var puffer_s : String;
    Komma_b  : Boolean;
    i        : Integer;

Begin
  puffer_s := text;

  If Not(ETypus = etString) Then  //Falls auf gltige Zahleneingabe geprft
                                  //werden soll
     If Key In [Chr(8), '0'..'9', ',', '-'] Then //Nur diese Zeichen sind
        Begin                                    //erlaubt,...

          //Keine Zahl und kein Komma vor dem Vorzeichen (Nur Backspace =
          //Chr(8)
            If Not(Key = Chr(8))   And
               (SelStart = 0)      And
               Not(Puffer_s = '')  And
               (Puffer_s[1] = '-') Then Key := #0;

          //Minuszeichen immer am Anfang
          If (Key = '-') And Not(SelStart = 0) Then Key := #0;

          //Kommabehandlung
          If (Key = ',') Then
             If ETypus = etInteger Then Key := #0 //Kein Komma bei ganzen Zahlen
             Else
             Begin
               //Keine doppelten Kommas
               Komma_b  := False;
               For i := 1 To Length(puffer_s) Do
                   If Puffer_s[i] = ',' Then Komma_b := True;
               If Komma_b Then Key := #0;

               //Kein Komma vor dem Vorzeichen
               If (SelStart = 0)      And
                  Not(Puffer_s = '')  And
                  (Puffer_s[1] = '-') Then Key := #0
             End

        End   //End If Key In [Chr(8), '0'..'9', ',', '-'] Then...
        Else  //...der Rest wird verworfen (keine Buchstaben, etc.).
        Key := #0;

  Inherited KeyPress(Key);  //Vererbung der eigentlichen Eingabebehandlungs-
                            //routinen, nachdem die Eingabe gefiltert worden ist
End;



Procedure TNEdit.DoExit;    //Das Textfeld sollte nach Verlassen des NEdit-
Begin                       //Dialogs (Focuswechsel) bei Prfung auf
  Text := StrRead_s;        //nummerische Eingabe alle Korrekturen anzeigen.
  Inherited DoExit          //(Einige Definitionsbereichkorrekturen knnen
End;                        //nicht direkt bei der Eingabe durchgefhrt werden.)



Constructor TNEdit.Create;
Begin
  Inherited Create(AOwner);
  Grenzen := TGrenzen.Create;
  Grenzen.Begrenzen_b_Prop := False;
  Grenzen.Von_e_Prop       := 0;
  Grenzen.Bis_e_Prop       := 0;
  ETypus := etString
End;



Destructor TNEdit.Destroy;
Begin
  Grenzen.Free;
  Inherited Destroy
End;



end.
