unit NStringGridKomponente;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Math, Clipbrd;

Type s1 = String[1];

     TSperrbereich = Class (TPersistent)

                     Private
                       Aktiviert_b : Boolean;
                       Left_i      : Integer;
                       Right_i     : Integer;
                       Top_i       : Integer;
                       Bottom_i    : Integer;

                     Published
                       Property Aktiviert_b_prop : Boolean Read    Aktiviert_b
                                                           Write   Aktiviert_b
                                                           Stored  True
                                                           Default False;

                       Property Left   : Integer Read    Left_i
                                                 Write   Left_i
                                                 Stored  True
                                                 Default -1;

                       Property Right  : Integer Read    Right_i
                                                 Write   Right_i
                                                 Stored  True
                                                 Default -1;

                       Property Top    : Integer Read    Top_i
                                                 Write   Top_i
                                                 Stored  True
                                                 Default -1;

                       Property Bottom : Integer Read Bottom_i
                                                 Write Bottom_i
                                                 Stored  True
                                                 Default -1;

                     End;


     TNStringGrid = class(TStringGrid)

                    private { Private-Deklarationen }

                    protected { Protected-Deklarationen }

                      Sperrbereich    : TSperrbereich;
                      Trennzeichen_s1 : s1;
                      NKStellen_by    : Byte;
                      Fehlerstatus_b  : Boolean;

                      //Gibt den Fehlerstatus(_b) an die Property Fehler_b_Prop
                      //weiter aus und setzt den Fehlerstatus zurck.
                      Function OutFehlerS_b : Boolean;
                      
                    public    { Public-Deklarationen }

                      Constructor Create(AOwner : TComponent); Override;
                      Destructor  Destroy;                     Override;

                      //Den gesperrten Bereich absichern und die Trenntzeichen-
                      //eingabe verhindern
                      Procedure KeyPress(Var Key : Char);              Override;
                      procedure SetEditText(      ACol, ARow: Longint;
                                            Const Value     : String); Override;

                      //Wird beides zur Verfgung gestellt und gegen
                      //Schutzverletungen gesichert
                      Procedure DeleteRow   (ARow : Longint); Override;
                      Procedure DeleteColumn(ACol : Longint); Override;
                      
                      Procedure NMoveRow(FromIndex,
                                         ToIndex       : Longint);
                      Procedure NMoveColumn(FromIndex,
                                           ToIndex    : Longint);
                      

                      Procedure FloatWrite(col_i, row_i : Integer;
                                           zahl_e       : Extended);
                      Procedure IntWrite  (col_i, row_i : Integer;
                                           zahl_i       : Integer);
                      Procedure StrWrite(col_i, row_i : Integer;
                                         string_s     : String);

                      Function FloatRead_e(col_i, row_i : Integer) : Extended;
                      Function IntRead_i  (col_i, row_i : Integer) : Integer;
                      Function StrRead_s  (col_i, row_i : Integer) : String;

                      Procedure ClearRow(row_i : Integer); //Zeile leeren
                      Procedure ClearAll;
                      Function ZeileAuslesen_s(row_i,
                                               von_i,
                                               bis_i : Integer) : String;

                      //Zeilen durch Zeilentausch sortieren: nimmt Rcksicht
                      //auf fixierte Zeilen, aber nicht auf fixierte Spalten
                      Procedure SortRows(col_i         : Integer;
                                         Aufsteigend_b : Boolean);

                      Procedure InClipboard;

                      Property ExecStatus_b_Prop : Boolean Read OutFehlerS_b;

                    Published { Published-Deklarationen }

                      Property Trennzeichen_s1_Prop : s1 Read  Trennzeichen_s1
                                                         Write Trennzeichen_s1;

                      Property Nachkommastellen_by_Prop:Byte Read   NKStellen_by
                                                             Write  NKStellen_by
                                                             Stored True
                                                             Default 3;

                      Property Sperrbereich_Prop : TSperrbereich
                                                            Read  Sperrbereich
                                                            Write Sperrbereich;

                    End;




procedure Register;





implementation




procedure Register;
begin
  RegisterComponents('Wissenschaft', [TNStringGrid]);
end;



Constructor TNStringGrid.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  Sperrbereich             := TSperrbereich.Create;
  Sperrbereich.Aktiviert_b := False;
  Sperrbereich.Top         := -1;
  Sperrbereich.Bottom      := -1;
  Sperrbereich.Left        := -1;
  Sperrbereich.Right       := -1;
  Trennzeichen_s1          := '';
  Nachkommastellen_by_Prop := 3;
  Fehlerstatus_b           := True
End;



Destructor TNStringGrid.Destroy;
Begin
  Sperrbereich.Free;
  Inherited Destroy
End;



Procedure TNStringGrid.KeyPress(var Key: Char);
Begin
  //Zellen, die im gesperrten Bereich liegen, knnen nicht mit dem Inplace-
  //Editor bearbeitet werden, falls dies gewnscht ist.
  If Sperrbereich.Aktiviert_b_Prop Then
     If ((Col >= Sperrbereich.Left) And (Col <= Sperrbereich.right )) And
        ((Row >= Sperrbereich.top ) And (Row <= Sperrbereich.bottom)) Then
        Key := #0;
  If Key = Trennzeichen_s1 Then Key := #0;
  Inherited KeyPress(Key)
End;



procedure TNStringGrid.SetEditText(ACol, ARow: Longint; const Value: String);

Var puffer_s : String;

Begin
  //Zellen, die im gesperrten Bereich liegen, knnen nicht mit dem Inplace-
  //Editor bearbeitet werden, falls dies gewnscht ist. In diesem Fall geht es
  //um die Del-Taste, die mit KeyPress oder KeyDown nicht abzufangen ist da hier
  //das Ereignis OnKeyDown und OnKeyPress vom Inplace-Editor ausgelst wird.
  If Sperrbereich.Aktiviert_b_Prop                                 And
     ((Col >= Sperrbereich.Left) And (Col <= Sperrbereich.right )) And
     ((Row >= Sperrbereich.top ) And (Row <= Sperrbereich.bottom)) Then
     InPlaceEditor.EditText := Cells[ACol, ARow]
     Else
     If Trennzeichen_s1_Prop = '' Then Inherited SetEditText(ACol, ARow, Value)
        Else    //Hierdurch wird verhindert, dass ein Trennzeichen per Copy/Past
        If Pos(Trennzeichen_s1_Prop, InPlaceEditor.EditText) = 0 Then//hinein-
           Inherited SetEditText(ACol, ARow, Value)                  //gelangt
           Else InPlaceEditor.EditText := Cells[ACol, ARow]
End;



Procedure TNStringGrid.DeleteRow(ARow : Longint);
Begin
  If (ARow < RowCount) And (ARow >= 0) Then //Ansonsten Zugriffsverletzung
     Inherited DeleteRow(ARow)
End;



Procedure TNStringGrid.DeleteColumn(ACol : Longint);
Begin
  If (ACol < ColCount) And (ACol >= 0) Then //Ansonsten Zugriffsverletzung
     Inherited DeleteRow(ACol)
End;



Procedure TNStringGrid.NMoveRow(FromIndex, ToIndex   : Longint);
Begin
  If (FromIndex < RowCount) And (FromIndex >= 0) And  //Ansonsten
     (ToIndex   < RowCount) And   (ToIndex >= 0) Then //Zugriffsverletzung
     Inherited MoveRow(FromIndex, ToIndex);
End;



Procedure TNStringGrid.NMoveColumn(FromIndex, ToIndex    : Longint);
Begin
  If (FromIndex < ColCount) And (FromIndex >= 0) And  //Ansonsten
     (ToIndex   < ColCount) And   (ToIndex >= 0) Then //Zugriffsverletzung
     Inherited MoveRow(FromIndex, ToIndex);
End;



Procedure TNStringGrid.FloatWrite(col_i, row_i : Integer;
                                 zahl_e       : Extended);
Begin
  //Cells[col_i, row_i] := FloatToStrF(zahl_e, ffFixed, 18, 3);
  Try Cells[col_i, row_i] := FloatToStr(Round(zahl_e * Power(10, NKStellen_by))
                                        / Power(10, NKStellen_by));
  Except Fehlerstatus_b := False
         End
End;



Procedure TNStringGrid.IntWrite(col_i, row_i : Integer;
                                zahl_i       : Integer);
Begin
  Cells[col_i, row_i] := IntToStr(zahl_i);
End;



Procedure TNStringGrid.StrWrite(col_i, row_i : Integer;
                                String_s     : String);
Begin
  Cells[col_i, row_i] := string_s;
End;



Function TNStringGrid.StrRead_s(col_i, row_i : Integer) : String;
Begin
  Result := Cells[col_i, row_i];
End;



Function TNStringGrid.FloatRead_e(col_i, row_i : Integer) : Extended;
Begin
  Try Result := StrToFloat(Cells[col_i, row_i]);
  Except Fehlerstatus_b := False;
         End
End;



Function TNStringGrid.IntRead_i(col_i, row_i : Integer) : Integer;
Begin
  Try Result := StrToInt(Cells[col_i, row_i]);
  Except Fehlerstatus_b := False
         End
End;



Function TNStringGrid.OutFehlerS_b : Boolean;
Begin
  Result         := Fehlerstatus_b;
  Fehlerstatus_b := True
End;




Procedure TNStringGrid.ClearRow(row_i : Integer);

Var s, z : Integer;

Begin
  NMoveRow(row_i, Pred(RowCount));
  For s := 0 + FixedCols To Pred(ColCount) Do Cells[s, Pred(RowCount)] := ''
End;



Procedure TNStringGrid.ClearAll;

Var s, z : Integer;

Begin
  For z := 0 + FixedRows To Pred(RowCount) Do
      For s := 0 + FixedCols To Pred(ColCount) Do
          Cells[s, z] := ''
End;



Function TNStringGrid.ZeileAuslesen_s(row_i, von_i, bis_i : Integer) : String;

Var i : Integer;

Begin
  Result := '';
  For i := von_i To Pred(bis_i) Do Result :=   Result
                                             + Cells[i, row_i]
                                             + Trennzeichen_s1;
  Result := Result + Cells[bis_i, row_i]
End;



Procedure TNStringGrid.SortRows(Col_i         : Integer;
                                Aufsteigend_b : Boolean);

Var bis_i, i, j, k : Integer;

Begin //Shell-Sort-Algorithmus
  //Die nicht beweglichen Zeilen nach hinten:
  For i := 0 To Pred(FixedRows) Do MoveRow(i, Pred(RowCount));

  //Shell-Sort-Algorithmus auf die beweglichen Zeilen anwenden:
  bis_i := Pred(RowCount) - FixedRows;
  k     := bis_i SHR 1;  //entspricht Div 2
  While k > 0 Do
        Begin
          For i := 0 To bis_i - k Do
              Begin
                j := i;
                If Aufsteigend_b Then
                   While (j >= 0) And (Cells[1, j] > Cells[1, j + k]) Do
                         Begin
                           MoveRow(j,           j + k);
                           MoveRow(Pred(j + k), j    );
                           If j > k Then Dec(j, k) Else j := 0
                         End
                   Else
                   While (j >= 0) And (Cells[1, j] < Cells[1, j + k]) Do
                         Begin
                           MoveRow(j,           j + k);
                           MoveRow(Pred(j + k), j    );
                           If j > k Then Dec(j, k) Else j := 0
                         End
              End;
          k := k Shr 1; //entspricht Div 2
        End;

  //Nicht bewegliche Zeilen wieder nach vorne
  For i := 0 To Pred(FixedRows) Do MoveRow(Pred(RowCount), 0)
End;



Procedure TNStringGrid.InClipboard;

Var StringGridInhalt_s : String;
    z, s                  : Integer;
    AClipboard            : TClipboard;

begin
  AClipboard := Clipboard;
  StringGridInhalt_s := '';
  For z := 0 To Pred(RowCount) Do
      Begin
        For s := 0 To ColCount - 2 Do
            StringGridInhalt_s :=   StringGridInhalt_s
                                  + StrRead_s(s, z)
                                  + Chr(9);
        StringGridInhalt_s := StringGridInhalt_s + StrRead_s(Pred(ColCount), z);
        StringGridInhalt_s := StringGridInhalt_s + Chr(13)
      End;
  SetLength(StringGridInhalt_s, Pred(Length(StringGridInhalt_s)));
  AClipboard.Clear;
  AClipboard.AsText := StringGridInhalt_s
end;



end.
