unit DateiInfoFormular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, NEditKomponente, CPortCtl, ExtCtrls, Grids,
  NStringGridKomponente, ComCtrls, Menus, EinstellungsFormular;

type
  TSpektrEinstellungen_a_s = Array[1..10]           Of String;
  TLinDat_a_s              = Array[1..MAXLINZAHL_I] Of String;

  TDatInfoForm = class(TForm)
    PageControl: TPageControl;
    LinTabSheet: TTabSheet;
    LinienNStringGrid: TNStringGrid;
    StatSonstTabSheet: TTabSheet;
    OKBitBtn: TBitBtn;
    StatSonstPanel: TPanel;
    ModifikationsNStringGrid: TNStringGrid;
    NormierungNStringGrid: TNStringGrid;
    SpektrometerNStringGrid: TNStringGrid;
    DriftNStringGrid: TNStringGrid;
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    Function ShowModal(AnzBasislinie_i : Integer;
                       AnzAbleitung_i  : Integer;
                       AnzGlaettung3_i : Integer;
                       AnzGlaettung5_i : Integer;
                       AnzGlaettung7_i : Integer;
                       ExtStNormLin_i  : Integer;
                       DriftGlGrad_i   : Integer;
                       SpektrEinst_a_s : TSpektrEinstellungen_a_s;
                       LinDat_a_s      : TLinDat_a_s) : Integer; Overload;
  end;

var
  DatInfoForm: TDatInfoForm;

implementation

{$R *.DFM}


//Dateikopf
{  dateikopf_a_s[1] := 'Spektrograph-Datei';
  dateikopf_a_s[2] := '';
  If chromatogramm_b Then dateikopf_a_s[3] := 'Chromatogramm:'
     Else dateikopf_a_s[3] := 'Spektrum:';
  dateikopf_a_s[4] := '';
  dateikopf_a_s[5] := 'Anzahl der Datenpunkte:';
  dateikopf_a_s[6] := IntToStr(Succ(High(ChromS.zeiten_da_e)));
  dateikopf_a_s[7] := '';
  dateikopf_a_s[8] := 'Betriebsparameter des Spektrometers:';
  dateikopf_a_s[9] := '';
  With EinstForm Do
       Begin
         dateikopf_a_s[10] := 'Datum:;' + DateToStr(Date);
         dateikopf_a_s[11] := 'Uhrzeit:;' + TimeToStr(Time);
         dateikopf_a_s[12] := 'Belichtungszeit:;' + OutEinst_s(paramBlz);
         dateikopf_a_s[13] := 'Anzahl an Messungen:;'
                              + OutEinst_s(paramMesszahl);
         dateikopf_a_s[14] := 'Baudrate der RS232:;' + OutEinst_s(paramB_rs232);
         dateikopf_a_s[15] := 'RS232-Port:;' + OutEinst_s(paramP_rs232);
         dateikopf_a_s[16] := 'Nullabgleich im Spektrum:;' +
                              OutEinst_s(paramNullabgleich);
         dateikopf_a_s[17] :=   'Glttung im Spektrum:;'
                              + OutEinst_s(paramSpektrGlaetten);
         dateikopf_a_s[18] := 'XXXXXXXXXXXXXXXXXXXXXXXXXX';
         dateikopf_a_s[19] := 'XXXXXXXXXXXXXXXXXXXXXXXXXX';
         dateikopf_a_s[20] := 'XXXXXXXXXXXXXXXXXXXXXXXXXX';
       End;
  dateikopf_a_s[21] := '';
  If chromatogramm_b Then
     Begin
       dateikopf_a_s[22] := 'Gemessene Linien:';
       dateikopf_a_s[23] := '';
       With EinstForm Do
            For i := 1 To 60 Do dateikopf_a_s[23 + i] := OutLinDat_s(i);
       dateikopf_a_s[84] := '';
       dateikopf_a_s[85] := 'Zeit in s' + TRENNZEICHEN + ChromS.LinNamen_s
     End
     Else Begin
            dateikopf_a_s[22] := 'Wellenlngekalibration:';
            dateikopf_a_s[23] := '';
            With WellenKalForm Do
                 For i := 1 To 60 Do dateikopf_a_s[23 + i] := IntToStr(i) +
                                                              TRENNZEICHEN +
                                                              KalLinOut_s(i);
            dateikopf_a_s[84] := '';
            dateikopf_a_s[85] :=   'Pixel'
                                 + TRENNZEICHEN
                                 + ChromS.LinNamen_s
                                 + TRENNZEICHEN
                                 + 'Wellenlnge in nm'
          End;}



Function TDatInfoForm.ShowModal(AnzBasislinie_i : Integer;
                                AnzAbleitung_i  : Integer;
                                AnzGlaettung3_i : Integer;
                                AnzGlaettung5_i : Integer;
                                AnzGlaettung7_i : Integer;
                                ExtStNormLin_i  : Integer;
                                DriftGlGrad_i   : Integer;
                                SpektrEinst_a_s : TSpektrEinstellungen_a_s;
                                LinDat_a_s      : TLinDat_a_s) : Integer;

Const TRENNZEICHEN = ';';

Var i, j, s : Integer;

Begin
  With ModifikationsNStringGrid Do
       Begin
         {FixedCols := 1;
         ClearAll;
         FixedCols := 0;   }
         IntWrite(1, 1, AnzBasislinie_i);
         IntWrite(1, 2, AnzGlaettung3_i);
         IntWrite(1, 3, AnzGlaettung5_i);
         IntWrite(1, 4, AnzGlaettung7_i);
         IntWrite(1, 5, AnzAbleitung_i);
         //Row := Pred(RowCount);
       End;
  With NormierungNStringGrid Do
       Begin
         If ExtStNormLin_i = -1 Then
            Begin
              StrWrite(0, 1, 'Nein');
              StrWrite(1, 1, '')
            End
            Else
            Begin
              StrWrite(0, 1, 'Ja');
              IntWrite(1, 1, ExtStNormLin_i);
            End
       End;
  With SpektrometerNStringGrid Do
       Begin
         For i := 1 To 10 Do StrWrite(1, i, SpektrEinst_a_s[i]);
       End;
  With DriftNStringGrid Do
       Begin
         If DriftGlGrad_i = -1 Then
            Begin
              StrWrite(0, 1, 'Nein');
              StrWrite(1, 1, '');
            End
            Else
            Begin
              StrWrite(0, 1, 'Ja');
              IntWrite(1, 1, DriftGlGrad_i);
            End
       End;
  With LinienNStringGrid Do
       Begin
         For i := 1 To MAXLINZAHL_I Do
             Begin
               j := 0;
               s := 0;
               While Not(j = Length(LinDat_a_s[i])) Do
                     Begin
                       Inc(j);
                       If LinDat_a_s[i][j] = TRENNZEICHEN Then
                          Inc(s)
                          Else
                          StrWrite(s, i, StrRead_s(s, i) + LinDat_a_s[i][j]);
                     End
             End
       End;
  Result := ShowModal
End;



procedure TDatInfoForm.FormCreate(Sender: TObject);
begin
  With ModifikationsNStringGrid Do
       Begin
         StrWrite(0, 0, 'Modifikation');
         StrWrite(1, 0, 'Wie oft');
         StrWrite(0, 1, 'Basislinienkorrektur');
         StrWrite(0, 2, 'Glttungen ber 3 Punkte');
         StrWrite(0, 3, 'Glttungen ber 5 Punkte');
         StrWrite(0, 4, 'Glttungen ber 7 Punkte');
         StrWrite(0, 5, 'Ableitungen');
         Row := Pred(RowCount);
       End;
  With NormierungNStringGrid Do
       Begin
         StrWrite(0, 0, 'Wurde Normiert?');
         StrWrite(1, 0,
                 'Linie fr die Normierung des externen Standards (0 = keine)');
         Row := Pred(RowCount);
       End;
  With SpektrometerNStringGrid Do
       Begin
         StrWrite(0,  0, 'Allgemein');
         StrWrite(0,  1, 'Dateityp');
         StrWrite(0,  2, 'Datum der Aufzeichung');
         StrWrite(0,  3, 'Uhrzeit der Aufzeichnung');
         StrWrite(0,  4, 'Anzahl der Datenpunkte');
         StrWrite(0,  5, 'Belichtungszeit');
         StrWrite(0,  6, 'Wiederholmessungen fr einen Datenpunkt');
         StrWrite(0,  7, 'Glttung im Spektrum');
         StrWrite(0,  8, 'Nullabgleich im Spektrum');
         StrWrite(0,  9, 'Baudrate der RS232');
         StrWrite(0, 10, 'RS232-Port');
         
       End;
  With DriftNStringGrid Do
       Begin
         StrWrite(0, 0, 'Driftkorrektur durchgefhrt?');
         StrWrite(1, 0, 'Glttung der Korrekturlinie ber wieviele Punkte?');
         Row := Pred(RowCount);
       End;
  With LinienNStringGrid Do
       Begin
         StrWrite(0,  0, 'Nr');
         StrWrite(1, 0, 'Bezeichung');
         StrWrite(2, 0, 'Von');
         StrWrite(3, 0, 'Bis');
         StrWrite(4, 0, 'Null-von');
         StrWrite(5, 0, 'Null-bis');
       End
end;



end.
