unit DatenKlasse;

interface




Uses sysutils, windows, graphics, math, ExtCtrls, signaleformular,
     Me1400Klasse, Forms, grids, Controls, WellenKalFormular,
     EinstellungsFormular, StringArrayKlasse, AutointegrationsFormular,
     datenbankklasse, SignaleKlasse, CPort, CPortCtl, ComCtrls, Dialogs,
     ImportFormular, NStringGridKomponente, DBEinstellungsFormular,
     LinienAuswahlFormular, ExtStandardKlasse, clipbrd,
     LinienUmbenennenFormular, SkalierungsFormular, DateiInfoFormular;




Const MAX_DPZ      = 60000;  //Maximale Zahl an Mepunkten, die verarbeitet
                             //werden knnen + 1
      SPEC_MAX_DPZ = 8399;   //Anzahl an Datenpunkten eines Spektrums - 1

      TRENNZEICHEN = ';';    //

      HISTORY_SEP  = '|';    //Trennzeichen (Separator) fr die History-Liste

      FARBENANZAHL = 14;

Type

  tfarben = Array[1..14] Of TColor;

  tanzeige = (anzChrom, anzSpekPI, anzSpekNM);//Typisiert den Anzeigemodus:
        //anzChrom  : Chromatogramm darstellen
        //anzSpekDp : Spektrum: Intensitten in Abhngigkeit von der Pixelnummer
        //anzSpekNM : Spektrum: Intensitten in Abhngigkeit von der Wellenlnge

  tauswertestatus = (asOk, asAbbruch, asZuviele, asKeinBereich, asKeineLinie);
                    //Status einer vollautomatischen Signalbestimmung:
                    //asOK -> Erfolg, asAbbruch -> wurde vom Benutzer abge-
                    //brochen, asZuviele -> bereits zu viele Signale, etc.

  Tint   = Array[0..MAX_DPZ] Of Integer;

  TPos   = Record
             x1_i, x2_i : Integer;
             y1_e, y2_e : Extended;
           End;

  TBereich = Record
               von_i, bis_i : Integer
             End;

  tintens_da_e = Array Of Array Of Extended;

  TChromS = Record //Chromatogramm oder Spektrum

              //Zeitachse und Wellenlngenachse:
              Zeiten_da_e         : Array Of Extended;

              //Intensitten bzw. Spektraldichten:
              Intens_da_e         : TIntens_da_e; //...aktuell
              IntenSpiegel_da_e   : TIntens_da_e; //...fr Undo
              IntenOrigin_da_e    : TIntens_da_e; //...fr komplettes Undo

              //Normierung vorgenommen?
              Normierung_b        : Boolean;
              NormierungSpiegel_b : Boolean;

              //Bezeichnung der Linien:
              LinNamen_s          : String;
              LinNamenSpiegel_s   : String;

              //Welche Linien sollen angezeigt werden?
              VisibleLines_a_b    : TChosenLines_a_b;

              //Koordinaten des sichtbaren Bereiches
              sichtbar            : TPos;

              //Koordinaten fr den Ausgangszoombereich:
              NormSicht           : TPos;

              //Signalerfassungsbereich:
              PeakBereich         : tBereich;
              BlankBereich        : tbereich;

              //Dokumentation der Vernderungen am Chromatogramm
              history_s           : String; //...aktuell
              HistorySpiegel_s    : String; //...fr Undo
              OriginHistory_s     : String; //...fr komplettes Undo

            End;

  TDateikopf_a_s = Array[1..89] Of String;

  //TVisibleLines  = Array[0..MAXLINZAHL_I] OF Boolean;

  Tdaten = Class (TObject) // Enthlt die Chromatogramme,
                           //die integriert werden sollen

           Protected { Protected-Deklarationen }

             ChromS        : TChromS;        //Gesamtchromatogramm oder Spektrum

             datenbank     : TDatenbank;

             ExtStandard   : TExtStandard;

             dateikopf_a_s : TDateikopf_a_s;

             signale       : TSignale;

             Procedure initialisieren;

             Procedure speicher_leeren; //Den Heap wieder freigeben

             Procedure dateikopf_erstellen(chromatogramm_b : Boolean);

             Procedure dateikopf_korrigieren;

             Procedure DatenpunktzahlInDateikopf;

             Function speicher_bereitstellen_b(g_lz_i, g_dpz_i : Integer) : Boolean;
                               //Speicher fr Linien auf dem Heap bereitstellen

             Procedure InClipboard(von_i, bis_i : Integer);

             Procedure signalbeschreibung(bezeichnung_s : String;
                                          nummer_i      : Integer;
                                          von_e         : Extended;
                                          bis_e         : Extended;
                                          blankvon_e    : Extended;
                                          blankvon2_e   : Extended;
                                          blankbis_e    : Extended;
                                          blankbis2_e   : Extended);

             Function AutoSignAuswertung
                      (MarkedArea_b : Boolean) : tauswertestatus;

             Procedure aufsummieren(    Offsetkorrektur_b : Boolean;
                                        von_i, bis_i      : Integer;
                                        linie_i           : Integer;
                                    Var summe_e           : Extended);

             Function AusDateikopf_s(was_s : String) : String;
             //Informationen aus dem Dateikopf entnehmen

             Procedure ModifikationsanzahlBestimmen
                                              (Var anz_basislinie_i  : Integer;
                                               Var anz_Ableitung_i   : Integer;
                                               Var anz_glaettung3_i  : Integer;
                                               Var anz_glaettung5_i  : Integer;
                                               Var anz_glaettung7_i  : Integer);

             Function Normiert_b(Var history_s : String;   //Wurde normiert?
                                 Var anfang_i  : Integer) : Boolean;

             Function WurdeDriftEntfernt_b(Var history_s : String;
                                           Var anfang_i  : Integer) : Boolean;
                                           //Driftkorrektur durchgefhrt?

             Function teilstueck_s(Var history_s : String;
                                   Var anfang_i  : Integer) : String;
             //...liest history_s von einem Separator zum anderen


             Function schrittweite_ermitteln(    ChromImageWidth_i  : Integer;
                                                 ChromImageHeigth_i : Integer;
                                             Var schrittweite_x_e,
                                                 schrittweite_y_e   : Extended):
                                             Boolean;
                                           //Ermittelt, wieviele Bildschirm-
                                           //punkte einem Datenpunkt entsprechen

             Procedure BereichSetzen(Var SetzBereich, VBereich    : TBereich;
                                         ChromImageWidth_i        : Integer;
                                         ChromImageHeight_i       : Integer;
                                         FRect                    : TRect;
                                         blank_b                  : Boolean);
                                      //"PeakBereich" oder "BlankBereich" setzen

             Procedure spiegeln;

             Procedure orginaldaten_in_array; //die unbehandelten Messdaten in
                                              //einem separaten Array verstauen

             Procedure x_Achse(ChromImage     : TImage;  //Zeichnet die x-Achse
                               AchsenImage    : TImage;
                               anzeige        : tanzeige;
                               schrittweite_e : Extended);

             Procedure y_Achse(ChromImage     : TImage; //Zeichnet die y-Achse
                               AchsenImage    : TImage;
                               schrittweite_e : Extended);

             Procedure linienbezeichnen(ChromImage  : TImage;
                                        AchsenImage : TImage);

             Procedure LinBezInStringArray(nummer_i    : Integer;
                                           p_lin_nam_s : String);

             Procedure SGGlaettung(    Linie_i, GlPtZahl_i : Integer;
                                   Var Puffer_da_e         : TIntens_da_e);
             //Sawitzky-Golay-Glttung einer Linie; Ergebnis in Puffer_da_i

           Public { Public-Deklarationen }

             Constructor create;

             Destructor destroy; Override;

             Procedure laden(    Dateiname_s     : String;
                             Var chromatogramm_b : Boolean;
                             Var fehler_b        : Boolean;
                             Var import_b        : Boolean);
                       //Ein Chromatogramm oder Spektrum vom Datentrger laden

             Procedure ChromRS232(AchsenImage       : TImage;
                                  ChromImage        : TImage;
                                  ChromPaintBox     : TPaintBox;
                                  StatusBar         : TStatusBar;
                                  ComLed            : TComLed;
                                  belichtungszeit_e : Extended;
                                  zeitsichtbar_e    : Extended;
                                  intsichtbar_i     : Integer);
                                  //Chromatogramm von der RS232 einlesen

             Procedure SpektrumRS232;  //Spektrum von der RS232 einlesen

             Procedure AuswahlInZwischenablage;
             Procedure AllesInZwischenablage;

             Procedure darstellen(ChromImage  : TImage;
                                  AchsenImage : TImage;
                                  anzeige : tanzeige);

             Procedure ZoomIn(ChromImageWidth_i  : Integer;
                              ChromImageHeight_i : Integer;
                              FRect              : TRect);

             Procedure zoom_minus;

             Procedure zoom_norm;

             Procedure zoom_norm_setzen; //Ermittelt aus dem Chromatogramm
                                         //den normalen bersichtszoombereich

             Procedure SkalierungVorwaehlen(Anzeige : TAnzeige);

             Function KoordinatenAusgeben_s(ChromImageWidth_i  : Integer;
                                            ChromImageHeight_i : Integer;
                                            x_i, y_i           : Integer;
                                            Anzeige            : TAnzeige)
                                            : String;

             Procedure peakbereich_setzen(ChromImageWidth_i  : Integer;
                                          ChromImageHeight_i : Integer;
                                          FRect              : TRect);

             Procedure blankbereich_setzen(ChromImageWidth_i  : Integer;
                                           ChromImageHeight_i : Integer;
                                           FRect              : TRect);

             Function peak_bestimmung : tauswertestatus;

             Function autoauswertung : tauswertestatus;

             //Externer Standard

             Function ExtStandardBestimmen_b
                      (    offset_b             : Boolean;
                       Var EStandardNStringGrid : TNStringGrid;
                       Var WannNStringGrid      : TNStringGrid) : Boolean;

             Procedure EStandardResetBezug
                       (Var EStandardNStringGrid : TNStringGrid;
                        Var WannNStringGrid      : TNStringGrid);

             Procedure EStandardLaden(Var EStandardNStringGrid : TNStringGrid;
                                      Var WannNStringGrid      : TNStringGrid);
             Procedure EStandardSpeichern;

             Procedure EStandardBezugAendern
                       (    Linie_i, Auf_i       : Integer;
                        Var EStandardNStringGrid : TNStringGrid;
                        Var WannNStringGrid      : TNStringGrid);

             Function DriftWeg_b : Boolean;


             Function chrom_speichern(dateiname_s     : String;
                                      chromatogramm_b : Boolean) : Boolean;

             Function BasislinienAngleichen(Spiegeln_b : Boolean) : Boolean;

             Procedure ableiten;  //Bildet die erste Ableitung des
                                  //Chromatogrammes

             Function glaetten : Boolean;  //Sawitzky-Golay-Glttung

             Function normieren_b : Boolean;
             //Normierung des Chromatogrammes auf einen ext. Standard

             Procedure undo;

             Procedure orginaldaten_wiederherstellen; //alles rckgngig

             Function SignaleBearbeiten_b : Boolean;

             Procedure SignaleAusblenden;

             Function SignalZahl_i : Integer;

             Function LinienLoeschen_b : Boolean;

             Procedure Info;

             Procedure DBEinstAendern;

             Procedure DBSimulation(Var ZuBestAufbSignal    : TAufbSignal;
                                    Var TetraederAufbSignal : TAufbSignal;
                                    Var Linien_a_s          : TLinien_a_s;
                                        SubstDatName_s      : String;
                                    Var VerwSignSubstanz    : TSubstanz;
                                        VerwSign_b          : Boolean;
                                        Statistik_b         : Boolean;
                                        VReduktion_b        : Boolean);

             Procedure DBOutSubstanzvergleich(SubstDatName1_s : String;
                                              SubstDatName2_s : String;
                                              Robust_b        : Boolean);
             Procedure DBOutSubstanzen(welches_i       : Integer;
                                       SubstDatName_s  : String;
                                       Schwellenwert_e : Extended);

           End;

Const farben : tfarben = (clBlue,   clFuchsia, clGreen,  clRed,
                          clYellow, clNavy,    clMaroon, clPurple,
                          clLime,   clAqua,    clGray,   clTeal,
                          clOlive,  clBlack);

//Var daten    : TDaten;



implementation




Var Odatenbank : TDatenbank; //Hier ist die Datenbank vor willkrlichen
                             //Vernderungen in anderen Modulen geschtzt.
                             //Sie gehrt nicht direkt in die DatenKlasse, da
                             //von ihr nur eine Instanz erzeugt werden sollte.

    OExtStandard : TExtStandard;  //Das Modul fr den externen Standard wird
                                  //ebenfalls vor direktem Zugriff geschtzt.



Procedure tdaten.initialisieren;

Var i : Integer;

Begin
  With ChromS Do
       Begin
         With sichtbar Do
              Begin
                x1_i := 0;
                x2_i := -1;
                y1_e := 0;
                y2_e := -1
              End;
         With PeakBereich Do
              Begin
                von_i := -1;
                bis_i := -1
              End;
         With BlankBereich Do
              Begin
                von_i := -1;
                bis_i := -1
              End;
         For i := 0 To Pred(MAXLINZAHL) Do VisibleLines_a_b[i] := True;
         NormSicht  := sichtbar;
         LinNamen_s := '';
         history_s  :=   HISTORY_SEP + DateToStr(Date) + HISTORY_SEP
                       + TimeToStr(Time) + HISTORY_SEP;

         Normierung_b        := False;
         NormierungSpiegel_b := False;
       End;
  signale.Initialisieren;
End;



Constructor tdaten.create;
Begin
  //Die String-Arrays fr die chromatographschen Signale werden erzeugt
  Signale := TSignale.Create(700);

  //Falls die Datenbank noch nicht existiert, wird erzeugt.
  If Odatenbank = Nil Then Odatenbank := TDatenbank.Create;
  //Um mit der Datenbank zu interagieren, bentigt das Datenobjekt einen
  //Zeiger darauf.
  Datenbank := Odatenbank;

  //Analoges Vorgehen beim Modul fr die Verwendung des externen Standards:
  If OExtStandard = Nil Then OExtStandard := TExtStandard.Create;
  ExtStandard := OExtStandard;

  initialisieren
End;



Destructor tdaten.Destroy;
Begin
  Signale.Free;
  speicher_leeren;
  Inherited Destroy
End;



Procedure tdaten.spiegeln;

Var i, j : Integer;

Begin
  With ChromS Do
       Begin
         For i := 0 To High(Intens_da_e) Do
             For j := 0 To High(Intens_da_e[i]) Do
                IntenSpiegel_da_e[i, j] := Intens_da_e[i, j];
         HistorySpiegel_s    := history_s;
         //OriginHistory_s     := history_s;
         NormierungSpiegel_b := Normierung_b;
       End
End;



Procedure tdaten.undo;

Var i, j : Integer;

Begin
  With ChromS Do
       Begin
         For i := 0 To High(Intens_da_e) Do
            For j := 0 To High(Intens_da_e[i]) Do
                Intens_da_e[i, j] := IntenSpiegel_da_e[i, j];
         zoom_norm_setzen;
         history_s    := HistorySpiegel_s;
         Normierung_b := NormierungSpiegel_b;
         sichtbar     := NormSicht
       End
End;



Procedure tdaten.orginaldaten_in_array;

Var i, j : Integer;

Begin
  With ChromS Do
       Begin
         For i := 0 To High(Intens_da_e) Do
             For j := 0 To High(Intens_da_e[i]) Do
                 IntenOrigin_da_e[i, j] := Intens_da_e[i, j];
         OriginHistory_s := history_s
       End
End;



Procedure tdaten.orginaldaten_wiederherstellen;

Var i, j : Integer;

Begin
  spiegeln;
  With ChromS Do
       Begin
         For i := 0 To High(Intens_da_e) Do
             For j := 0 To High(Intens_da_e[i]) Do
                 Intens_da_e[i, j] := IntenOrigin_da_e[i, j];
         zoom_norm_setzen;
         history_s := OriginHistory_s;
         sichtbar  := NormSicht;
         Normierung_b        := False;
         //NormierungSpiegel_b := False;
       End
End;



Function TDaten.AusDateikopf_s(was_s : String) : String; //Informationen aus dem
                                                        //Dateikopf entnehmen
Var i : Integer;

Begin  //AusDateikopf_s
  For i := 10 To 17 Do
      If was_s = Copy(dateikopf_a_s[i], 1, Length(was_s)) Then
         Result := Copy(dateikopf_a_s[i], Length(was_s) + 3,
                        Length(dateikopf_a_s[i]));

  //Zur Erinnerung:
  //dateikopf_a_s[12] := 'Belichtungszeit:;' + OutEinst_s(paramBlz);
  //dateikopf_a_s[13] :=   'Anzahl an Messungen:;'
  //                     + OutEinst_s(paramMesszahl);
  //dateikopf_a_s[14] := 'Baudrate der RS232:;' + OutEinst_s(paramB_rs232);
  //dateikopf_a_s[15] := 'RS232-Port:;' + OutEinst_s(paramP_rs232);
  //dateikopf_a_s[16] := 'Nullabgleich im Spektrum:;' +
  //                     OutEinst_s(paramNullabgleich);
  //dateikopf_a_s[17] :=   'Glttung im Spektrum:;'
  //                     + OutEinst_s(paramSpektrGlaetten);  }
End;



Procedure TDaten.ModifikationsanzahlBestimmen(Var anz_basislinie_i  : Integer;
                                              Var anz_Ableitung_i   : Integer;
                                              Var anz_glaettung3_i  : Integer;
                                              Var anz_glaettung5_i  : Integer;
                                              Var anz_glaettung7_i  : Integer);

Const BASISLINIE = 'Basislinienkorektur';
      ABLEITUNG  = 'Ableitung';
      GLAETTEN3  = 'Gltten(3)';
      GLAETTEN5  = 'Gltten(5)';
      GLAETTEN7  = 'Gltten(7)';

Var i : Integer;

Begin //modifikationszahl_bestimmung
  anz_basislinie_i := 0;
  anz_ableitung_i  := 0;
  anz_glaettung3_i := 0;
  anz_glaettung5_i := 0;
  anz_glaettung7_I := 0;
  For i := 1 To Length(ChromS.history_s) Do
      Begin
        If BASISLINIE = Copy(ChromS.history_s, i, Length(BASISLINIE)) Then
           Inc(anz_basislinie_i);
        If ABLEITUNG = Copy(ChromS.history_s, i, Length(ABLEITUNG)) Then
           Inc(anz_ableitung_i);
        If GLAETTEN3 = Copy(ChromS.history_s, i, Length(GLAETTEN3)) Then
           Inc(anz_glaettung3_i);
        If GLAETTEN5 = Copy(ChromS.history_s, i, Length(GLAETTEN5)) Then
           Inc(anz_glaettung5_i);
        If GLAETTEN7 = Copy(ChromS.history_s, i, Length(GLAETTEN7)) Then
           Inc(anz_glaettung7_i)
      End
End;



Function tdaten.Normiert_b(Var history_s : String;
                           Var anfang_i : Integer) : Boolean;
Begin  //Normiert_b: Wurde normiert?
  While (anfang_i <= Length(history_s))                   AND
        NOT('Normierung' = Copy(history_s, anfang_i, 10)) Do  Inc(anfang_i);
  If anfang_i >= Length(history_s) Then
     Result := False
     Else
     Begin
       Result := True;
       Inc(anfang_i, 11)
     End
End;



Function tdaten.WurdeDriftEntfernt_b(Var history_s : String;
                                     Var anfang_i  : Integer) : Boolean;
Begin
  While (anfang_i <= Length(history_s))                       AND
        NOT('Driftkorrektur' = Copy(history_s, anfang_i, 14)) Do  Inc(anfang_i);
  If anfang_i >= Length(history_s) Then
     Result := False
     Else
     Begin
       Result := True;
       Inc(anfang_i, 15)
     End
End;



Procedure tdaten.aufsummieren(    Offsetkorrektur_b : Boolean;
                                  von_i, bis_i      : Integer;
                                  linie_i           : Integer;
                              Var summe_e           : Extended);

Function OffsetKorregiert_b(    von_i, bis_i      : Integer;
                                linie_i           : Integer;
                                OffsetLinie_i     : Integer;
                                KorrektLinie_i    : Integer;
                            Var summe_e           : Extended) : Boolean;

Var differenz_e : Extended;
    i           : Integer;

Begin //Offsetkorregiert_b
  If (Pred(OffsetLinie_i)  = linie_i                   ) And
     (KorrektLinie_i      <= Length(ChromS.Intens_da_e)) Then
     With EinstForm, ExtStandard, ChromS Do
          Begin
            //Eine Korrektur der offsetbehafteten Linie anhand des externen
            //Standards kann nur dann erfolgen, wenn das Chromatogramm und
            //der externe Standard auf Basis der gleichen Linien und Banden
            //aufgenommen worden sind. An sonsten macht die Anwendung des ex-
            //ternen Standards keinen Sinn.
            If LinNamen_s_prop = LinNamen_s Then
               Begin
                 Try With EStandardStringArray Do
                          Differenz_e :=   FloatRead_e(3, OffsetLinie_i)
                                         - FloatRead_e(3, KorrektLinie_i);
                 Except Differenz_e := 0;
                        End
               End
               Else
               Differenz_e := 0;

            If Normierung_b Then summe_e := 0
               Else
               For i := von_i To bis_i Do
                   summe_e :=   summe_e
                              + Intens_da_e[Pred(KorrektLinie_i), i]
                              + Differenz_e;
            Result := True;
          End
          Else Result := False
End;

Var i : Integer;

Begin //Aufsummieren
  //Prventivmanahme gegen Zugriffsverletzungen
  If von_i < 0                        Then von_i := 0;
  If bis_i > High(ChromS.Zeiten_da_e) Then bis_i := High(ChromS.Zeiten_da_e);

  summe_e        := 0;
  With EinstForm Do
       If Not(OffsetKorrektur_b
              And
              OffsetKorregiert_b(von_i, bis_i, Linie_i,
                                 StrToInt(OutEinst_s(paramOLinie)),
                                 StrToInt(OutEinst_s(paramOKorrektLinie)),
                                 summe_e))                                 Then
          For i := von_i To bis_i Do summe_e :=   summe_e
                                                + ChromS.Intens_da_e[linie_i,i];

  If Succ(bis_i-von_i) > 0 Then summe_e := summe_e / Succ(bis_i-von_i)
                           Else summe_e := 0
End;




Function tDaten.teilstueck_s(Var history_s : String;
                             Var anfang_i  : Integer) : String;
//...liest history_s von einem Separator zum anderen

Var ende_i : Integer;

Begin //teilstueck_s
  ende_i := anfang_i;
  While Not(history_s[ende_i] = HISTORY_SEP) Do Inc(ende_i);
  Result := Copy(history_s, anfang_i, ende_i-anfang_i);
  anfang_i := Succ(ende_i)
End;



Procedure TDaten.signalbeschreibung(bezeichnung_s : String;
                                    nummer_i      : Integer;
                                    von_e         : Extended;
                                    bis_e         : Extended;
                                    blankvon_e    : Extended;
                                    blankvon2_e   : Extended;
                                    blankbis_e    : Extended;
                                    blankbis2_e   : Extended);

Var anz_basislinie_i : Integer;
    anz_Ableitung_i  : Integer;
    anz_glaettung3_i : Integer;
    anz_glaettung5_i : Integer;
    anz_glaettung7_i : Integer;
    anfang_i         : Integer;
    puffer_s         : String;

Begin  //Tdaten.Signalbeschreibung
  With Signale.HistoryStringArray Do
       Begin
         StrWrite(0, nummer_i, bezeichnung_s);

         //Zeitabschnitt des Signals im Chromatogramm, sowie der der
         //Offsetkorektur
         FloatWrite(1, nummer_i, von_e);
         FloatWrite(2, nummer_i, bis_e);
         If blankvon2_e = -1 Then
            Begin
              FloatWrite(3, nummer_i, blankvon_e);
              FloatWrite(4, nummer_i, blankbis_e)
            End
            Else
            Begin
              FloatVonBisWrite(3, nummer_i, blankvon_e, blankvon2_e);
              FloatVonBisWrite(4, nummer_i, blankbis_e, blankbis2_e)
            End;

         //Datum und Urzeit der Signalberechnung und der Chromatogrammerstellung
         anfang_i := 2;
         StrWrite(11, nummer_i, DateToStr(Date));
         StrWrite(12, nummer_i, TimeToStr(Time));
         StrWrite(5,  nummer_i, teilstueck_s(ChromS.history_s, anfang_i));
         StrWrite(6,  nummer_i, teilstueck_s(ChromS.history_s, anfang_i));

         //Spektrometereinstellungen
         With EinstForm Do
            Begin
              StrWrite(7,  nummer_i, AusDateikopf_s('Belichtungszeit'));
              StrWrite(8,  nummer_i, AusDateikopf_s('Anzahl an Messungen'));
              StrWrite(9,  nummer_i, AusDateikopf_s('Glttung im Spektrum'));
              StrWrite(10, nummer_i, AusDateikopf_s('Nullabgleich im Spektrum'))
            End;

         If Normiert_b(ChromS.history_s, anfang_i) Then //Wurde normiert?
            Begin                                  //Wenn ja dann wie und wann?
              puffer_s := teilstueck_s(ChromS.history_s, anfang_i);
               //Wegen der Kompatiblitt zu lteren Dateiversionen!
               //Es muss bercksichigt werden, dass die Angabe einer Linie
               //zur Normierung des ext. Standdards fehlen kann.
              Try StrToInt(puffer_s);
                  StrWrite(13, nummer_i, 'Ja (' + puffer_s + ')');
                  StrWrite(14,nummer_i,teilstueck_s(ChromS.history_s,anfang_i));
              Except StrWrite(13, nummer_i, 'Ja (0)');
                     StrWrite(14, nummer_i, puffer_s);
                     End;

              StrWrite(15, nummer_i, teilstueck_s(ChromS.history_s, anfang_i));
              StrWrite(16, nummer_i, teilstueck_s(ChromS.history_s, anfang_i));
              StrWrite(17, nummer_i, teilstueck_s(ChromS.history_s, anfang_i));
            End
            Else StrWrite(13, nummer_i, 'Nein');

         ModifikationsanzahlBestimmen(anz_basislinie_i,  //In welcher Art und
                                      anz_Ableitung_i,   //wie oft ist das
                                      anz_glaettung3_i,  //Chromatogramm
                                      anz_glaettung5_i,  //sonst noch ver-
                                      anz_glaettung7_i); //ndert worden?
         IntWrite(18, nummer_i, anz_glaettung3_i);
         IntWrite(19, nummer_i, anz_glaettung5_i);
         IntWrite(20, nummer_i, anz_glaettung7_i);
         IntWrite(21, nummer_i, anz_basislinie_i);
         IntWrite(22, nummer_i, anz_ableitung_i);

         StrWrite(23, nummer_i, ChromS.history_s) //Einlesen des Protokoll-
                                                  //Strings
       End
End;



Function tdaten.peak_bestimmung : tauswertestatus;

Procedure Basislinie(     Bvon_i, Bbis_i  : Integer;
                          von_i, bis_i    : Integer;
                          linie_i         : Integer;
                      Var AchsenAbsch_e   : Extended;
                      Var Steigung_e      : Extended);

Var BLLeft_e, BLRight_e : Extended;

Begin //Basislinie
  If (Bvon_i > bis_i) Or (Bbis_i < von_i) Then  //Falls der Bereich fr den
     Begin                          //Nullabgleich nicht das Signal enthlt...
       Aufsummieren(True, Bvon_i, Bbis_i, linie_i, Achsenabsch_e);
       Steigung_e := 0;
     End
     Else
     With EinstForm Do
          Begin
            Aufsummieren(False, Bbis_i - Pred(OutNull2PZahl_i), Bbis_i,
                         linie_i, BlRight_e);
            Aufsummieren(False, Bvon_i, Bvon_i + Pred(OutNull2PZahl_i),
                         linie_i, BlLeft_e);
            If Succ(Bbis_i - Bvon_i - OutNull2PZahl_i) <= 0 Then
               Steigung_e := (BlRight_e - BlLeft_e) / Succ(Bbis_i - Bvon_i)
               Else
               Steigung_e :=   (BlRight_e - BlLeft_e)
                             / Succ(Bbis_i - Bvon_i - OutNull2PZahl_i);
            AchsenAbsch_e :=   BlLeft_e
                             - (Steigung_e * (Bvon_i+OutNull2PZahl_i/2-0.5))
          End;
End;

//  DIE STEIGUNGSBERECHNUNG
//
//      Steigung_e :=   (BlRight_e - BlLeft_e)
//                    / (  (Bbis_i - (OutNull2PZahl_i - 1) / 2
//                       - (Bvon_i + (OutNull2PZahl_i - 1) / 2)
//
//  =>  Steigung_e :=   (BlRight_e - BlLeft_e)
//                    / (Bbis_i - BVon_i - OutNull2PZahl_i +1/2 +1/2)
//
//  =>  Steigung_e :=   (BlRight_e - BlLeft_e)
//                    / Succ(Bbis_i - BVon_i - OutNull2PZahl_i)
//
//  Beispiel: BBis_i = 12; BVon_i = 0; OutNull2PZahl_i = 3
//
//            ...dann muss die Steigung von der Mitte des einen zur Mitte
//               des anderen Nullbereiches berechnet werden, also von 1 nach 11.
//
//            Mitte des Nullbereiches links:  Bvon_i + (OutNull2PZahl_i - 1) / 2
//            Mitte des Nullbereiches rechts: BBis_i - (OutNull2PZahl_i - 1) / 2
//
//            Ergibt: Mitte des Nullbereiches links:  0  + (3-1)/2 =  1
//            Ergibt: Mitte des Nullbereiches rechts: 12 - (3-1)/2 = 11
//
//            Die Differenz dieser beiden Werte betrgt 10.
//   |
// I |
// N |                                        X
// T |
// E |                                  X
// N |
// S |
// I |                                              X
// T |                            X
//  |
// T |
//   |                                                    X
//   |                      X                                   X     X     X
//   X    X     X     X
//   |_________________________________________________________________________
//   0    1     2     3     4     5     6     7     8     9     10    11    12
//                                    Arrayindex

Function FIntegral_e(     von_i, bis_i    : Integer;
                          linie_i         : Integer;
                      Var AchsenAbsch_e   : Extended;
                      Var Steigung_e      : Extended) : Extended;

Var summe_e             : Extended;
    Belichtungszeit_e   : Extended;
    i                   : Integer;

Begin  //FIntegral_e
  Aufsummieren(False, von_i, bis_i, linie_i, summe_e);
  Result := 0;
  For i := von_i To bis_i Do
      Result := Result + Summe_e - (Achsenabsch_e + Steigung_e * i);
  With EinstForm, ChromS Do
       If von_i = bis_i Then
          Result :=   Result
                    * StrToFloat(AusDateikopf_s('Belichtungszeit'))
                    * StrToFloat(AusDateikopf_s('Anzahl an Messungen'))
                    / 1000
          Else
          Result := Result * (Zeiten_da_e[Succ(von_i)] - Zeiten_da_e[von_i]);
End;

Function VonBisKorregiert_i(Linie_i, Index_i, Spanne_i,
                            Von_i, Bis_i                  : Integer;
                            BlAchsenabsch_e, BlSteigung_e : Extended) : Integer;
//Korrektur des Integrationsbereiches

Var Steigung_e, Achsenabschnitt_e : Extended;

Begin  //VonBisKorregiert_e
  With ChromS Do
       Begin
         Steigung_e :=   Intens_da_e[linie_i, Index_i + Spanne_i]
                       - Intens_da_e[linie_i, Index_i - Spanne_i]
                       - BlSteigung_e;
         Steigung_e := Steigung_e / (2 * Spanne_i);
         Achsenabschnitt_e :=   Intens_da_e[linie_i, Index_i + Spanne_i]
                              - BlAchsenAbsch_e +   (Index_i + Spanne_i)
                                                  * BlSteigung_e
                              - Steigung_e * (Index_i + Spanne_i)
                              + Intens_da_e[linie_i, Index_i - Spanne_i]
                              - BlAchsenAbsch_e +   (Index_i - Spanne_i)
                                                  * BlSteigung_e
                              - Steigung_e * (Index_i - Spanne_i);
         Achsenabschnitt_e := Achsenabschnitt_e / 2;
         Try Result := Round(- Achsenabschnitt_e / Steigung_e);
         Except Result := Index_i;
                End;
       End;
  //Verhindert, dass der Integrationsbereich ausgeweitet statt eingeschrnkt
  //wird:
  If Result < Von_i Then Result := Von_i;
  If Result > Bis_i Then Result := Bis_i;
End;

Procedure MaxMinSteigung(    Linie_i, Von_i, Bis_i : Integer;
                             BlSteigung_e          : Extended;
                         Var MaxStg_i, MinStg_i    : Integer;
                         Var maxstg_e, minstg_e    : Extended);

//Die maximale und minimale Steigung des Einzelsignals wird ermittelt

Var i              : Integer;
    PeakSteigung_e : Extended;

Begin //MaxMinSteigung
  maxstg_e := 0;
  minstg_e := 0;
  MaxStg_i := Von_i;
  MinStg_i := Bis_i;
  With ChromS Do
       For i := Succ(von_i) To bis_i Do
           Begin
             peaksteigung_e :=   Intens_da_e[linie_i, i]
                               - Intens_da_e[linie_i, Pred(i)]
                               - BlSteigung_e;
             peaksteigung_e :=   peaksteigung_e
                               / (zeiten_da_e[i] - zeiten_da_e[Pred(i)]);
             If peaksteigung_e < minstg_e Then
                Begin
                  minstg_e := peaksteigung_e;
                  MinStg_i := i
                End;
             If peaksteigung_e > maxstg_e Then
                Begin
                  maxstg_e := peaksteigung_e;
                  MaxStg_i := i
                End
           End;
End;

Procedure peakform(    von_i, bis_i    : Integer;
                       linie_i         : Integer;
                       BlAchsenAbsch_e : Extended;
                       BlSteigung_e    : Extended;
                   Var max_wo_i        : Integer;
                   Var max_e           : Extended;
                   Var hwb_e           : Extended;
                   Var maxstg_e        : Extended;
                   Var minstg_e        : Extended;
                   Var Integral_e      : Extended);

Var i                             : Integer;
    hwb_von_i, hwb_bis_i          : Integer;
    hwb_von_e, hwb_bis_e          : Extended;
    achsenabschnitt_e, steigung_e : Extended;
    MaxStg_i, MinStg_i, GK_i      : Integer;
    Lin_i                         : Integer;

Begin
  With ChromS Do
  Begin
    max_wo_i := von_i;                  //Das Intensittsmaximum wird ermittelt.
    For i := Succ(von_i) To bis_i Do
    If (  Intens_da_e[linie_i, i] - (BlAchsenAbsch_e + i * BlSteigung_e))
       >
       (  Intens_da_e[linie_i, max_wo_i]
        - (BlAchsenAbsch_e + max_wo_i * BlSteigung_e))
       Then max_wo_i := i;
    max_e :=   Intens_da_e[linie_i, max_wo_i]
             - BlAchsenAbsch_e + max_wo_i * BlSteigung_e;

    //Die Punkte, bei dem die Intensitt am ehesten der Hlfte des Maximums
    //entspricht, werden bestimmt. Der Nullabgleich wird hierbei bercksichtigt.

    hwb_von_i := von_i;
    While ((  Intens_da_e[linie_i, hwb_von_i]
            - BlAchsenAbsch_e + hwb_von_i * BlSteigung_e) * 2 < max_e) And
          Not(hwb_von_i = High(Intens_da_e[linie_i])                 ) Do
          Inc(hwb_von_i);
    //If hwb_von_i = von_i Then Inc(hwb_von_i);

    hwb_bis_i := bis_i;
    While ((  Intens_da_e[linie_i, hwb_bis_i]
            - BlAchsenAbsch_e + hwb_bis_i * BlSteigung_e) * 2 < max_e) And
          Not(hwb_bis_i = 0)                                           Do
          Dec(hwb_bis_i);
    //If hwb_bis_i = von_i Then Inc(hwb_bis_i);

    //Interpolation der beiden Zeitpunkte, an denen die Hlfte der Intensitt
    //des Maximums zu finden ist. Die Interpolation erfolgt anhand einer Gerade,
    //die durch die beiden Punkte gezogen wird, bei denen die Intensitt am
    //ehesten der Hlfte des Maximums entspricht.

    Try steigung_e := (  Intens_da_e[linie_i, hwb_von_i]
                       - Intens_da_e[linie_i, Pred(hwb_von_i)]
                       - BlSteigung_e)
                       /
                      (  zeiten_da_e[hwb_von_i]
                       - zeiten_da_e[Pred(hwb_von_i)]);

        achsenabschnitt_e :=   Intens_da_e[linie_i, Pred(hwb_von_i)]
                             - BlAchsenAbsch_e + Pred(hwb_von_i) * BlSteigung_e
                             - steigung_e * zeiten_da_e[Pred(hwb_von_i)];

        hwb_von_e := (max_e / 2 - achsenabschnitt_e) / steigung_e;

        steigung_e := (  Intens_da_e[linie_i, Succ(hwb_bis_i)]
                       - Intens_da_e[linie_i, hwb_bis_i]
                       - BlSteigung_e)
                      /
                      (  zeiten_da_e[Succ(hwb_bis_i)]
                       - zeiten_da_e[hwb_bis_i]);

        achsenabschnitt_e :=   Intens_da_e[linie_i, hwb_bis_i]
                             - BlAchsenAbsch_e + hwb_bis_i * BlSteigung_e
                             - steigung_e * zeiten_da_e[hwb_bis_i];

        hwb_bis_e := (max_e / 2 - achsenabschnitt_e) / steigung_e;

    Except hwb_bis_e := zeiten_da_e[hwb_bis_i];
           hwb_von_e := zeiten_da_e[hwb_von_i];
    End;

    //Die Differenz der beiden Zeiten "hwb_von_e" und "hwb_bis_e" ergib eine gute
    //Nherung der Halbwertsbreite:

    hwb_e := hwb_bis_e - hwb_von_e;

    //Korrektur des Integrationsbereiches, falls erwnscht
    GK_i := StrToInt(EinstForm.OutEinst_s(paramGrenzkorrektur));
    If (GK_i > 0)                 And
       (MaxStg_i - GK_i >= von_i) And
       (MinStg_i + GK_i <= bis_i) Then
       Begin
         If Pred(StrToInt(EinstForm.OutEinst_s(paramOKorrektLinie))) = Linie_i
            Then
            Lin_i := Pred(StrToInt(EinstForm.OutEinst_s(paramAErkLinie)))
            Else
            Lin_i := Linie_i;

         //Die maximale und minimale Steigung des Signals wird ermittelt, oder
         //im Falle des Offsetsignals zunchst die des zur Signalbestimmung
         //herangezogenen Signals
         MaxMinSteigung(Lin_i, Von_i, Bis_i, BlSteigung_e,
                        MaxStg_i, MinStg_i, maxstg_e, minstg_e);

         //Die eigentliche Korrektur der Ingegrationsgrenzen:
         von_i := VonBisKorregiert_i(Lin_i, MaxStg_i, GK_i, von_i, bis_i,
                                     BlAchsenabsch_e, BlSteigung_e);
         bis_i := VonBisKorregiert_i(Lin_i, MinStg_i, GK_i, von_i, Bis_i,
                                     BlAchsenabsch_e, BlSteigung_e);
         If von_i > bis_i Then
            Begin
              i     := von_i;
              von_i := bis_i;
              bis_i := i;
            End;

         //Bestimmung von maximaler und minimaler Steigung des Offsetsignals
         //im korregierten Integrationsbereich:
         If Pred(StrToInt(EinstForm.OutEinst_s(paramOKorrektLinie))) = Linie_i
            Then
            MaxMinSteigung(Linie_i, Von_i, Bis_i, BlSteigung_e,
                           MaxStg_i, MinStg_i, maxstg_e, minstg_e);
       End
       Else
       //Die maximale und minimale Steigung des Signals wird ermittelt
       MaxMinSteigung(Linie_i, Von_i, Bis_i, BlSteigung_e,
                      MaxStg_i, MinStg_i, maxstg_e, minstg_e);

    Integral_e := FIntegral_e(von_i, bis_i, linie_i, BlAchsenAbsch_e, BLSteigung_e);
  End
End;

Procedure GrenzenAnpassen(    linie_i          : Integer;
                          Var Anfang_i, Ende_i : Integer);

//npassung der Grenzen, damit nicht auf nicht vorhandene Elemente des
//dynamischen Intensittenarrays zugegriffen wird.

Begin  //GrenzenAnpassen
  If Anfang_i < 0 Then Anfang_i := 0;
  If Ende_i   > High(ChromS.Intens_da_e[linie_i]) Then
     Ende_i := High(ChromS.Intens_da_e[linie_i]);
End;

Procedure offset(    linie_i         : Integer;
                     BlAchsenabsch_e : Extended;
                     BlSteigung_e    : Extended;
                     von_i           : Integer;
                     MaxWo_i         : Integer;
                 Var min_e           : Extended);

//1. vom Signalanfang "Distanz_i" abwrts nach einem absoluten Minimum suchen
//2. Der Mittelwert vom "Wievielen_i" Punkten um das absolute Minimum herum ist
//   der Offset.

Var MinWo_i      : Integer;
    i            : Integer;
    AbsMin_i     : Integer;
    Anfang_i     : Integer;
    Ende_i       : Integer;
    Wieviele_i   : Integer; //Aus wievielen Datenpunkten soll der Offset
                            //gemittelt werden?
    Distanz_i    : Integer; //ber wieviele Punkte vor dem Signalanfang
                            //soll nach einem absoluten Minimum gesucht werden?

Begin //offset
  //Parameter bestimmen
  Wieviele_i := StrToInt(EinstForm.OutEinst_s(paramOffsetWieviele));
  Distanz_i  := StrToInt(EinstForm.OutEinst_s(paramOffsetDist));

  //Festlegung, wo nach dem Minimum gesucht werden soll
  Ende_i := Pred(MaxWo_i);
  Anfang_i := Von_i - Pred(Distanz_i);
  GrenzenAnpassen(Linie_i, Anfang_i, Ende_i);//...damit nicht auf nicht vorhan-
                                             //dene Elemente des dyn. Inten-
                                             //sittenarrays zugegriffen wird.
  MinWo_i := Anfang_i;

  //Bestimmung des absoluten Minimums in der nchsten Umgebung des Signalanfangs
  With ChromS Do
       For i := Succ(Anfang_i) To Ende_i Do
           If Intens_da_e[linie_i, i] < Intens_da_e[linie_i, MinWo_i] Then
              MinWo_i := i;

  //Elemente zur Mittelung des Offsets bestimmen
  Anfang_i := MinWo_i - Wieviele_i Div 2;
  Ende_i   := MinWo_i + Wieviele_i Div 2;
  If Not(Succ(Ende_i - Anfang_i) = Wieviele_i) Then Dec(Ende_i);
  GrenzenAnpassen(Linie_i, Anfang_i, Ende_i);

  //Mittelwert ber "Wieviele_i" Datenpunkte um das Minimum herum ergibt den
  //Offset
  Min_e := 0;
  For i := Anfang_i To Ende_i Do
      Min_e := Min_e + ChromS.Intens_da_e[linie_i, i];
  Min_e := Min_e / (Wieviele_i) - BlAchsenAbsch_e + MinWo_i * BlSteigung_e
End;

Function DeformFaktor(maxstg_e, minstg_e : Extended) : Extended;
Begin //deform_faktor
  Try Result := Abs(maxstg_e / minstg_e)
  Except Result := 2E9
  End
End;

Function Maximalintensitaet_e(von_i, bis_i, linie_i : Integer) : Extended;
//Maximale Intensitt eines Signals im unbehandelten Chromatogramm

Var i : Integer;

Begin //Maximalintensitaet_i
  Result := ChromS.IntenOrigin_da_e[linie_i, von_i];
  For i := Succ(von_i) To bis_i Do
      If ChromS.IntenOrigin_da_e[linie_i, i] > Result Then
         Result := ChromS.IntenOrigin_da_e[linie_i, i]
End;

Var bereich_e          : Extended;
    BlAchsenabsch_e    : Extended;
    BlSteigung_e       : Extended;
    MaxWo_i            : Integer;
    max_e              : Extended;
    maxstg_e, minstg_e : Extended;
    hwb_e              : Extended;
    min_e              : Extended; //Minimale Intensitt vor dem Sign.
    j                  : Integer;
    integral_e         : Extended;
    peakzahl_i         : Integer;  //Index des aktuell einzulesenden Signals
    name_s             : String;

    VonONZ_i, BisONZ_i : Integer; //ONZ = Anspielung auf OutNull2PZahl_i
   //Von_i und Bis_i minus bzw. plus eine vorgegebene Anzahl OutNull2PZahl_i von
   //Punkten, die die Intensitt kurz vor und nach dem Signal beschreiben.
   //Durch die beiden Punkte wird eine Gerade gelegt und diese vom eigentlichen
   //Signal abgezogen. Dieses Verfahren kommt dann zum Tragen, wenn der
   //vorgewhlte Nullbereich vor dem Signal beginnt und nach dem Signal endet.

Begin  //sign_auswertung
  If (ChromS.PeakBereich.von_i = -1) Or (ChromS.BlankBereich.von_i = - 1) Then
     Result := asKeinBereich
     Else
     If Signale.IntegrStringArray.voll_b(1) Then Result := asZuviele
        Else
        Begin
          Result := asOk;
          With Signale.HistoryStringArray Do
               peakzahl_i := Succ(ZeilenFuellstatus_i(1));

          name_s := 'Signal ' + IntToStr(peakzahl_i);

          With ChromS.BlankBereich, ChromS, EinstForm Do
               If (von_i > PeakBereich.bis_i) Or
                  (bis_i < PeakBereich.von_i) Then
                  signalbeschreibung(name_s,
                                     peakzahl_i,
                                     zeiten_da_e[PeakBereich.von_i],
                                     zeiten_da_e[PeakBereich.bis_i],
                                     zeiten_da_e[von_i],
                                     -1.0,
                                     zeiten_da_e[bis_i],
                                     -1.0)
                  Else
                  Begin
                    //...damit nicht auf nicht vorhandene Arrayelemente
                    //zurckgegriffen wird...
                    VonONZ_i := von_i+Pred(OutNull2pZahl_i);
                    If VonONZ_i > High(zeiten_da_e) Then
                       VonONZ_i := High(zeiten_da_e);
                    BisONZ_i := bis_i - Pred(OutNull2pZahl_i);
                    If BisONZ_i < 0 Then BisONZ_i := 0;
                    signalbeschreibung(name_s,  //Mglicher Fehler
                                       peakzahl_i,
                                       zeiten_da_e[PeakBereich.von_i],
                                       zeiten_da_e[PeakBereich.bis_i],
                                       zeiten_da_e[von_i],
                                       zeiten_da_e[VonONZ_i],
                                       zeiten_da_e[BisONZ_i],
                                       zeiten_da_e[bis_i]);
                  End;
          With signale Do
               Begin
                 IntegrStringArray. StrWrite(0, peakzahl_i, name_s);
                 MaxIntStringArray. StrWrite(0, peakzahl_i, name_s);
                 RetZeitStringArray.StrWrite(0, peakzahl_i, name_s);
                 HWBStringArray.    StrWrite(0, peakzahl_i, name_s);
                 MaxStgStringArray. StrWrite(0, peakzahl_i, name_s);
                 MinStgStringArray. StrWrite(0, peakzahl_i, name_s);
                 DeformStringArray. StrWrite(0, peakzahl_i, name_s);
                 OffsetStringArray. StrWrite(0, peakzahl_i, name_s);
                 IdentStringArray.  StrWrite(0, peakzahl_i, name_s)
               End;
          For j := 0 To High(ChromS.Intens_da_e) Do
              Begin
                With ChromS Do
                     Basislinie(BlankBereich.von_i,
                                BlankBereich.bis_i,
                                PeakBereich.von_i,
                                Peakbereich.bis_i,
                                j,
                                BlAchsenAbsch_e,
                                BlSteigung_e);

                With ChromS.PeakBereich Do
                     Begin
                       peakform(Von_i, Bis_i, j, BlAchsenabsch_e,
                                BlSteigung_e,MaxWo_i, max_e, hwb_e, maxstg_e,
                                minstg_e, Integral_e);
                       Offset(j, BlAchsenabsch_e, BlSteigung_e,
                              Von_i, MaxWo_i, Min_e);
                     End;

                With Signale, ChromS Do
                     Begin
                       IntegrStringArray. FloatWrite(Succ(j), peakzahl_i,
                                                     integral_e);
                       RetZeitStringArray.FloatWrite(Succ(j), peakzahl_i,
                                                     zeiten_da_e[MaxWo_i]);
                       MaxIntStringArray. FloatWrite(Succ(j), peakzahl_i,
                                                     max_e);
                       HWBStringArray.    FloatWrite(Succ(j), peakzahl_i,
                                                     hwb_e);
                       MaxStgStringArray. FloatWrite(Succ(j), peakzahl_i,
                                                     maxstg_e);
                       MinStgStringArray. FloatWrite(Succ(j), peakzahl_i,
                                                     minstg_e);
                       DeformStringArray. FloatWrite(Succ(j), peakzahl_i,
                                          DeformFaktor(maxstg_e, minstg_e));
                       OffsetStringArray. FloatWrite(Succ(j), peakzahl_i,
                                                     min_e);

                     End
              End;
          //Falls ein Spektrum aufgenommen worden ist...
          With Signale.RetZeitStringArray Do
               If (StrRead_s(2, 0)          = 'Wellenlnge in nm') And
                  (StrRead_s(2, peakzahl_i) = ''                 ) Then
                  FloatWrite(2,peakzahl_i,WellenKalForm.WaveLOut_e(MaxWo_i))
        End
End;



Function tdaten.AutoSignAuswertung(MarkedArea_b : Boolean) : tauswertestatus;

Var i, j               : Integer;
    signal_b           : Boolean;
    integrieren_b      : Boolean;
    signalanfang_i     : Integer;
    blank_e            : Extended;
    blank_a_e          : Array[0..60] Of Extended;
    RZVon_i, RZBis_i   : Integer; //Bereich der Retentionszeit, in dem gesucht
                                  //werden soll
    lu_von_i, lu_bis_i : Integer; //Linien zu untersuchen von / bis
    PeakStartlevel_e   : Extended;//Intensitt, ab der bei der Autonintegration
                                  //das Signal erkannt wird
    AutointWahl_i      : Integer; //Welche Linie(n) wird/werde
                                  //zur Autointegration herangezogen

Begin
  PeakStartLevel_e := StrToFloat(EinstForm.OutEinst_s(paramAErkMinHoehe));
  If EinstForm.OutEinst_s(paramAErkMehrere) = 'Ja'
     Then AutoIntWahl_i := -1
     Else AutoIntWahl_i := Pred(StrToInt(EinstForm.OutEinst_s(paramAErkLinie)));
  If AutoIntWahl_i > High(ChromS.Intens_da_e) Then
     AutoIntWahl_i := High(ChromS.Intens_da_e);

  If (ChromS.BlankBereich.von_i = - 1) Then
     Result := asKeinBereich
     Else
     Begin
       Result        := asOk;
       signal_b      := False;
       integrieren_b := False;

       If AutointWahl_i = -1 Then //alle Linien werden auf Signale untersucht
          Begin
            lu_von_i := 0;
            lu_bis_i := High(ChromS.Intens_da_e)
          End
          Else Begin              //nur eine Linie wird auf Signale untersucht
                 lu_von_i := AutointWahl_i;
                 lu_bis_i := AutointWahl_i
                End;

       For i := lu_von_i To lu_bis_i Do //Basislinienkorrektur...
           With ChromS.BlankBereich Do  //es soll ja ein Intensittsanstieg und
                                        //nicht die Intensitt berwacht werden.
                aufsummieren(True, von_i, bis_i, i, blank_a_e[i]);

       If MarkedArea_b Then
          Begin
            RZVon_i := ChromS.PeakBereich.Von_i;
            RZBis_i := ChromS.PeakBereich.Bis_i
          End
          Else
          Begin
            RZVon_i := 0;
            RZBis_i := High(ChromS.Intens_da_e[0])
          End;

       For i := RZVon_i To RZBis_i Do
           Begin
             If Not(signal_b) Then    //Integrationsstartpunkt = Anfang des
                For j := lu_von_i To lu_bis_i Do //Signals bestimmen
                    If (ChromS.Intens_da_e[j, i] - blank_a_e[j])
                         >= peakstartlevel_e Then  //Falls es zu einen
                         Begin                     //Intensittsanstieg bis
                           signal_b       := True; //oder ber
                           signalanfang_i := i     //peak_start_level_i kommt...
                         End; //signal_b = True sagt, dass ein Signal gefunden
                              //wurde und dessen Ende nun gesucht wird.

             If signal_b Then //Integrationsendpunkt = Ende des Signals
                Begin         //bestimmen
                  integrieren_b := True;  //zunchst wird vom Erreichen des
                  For j := lu_von_i To lu_bis_i Do  //Peakendes ausgegangen
                      If (ChromS.Intens_da_e[j, i] - blank_a_e[j])
                         >= peakstartlevel_e Then   //falls eine Linie doch noch
                         integrieren_b := False     //ber peak_start_level_i
                End;                                //liegt...

             If integrieren_b Then //...ansonsten wird integriert
                Begin
                  With ChromS.PeakBereich Do
                       Begin
                         von_i := signalanfang_i;
                         bis_i := Pred(i);
                         If (bis_i - von_i) > 2 Then
                            If Signale.IntegrStringArray.voll_b(1) Then
                               Result := asZuviele
                               Else peak_bestimmung
                       End;
                  integrieren_b := False;
                  signal_b      := False
                End
           End
     End
End;



Function tdaten.autoauswertung : tauswertestatus;

Var ModalResult  : tModalResult;
    MarkedArea_b : Boolean;

Begin
  ModalResult := Autointegrationsform.ShowModal(MarkedArea_b);
  If (ModalResult = mrOk) Or (ModalResult = mrAll) Then
     Result := AutoSignAuswertung(MarkedArea_b)
     Else Result := asAbbruch
End;



Function tdaten.extstandardbestimmen_b
                (    offset_b             : Boolean;
                 Var EStandardNStringGrid : TNStringGrid;
                 Var WannNStringGrid      : TNStringGrid) : Boolean;

Function bestimmen(    von_i, bis_i             : Integer;
                       spalte_i                 : Integer) : Boolean;


Var summe_e : Extended;
    i       : Integer;

Begin //bestimmen
  If von_i = -1 Then Result := False
     Else
     With ExtStandard.EStandardStringArray, ChromS Do
          Begin
            For i := 0 To High(Intens_da_e) Do
                Begin
                  aufsummieren(False, von_i, bis_i, i, summe_e);
                  FloatWrite(spalte_i, Succ(i), Round(summe_e * 1000) / 1000)
                End;
            For i := High(Intens_da_e) + 2 To 60 Do
                StrWrite(spalte_i, i, '');
            Result := True
          End;
End;

Begin
  If offset_b Then
     With ChromS.BlankBereich Do
          Result := bestimmen(von_i, bis_i, 3)
     Else With ChromS.PeakBereich Do
               Result := bestimmen(von_i, bis_i, 2);
  If Result Then
     With ExtStandard Do
          Begin
            SetDateTime(AusDateikopf_s('Datum'),
                        AusDateikopf_s('Uhrzeit'),
                        Offset_b);
            LinNamenSetzen(ChromS.LinNamen_s, Offset_b);
            Differenz;
            OutDaten(EStandardNStringGrid, WannNStringGrid)
          End
          Else
          With Application Do
              If Offset_b Then
                 MessageBox('Bereich zur Offsetbestimmung nicht gesetzt!',
                            'Fehlermeldung', Mb_Ok)
                 Else
                 MessageBox('Bereich zur Intensitstsbestimmung nicht gesetzt!',
                            'Fehlermeldung', Mb_Ok)
End;



Function tdaten.schrittweite_ermitteln(ChromImageWidth_i     : Integer;
                                       ChromImageHeigth_i    : Integer;
                                        Var schrittweite_x_e,
                                            schrittweite_y_e : Extended)
                                       : Boolean;

Var fehler_b : Boolean;

Begin
  fehler_b := False;
  Try schrittweite_x_e :=   ChromImageWidth_i
                          / (ChromS.sichtbar.x2_i  - ChromS.sichtbar.x1_i);
  Except On EZeroDivide Do
    fehler_b := True;
  End;

  If Not(fehler_b) Then
     Try schrittweite_y_e :=   (ChromImageHeigth_i)
                             / (ChromS.sichtbar.y2_e - ChromS.sichtbar.y1_e);
     Except On EZeroDivide Do
       fehler_b := True;
     End;
  If fehler_b Then
     Begin
       schrittweite_x_e := 0;
       schrittweite_y_e := 0
     End;
  schrittweite_ermitteln := Not(fehler_b)
End;



Procedure tdaten.BereichSetzen(Var SetzBereich, VBereich    : TBereich;
                                   ChromImageWidth_i        : Integer;
                                   ChromImageHeight_i       : Integer;
                                   FRect                    : TRect;
                                   blank_b                  : Boolean);

Var schrittweite_x_e : Extended;
    schrittweite_y_e : Extended;
    bereich          : TBereich;

Begin
  schrittweite_ermitteln(ChromImageWidth_i,
                         ChromImageHeight_i,
                         schrittweite_x_e,
                         schrittweite_y_e);
  With bereich Do
       Begin
         With ChromS.Sichtbar Do
              Begin
                von_i := x1_i + Round((FRect.Left)  / schrittweite_x_e);
                bis_i := x1_i + Round((FRect.Right) / schrittweite_x_e)
              End;
         If ((bis_i <= VBereich.von_i)                                      Or
             (von_i >= VBereich.bis_i)                                      Or
             (blank_b And (von_i<VBereich.von_i) And (bis_i>VBereich.bis_i))  )
            And
            ((von_i>=ChromS.NormSicht.x1_i) Or (bis_i<=ChromS.NormSicht.x2_i))
            Then
            Begin
              SetzBereich.von_i := von_i;
              SetzBereich.bis_i := bis_i
            End
       End
End;



Procedure tdaten.peakbereich_setzen(ChromImageWidth_i  : Integer;
                                    ChromImageHeight_i : Integer;
                                    FRect              : TRect);
Begin
  With ChromS Do BereichSetzen(PeakBereich,
                               BlankBereich,
                               ChromImageWidth_i,
                               ChromImageHeight_i,
                               FRect,
                               False)
End;



Procedure tdaten.blankbereich_setzen(ChromImageWidth_i  : Integer;
                                     ChromImageHeight_i : Integer;
                                     FRect              : TRect);
Begin
  With ChromS Do BereichSetzen(BlankBereich, PeakBereich,
                               ChromImageWidth_i, ChromImageHeight_i,
                               FRect, True)
End;



Procedure tdaten.zoom_minus;
Begin
  With ChromS, ChromS.sichtbar Do
       Begin
         x1_i := x1_i - (x1_i * 2) Div 10;
         If x1_i < NormSicht.x1_i Then x1_i := NormSicht.x1_i;

         y1_e := y1_e - (y1_e * 2)  /  10;
         If y1_e < NormSicht.y1_e Then y1_e := NormSicht.y1_e;

         x2_i := x2_i + (x2_i * 2) Div 10;
         If x2_i > NormSicht.x2_i Then x2_i := NormSicht.x2_i;

         y2_e := y2_e + (y2_e * 2)  /  10;
         If y2_e > NormSicht.y2_e Then y2_e := NormSicht.y2_e
       End
End;



Procedure tdaten.zoom_norm;
Begin
  ChromS.sichtbar := ChromS.NormSicht;
End;



Procedure tdaten.SkalierungVorwaehlen(Anzeige : TAnzeige);

Var ZeitVon_e, ZeitBis_e : Extended;
    ZeitVon_i, ZeitBis_i : Integer;
    Puffer_e             : Extended;
    Puffer_i             : Integer;

Begin
  If Not(ChromS.Intens_da_e = Nil) Then
     Begin
       If Anzeige = anzSpekNM Then
          Begin
            ZeitVon_e := WellenKalForm.WaveLOut_e(ChromS.Sichtbar.x1_i);
            ZeitBis_e := WellenKalForm.WaveLOut_e(ChromS.Sichtbar.x2_i);
          End
          Else
          Begin
            ZeitVon_e := ChromS.Zeiten_da_e[ChromS.Sichtbar.x1_i];
            ZeitBis_e := ChromS.Zeiten_da_e[ChromS.Sichtbar.x2_i];
          End;
       With ChromS.sichtbar, ChromS Do
            If SkalierungsForm.ShowModal(ZeitVon_e,ZeitBis_e, y1_e,y2_e) = mrOK Then
               Begin
                 //Fr Leute, die "von" von "bis" nicht unterscheiden knnen
                 If y1_e > y2_e Then
                    Begin
                      puffer_e := y1_e;
                      y1_e     := y2_e;
                      y2_e     := puffer_e;
                    End;

                 //Skalierung der X-Achse errechnen:
                 If Anzeige = anzSpekNM Then
                    Begin
                      ZeitVon_i := 0;
                      ZeitBis_i := SPEC_MAX_DPZ;
                      With WellenKalForm Do
                           Begin
                             While (ZeitVon_i             <= SPEC_MAX_DPZ) And
                                   (WaveLOut_e(ZeitVon_i) <  ZeitVon_e)    Do
                                   Inc(ZeitVon_i);
                             While (ZeitBis_i             >= 0)         And
                                   (WaveLOut_e(ZeitBis_i) >  ZeitBis_e) Do
                                   Dec(ZeitBis_i);
                           End
                    End
                    Else
                    Begin
                      ZeitVon_i := 0;
                      ZeitBis_i := High(Zeiten_da_e);
                      While (ZeitVon_i <= High(Zeiten_da_e))     And
                            (Zeiten_da_e[ZeitVon_i] < ZeitVon_e) Do  Inc(ZeitVon_i);
                      While (ZeitBis_i >= 0)                     And
                            (Zeiten_da_e[ZeitBis_i] > ZeitBis_e) Do  Dec(ZeitBis_i);
                    End;

                 //Damit nicht auf nicht vorhandene Daten zurckgegriffen wird:
                 If ZeitVon_i <  ChromS.NormSicht.x1_i Then
                    ZeitVon_i := ChromS.NormSicht.x1_i;
                 If ZeitVon_i >  ChromS.NormSicht.x2_i Then
                    ZeitVon_i := ChromS.NormSicht.x2_i;
                 If ZeitBis_i <  ChromS.NormSicht.x1_i Then
                    ZeitBis_i := ChromS.NormSicht.x1_i;
                 If ZeitBis_i >  ChromS.NormSicht.x2_i Then
                    ZeitBis_i := ChromS.NormSicht.x2_i;
                 If ZeitVon_i > ZeitBis_i Then
                    Begin
                      puffer_i  := ZeitVon_i;
                      ZeitVon_i := ZeitBis_i;
                      ZeitBis_i := puffer_i;
                    End;

                 //Zuweisung der X-Achsenskalierung:
                 x1_i := ZeitVon_i;
                 x2_i := ZeitBis_i
               End;
     End;
End;



Procedure tdaten.ZoomIn(ChromImageWidth_i  : Integer;
                        ChromImageHeight_i : Integer;
                        FRect              : TRect);

Var schrittweite_x_e : Extended;
    schrittweite_y_e : Extended;

Begin
  schrittweite_ermitteln(ChromImageWidth_i, ChromImageHeight_i,
                         schrittweite_x_e, schrittweite_y_e);

  With ChromS.sichtbar, ChromS Do
       Begin
         //Zoom
         x1_i := x1_i + Round((FRect.left)               / schrittweite_x_e);
         x2_i := x1_i + Round((FRect.right - FRect.Left) / schrittweite_x_e);
         y2_e := y2_e -      ((FRect.Top)                / schrittweite_y_e);
         y1_e := y2_e -      ((FRect.Bottom - FRect.Top) / schrittweite_y_e);

         //Werte, die zu Variablenberlufen fhren, werden abgefangen
         If x2_i - x1_i = 0 Then
            If x2_i = NormSicht.x2_i then Dec(x1_i)
                                     Else Inc(x2_i);
         If Abs(y2_e - y1_e) < 0.0000000000002 Then
            If y2_e = NormSicht.y2_e then y1_e := y1_e - 0.0000000000001
                                     Else y2_e := y2_e + 0.0000000000001;
       End
End;



Procedure Tdaten.zoom_norm_setzen;  //Hier wird die Skalierung fr die Normal-
                                    //ansicht erstellt

Var i, j      : Integer;
    Faktor_e  : Integer;
    dummy_e   : Extended;

Procedure normbereich_setzen(Var yk_e : Extended);

Var i       : Integer;
    ykAlt_e : Extended;

Begin
  If Not(yk_e = 0) Then
     Begin
       ykAlt_e := yk_e;
       i := -5;
       Repeat
         yk_e := Power(10, i);
         Inc(i);
       Until yk_e > ykAlt_e;
       yk_e := yk_e / 10;
       i := 2;
       While yk_e * i < ykAlt_e Do Inc(i);
       yk_e := yk_e * i
     End
End;

Begin  //Tdaten.zoom_norm_setzen
  With ChromS.NormSicht, ChromS Do
       Begin
         x1_i := 0;
         y1_e := 0;

         x2_i := High(zeiten_da_e);
         y2_e := -1;

         If Not(zeiten_da_e = Nil) Then
            Begin
              For i := 0 To High(Intens_da_e) Do
                  If VisibleLines_a_b[i] Then
                     Begin
                       dummy_e := Intens_da_e[0, 0];
                       For j := 1 To High(Intens_da_e[0]) Do
                           If dummy_e < Intens_da_e[i, j] Then
                              dummy_e := Intens_da_e[i, j];
                       If dummy_e > y2_e Then y2_e := dummy_e
                     End;
              normbereich_setzen(y2_e);

              For i := 0 To High(Intens_da_e) Do
                  If VisibleLines_a_b[i] Then
                     Begin
                       dummy_e := Intens_da_e[0, 0];

                       For j := 1 To High(Intens_da_e[0]) Do
                           If dummy_e > Intens_da_e[i, j] Then
                              dummy_e := Intens_da_e[i, j];
                       //If dummy_d > y2_i Then y2_i := Round(dummy_d);
                       If dummy_e > 0 Then dummy_e := 0
                          Else dummy_e := Abs(dummy_e);
                       If dummy_e > y1_e Then y1_e := dummy_e
                     End;
              normbereich_setzen(y1_e);
              y1_e := -1 * y1_e
            End
       End
End;



Function Tdaten.KoordinatenAusgeben_s(ChromImageWidth_i  : Integer;
                                      ChromImageHeight_i : Integer;
                                      x_i, y_i           : Integer;
                                      anzeige            : TAnzeige) : String;

Var schrittweite_x_e : Extended;
    schrittweite_y_e : Extended;
    yk_e, faktor_e   : Extended;  //  (anzChrom, anzSpekPI, anzSpekNM)

Begin
  If High(ChromS.Intens_da_e) = -1 Then Result := 'X: -1, Y: -1'
     Else
     Begin
       schrittweite_ermitteln(ChromImageWidth_i, ChromImageHeight_i,
                              schrittweite_x_e, schrittweite_y_e);
       With ChromS.Sichtbar, ChromS Do
            Begin
              Case anzeige Of
                   anzChrom  : Result := 'Zeit: ';
                   anzSpekPI : Result := 'Pixelnummer: ';
                   anzSpekNM : Result := 'Wellenlnge: '
                 End;
              If anzeige = anzSpekNM Then
                 With WellenKalForm Do
                      Result :=   Result
                                + FloatToStr(Round(WaveLOut_e(x1_i +
                                                  Round(x_i / schrittweite_x_e))
                                             * 100) / 100)
                 Else
                 Result :=   Result
                           + FloatToStr(Round(zeiten_da_e[x1_i +
                                                  Round(x_i / schrittweite_x_e)]
                                              * 1000) / 1000);
              Case anzeige Of
                   anzChrom  : Result := Result + 's';
                   anzSpekNM : Result := Result + 'nm'
                 End;
              yk_e := y2_e  - y_i / schrittweite_y_e;
              Faktor_e := 1;
              If Not(yk_e = 0) Then
                 While Not(Abs(yk_e) > 1000) Do
                    Begin
                      yk_e     := yk_e     * 10;
                      Faktor_e := Faktor_e * 10
                    End;
              Result :=   Result
                        + '   I:'
                        + FloatToStr(Round(yk_e) / Faktor_e)
            End
     End
End;



Procedure tdaten.x_Achse(ChromImage     : TImage;
                         AchsenImage    : TImage;
                         anzeige        : tanzeige;
                         schrittweite_e : Extended);

Var zeitintervall_i  : Integer;
    zeitpos_i        : Integer;
    i                : Integer;
    zeit_s           : String;
    achsenbez_s      : String;
    font_dze_i      : Integer; //Standardfont

Begin {tdaten.x_Achse}
  With AchsenImage.Canvas, ChromS Do
    Begin
      font_dze_i := Font.Size;
      Font.size := 6;
      Case anzeige Of
           anzChrom : achsenbez_s := 'Zeit in s';
           anzSpekPI : achsenbez_s := 'Pixel';
           anzSpekNM : achsenbez_s := 'Wellenlnge in nm'
         End;
      Font.Style := [fsBold];
      Font.Color := clBlack;
      TextOut(  ChromImage.left + ChromImage.Width Div 2
              - TextWidth(achsenbez_s) Div 2,
              ChromImage.Top + ChromImage.Height + 18,
              achsenbez_s);
      Font.Style := [];
      Font.Size  := font_dze_i;

      Pen.Color := clBlack;
      zeitintervall_i := (Sichtbar.x2_i - Sichtbar.x1_i) Div 6;
      zeitpos_i := ChromImage.Left;

      For i := 0 To 5 Do
          Begin
            With ChromImage Do
                 Begin
                   MoveTo(zeitpos_i, Top + Height);
                   LineTo(zeitpos_i, Top + Height + 5)
                 End;
            If anzeige = anzSpekNM Then
               zeit_s := FloatToStr(Round(WellenKalForm.
                                          WaveLOut_e(sichtbar.x1_i +
                                                   zeitintervall_i * i) * 1000))
               Else
               zeit_s := FloatToStr(Round(zeiten_da_e[sichtbar.x1_i +
                                                  zeitintervall_i * i] * 1000));
            While Length(zeit_s) < 3 Do zeit_s := '0' + zeit_s;
            TextOut(zeitpos_i - TextWidth(zeit_s) Div 2,
                    ChromImage.Top + ChromImage.Height + 6,
                    Copy(zeit_s, 1, Length(zeit_s) - 3) + ',' +
                    Copy(zeit_s, Length(zeit_s) - 2, 3));
            zeitpos_i := zeitpos_i +
                         Round(zeitintervall_i * schrittweite_e)
          End
    End
End;



Procedure tdaten.y_Achse(ChromImage     : TImage;
                         AchsenImage    : TImage;
                         schrittweite_e : Extended);

Var intensint_e   : Extended; //Intensittsinvervall
    intenspos_i   : Integer;  //Position auf dem Bildschirm in y-Richtung
    intenszahl_e  : Extended;
    Faktor_e      : Extended;
    i             : Integer;
    xk_i          : Integer;
    intensitaet_s : String;

Begin
  With AchsenImage.Canvas, ChromS Do
    Begin
      xk_i := ChromImage.Left Div 4;

      intensint_e  := (sichtbar.y2_e - sichtbar.y1_e) / 5;
      intenszahl_e := sichtbar.y1_e;
      intenspos_i  := Pred(ChromImage.Top + ChromImage.Height);

      For i := 0 To 5 Do
          Begin
            Pen.Color := clBlack;
            MoveTo(ChromImage.Left - 5, intenspos_i);
            LineTo(ChromImage.Left,     intenspos_i);
            Faktor_e := 1;
            If Not(IntensZahl_e = 0) Then
               While (Abs(IntensZahl_e) < 100 ) And
                     (Faktor_e          < 1000) Do
                     Begin
                       IntensZahl_e := IntensZahl_e * 10;
                       Faktor_e     := Faktor_e * 10
                     End;
            intensitaet_s := FloatToStr(Round(intenszahl_e) / Faktor_e);
            IntensZahl_e := IntensZahl_e / Faktor_e;
            TextOut(xk_i, intenspos_i - TextHeight(intensitaet_s) Div 2,
                    intensitaet_s);
            intenspos_i  := intenspos_i - Round(intensint_e * schrittweite_e);
            intenszahl_e := intenszahl_e + intensint_e
          End;
    End
End;



Procedure tdaten.linienbezeichnen(ChromImage  : TImage;
                                  AchsenImage : TImage);

Var i, j : Integer;

Begin
  With AchsenImage.Canvas, ChromS Do
    Begin
      Font.Color := ClBlack;
      With ChromImage Do
           TextOut(Left, Top - 15, 'Linienbezeichnungen: ');

      i          := 1;
      Font.Color := farben[i];
      j          := 0;

      If Not(LinNamen_s = '') Then
      Repeat
        Inc(j);
        If LinNamen_s[j] = ';' Then
           Begin
             TextOut(PenPos.X, PenPos.Y, ', ');
             Inc(i);
             If i = Succ(farbenanzahl) Then i := 1;
             Font.Color := farben[i]
           End
           Else TextOut(PenPos.X, PenPos.Y, LinNamen_s[j]);
      Until (j = Length(LinNamen_s)) Or (PenPos.x > ChromImage.Left +
                                                               ChromImage.Width)
    End
End;



Procedure Tdaten.darstellen(ChromImage  : TImage;
                            AchsenImage : TImage;
                            anzeige     : tanzeige);

Var schrittweite_x_e : Extended;
    schrittweite_y_e : Extended;
    x_e              : Extended;
    x_i, y_i         : Integer;
    v_x_i, v_y_i     : Integer;
    i, j, k          : Integer;

Begin
  With AchsenImage.Canvas, Achsenimage Do //Lschen der Achsen
       Begin
         Pen.Color   := clBtnFace;
         Brush.Color := clBtnFace;
         Rectangle(ClientRect)
       End;

  With ChromImage.Canvas, ChromImage, ChromS Do
    Begin
      Rectangle(ClientRect);

      If Not(High(Intens_da_e) = -1) Then //Chrom. oder Spektr. geladen?
         //Nur wenn ein Chromatogramm/Spektrum geladen ist, sinnvoll...
         schrittweite_ermitteln(Width,Height,schrittweite_x_e,schrittweite_y_e);

      k := 0;

      For j := 0 To High(Intens_da_e) Do
          Begin
            Inc(k);
            If k = Succ(farbenanzahl) Then k := 1;

            If VisibleLines_a_b[j] Then
               Begin
                 //Farbliche Markierung des Signals und des Blankbereiches
                 If (sichtbar.x1_i > PeakBereich.von_i) And
                    (sichtbar.x1_i < PeakBereich.bis_i) Then
                    Pen.Color := ClBlack
                    Else
                    Pen.Color := farben[k];

                 If (sichtbar.x1_i > BlankBereich.von_i) And
                    (sichtbar.x1_i < BlankBereich.bis_i) Then
                    pen.Style := PsDot
                    Else
                    Pen.Style := PsSolid;

                 x_e := 0;
                 y_i :=   Height
                        - Round(schrittweite_y_e
                            * (Intens_da_e[j, sichtbar.x1_i] - sichtbar.y1_e));
                 If y_i < 0       Then y_i := 0;
                 If y_i >= Height Then y_i := Pred(Height);
                 MoveTo(0, y_i);
                 v_x_i := 0;
                 v_y_i := 0;
                 For i := sichtbar.x1_i To sichtbar.x2_i Do
                     Begin
                       x_i := Round(x_e);
                       y_i :=   Height
                              - Round(schrittweite_y_e
                                        * (Intens_da_e[j, i] - sichtbar.y1_e));
                       If y_i < 0        Then y_i := 0;
                       If y_i >=  Height Then y_i := Pred(Height);

                       If i = Succ(PeakBereich.von_i) Then pen.Color:=ClBlack;
                       If i = Succ(PeakBereich.bis_i) Then Pen.Color:=farben[k];
                       If i = PeakBereich.von_i Then
                          If i = PeakBereich.bis_i Then
                             Begin
                               lineto(x_i, y_i);
                               Pen.Color := ClBlack;
                               LineTo(x_i, 0);
                               LineTo(x_i, Pred(Width))
                             End;

                       If i = Succ(BlankBereich.von_i) Then pen.Style:= PsDot;
                       If i = Succ(BlankBereich.bis_i) Then pen.Style:= PsSolid;
                       If i = BlankBereich.von_i Then
                          If i = BlankBereich.bis_i Then
                             Begin
                               lineto(x_i, y_i);
                               Pen.Style := PsDot;
                               LineTo(x_i, 0);
                               LineTo(x_i, Pred(Height))
                             End;

                       If Not(x_i = v_x_i) Then lineto(x_i, y_i);

                       v_y_i := y_i;
                       v_x_i := x_i;
                       x_e   := x_e + schrittweite_x_e
                     End
               End
          End;
      If Not(High(Intens_da_e) = -1) Then
         Begin//Nur sinnvoll,wenn ein Chromatogramm/Spektrum geladen ist...
           x_Achse(ChromImage, AchsenImage, anzeige, schrittweite_x_e);
           y_Achse(ChromImage, AchsenImage, schrittweite_y_e)
         End
         Else Brush.Color := clBtnFace;

      linienbezeichnen(ChromImage, AchsenImage);

      Pen.Color   := clBlack;
      Brush.Color := clWhite;
      Brush.Style := bsClear;
      Rectangle(ClientRect);
      Brush.Style := bsSolid
    End
End;



Procedure Tdaten.speicher_leeren;

Var i : Integer;

Begin
  With ChromS Do
       Begin
         Intens_da_e       := Nil;
         IntenSpiegel_da_e := Nil;
         IntenOrigin_da_e  := Nil;
         zeiten_da_e       := Nil
       End
End;



Function tdaten.speicher_bereitstellen_b(g_lz_i, g_dpz_i : Integer) : Boolean;

//Stellt fr eine gewnschte Linienzahl "g_lz_i"  und fr eine gewnschte
//Datenpunktzahl "g_dpz_i" Speicher auf dem Heap bereit

Var zaehler_i, l, d : Integer;

Begin
  Result    := True;
  zaehler_i := 0;

  Try Setlength(ChromS.Intens_da_e, Succ(g_lz_i), Succ(g_dpz_i));
      SetLength(ChromS.IntenSpiegel_da_e, Succ(g_lz_i), Succ(g_dpz_i));
      SetLength(ChromS.IntenOrigin_da_e,   Succ(g_lz_i), Succ(g_dpz_i));
      SetLength(ChromS.zeiten_da_e, Succ(g_dpz_i));
       {For l := 0 To High(intensitaeten_da_i) Do
           For d := 0 To High(intensitaeten_da_i[l]) Do
               intensitaeten_da_i[l, d] := 0;}
  Except On EOutOfMemory Do
            With ChromS Do
                 Begin
                   Intens_da_e       := Nil;
                   IntenSpiegel_da_e := Nil;
                   IntenOrigin_da_e  := Nil;
                   zeiten_da_e       := Nil;
                   Result             := False
                 End
         End
End;



Procedure TDaten.LinBezInStringArray(nummer_i    : Integer;
                                     p_lin_nam_s : String);
Begin  //Liest die Linienbezeichnungen der Signale in die StringArrays
  With signale Do
       Begin
         IntegrStringArray. StrWrite(Succ(nummer_i), 0, p_lin_nam_s);
         RetZeitStringArray.StrWrite(Succ(nummer_i), 0, p_lin_nam_s);
         MaxIntStringArray. StrWrite(Succ(nummer_i), 0, p_lin_nam_s);
         HWBStringArray.    StrWrite(Succ(nummer_i), 0, p_lin_nam_s);
         MaxStgStringArray. StrWrite(Succ(nummer_i), 0, p_lin_nam_s);
         MinStgStringArray. StrWrite(Succ(nummer_i), 0, p_lin_nam_s);
         DeformStringArray. StrWrite(Succ(nummer_i), 0, p_lin_nam_s);
         OffsetStringArray. StrWrite(Succ(nummer_i), 0, p_lin_nam_s)
       End
End;



Procedure Tdaten.laden(    dateiname_s     : String;
                       Var chromatogramm_b : Boolean;
                       Var fehler_b        : Boolean;
                       Var import_b        : Boolean);

Type str1           = String[1];
     TZahlFormat    = (zfInteger, zfKommazahl, zfKeins);

Var datei_txt                : Text;           //Textdatei

    g_lz_i                   : Integer;        //gewschte Linienzahl: Anzahl
                                               //an Linien, die eingelesen wer-
                                               //den sollen

    g_dpz_i                  : Integer;        //gewschte Datenpunktzahl:
                                               //Anzahl an Datepunkten pro
                                               //Linie, die einzulesen sind
    i                        : Integer;

Function sektion_lesen_b(Var datei_txt : Text;   //Liest aus, bis TRENNZEICHEN
                         Var dummy_s   : String;
                         Var ende_b    : Boolean)//<- True falls EoLn
                         : Boolean;

Var dummy_s1 : str1;

Begin
  Try ende_b   := False;
      dummy_s1 := '';
      dummy_s  := '';

      Repeat
        dummy_s := dummy_s + dummy_s1;
        Read(Datei_txt, dummy_s1);
        If EoLn(datei_txt) Then ende_b := True;
      Until (dummy_s1 = TRENNZEICHEN) Or ende_b;

      If Not(dummy_s1 = trennzeichen) Then dummy_s := dummy_s + dummy_s1;
      Result := True;
  Except Result := False;
         End
End;

Function grenzen_lesen_b(Var datei_txt                : Text;
                         Var int_bezeichnung_s        : String;
                         Var von_e, bis_e,
                             blankvon_e, blankbis_e : Extended) : Boolean;

Var ende_b  : Boolean;
    dummy_s : String;

Begin     //Einlesen der Integrationsgrenzen
  Try ReadLn(datei_txt);
      sektion_lesen_b(datei_txt, int_bezeichnung_s, ende_b);

      sektion_lesen_b(datei_txt, dummy_s, ende_b);
      von_e := StrToFloat(dummy_s);
      sektion_lesen_b(datei_txt, dummy_s, ende_b);
      bis_e := StrToFloat(dummy_s);
      sektion_lesen_b(datei_txt, dummy_s, ende_b);
      blankvon_e := StrToFloat(dummy_s);
      sektion_lesen_b(datei_txt, dummy_s, ende_b);
      blankbis_e := StrToFloat(dummy_s);
      Result := True;
  Except Result := False
         End
End;

Function datei_oeffnen_b(Var datei_txt   : Text;
                             dateiname_s : String) : Boolean;
Begin //datei_oeffnen_b
  Try AssignFile(datei_txt, dateiname_s);
      Reset(datei_txt);
      Result := True;
  Except Result := False
         End
End;

Function datei_identifizieren_b(Var datei_txt : Text) : Boolean;
//berprfung, ob es sich berhaupt um eine Datei im Spektrograph-Format handelt

Var header_s : String;

Begin //datei_identifizieren_b
  Try ReadLn(datei_txt, header_s);
      If header_s = 'Spektrograph-Datei' Then
         Result := True
      Else Result := False
  Except Result := False;
         End
End;

Function parameter_laden_b(Var datei_txt       : Text;
                           Var chromatogramm_b : Boolean;
                           Var g_dpz_i         : Integer) : Boolean;

Var welche_art_s : String;

Begin //parameter_laden_b
  Try ReadLn(datei_txt);
      ReadLn(datei_txt, welche_art_s);
      If welche_art_s = 'Chromatogramm:' Then chromatogramm_b := True
         Else chromatogramm_b := False;
      ReadLn(datei_txt);
      ReadLn(datei_txt);
      ReadLn(datei_txt, g_dpz_i);   //Wieviele Datenpunkte enthlt die Datei?
      Dec(g_dpz_i);
      CloseFile(datei_txt);
      Reset(datei_txt);
      Result := True
  Except Result := False
         End
End;

Function dateikopf_laden_b(Var datei_txt : Text) : Boolean;

Var i : Integer;

Begin //dateikopf_laden_b
  Try For i := 1 To 85 Do ReadLn(datei_txt, dateikopf_a_s[i]);
      CloseFile(datei_txt);
      Reset(datei_txt);
      Result := True;
  Except Result := False
         End
End;

Function linieninfo_laden_b(Var datei_txt       : Text;
                            Var g_lz_i          : Integer;
                                Chromatogramm_b : Boolean;
                                import_b        : Boolean) : Boolean;
//Einlesen der Linienbezeichnungen und Bestimmung der Linienzahl

Var i                : Integer;
    ende_b           : Boolean;
    dummy_s          : String;

Begin //linieninfo_laden_b
  Try If Not(Import_b) Then For i := 1 To 84 Do ReadLn(datei_txt);
      Result := sektion_lesen_b(datei_txt, dummy_s, ende_b);
      g_lz_i := -1;
      ende_b := False;
      While Not(ende_b) Or Not(Result)  Do
            Begin
              Inc(g_lz_i);
              Result := sektion_lesen_b(datei_txt, dummy_s, ende_b);
              LinBezInStringArray(g_lz_i, dummy_s);
              ChromS.LinNamen_s := ChromS.LinNamen_s + dummy_s;
              If Not(ende_b) Then
                 With ChromS Do   LinNamen_s := LinNamen_s + trennzeichen
            End;
      If Not(chromatogramm_b) Then
         Begin
           Dec(g_lz_i);  //Nicht die Wellenlngen einlesen!
           ChromS.LinNamen_s := 'Spektrum'
         End;
      ReadLn(Datei_txt);
  Except Result := False
         End
End;

Function chrom_spektr_laden_b(Var datei_txt    : Text;
                                  intens_da_e : tintens_da_e) : Boolean;

Var i, j             : Integer;
    ende_b           : Boolean;
    dummy_s          : String;

Begin //chrom_spektr_laden_b
  Try Result := True;
      i := -1;
      Repeat
        Inc(i);

        //Einlesen der Zeitachse (x-Achse)
        If Not(sektion_lesen_b(datei_txt,
                               dummy_s,
                               ende_b)) Then Result := False;
        If intens_da_e = ChromS.Intens_da_e Then
           ChromS.zeiten_da_e[i] := StrToFloat(dummy_s);

        j := 0;
        For j := 0 To High(intens_da_e) Do
            Begin                          //Die Intensitten werden eingelesen
              If Not(sektion_lesen_b(datei_txt,
                                     dummy_s,
                                     ende_b)) Then Result := False;
              intens_da_e[j, i] := StrToFloat(dummy_s)
            End;
        ReadLn(datei_txt);
      Until (i = g_dpz_i) Or (i = MAX_DPZ);
  Except Result := False
         End
End;

Function signale_laden_b(Var datei_txt : Text) : Boolean;

Var i, j, peak_anzahl_i      : Integer;
    ende_b                   : Boolean;        //Ende der Zeile?
    dummy_s                  : String;         //Pufferstring

Function signalparameter_laden_b(Var datei_txt   : Text;
                                     ZahlFormat  : TZahlFormat;
                                     StringArray : TStringArray) : Boolean;

Var i, j : Integer;

Begin //signalparameter_laden
  Result := True;
  Try For i := 1 To 4 Do ReadLn(datei_txt);
      For i := 1 To peak_anzahl_i Do  //Parameter = Auswerteergebnisse
          With StringArray Do        //der Signale einlesen
               Begin
                 If sektion_lesen_b(datei_txt, dummy_s, ende_b) Then
                    StrWrite(0, i, dummy_s)
                    Else Result := False;
                 j := 1;
                 //For j := 1 To Spalten_i_Prop Do
                 //    If (sektion_lesen_b(datei_txt, dummy_s, ende_b)) Then
                 While Result                                      And
                       Not(ende_b)                                 Do
                       Begin
                         If sektion_lesen_b(datei_txt, dummy_s, ende_b) Then
                            Begin
                              If ZahlFormat = zfInteger Then //berprfung des
                                 StrToInt(dummy_s)           //Dateiinhaltes
                                 Else
                                 If ZahlFormat = zfKommaZahl Then
                                    StrToFloat(dummy_s);
                              StrWrite(j, i, dummy_s)
                            End
                            Else Result  := False;
                         Inc(j)
                       End;
                 ReadLn(datei_txt)
               End;

  Except Result := False
  End
End;

Begin //signale_laden_b
  Try Result := True;
      ReadLn(datei_txt);
      ReadLn(datei_txt);
      ReadLn(datei_txt);
      ReadLn(datei_txt);
      ReadLn(datei_txt, peak_anzahl_i);

      //Signalbeschreibungen einlesen
     If Not(signalparameter_laden_b(datei_txt, zfKeins,
                                    Signale.HistoryStringArray)) Then
         Result := False;

      //Integrale einlesen
      If Not(signalparameter_laden_b(datei_txt, zfKommazahl,
                                    Signale.IntegrStringArray)) Then
         Result := False;

      //Retentionszeiten =Maximazeiten einlesen
      If Not(signalparameter_laden_b(datei_txt, zfKommazahl,
                                     Signale.RetZeitStringArray)) Then
         Result := False;

      //Maximalintensitten einlesen
      If Not(signalparameter_laden_b(datei_txt, zfKommazahl,
                                     Signale.MaxIntStringArray)) Then
         Result := False;

      //Halbwertsbreiten einlesen
      If Not(signalparameter_laden_b(datei_txt, zfKommazahl,
                                     Signale.HWBStringArray)) Then
         Result := False;

      //Maximalsteigungen einlesen
      If Not(signalparameter_laden_b(datei_txt, zfKommazahl,
                                     Signale.MaxStgStringArray)) Then
         Result := False;

      //Minimalsteigungen einlesen
      If Not(signalparameter_laden_b(datei_txt, zfKommazahl,
                                     Signale.MinStgStringArray)) Then
         Result := False;

      //Deationsfaktoren einlesen
      If Not(signalparameter_laden_b(datei_txt, zfKommaZahl,
                                     Signale.DeformStringArray)) Then
         Result := False;

      //Offset einlesen
      If Not(signalparameter_laden_b(datei_txt, zfKommazahl,
                                     Signale.OffsetStringArray)) Then
         Result := False;

      //Signalidentifikationsdaten einlesen
      If Not(signalparameter_laden_b(datei_txt, zfKeins,
                                     Signale.IdentStringArray)) Then
         Result := False;

      For i := 1 To 3 Do
          ReadLn(datei_txt, dummy_s);//Ehemalig Laden von Informationen zur
      ReadLn(datei_txt);             //Autointegration
      For i := 1 To 3 Do ReadLn(datei_txt);
      ReadLn(datei_txt);

  Except Result := False
         End
End;

Function history_laden_b(Var datei_txt : Text) : Boolean;

Var i : Integer;

Begin //history_laden_b
  Try For i := 1 To 3 Do ReadLn(datei_txt);  //Die bereits durchgefhrten
      ReadLn(datei_txt, ChromS.history_s);   //Modifikationen am Chromamm oder
      Result := True                         //Spektrum laden
  Except Result := False
         End
End;

Function orignialdaten_laden_b(Var datei_txt : Text) : Boolean;

Var i : Integer;

Begin //orignialdaten_laden_b
  Try For i := 1 To 7 Do ReadLn(datei_txt);
      ReadLn(datei_txt, ChromS.OriginHistory_s);
      ReadLn(datei_txt);
      ReadLn(datei_txt);
      Result := chrom_spektr_laden_b(datei_txt, ChromS.IntenOrigin_da_e);
  Except Result := False;
         End
End;

Function SichtbareLinienLaden_b(Var datei_txt : Text) : Boolean;

Var i        : Integer;
    ende_b   : Boolean;
    Puffer_s : String;

Begin //SichtbareLinienLaden_b
  Try    For i := 1 To 6 Do ReadLn(datei_txt);
         Ende_b := False;
         i      := 0;
         Result := True;
         While Not(ende_b) And Result Do
               Begin
                 Result := Sektion_Lesen_b(Datei_txt, puffer_s, Ende_b);
                 If Puffer_s = 'Ja' Then ChromS.VisibleLines_a_b[i] := True
                                    Else ChromS.VisibleLines_a_b[i] := False;
                 Inc(i)
               End;
  Except Result := False
         End
End;

Function datei_schliessen_b(Var datei_txt : Text) : Boolean;
Begin //datei_schliessen_b
  Try Close(datei_txt);
      Result := True;
  Except Result := False
         End;
End;

Function GroesseErmitteln_b(Var datei_txt : Text;
                            Var g_dpz_i   : Integer{;
                            Var g_lz_i    : Integer}) : Boolean;

Var ende_b   : Boolean;
    puffer_s : String;

Begin //GroesseErmitteln_b
  g_dpz_i := -2;
  Try While Not EOF(datei_txt) Do
      Begin
        Readln(datei_txt);
        Inc(g_dpz_i)
      End;
      Reset(datei_txt);
      //g_lz_i := -1;
      {sektion_lesen_b(datei_txt, puffer_s, ende_b);
      While Not ende_b Do
            Begin
              sektion_lesen_b(datei_txt, puffer_s, ende_b);
              Inc(g_lz_i)
            End;   }
      If g_dpz_i > -1 Then Result := True
         Else Result := False;
  Except Result := False
  End
End;

Procedure LinInDateikopf(    LinNamen_s    : String;
                         Var dateikopf_a_s : Tdateikopf_a_s);

Var i        : Integer;
    zeile_i  : Integer;

Begin  //LinInDateikopf
  For i := 1 To 60 Do dateikopf_a_s[23 + i] := '';
  zeile_i := 24;
  For i := 1 To Length(Linnamen_s) Do
      If Linnamen_s[i] = TRENNZEICHEN Then Inc(zeile_i)
         Else dateikopf_a_s[zeile_i] :=   dateikopf_a_s[zeile_i]
                                        + Linnamen_s[i]
End;

Begin //Tdaten.laden
  speicher_leeren;
  initialisieren;
  chromatogramm_b := True;

  fehler_b := True;
  import_b := False;

  If datei_oeffnen_b(datei_txt, dateiname_s) Then
     Begin
       If datei_identifizieren_b(datei_txt) Then
          Begin
            If parameter_laden_b(datei_txt, chromatogramm_b, g_dpz_i) Then
               If dateikopf_laden_b(datei_txt) Then
                  If linieninfo_laden_b(datei_txt, g_lz_i,
                                        chromatogramm_b, False) Then
                     If speicher_bereitstellen_b(g_lz_i, g_dpz_i) Then
                        If chrom_spektr_laden_b(datei_txt,
                                                ChromS.Intens_da_e) Then
                           If signale_laden_b(datei_txt) Then
                              If history_laden_b(datei_txt) Then
                                 If orignialdaten_laden_b(datei_txt) Then
                                    If SichtbareLinienLaden_b(datei_txt) Then
                                       fehler_b := False
          End
          Else
          Begin
            MessageBeep(MB_ICONHAND);
            If MessageDlg('Keine Spektrographdatei! '      +
                          'Soll ein Importversuch als xy-' +
                          'Datenreihe unternommen werden?',
                          mtWarning, [mbYes, mbNo], 0       ) = mrYES Then
               Begin
                 If GroesseErmitteln_b(datei_txt, g_dpz_i) Then
                    If linieninfo_laden_b(datei_txt, g_lz_i,
                                          chromatogramm_b, True) Then
                       If speicher_bereitstellen_b(g_lz_i, g_dpz_i) Then
                          If chrom_spektr_laden_b(datei_txt,
                                                  ChromS.Intens_da_e) Then
                             fehler_b := False;
                 If Not fehler_b Then
                    Begin
                      import_b := True;
                      ChromS.history_s :=   HISTORY_SEP
                                          + DateToStr(Date)
                                          + HISTORY_SEP
                                          + TimeToStr(Time)
                                          + HISTORY_SEP;
                      dateikopf_erstellen(chromatogramm_b);
                      ImportForm.ModalZeigen(dateikopf_a_s[12],//Belichtungszeit
                                             dateikopf_a_s[13],//Messungsanzahl
                                             dateikopf_a_s[16],//Nullabgleich?
                                             dateikopf_a_s[17],//Glttung?
                                             ChromS.history_s);
                      LinInDateikopf(ChromS.LinNamen_s, dateikopf_a_s);
                    End
               End
               Else
               fehler_b := False
          End;
       If Not(datei_schliessen_b(datei_txt)) Then fehler_b := True
     End;

  If fehler_b Then     //Falls das Chromatogramm/Spektrum
     speicher_leeren   //nicht geladen werden konnte
     Else
     Begin
       i := 1;
       ChromS.Normierung_b        := Normiert_b(ChromS.history_s, i);
       ChromS.NormierungSpiegel_b := ChromS.Normierung_b
     End;

  zoom_norm_setzen; //Den Bereich fr die Normalansicht setzen
  With ChromS Do Sichtbar := NormSicht
End;



Procedure tdaten.dateikopf_erstellen(chromatogramm_b : Boolean);

Var i : Integer;

Begin
  dateikopf_a_s[1] := 'Spektrograph-Datei';
  dateikopf_a_s[2] := '';
  If chromatogramm_b Then dateikopf_a_s[3] := 'Chromatogramm:'
     Else dateikopf_a_s[3] := 'Spektrum:';
  dateikopf_a_s[4] := '';
  dateikopf_a_s[5] := 'Anzahl der Datenpunkte:';
  dateikopf_a_s[6] := IntToStr(Succ(High(ChromS.zeiten_da_e)));
  dateikopf_a_s[7] := '';
  dateikopf_a_s[8] := 'Betriebsparameter des Spektrometers:';
  dateikopf_a_s[9] := '';
  With EinstForm Do
       Begin
         dateikopf_a_s[10] := 'Datum:;' + DateToStr(Date);
         dateikopf_a_s[11] := 'Uhrzeit:;' + TimeToStr(Time);
         dateikopf_a_s[12] := 'Belichtungszeit:;' + OutEinst_s(paramBlz);
         dateikopf_a_s[13] := 'Anzahl an Messungen:;'
                              + OutEinst_s(paramMesszahl);
         dateikopf_a_s[14] := 'Baudrate der RS232:;' + OutEinst_s(paramB_rs232);
         dateikopf_a_s[15] := 'RS232-Port:;' + OutEinst_s(paramP_rs232);
         dateikopf_a_s[16] := 'Nullabgleich im Spektrum:;' +
                              OutEinst_s(paramNullabgleich);
         dateikopf_a_s[17] :=   'Glttung im Spektrum:;'
                              + OutEinst_s(paramSpektrGlaetten);
         dateikopf_a_s[18] := 'XXXXXXXXXXXXXXXXXXXXXXXXXX';
         dateikopf_a_s[19] := 'XXXXXXXXXXXXXXXXXXXXXXXXXX';
         dateikopf_a_s[20] := 'XXXXXXXXXXXXXXXXXXXXXXXXXX';
       End;
  dateikopf_a_s[21] := '';
  If chromatogramm_b Then
     Begin
       dateikopf_a_s[22] := 'Gemessene Linien:';
       dateikopf_a_s[23] := '';
       With EinstForm Do
            For i := 1 To 60 Do dateikopf_a_s[23 + i] := OutLinDat_s(i);
       dateikopf_a_s[84] := '';
       dateikopf_a_s[85] := 'Zeit in s' + TRENNZEICHEN + ChromS.LinNamen_s
     End
     Else Begin
            dateikopf_a_s[22] := 'Wellenlngekalibration:';
            dateikopf_a_s[23] := '';
            With WellenKalForm Do
                 For i := 1 To 60 Do dateikopf_a_s[23 + i] := IntToStr(i) +
                                                              TRENNZEICHEN +
                                                              KalLinOut_s(i);
            dateikopf_a_s[84] := '';
            dateikopf_a_s[85] :=   'Pixel'
                                 + TRENNZEICHEN
                                 + ChromS.LinNamen_s
                                 + TRENNZEICHEN
                                 + 'Wellenlnge in nm'
          End;
End;



Procedure tdaten.dateikopf_korrigieren;

Var i : Integer;

Begin
  With WellenKalForm Do
       For i := 1 To 60 Do dateikopf_a_s[23+i] := IntToStr(i)  +
                                                  TRENNZEICHEN + KalLinOut_s(i)
End;



Procedure tdaten.DatenpunktzahlInDateikopf;
Begin
  dateikopf_a_s[6] := IntToStr(Succ(High(ChromS.zeiten_da_e)));
End;



Procedure tdaten.ChromRS232(AchsenImage       : TImage;
                            ChromImage        : TImage;
                            ChromPaintBox     : TPaintBox;
                            StatusBar         : TStatusBar;
                            ComLed            : TComLed;
                            belichtungszeit_e : Extended;
                            zeitsichtbar_e    : Extended;
                            intsichtbar_i     : Integer);

Var i, j, dpz_i         : Integer;
    retentionszeit_i    : Integer;
    x_e                 : Extended; //X-Position der Online-Darstellung in
                                    //Pixeln; nimmt keine Rcksicht, ob die
                                    //x-Position ber den Bildschirmbereich
                                    //hinausgeht
    Screen_i            : Integer;  //Wie oft wurde der darstellbare Bereich
                                    //abgefahren?
    x_i, y_i, vx_i      : Integer;
    vy_a_i              : Array[0..59] Of Integer;
    zeit_e              : Extended;
    schrittweite_x_e    : Extended;
    schrittweite_y_e    : Extended;
    Int_a_i             : Array[0..59] Of Integer;
    fehler_b            : Boolean;
    Messzahl_i          : Integer;
    Durchlaeufe_i       : Integer;
    Zahl_smi            : SmallInt;
    Abbruch_b           : Boolean;
    FalscheLz_b         : Boolean;
    ErsteZahl_b         : Boolean;

Begin
  fehler_b := False;
  If EinstForm.SpektrometerBenachrichtigen_b(coChromatogramm) Then
     Begin
       StatusBar.Panels[0].Text := 'Zum Starten und Stoppen Taster drcken!';
       StatusBar.Repaint;
       initialisieren;
       ChromS.zeiten_da_e := Nil;

       Messzahl_i    := StrToInt(EinstForm.OutEinst_s(paramMesszahl));
       zeit_e        := 0;
       i             := 0;
       Try While zeit_e <= zeitsichtbar_e Do
                 Begin
                   Inc(i);
                   SetLength(ChromS.zeiten_da_e, i);
                   ChromS.zeiten_da_e[High(ChromS.zeiten_da_e)] := zeit_e;
                   zeit_e := zeit_e + belichtungszeit_e * Messzahl_i / 1000;
                 End
       Except fehler_b := True;
              speicher_leeren;
              zoom_norm_setzen;
              With ChromS Do sichtbar := NormSicht;
              Exit
              End;

       With ChromS.sichtbar, ChromS Do
            Begin
              x1_i := 0;
              y1_e := 0;
              x2_i := High(zeiten_da_e);
              y2_e := intsichtbar_i
            End;

       With ChromS Do NormSicht := sichtbar;

       schrittweite_ermitteln(ChromPaintBox.Width, ChromPaintBox.Height,
                              schrittweite_x_e, schrittweite_y_e);

       With AchsenImage.Canvas, AchsenImage Do //Lschen der Achsen
            Begin
              Pen.Color   := clBtnFace;
              Brush.Color := clBtnFace;
              Rectangle(ClientRect);
              Pen.Color   := clBlack;
            End;

       For j := 1 To EinstForm.lz_i_Prop Do //Die im Lininenformular vorhandenen
           Begin                         //Linieninformationen werden bernommen
             If j = EinstForm.lz_i_Prop Then
                With ChromS Do
                     LinNamen_s :=   LinNamen_s
                                   + EinstForm.OutLinBez_s(EinstForm.lz_i_Prop)
                Else
                With ChromS Do
                     LinNamen_s :=   LinNamen_s
                                   + EinstForm.OutLinBez_s(j) + ';';
             LinBezInStringArray(Pred(j), EinstForm.OutLinBez_s(j))
           End;

       x_Achse(ChromImage, AchsenImage, anzChrom, schrittweite_x_e);
       y_Achse(ChromImage, AchsenImage, schrittweite_y_e);
       linienbezeichnen(ChromImage, AchsenImage);
       AchsenImage.Repaint;

       With ChromPaintBox Do
            Begin
              Visible := True;
              Canvas.Pen.Color   := clBlack;
              Canvas.Brush.Color := clWhite;
              Canvas.Rectangle(ClientRect)
            End;

       speicher_leeren;
       dpz_i      := -1;
       x_e        := 0;
       Screen_i   := 0;
       vx_i       := 0;
       For i := 0 To 59 Do vy_a_i[i] := 0;
       For j := 0 To 59 Do int_a_i[j] := 0;
       durchlaeufe_i := 0;
       zahl_smi      := 0;
       ErsteZahl_b   := True;
       Abbruch_b     := False;
       FalscheLz_b   := False;
       Repeat
         Inc(Durchlaeufe_i);
         If EinstForm.ComPort.Read(zahl_smi, 2) = 0 Then Fehler_b := True;
         If (zahl_smi>=30000) And Not(zahl_smi=30000+EinstForm.lz_i_Prop) Then
            Begin
              FalscheLz_b := True;
              Fehler_b    := True
            End;
         If (durchlaeufe_i = 5) And (ComLed.Kind = lkBlueLight) Then
            Begin
              ComLed.Kind := lkGreenLight;
              ComLed.Repaint
            End;
         If Not(GetAsyncKeyState(VK_Escape) = 0) Then
            Begin
              Abbruch_b := True;
              Fehler_b  := True
            End;
       Until Not(zahl_smi >= 30000) Or Fehler_b;
       If Not(fehler_b) Then dateikopf_erstellen(True);
       durchlaeufe_i := 0;
       With EinstForm, ChromPaintBox, ChromPaintBox.Canvas Do
            Begin
              Repeat
                If ErsteZahl_b Then ErsteZahl_b := False
                   Else
                   If ComPort.Read(zahl_smi, 2) = 0 Then Fehler_b := True;
                If zahl_smi = -30000 Then
                   Begin
                     If ComPort.Read(retentionszeit_i, 4) = 0 Then
                        fehler_b := True;

                     //Bei mehreren Belichtungen pro augezeichneten Datenpunkt
                     //besteht der letzte Datenpunkt nicht unbeding aus dem
                     //Mittelwert aller erforderlichen Messungen (=Belichtungen)
                     //sondern aus allen Messungen, die bis zum Beenden der
                     //Messung aufgezeichnet werden konnten.
                     If Not(durchlaeufe_i = messzahl_i) And
                        Not(Durchlaeufe_i = 0)          Then
                        If speicher_bereitstellen_b(Pred(EinstForm.lz_i_Prop),
                                                    Succ(dpz_i))            Then
                           Begin
                             Inc(dpz_i);
                             For j := 0 To Pred(EinstForm.lz_i_Prop) Do
                                 ChromS.Intens_da_e[j, dpz_i] := int_a_i[j]
                                                                  Div
                                                                  durchlaeufe_i
                           End
                           Else fehler_b := True
                   End
                   Else
                   Begin
                     Inc(durchlaeufe_i);
                     If durchlaeufe_i = Succ(Messzahl_i) Then
                        Begin
                          For j := 0 To 59 Do int_a_i[j] := 0;
                          durchlaeufe_i := 1
                        End;
                     Inc(int_a_i[0], zahl_smi);
                     For i := 1 To Pred(EinstForm.Lz_i_Prop) Do
                         Begin
                           If Not(fehler_b) Then
                              If ComPort.Read(zahl_smi, 2) = 0 Then
                                 Fehler_b := True;
                           Inc(int_a_i[i], zahl_smi)
                         End;
                     If durchlaeufe_i = messzahl_i Then
                        If speicher_bereitstellen_b(Pred(EinstForm.lz_i_Prop),
                                                    Succ(dpz_i))            Then
                           Begin
                             Inc(dpz_i);
                             For j := 0 To Pred(EinstForm.lz_i_Prop) Do
                                 ChromS.Intens_da_e[j, dpz_i] := int_a_i[j]
                                                                  Div
                                                                  messzahl_i;

                             i   := 0;
                             x_i := Round(x_e) - Width * Screen_i;
                             If x_i > Width Then
                                Begin
                                  Pen.Color := clBlack;
                                  Rectangle(ClientRect);
                                  TextOut(10,10, FloatToStr(  belichtungszeit_e
                                                            * messzahl_i
                                                            * Pred(dpz_i)
                                                            / 1000)
                                                 +
                                                 ' Sekunden Messzeit');
                                  Inc(Screen_i);
                                  x_i  := x_i - Width;
                                  vx_i := 0
                                End;

                             For j := 0 To High(ChromS.Intens_da_e) Do
                                 Begin
                                   y_i := Round
                                          (  Height
                                           -   schrittweite_y_e
                                            * ChromS.Intens_da_e[j, dpz_i]);
                                   If y_i <  0      Then y_i := 0;
                                   If y_i >= Height Then y_i := Pred(Height);
                                   If dpz_i = 0 Then vy_a_i[j] := y_i;
                                   If Not(x_i = vx_i) Then
                                      Begin
                                        Inc(i);
                                        Pen.Color := farben[i];
                                        If i = 14 Then i := 0;
                                        MoveTo(vx_i, vy_a_i[j]);
                                        LineTo(x_i,   y_i);
                                        vy_a_i[j] := y_i
                                      End
                                 End;
                             If Not(x_i = vx_i) Then vx_i := x_i;
                             x_e  := x_e + schrittweite_x_e
                           End
                           Else fehler_b := True
                   End;
              Until (zahl_smi = -30000)  Or
                    (dpz_i    = MAX_DPZ) Or
                    (fehler_b = True);

              ComPort.Close;

              If Not(fehler_b) Then //Auffllen des Retentionszeitenarrays
                 Begin
                   DatenpunktzahlInDateikopf;
                   If (dpz_i = 0) Or (dpz_i = -1) Then fehler_b := True
                      Else If dpz_i = MAX_DPZ Then zeit_e :=   belichtungszeit_e
                                                             * messzahl_i
                                                             / 1000
                           Else
                           Begin
                             zeit_e := retentionszeit_i;
                             zeit_e := (zeit_e / dpz_i) / 100
                           End;
                   If Not(fehler_b) Then
                      For i := 0 To High(ChromS.zeiten_da_e) Do
                          ChromS.zeiten_da_e[i] := zeit_e * i;
                 End
            End;
       If fehler_b Then //Falls das Chromatogramm nicht empfangen werden konnte
          Begin
            speicher_leeren;
            If FalscheLz_b Then
               Application.MessageBox(  'Das Spektrometer hat die falsche An'
                                      + 'zahl an Linien gesendet!',
                                      'Fehlermeldung', Mb_Ok + MB_ICONSTOP)
               Else
               If Abbruch_b Then
                  Application.MessageBox('Chromatogrammessung abgebrochen!',
                                         'Info',
                                         Mb_Ok + MB_ICONINFORMATION)
                  Else
                  If (dpz_i = 0) Or (dpz_i = -1) Then
                     Application.MessageBox('Messzeit zu kurz!',
                                            'Fehlermeldung', Mb_Ok+MB_ICONSTOP)
                     Else
                     Application.MessageBox('Fehler bei der Datenbertragung!',
                                            'Fehlermeldung', Mb_Ok+MB_ICONSTOP)
          End;
       ComLed.Kind := lkBlueLight;
     End
     Else  //Falls der Kontakt zum Spektrometer erst gar nicht zu Stande kam
     Application.MessageBox('Keine Kommunikation mit dem Spektrometer mglich!',
                            'Fehlermeldung', Mb_Ok + MB_ICONSTOP);

  EinstForm.SpektrometerBenachrichtigen_b(coLeerlauf);
  ChromPaintBox.Visible := False;
  zoom_norm_setzen;
  With ChromS Do sichtbar := NormSicht;
  //dateikopf_erstellen(True);
  orginaldaten_in_array      //Die unbehandelten Messdaten in einem separaten
End;                         //Array verstauen



Procedure tdaten.SpektrumRS232;

Var i, j, dpz_i, messzahl_i               : Integer;
    MesszahlFalsch_b, fehler_b, abbruch_b : Boolean;
    zahl_smi                              : SmallInt;
    SpekDpz_i                             : Integer;

Begin
  If EinstForm.SpektrometerBenachrichtigen_b(coSpektrum) Then
     Begin
       speicher_leeren;
       initialisieren;
       LinBezInStringArray(0, 'Spektrum');
       messzahl_i := StrToInt(EinstForm.OutEinst_s(paramMesszahl));
       If WellenKalForm.CCDZahl_i = 3 Then
          SpekDpz_i := 6299
          Else
          SpekDpz_i := 8399;

       If speicher_bereitstellen_b(0, SpekDpz_i) Then
          Begin
            Fehler_b          := False;
            abbruch_b         := False;
            MesszahlFalsch_b  := False;
            ChromS.LinNamen_s := 'Spektrum';
            dpz_i := SpekDpz_i;
            Repeat
              If EinstForm.ComPort.Read(zahl_smi, 2) = 0 Then fehler_b := True;
              If (zahl_smi >= 30000) And Not(zahl_smi = 30000 + messzahl_i) Then
                 Begin
                   MesszahlFalsch_b := True;
                   Fehler_b         := True
                 End;
              If Not(GetAsyncKeyState(VK_Escape) = 0) Then
                 Begin
                  Abbruch_b := True;
                  Fehler_b  := True
                End;
            Until Not(zahl_smi = 30000 + messzahl_i) Or Fehler_b;

            If Not(fehler_b) Then dateikopf_erstellen(False);

            With ChromS Do
                 Begin
                   zeiten_da_e[0]    := 0;
                   Intens_da_e[0, 0] := zahl_smi
                 End;
            For i := 1 To SpekDpz_i Do
                Begin
                  ChromS.zeiten_da_e[i] := i;
                  If Not(fehler_b) Then
                     Begin
                       fehler_b := (EinstForm.ComPort.Read(zahl_smi, 2) = 0);
                       ChromS.Intens_da_e[0, i] := zahl_smi
                     End
                End;
            If fehler_b Then
               Begin
                 If abbruch_b Then
                    Application.MessageBox('Messung des Spektrums abgebrochen!',
                                           'Info',
                                           Mb_Ok + MB_ICONINFORMATION)
                    Else If messzahlFalsch_b Then
                         Application.MessageBox('Das Spektrometer arbeitet ' +
                                           'mit der falchen Zahl an ' +
                                           'Wiederholmessungen!',
                                           'Fehlermeldung', Mb_Ok + MB_ICONSTOP)
                         Else
                         Application.MessageBox('Fehler bei der Datenbertr' +
                                                'agung!',
                                                'Fehlermeldung',
                                                Mb_Ok + MB_ICONSTOP);
                 speicher_leeren
               End
         End
     End
     Else  //Falls der Kontakt zum Spektrometer erst gar nicht zu Stande kam
     Application.MessageBox('Keine Kommunikation mit dem Spektrometer mglich!',
                            'Fehlermeldung', Mb_Ok + MB_ICONSTOP);

  EinstForm.SpektrometerBenachrichtigen_b(coLeerlauf);
  zoom_norm_setzen;
  With ChromS Do sichtbar := NormSicht;
  //dateikopf_erstellen(False);
  orginaldaten_in_array
End;



Procedure tdaten.InClipboard(von_i, bis_i : Integer);

Var Clipboard_s : String;
    z, s               : Integer;
    AClipboard         : TClipboard;

Begin
  AClipboard := Clipboard;
  Clipboard_s := 'Zeit' + Chr(9) + ChromS.LinNamen_s + Chr(13);
  For s := 1 To Length(Clipboard_s) Do
      If Clipboard_s[s] = TRENNZEICHEN Then Clipboard_s[s] := Chr(9);
  For z := von_i To bis_i Do
      Begin
        Clipboard_s := Clipboard_s + FloatToStr(ChromS.Zeiten_da_e[z]);
        For s := 0 To High(ChromS.Intens_da_e) Do
                 Clipboard_s :=   Clipboard_s
                                + Chr(9)
                                + FloatToStr(ChromS.Intens_da_e[s, z]);
        Clipboard_s := Clipboard_s + Chr(13)
      End;
  SetLength(Clipboard_s, Pred(Length(ClipBoard_s)));
  AClipboard.Clear;
  AClipboard.AsText := Clipboard_s
End;




Procedure tdaten.AuswahlInZwischenablage;
Begin
  If ChromS.PeakBereich.von_i = - 1 Then
     Begin
       MessageBeep(MB_ICONSTOP);
       MessageDlg('Kein Bereich markiert!', mtError, [mbOK], 0)
     End
     Else
     If ChromS.PeakBereich.bis_i - ChromS.Peakbereich.von_i > 3000 Then
        Begin
          MessageBeep(MB_ICONSTOP);
          MessageDlg('Bereich zu gro, d. h. mehr als 3000 Datenpunkte!',
                     mtError, [mbOK], 0)
        End
        Else InClipboard(ChromS.Peakbereich.von_i, ChromS.PeakBereich.bis_i)
End;




Procedure tdaten.AllesInZwischenablage;
Begin
  If Length(ChromS.zeiten_da_e) > 3000 Then
     Begin
       MessageBeep(MB_ICONSTOP);
       MessageDlg('Chromatogramm zu gro, d. h. mehr als 3000 Datenpunkte!',
                  mtError, [mbOK], 0)
     End
     Else InClipboard(0, High(ChromS.zeiten_da_e))
End;



Function tdaten.chrom_speichern(dateiname_s     : String;
                                chromatogramm_b : Boolean) : Boolean;

Var datei_txt : Text;

Function datei_erzeugen_b(Var datei_txt   : Text;
                              dateiname_s : String) : Boolean;
Begin //datei_erzeugen_b
  Try AssignFile(datei_txt, dateiname_s);
      Rewrite(datei_txt);
      Result := True;
  Except Result := False
         End
End;

Function dateikopf_speichern_b(Var datei_txt : Text) : Boolean;

Var i : Integer;

Begin //dateikopf_speichern_b
  Try For i := 1 To 85 Do WriteLn(datei_txt, dateikopf_a_s[i]);
      Result := True;
  Except Result := False
         End
End;

Function chrom_spektr_speichern_b(    intens_da_e : tintens_da_e;
                                  Var datei_txt    : Text) : Boolean;

Var i, j : Integer;

Begin //chrom_spektr_speichern_b
  Try For i := 0 To High(ChromS.zeiten_da_e) Do
          //Chromatogramm oder Spektrum schreiben
          Begin
            Write(datei_txt, FloatToStr(ChromS.zeiten_da_e[i]), TRENNZEICHEN);
            If chromatogramm_b Then
               Begin
                 For j := 0 To Pred(High(intens_da_e)) Do
                     Write(datei_txt,
                           FloatToStr(intens_da_e[j, i]), TRENNZEICHEN);
                 If High(intens_da_e) = -1 Then WriteLn(datei_txt)
                    Else WriteLn(datei_txt,
                                 FloatToStr(
                                      intens_da_e[High(ChromS.Intens_da_e), i]))
               End
               Else
               Begin
                 Write(datei_txt, FloatToStr(intens_da_e[0, i]));
                 Write(datei_txt, Trennzeichen);
                 WriteLn(datei_txt,
                       FloatToStr(Round(WellenKalForm.WaveLOut_e(i)*100)/100))
               End
          End;
         Result := True;
  Except Result := False //Fehler beim Schreiben des Chromatogrammes!
         End
End;

Function signale_speichern_b(Var datei_txt : Text) : Boolean;

Const BEZ_BER = 'Bezeichnung;von;bis;blankvon;blankbis;'; //Bezeichnung und
                                                          //Integrationsbereiche

Var i : Integer;

Begin //parameter_speichern_b
  Try WriteLn(datei_txt);    //Peakparameter schreiben
      WriteLn(datei_txt);
      WriteLn(datei_txt);
      WriteLn(datei_txt, 'Anzahl an Signalen:');
      WriteLn(datei_txt, Signale.IntegrStringArray.ZeilenFuellstatus_i(1));

      WriteLn(datei_txt);
      WriteLn(datei_txt, 'Signalbeschreibung:');
      WriteLn(datei_txt);
      With Signale.HistoryStringArray Do
           For i := 0 To signalzahl_i Do
               WriteLn(datei_txt, ZeileAuslesen_s(i, 0, 23, TRENNZEICHEN));

      Writeln(datei_txt);
      WriteLn(datei_txt, 'Integrale:');
      WriteLn(datei_txt);
      With Signale.IntegrStringArray Do
           For i := 0 To signalzahl_i Do
               WriteLn(datei_txt,
                       ZeileAuslesen_s(i, 0, Succ(High(ChromS.Intens_da_e)),
                                       TRENNZEICHEN));

      WriteLn(datei_txt);
      WriteLn(datei_txt, 'Maximas bei:');
      WriteLn(datei_txt);
      With Signale.RetZeitStringArray Do
           For i := 0 To signalzahl_i Do
               WriteLn(datei_txt,
                       ZeileAuslesen_s(i, 0, Succ(High(ChromS.Intens_da_e)),
                                       TRENNZEICHEN));

      WriteLn(datei_txt);
      WriteLn(datei_txt, 'Maximale Intensitt:');
      WriteLn(datei_txt);
      With Signale.MaxIntStringArray Do
           For i := 0 To signalzahl_i Do
               WriteLn(datei_txt,
                       ZeileAuslesen_s(i, 0, Succ(High(ChromS.Intens_da_e)),
                                       TRENNZEICHEN));

      WriteLn(datei_txt);
      WriteLn(datei_txt, 'Halbwertsbreiten:');
      WriteLn(datei_txt);
      With Signale.HWBStringArray Do
           For i := 0 To signalzahl_i Do
               WriteLn(datei_txt,
                       ZeileAuslesen_s(i, 0, Succ(High(ChromS.Intens_da_e)),
                                       TRENNZEICHEN));

      WriteLn(datei_txt);
      WriteLn(datei_txt, 'Maximale Steigung:');
      WriteLn(datei_txt);
      With Signale.MaxStgStringArray Do
           For i := 0 To signalzahl_i Do
               WriteLn(datei_txt,
                       ZeileAuslesen_s(i, 0, Succ(High(ChromS.Intens_da_e)),
                                       TRENNZEICHEN));

      WriteLn(datei_txt);
      WriteLn(datei_txt, 'Minimale Steigung:');
      WriteLn(datei_txt);
      With Signale.MinStgStringArray Do
           For i := 0 To signalzahl_i Do
               WriteLn(datei_txt,
                       ZeileAuslesen_s(i, 0, Succ(High(ChromS.Intens_da_e)),
                                       TRENNZEICHEN));

      WriteLn(datei_txt);
      WriteLn(datei_txt, 'Signaldeformation:');
      WriteLn(datei_txt);
      With Signale.DeformStringArray Do
           For i := 0 To signalzahl_i Do
               WriteLn(datei_txt,
                       ZeileAuslesen_s(i, 0, Succ(High(ChromS.Intens_da_e)),
                                       TRENNZEICHEN));

      WriteLn(datei_txt);
      WriteLn(datei_txt, 'Offset:');
      WriteLn(datei_txt);
      With Signale.OffsetStringArray Do
           For i := 0 To signalzahl_i Do
               WriteLn(datei_txt,
                       ZeileAuslesen_s(i, 0, Succ(High(ChromS.Intens_da_e)),
                                       TRENNZEICHEN));

      WriteLn(datei_txt);
      WriteLn(datei_txt, 'Substanzbestimmung:');
      WriteLn(datei_txt);
      With Signale.IdentStringArray Do
           For i := 0 To signalzahl_i Do
               WriteLn(datei_txt,
                       ZeileAuslesen_s(i, 0,
                                       Pred(spalten_i_prop), TRENNZEICHEN));

      WriteLn(datei_txt); //Speichern von Informationen zur Autointegration
      WriteLn(datei_txt, 'Mindestintensitt zur automatischen Integration:');
      WriteLn(datei_txt);
      WriteLn(datei_txt,   EinstForm.OutEinst_s(paramAErkMinHoehe)
                         + ' (Einstellung beim Abspeichern)');
      WriteLn(datei_txt);
      WriteLn(datei_txt,'Zur Signalerkennung herangezogene Linie (0 = alle):');
      WriteLn(datei_txt);
      If EinstForm.OutEinst_s(paramAErkMehrere) = 'Ja' Then Write(datei_txt,'0')
         Else Write(datei_txt, EinstForm.OutEinst_s(paramAErkLinie));
      WriteLn(datei_txt, ' (Einstellung beim Abspeichern)');
      Result := True;

  Except Result := False;
         End
End;

Function history_speichern_b(Var datei_txt      : Text;
                                 chromatogram_b : Boolean) : Boolean;
Begin  //history_speichern_b
  Try WriteLn(datei_txt);     //Sichern einer Liste mit durchgefhrten
      If chromatogramm_b Then //Modifikationen am Spektrum bzw. Chromatogramm
         WriteLn(datei_txt, 'Durchgefhrte Modifikationen am Chromatogramm:')
         Else WriteLn(datei_txt, 'Durchgefhrte Modifikationen am Spektrum:');
      WriteLn(datei_txt);
      WriteLn(datei_txt, ChromS.history_s);
      Result := True;
  Except Result := False
         End
End;

Function origin_chrom_speichern_b(Var datei_txt       : Text;
                                      chromatogramm_b : Boolean) : Boolean;
//Sichern des ursprnglichen bzw. nicht modifierten Spektrums/Chromatogramms
Begin //origin_chrom_speichern_b
  Try WriteLn(datei_txt);
      WriteLn(datei_txt);
      WriteLn(datei_txt);
      If chromatogramm_b Then
         WriteLn(datei_txt, 'Nicht modifiziertes Chromatogramm:')
         Else WriteLn(datei_txt, 'Nicht modifiziertes Spektrum:');
      WriteLn(datei_txt);
      WriteLn(datei_txt, 'Datum und Uhrzeit der Entstehung:');
      WriteLn(datei_txt);
      WriteLn(datei_txt, ChromS.OriginHistory_s);
      WriteLn(datei_txt);
      WriteLn(datei_txt, dateikopf_a_s[85]);
      If chrom_spektr_speichern_b(ChromS.IntenOrigin_da_e, datei_txt) Then
         Result := True
         Else Result := False
  Except Result := False
         End
End;

Function SichtbareLinienSpeichern_b(Var datei_txt : TextFile) : Boolean;

Var i : Integer;

Begin //SichtbareLinienSpeichern_b
  Try WriteLn(datei_txt);
      WriteLn(datei_txt);
      WriteLn(datei_txt);
      WriteLn(datei_txt, 'Linie sichtbar?');
      WriteLn(datei_txt);
      WriteLn(datei_txt, ChromS.LinNamen_s);
      For i := 0 To Pred(High(ChromS.Intens_da_e)) Do
          If ChromS.VisibleLines_a_b[i] Then Write(datei_txt, 'Ja;')
                                        Else Write(datei_txt, 'Nein;');
     If ChromS.VisibleLines_a_b[High(ChromS.Intens_da_e)]
        Then Write(datei_txt,'Ja')
        Else Write(datei_txt,'Nein');
     Result := True;
  Except Result := False
         End
End;

Function datei_schliessen_b(Var datei_txt : Text) : Boolean;
Begin //datei_schliessen_b
  Try Close(datei_txt);
      Result := True;
  Except Result := False
         End;
End;

Begin  //tdaten.chrom_speichern
  If Not(chromatogramm_b) Then dateikopf_korrigieren;
  Result := False;
  If Not((ChromS.zeiten_da_e = Nil) Or (ChromS.Intens_da_e = Nil)) And
     datei_erzeugen_b(datei_txt, dateiname_s)                      Then
     Begin
       If dateikopf_speichern_b(datei_txt) Then
          If chrom_spektr_speichern_b(ChromS.Intens_da_e, datei_txt) Then
             If signale_speichern_b(datei_txt) Then
                If history_speichern_b(datei_txt, chromatogramm_b) Then
                   If origin_chrom_speichern_b(datei_txt, chromatogramm_b) Then
                      If SichtbareLinienSpeichern_b(datei_txt) Then
                      Result := True;
       If Not(datei_schliessen_b(datei_txt)) Then Result := False
     End
End;



Function tdaten.BasislinienAngleichen(Spiegeln_b : Boolean) : Boolean;
//die Basislinnien auf Null abgleichen

Var summe_e : Extended;
    i,j     : Integer;

Begin
  If (ChromS.BlankBereich.von_i = - 1) Then
      Begin
        Result := False;
        MessageBeep(MB_ICONSTOP);
        MessageDlg('Undefinierter Nullabgleichsbereich!',
                   mtError, [mbCancel], 0                );
        Exit
      End
      Else Result := True;
  If Spiegeln_b Then spiegeln;
  For i := 0 To High(ChromS.Intens_da_e) Do
      With ChromS, BlankBereich Do
           Begin
             aufsummieren(True, von_i, bis_i, i, summe_e);
             For j := 0 To High(Intens_da_e[i]) Do
                 Intens_da_e[i, j] := Intens_da_e[i, j] - summe_e
           End;
  With ChromS, Blankbereich Do
       history_s :=   ChromS.history_s
                    + 'Basislinienkorektur ber '
                    + FloatToStr(Round(zeiten_da_e[von_i] * 1000) / 1000)
                    + ' bis '
                    + FloatToStr(Round(zeiten_da_e[bis_i] * 1000) / 1000)
                    + HISTORY_SEP;
  zoom_norm_setzen
End;



Procedure Tdaten.ableiten;

Var i, j : Integer;

Begin
  spiegeln;
  For i := 0 To High(ChromS.Intens_da_e) Do
      For j := 0 To High(ChromS.Intens_da_e[i]) - 1  Do
          With ChromS Do
               Intens_da_e[i, j] :=   (Intens_da_e[i,j+1] - Intens_da_e[i,j])
                                     / (zeiten_da_e[j + 1]-zeiten_da_e[j]);
  For i := 0 To High(ChromS.Intens_da_e) Do
      ChromS.Intens_da_e[i, High(ChromS.Intens_da_e[i])] := 0;
  zoom_norm_setzen;
  ChromS.history_s := ChromS.history_s + 'Ableitung' + HISTORY_SEP;
  With ChromS Do sichtbar := NormSicht
End;



Function Tdaten.glaetten : Boolean;

Var glgrad_i                   : Integer;
    i, k                       : Integer;
    pos_i                      : Integer;
    puffer_da_e, tauscher_da_e : tintens_da_e;

Begin //glaetten
  Try //SetLength(puffer_da_e, 1, Succ(High(ChromS.Intens_da_e[0])));
      SetLength(puffer_da_e, 1, Length(ChromS.Zeiten_da_e));
      SetLength(tauscher_da_e, 1);
      Result := True;
                             //Bereitstellen des Speichers fr das zwischen-
  Except On EOutOfMemory Do  //gespeicherte Glttungsergebnis und Absicherung
            Begin            //dieser Aktion gegen einen Speicherberlauf
              Result        := False;
              puffer_da_e   := Nil;
              tauscher_da_e := Nil;
              Application.MessageBox('Zu wenig Speicher!',
                                     'Fehlermeldung', Mb_Ok);
            End
         End;

  If Result                                                     And
     (High(ChromS.Zeiten_da_e) > EinstForm.OutChromGlaettung_i) Then //*
     Begin                        //*keine Glttung bei zu wenigen Datenpunkten
       spiegeln;
       With ChromS Do
            history_s := history_s +
                         'Gltten(' +
                         IntToStr(EinstForm.OutChromGlaettung_i) +
                         ')' +
                         HISTORY_SEP;

       For k := 0 To High(ChromS.Intens_da_e) Do
           Begin
             SGGlaettung(k, EinstForm.OutChromGlaettung_i, puffer_da_e);
             tauscher_da_e[0]      := ChromS.Intens_da_e[k];//Tauschen von ge-
             ChromS.Intens_da_e[k] := puffer_da_e[0];      //gegltteter Linie
             puffer_da_e[0]        := tauscher_da_e[0];
           End
     End
     Else Result := False;
  SetLength(Puffer_da_e[0],   0);
  SetLength(Tauscher_da_e[0], 0);
  puffer_da_e   := Nil;
  tauscher_da_e := Nil
End;




Function tdaten.normieren_b : Boolean;

Var i, j, DivLine_i : Integer;

Begin
  With ExtStandard.EStandardStringArray, ExtStandard Do
       If Not(ChromS.Normierung_b)              And
          (LinNamen_s_Prop = ChromS.LinNamen_s) And //Bedingungen fr eine
          NOT(StrRead_s(4, 1) = '')             And //erfolgreiche Normierung
          BasislinienAngleichen(False)          Then
          Begin  //Normierung auf den externen Standard
            spiegeln;
            With ChromS Do
                 Begin
                   For i := 0 To High(Intens_da_e) Do
                       For j := 0 To High(Intens_da_e[0]) Do
                           Intens_da_e[i, j] :=    Intens_da_e[i, j]
                                                 / FloatRead_e(4, Succ(i));
                   DivLine_i := StrToInt(EinstForm.
                                         OutEinst_s(paramEStandardDLine));
                   If DivLine_I > Length(Intens_da_e) Then DivLine_i := 0;
                   If (DivLine_i > 0) Then
                      For i := 0 To High(Intens_da_e) Do
                          For j := 0 To High(Intens_da_e[0]) Do
                              Intens_da_e[i, j] :=   Intens_da_e[i, j]
                                                   * FloatRead_e(4, DivLine_i)
                      Else
                      For i := 0 To High(Intens_da_e) Do
                          For j := 0 To High(Intens_da_e[0]) Do
                              Intens_da_e[i, j] := Intens_da_e[i, j] * 100;
                   ChromS.Normierung_b := True;
                 End;

            zoom_norm_setzen;
            With ChromS Do sichtbar := NormSicht;
            With WannStringArray_Prop, ChromS Do
                 history_s :=    history_s
                              + 'Normierung'
                              + HISTORY_SEP
                              + IntToStr(DivLine_i)
                              + HISTORY_SEP
                              + StrRead_s(1, 1)
                              + HISTORY_SEP
                              + StrRead_s(2, 1)
                              + HISTORY_SEP
                              + StrRead_s(1, 2)
                              + HISTORY_SEP
                              + StrRead_s(2, 2)
                              + HISTORY_SEP;
            Result := True
          End
          Else
          Begin //Fehlermeldungen
            If ChromS.Normierung_b Then
               Begin
                 MessageBeep(MB_ICONSTOP);
                 MessageDlg('Normierung bereits durchgefhrt!',
                            mtError, [mbCancel], 0             )
               End;
            If StrRead_s(4, 1) = '' Then
               Begin
                 MessageBeep(MB_ICONSTOP);
                 MessageDlg('Der externe Standard wurde nicht bestimmt!',
                            mtError, [mbCancel], 0             )
               End;
            If Not(ExtStandard.LinNamen_s_Prop = ChromS.LinNamen_s) Then
               Begin
                 MessageBeep(MB_ICONSTOP);
                 MessageDlg('Beim externen Standard wurden andere '+
                            'Linien gemessen wie beim Chromatogramm!',
                            mtError, [mbCancel], 0             )
               End;
            Result := False
          End
End;



Function TDaten.SignaleBearbeiten_b : Boolean;
Begin
  SignaleForm.ShowModal(signale, datenbank, Result)
End;



Procedure TDaten.SignaleAusblenden;
Begin
  With ChromS Do
       LinienAuswahlForm.ShowModal(VisibleLines_a_b, LinNamen_s);
  Zoom_Norm_Setzen
End;



Function TDaten.signalzahl_i : Integer;
Begin
  Result := Signale.HistoryStringArray.ZeilenFuellstatus_i(1)
End;



Procedure TDaten.DBEinstAendern;

Var AnzBasislinie_i  : Integer; //wie oft ist das
    AnzAbleitung_i   : Integer; //Chromatogramm
    AnzGlaettung3_i  : Integer; //sonst noch ver-
    AnzGlaettung5_i  : Integer; //ndert worden?
    AnzGlaettung7_i  : Integer;
    Glaettungsgrad_i : Integer;
    NormA_i          : Integer;
    NormLin_s        : String;

Begin
  ModifikationsanzahlBestimmen(AnzBasislinie_i,
                               AnzAbleitung_i,   //In welcher Art und
                               AnzGlaettung3_i,  //wie oft ist das
                               AnzGlaettung5_i,  //Chromatogramm
                               AnzGlaettung7_i); //verndert worden?
  Glaettungsgrad_i := 1;
  If Not(AnzGlaettung3_i = 0) Then Glaettungsgrad_i := 3
     Else If Not(AnzGlaettung5_i = 0) Then Glaettungsgrad_i := 5
          Else If Not(AnzGlaettung7_i = 0) Then Glaettungsgrad_i := 7;

  NormLin_s := '';
  NormA_i   := 1;
  If Normiert_b(ChromS.history_s, NormA_i) Then
     While Not(ChromS.History_s[NormA_i] = HISTORY_SEP) Do
           Begin
             NormLin_s := NormLin_s + ChromS.History_s[NormA_i];
             Inc(NormA_i)
           End;
  Try StrToInt(NormLin_s);
  Except NormLin_s := '0'
         End ;

  Datenbank.EinstAendern(AusDateikopf_s('Belichtungszeit'),
                         AusDateikopf_s('Anzahl an Messungen'),
                         AusDateikopf_s('Nullabgleich im Spektrum'),
                         AusDateikopf_s('Glttung im Spektrum'),
                         ChromS.LinNamen_s,
                         Succ(High(ChromS.Intens_da_e)),
                         NormLin_s,
                         GlaettungsGrad_i);
End;



Procedure TDaten.DBSimulation(Var ZuBestAufbSignal    : TAufbSignal;
                              Var TetraederAufbSignal : TAufbSignal;
                              Var Linien_a_s          : TLinien_a_s;
                                  SubstDatName_s      : String;
                              Var VerwSignSubstanz    : TSubstanz;
                                  VerwSign_b          : Boolean;
                                  Statistik_b         : Boolean;
                                  VReduktion_b        : Boolean);

Begin
  Datenbank.OutInterpolation(ZuBestAufbSignal,
                             TetraederAufbSignal,
                             Linien_a_s,
                             SubstDatName_s,
                             VerwSignSubstanz,
                             VerwSign_b,
                             Statistik_b,
                             VReduktion_b);
End;



Procedure TDaten.DBOutSubstanzvergleich(SubstDatName1_s : String;
                                        SubstDatName2_s : String;
                                        Robust_b        : Boolean);
Begin
  Datenbank.OutSubstanzvergleich(SubstDatName1_s, SubstDatName2_s, Robust_b)
End;



Procedure TDaten.DBOutSubstanzen(welches_i       : Integer;
                                 SubstDatName_s  : String;
                                 Schwellenwert_e : Extended);
Begin
  Datenbank.DBOutSubstanzen(welches_i, SubstDatName_s, Schwellenwert_e);
End;



Procedure TDaten.EStandardLaden(Var EStandardNStringGrid : TNStringGrid;
                                Var WannNStringGrid      : TNStringGrid);
Begin
  ExtStandard.Laden;
  ExtStandard.OutDaten(EStandardNStringGrid, WannNStringGrid)
End;



Procedure TDaten.EStandardSpeichern;
Begin
  ExtStandard.Speichern
End;



Procedure TDaten.EStandardResetBezug(Var EStandardNStringGrid : TNStringGrid;
                                     Var WannNStringGrid      : TNStringGrid);
Begin
  ExtStandard.bezugzuruecksetzen;
  ExtStandard.OutDaten(EStandardNStringGrid, WannNStringGrid)
End;



Procedure TDaten.EStandardBezugAendern(    Linie_i, Auf_i       : Integer;
                                       Var EStandardNStringGrid : TNStringGrid;
                                       Var WannNStringGrid      : TNStringGrid);
Begin
  ExtStandard.BezugAendern(Linie_i, Auf_i);
  ExtStandard.OutDaten(EStandardNStringGrid, WannNStringGrid)
End;




Procedure TDaten.SGGlaettung(    Linie_i, GlPtZahl_i : Integer;
                             Var Puffer_da_e         : TIntens_da_e);

//GlPtZahl_i gibt an, mit wie vielen Binominalkoeffizienten geglttet werden
//soll: 3, 5, 7, ...

Var pos_i    : Integer;
    GlGrad_i : Integer;
    i        : Integer;

Function fakultaet(wert_i : Integer) : Integer;

Var i : Integer;

Begin
  Result := 1;
  For i := 1 To wert_i Do Result := Result * i
End;

Function a_ueber_b(a_i, b_i : Integer) : Integer;
Begin
  Result := fakultaet(a_i) DIV (fakultaet(b_i) * fakultaet(a_i - b_i))
End;

Function einzelglaettung_e(pos_i, grad_i, linie_i : Integer) : Extended;

//einzelglttung_e fhrt den Bewegtsegmentalgorithmus fr das duch pos_i
//bestimmte Arrayelement durch.

Var i, j                 : Integer;
    summe_e, summe_fak_e : Extended;

Begin
  summe_e     := 0;
  summe_fak_e := 0;
  j           := pos_i - grad_i Div 2;
  //Der Bewegtsegmentglttungsslgorithmus wird angewandt:
  For i := 0 To Pred(grad_i) Do
      Begin
        //Statt die Binominalkoeffizienten in ein Filterarray zu laden,
        //werden sie ber die Funktion a_ber_b direkt gebildet.
        //Pred(grad_i) entspricht grad_i - 1.
        summe_e :=   summe_e
                   + a_ueber_b(Pred(grad_i),i) * ChromS.Intens_da_e[linie_i, j];
        summe_fak_e := summe_fak_e + a_ueber_b(Pred(grad_i), i);
        Inc(j) //entspricht j := j + 1
      End;
  Result := summe_e / summe_fak_e
End;

Begin
  pos_i    :=  -1;     //Den Anfangsbereich des Chromatogrammes mit der
  glgrad_i :=  -1;     //hchstmglichen Zahl an Binominalkoeffizienten gltten:
  Repeat
    Inc(pos_i);
    Inc(glgrad_i, 2);
    puffer_da_e[0, pos_i] := einzelglaettung_e(pos_i, glgrad_i, Linie_i);
  Until glgrad_i = GlPtZahl_i;

  //Den Hauptteil mit der vorgegebenen Zahl an Binominalkoeffizienten gltten:
  For i := Succ(pos_i) To High(ChromS.Intens_da_e[Linie_i]) - glgrad_i Div 2 Do
      puffer_da_e[0, i] := einzelglaettung_e(i, glgrad_i, Linie_i);
  pos_i := High(ChromS.Intens_da_e[Linie_i]) - glgrad_i Div 2;

  While Not(glgrad_i = 1) Do //Das Chromatogrammende mit den hchstmglichen
        Begin                //Zahl an Binominalkoeffizienten gltten:
          Inc(pos_i);
          Dec(glgrad_i, 2);
          puffer_da_e[0, pos_i] := einzelglaettung_e(pos_i, glgrad_i, Linie_i);
        End
End;



Function TDaten.DriftWeg_b : Boolean;

Var glgrad_i        : Integer;
    i, k            : Integer;
    pos_i           : Integer;
    puffer_da_e     : tintens_da_e;
    DriftKLinie_i   : Integer; //Linie, anhand der die Drift korrigiert werden
                               //soll.
    Mittelwert_e    : Extended;

Function Durchschnitt_e(Var Puffer_da_e : TIntens_da_e) : Extended;

Var i : Integer;

Begin //Durchschnitt_i
  Result := 0;
  For i := 0 To High(Puffer_da_e[0]) Do Result := Result + Puffer_da_e[0, i];
  Result := Result / Length(Puffer_da_e[0])
End;

Begin //DriftWeg
  Try SetLength(puffer_da_e, 1, Length(ChromS.Zeiten_da_e));
      Result := True;        //Bereitstellen des Speichers fr das zwischen-
  Except On EOutOfMemory Do  //gespeicherte Glttungsergebnis und Absicherung
            Result := False; //dieser Aktion gegen einen Speicherberlauf
         End;
  DriftKLinie_i := Pred(StrToInt(EinstForm.OutEinst_s(paramDriftKLinie)));
  GlGrad_i      := StrToInt(EinstForm.OutEinst_s(paramDriftGlGrad));

  If Result                                                And//genug Speicher
     (High(ChromS.Zeiten_da_e) > GlGrad_i)                 And//genug Punkte
     (DriftKLinie_i            > -1)                       And//Linie vorhan-
     (Pred(DriftKLinie_i)      < High(ChromS.Intens_da_e)) Then//den
     Begin
       spiegeln;
       With ChromS Do
            history_s :=   history_s
                         + 'Driftkorrektur(' + IntToStr(GlGrad_i) + ')'
                         + HISTORY_SEP;
       SGGlaettung(DriftKLinie_i, GlGrad_i, Puffer_da_e);
       Mittelwert_e := Durchschnitt_e(Puffer_da_e);
       For i := 0 To High(puffer_da_e[0]) Do
           Puffer_da_e[0, i] := Puffer_da_e[0, i] - Mittelwert_e;

       For k := 0 To High(ChromS.Intens_da_e) Do
           For i := 0 To High(ChromS.Intens_da_e[0]) Do
               ChromS.Intens_da_e[k, i] :=   ChromS.Intens_da_e[k, i]
                                            - puffer_da_e[0, i]
     End
     Else Result := False;

  SetLength(Puffer_da_e[0], 0);
  puffer_da_e := Nil
End;



Function tDaten.LinienLoeschen_b : Boolean;

Var ChosenLines_a_b            : TChosenLines_a_b;
    PosVorher_a_i              : TPosVorher_a_i;
    i, lz_i                    : Integer;
    NeuLinNamen_s              : String;
    NeuChromS                  : TChromS;
    ChosenLines_a_s            : TChosenLines_a_s;
    FuerSignaleChosenLines_a_s : TChosenLines_a_s;
    NeuSignale                 : TSignale;

Function LinAusDateikopf_s(welche_s : String) : String;

Var i, Start_i : Integer;

Begin
  For i := 24 To 24 + Pred(MAXLINZAHL_I) Do
      If (welche_s = Copy(dateikopf_a_s[i], 1, Length(welche_s)))  And
         (dateikopf_a_s[i][Succ(Length(welche_s))] = TRENNZEICHEN) Then
         Begin
           Start_i := Length(welche_s) + 2;
           While Not(dateikopf_a_s[i][Start_i] = TRENNZEICHEN) Do INC(Start_i);
           Inc(Start_i);
           Result := Copy(dateikopf_a_s[i], Start_i, Length(dateikopf_a_s[i]));
         End
End;

Procedure SignaleSpalteUmkopieren(Var NeuSign       : TSignale;
                                      von_i, nach_i : Integer);

Var i : Integer;

Begin
  With NeuSign Do
       For i := 0 To MaxSignZahl_i_prop Do
           Begin
             IntegrStringArray. StrWrite(nach_i, i, Signale.IntegrStringArray.
                                                    StrRead_s(von_i, i)       );
             MaxIntStringArray. StrWrite(nach_i, i, Signale.MaxIntStringArray.
                                                    StrRead_s(von_i, i)       );
             RetZeitStringArray.StrWrite(nach_i, i, Signale.RetZeitStringArray.
                                                    StrRead_s(von_i, i)       );
             HWBStringArray.    StrWrite(nach_i, i, Signale.HWBStringArray.
                                                    StrRead_s(von_i, i)       );
             MaxStgStringArray. StrWrite(nach_i, i, Signale.MaxStgStringArray.
                                                    StrRead_s(von_i, i)       );
             MinStgStringArray. StrWrite(nach_i, i, Signale.MinStgStringArray.
                                                    StrRead_s(von_i, i)       );
             DeformStringArray. StrWrite(nach_i, i, Signale.DeformStringArray.
                                                    StrRead_s(von_i, i)       );
             OffsetStringArray. StrWrite(nach_i, i, Signale.OffsetStringArray.
                                                    StrRead_s(von_i, i)       );
           End;
End;

Procedure StringArrayUmkopieren(VonStringArray, NachStringArray : TStringArray);

Var z, s : Integer;

Begin
  For s := 0 To VonStringArray.spalten_i_prop Do
      For z := 0 To VonStringArray.zeilen_i_prop Do
          NachStringArray.StrWrite(s, z, VonStringArray.StrRead_s(s, z));
End;

Begin
  If Length(ChromS.Intens_da_e) = 0 Then
     Begin
       Result := False;
       Exit
     End;
  For i := 0 To Pred(MAXLINZAHL_I) Do ChosenLines_a_b[i] := False;
  LinienAuswahlForm.ShowModal(ChosenLines_a_b,
                              ChosenLines_a_s,
                              ChromS.LinNamen_s,
                              NeuLinNamen_s,
                              PosVorher_a_i);
  If NeuLinNamen_s = ChromS.LinNamen_s Then Result := False
     Else
     With NeuChromS Do
          Begin
            //Intensitten bzw. Spektraldichten:
            lz_i := -1;
            Try //Linien bertragen
                NeuSignale := TSignale.Create(Signale.MaxSignZahl_i_prop);
                SignaleSpalteUmkopieren(NeuSignale, 0, 0);
                For i := 0 To High(ChromS.Intens_da_e) Do
                    If Not(ChosenLines_a_b[i]) Then
                       Begin
                         Inc(lz_i);
                         SetLength(Intens_da_e, Succ(lz_i));
                         SetLength(IntenSpiegel_da_e, Succ(lz_i));
                         SetLength(IntenOrigin_da_e, Succ(lz_i));
                         Intens_da_e[lz_i]
                                  := ChromS.Intens_da_e[PosVorher_a_i[i]];
                         IntenSpiegel_da_e[lz_i]
                                  := ChromS.IntenSpiegel_da_e[PosVorher_a_i[i]];
                         IntenOrigin_da_e[lz_i]
                                  := ChromS.IntenOrigin_da_e[PosVorher_a_i[i]];
                         VisibleLines_a_b[lz_i]
                                  := ChromS.VisibleLines_a_b[PosVorher_a_i[i]];
                         SignaleSpalteUmkopieren(NeuSignale,
                                                 Succ(PosVorher_a_i[i]),
                                                 Succ(Lz_i));
                       End;

                Zeiten_da_e    := ChromS.Zeiten_da_e;

                LinNamen_s := NeuLinNamen_s;

                sichtbar            := ChromS.Sichtbar;
                NormSicht           := ChromS.NormSicht;
                PeakBereich         := ChromS.PeakBereich;
                BlankBereich        := ChromS.BlankBereich;
                history_s           := ChromS.history_s;
                historySpiegel_s    := ChromS.historySpiegel_s;
                OriginHistory_s     := ChromS.OriginHistory_s;
                Normierung_b        := ChromS.Normierung_b;
                NormierungSpiegel_b := ChromS.NormierungSpiegel_b;

                //Kopie, die zur Aktualisierung der Linien bei den Signalen
                //dient
                //FuerSignaleChosenLines_a_s := ChosenLines_a_s;

                For i := 0 To Lz_i Do
                    ChosenLines_a_s[i] :=   IntToStr(Succ(i))
                                          + TRENNZEICHEN
                                          + ChosenLines_a_s[i]
                                          + TRENNZEICHEN
                                          + LinAusDateikopf_s
                                               (IntToStr(PosVorher_a_i[i] + 1));
                For i := Succ(Lz_i) To Pred(MAXLINZAHL_I) Do
                    ChosenLines_a_s[i] := IntToStr(Succ(i)) + ';;;;;';

                Result := True;
            Except Result := False;
                   End;
            If Result Then
               Begin
                 //Dateikopf ndern und "Signale" aktualisieren
                 For i := 0 To Pred(MAXLINZAHL_I) Do
                     Dateikopf_a_s[i + 24] := ChosenLines_a_s[i];
                 StringArrayUmkopieren(Signale.   HistoryStringArray,
                                       NeuSignale.HistoryStringArray);
                 StringArrayUmkopieren(Signale.   IdentStringArray,
                                       NeuSignale.IdentStringArray);
                 Signale.Free;
                 Signale := NeuSignale;

                 Dateikopf_a_s[85] :=   'Zeit in s'
                                      + TRENNZEICHEN
                                      + NeuLinNamen_s;

                 //Neuen Liniensatz berspielen
                 speicher_leeren;
                 ChromS := NeuChromS;

                 //Hinweis geben, dass Linien gelscht worden sind
                 history_s :=          history_s
                                     + 'Linien wurden gelscht!'
                                     + HISTORY_SEP;
                 OriginHistory_s  :=   history_s
                                     + 'Linien wurden gelscht!'
                                     + HISTORY_SEP;
                 historySpiegel_s :=   history_s
                                     + 'Linien wurden gelscht!'
                                     + HISTORY_SEP
               End
          End
End;



Procedure tdaten.Info;

Var i               : Integer;
    Anfang_i        : Integer;
    Puffer_s        : String;
    AnzBasislinie_i : Integer;
    AnzAbleitung_i  : Integer;
    AnzGlaettung3_i : Integer;
    AnzGlaettung5_i : Integer;
    AnzGlaettung7_i : Integer;
    ExtStNormLin_i  : Integer; //Linie, auf die der externe Standard normiert
                               //wurde
    DriftGlGrad_i   : Integer;
    SpektrEinst_a_s : TSpektrEinstellungen_a_s;
    LinDat_a_s      : TLinDat_a_s;

Begin
  ModifikationsanzahlBestimmen(AnzBasislinie_i,
                               AnzAbleitung_i,
                               AnzGlaettung3_i,
                               AnzGlaettung5_i,
                               AnzGlaettung7_i);
  If ChromS.Normierung_b Then
     Begin
       Anfang_i := 1;
       Normiert_b(ChromS.History_s, Anfang_i);
       puffer_s := teilstueck_s(ChromS.history_s, anfang_i);
       //Wegen der Kompatiblitt zu lteren Dateiversionen!
       //Es muss bercksichigt werden, dass die Angabe einer Linie
       //zur Normierung des ext. Standdards fehlen kann.
       Try ExtStNormLin_i := StrToInt(puffer_s);
       Except ExtStNormLin_i := 0
              End;
     End
     Else
     ExtStNormLin_i := -1;

  Anfang_i := 1;
  If WurdeDriftEntfernt_b(ChromS.History_s, anfang_i) Then
     Begin
       puffer_s := '';
       i        := Anfang_i;
       While Not(ChromS.history_s[i] = ')') Do
             Begin
               Puffer_s := puffer_s + ChromS.history_s[i];
               Inc(i)
             End;
       DriftGlGrad_i := StrToInt(puffer_s)
     End
     Else
     DriftGlGrad_i := -1;

  SpektrEinst_a_s[1]  := Dateikopf_a_s[3];
  SpektrEinst_a_s[2]  := AusDateikopf_s('Datum');
  SpektrEinst_a_s[3]  := AusDateikopf_s('Uhrzeit');
  SpektrEinst_a_s[4]  := Dateikopf_a_s[6];
  SpektrEinst_a_s[5]  := AusDateikopf_s('Belichtungszeit');
  SpektrEinst_a_s[6]  := AusDateikopf_s('Anzahl an Messungen');
  SpektrEinst_a_s[7]  := AusDateikopf_s('Glttung im Spektrum');
  SpektrEinst_a_s[8]  := AusDateikopf_s('Nullabgleich im Spektrum');
  SpektrEinst_a_s[9]  := AusDateikopf_s('Baudrate der RS232');
  SpektrEinst_a_s[10] := AusDateikopf_s('RS232-Port');
  SetLength(SpektrEinst_a_s[1], Pred(Length(SpektrEinst_a_s[1])));

  For i := 1 To 60 Do LinDat_a_s[i] := dateikopf_a_s[23 + i];

  If (Length(ChromS.Zeiten_da_e) > 0) And (Length(ChromS.Intens_da_e) > 0) Then
     DatInfoForm.ShowModal(AnzBasislinie_i,
                           AnzAbleitung_i,
                           AnzGlaettung3_i,
                           AnzGlaettung5_i,
                           AnzGlaettung7_i,
                           ExtStNormLin_i,
                           DriftGlGrad_i,
                           SpektrEinst_a_s,
                           LinDat_a_s)
     Else
     Begin
       MessageBeep(MB_ICONSTOP);
       MessageDlg('Keine Datei geladen!', mtError, [mbOK], 0)
     End;
End;



Initialization


//


Finalization


Odatenbank.Free;


end.
