Unit DatenbankKlasse;



interface



Uses Math, stringgitter, StdCtrls, FileCtrl, Forms, Windows, SysUtils,
     DBEinstellungsFormular, StringArrayKlasse, SignaleKlasse,
     ZuordnungsFormular, Controls, Dialogs, FehlerSammlungFormular, ClipBrd;



Type tlinien_a_s    = Array[1..DBMAXLINZAHL] Of String;  //gemessene Linien
     tLinienGew_a_i = Array[1..DBMAXLINZAHL] Of Integer; //Welche Signale
                                                         //sollen fr eine
                                                         //Substanzbestimmung
                                                         //herangezogen werden?

     tSpr = (SprOK, SprZuAehnlich, SprFehler); //Status nach dem Speichern
                                               //eines Signals, Spr= "Speichern-
                                               //Result"

     TA_e         = Array[0..4] Of Extended;

     tvektor_da_i = Array Of Integer;
     tvektor_da_e = Array Of Extended;
     tmatrix_da_e = Array Of TVektor_da_e;

     tPacked_a_si = Packed Array[1..60] Of Single;

     tAufbSignal  = Record  //Eine Variable dieses Typs enthlt alle relevanten
                       KParam_da_e   : tvektor_da_e;//Klassifizierungsparameter
                       intens_da_e   : tvektor_da_e;//und Intensitaeten
                       Abstand_e     : Extended;
                     End;

     tGespSignal = Packed Record  //Gespeichertes Signal
                     IntegrPack_a_si : TPacked_a_si;
                     MaxIntPack_a_si : TPacked_a_si;
                     HwbPack_a_si    : TPacked_a_si;
                     DeformPack_a_si : TPacked_a_si;
                     OffsetPack_a_si : TPacked_a_si;
                     ChromDateTime   : TDateTime;
                     PeakDateTime    : TDateTime;
                   End;

     TFileOFGespSignal  = File Of TGespSignal;


     tsubstanz        = Array Of tAufbSignal;
     tsubstanzen_da_s = Array Of String;

     tDBInfo = Record //Datenbankinformationen: Wie wurden die Signale erstellt?
                 name_s             : String;  //Wie heit die Datenbank?
                 linien_a_s         : tLinien_a_s;
                 lz_i               : Integer; //Linienzahl
                 blz_i              : Integer;
                 dlz_i              : Integer;
                 glaettung_i        : Integer;
                 SPGlaettung_i      : Integer; //Glaettung des Spektrums
                 EStandardNormLin_i : Integer;
                 nullspek_b         : Boolean
               End;

     tAWStil = Record
                 LinienGew_a_i : tLinienGew_a_i; //Welche Linien werden zur
                                                 //substanzidentifikation
                                                 //wie hoch gewichtet werden?
                 PrimSign_i    : Integer; //Welches Signale wird zur Bestimmung
                                          //von Hhe, Breite, Deformation, etc.
                                          //verwendet?
                 Offset_i      : Integer; //Welches Signal wird zur Offset
                                          //bestimmung verwendet?
                 MaxInt_b      : Boolean; //Maximas oder Siganflchen auswerten
                 MinAbw_e      : Extended;
                 SGewicht_a_e  : TA_e;     //Wie stark sollen
                                           //Intensitt,
                                           //Intensitt der Offsetlinie,
                                           //Offset
                                           //Halbwertsbreite und
                                           //Deformation
                                           //beim Aussortieren von Signalen
                                           //vor der Regression gewichtet werden.
                 RAnteil_e     : Extended; //Anteil der Signale, die zur Re-
                                           //gressionsrechnung herangezogen
                                           //werden
                 Unabhaengige_i: Integer;  //Wieviele der Klassifizierungs-
                                           //Parameter sollen als unabhngige
                                           //Variablen in die Regressionsana-
                                           //lyse eingehen?
                 Wertebereiche_s : String; //Welche Wertebereiche sollen kon-
                                           //trolliert werden?
                 AbstandIntens_b : Boolean;//Sollen zur Abstandsbereichnung
                                           //zwecks Substanzbestimmung Intensi-
                                           //ttswerte herangezogen werden
                                           //(TRUE)? Andernfalls werden Intensi-
                                           //ttsverhltnisse verwendet
               End;

     TDist              = Record
                            Distanz_e      : Extended;
                            SubstNr_i      : Integer;
                            Wertebereich_b : Boolean
                          End;
     TDistanzen         = Array Of TDist;

     {tVerwSubst = Record  // Alle Substanzen, die sich derzeit in der Datenbank
                    namen_da_s : T_da_s;//Array Of String;           //befinden
                    pfade_da_s : T_da_s //Array Of String
                  End; }

     tdatenbank = Class (tObject)

                    Private

                    substanz      : tsubstanz; //Aktuell geladener Teildaten-
                                               //satz fr 1 Substanz

                    VerwSubst     : tVerwSubst; //Namen und Pfade aller Substan-
                                                //zen

                    DBInfo        : tDBInfo;  //Datenbankinformationen

                    DBDatName_s   : String;   //Dateiname der aktuellen
                                              //Datenbank

                    AWStil        : TAWStil;  //Wie soll aufgewertet werden?

                    DBVorhanden_b : Boolean;

                    Function VektorDistanz_e(AVektor_da_e,
                                             BVektor_da_e  : TVektor_da_e)
                                            : Extended;

                    Function VektorLaenge_e(Vektor_da_e : TVektor_da_e)
                                           : Extended;

                    Function DifferenzVektor_da_e(AVektor_da_e,
                                                  BVektor_da_e  : TVektor_da_e)
                                                 : TVektor_da_e;

                    Procedure Schwerpunkt(Var Substanz         : TSubstanz;
                                          Var Schwerpunkt_da_e : TVektor_da_e);

                    Function TransMalMatrix_da_e(matrix_da_e : tmatrix_da_e)
                                                                 : tmatrix_da_e;
                             //Die transponierte Matrix wird mit der nicht
                             //transponierten multipliziert

                    Function tmatrix_mal_vektor(matrix_da_e : tmatrix_da_e;
                                                vektor_da_e : tvektor_da_e)
                                                                 : tvektor_da_e;
                             //Die transponierte Matrix wird mit einem Vektor
                             //multipliziert

                    Procedure LinienSchreiben(Var Clipboard_s : String;
                                                  LinZahl_i   : Integer);
                              //Linienbezeichnungen in die Zwischenablage
                              //schreiben

                    Procedure ASortieren(Var Substanz : TSubstanz);
                              //Sortieren nach dem Abstand (Abstand_e)

                    Procedure Filtern(Var ISubstanz        : TSubstanz;
                                          ZuBestAufbSignal : TAufbSignal);
                              //Herausfiltern von Signalen, damit ein Teilansatz
                              //fr die lineare Regression erstellt werden
                              //kann. Die Filterung erfolgt ber eine Art ge-
                              //wichtete Distanzbestimmung.
                              //("AWStil.RGewicht_a_e", "AWStil.RAnteil_e")

                    Function LgsLoesen_b(Var lgs_da_e     : tmatrix_da_e;
                                         Var loesung_da_e : tvektor_da_e) : Boolean;
                             //Lst, wenn mglich, ein lineares Gleichungssystem
                             //beliebiger Gre nach Gau

                    Function Determinante_e(Var Matrix_da_e : tmatrix_da_e)
                                            : Extended;
                             //Determinantenentwicklung nach Laplace und Gau

                    Function SQX_e(Var ISubstanz   : TSubstanz;
                                       Regressor_i : Integer) : Extended;
                             //Quadratsumme aus der Differenz von einem
                             //Klassifizierungsparameter bzw. Regressor
                             //und dem Mittelwert aller Regressorwerte

                    Function regression_b(regressormatrix_da_e : tmatrix_da_e;
                                          signalvektor_da_e    : tvektor_da_e;
                                          ergebnisvektor_da_e  : tvektor_da_e)
                                          : Boolean;
                             //Fhrt eine multivble lineare Regression durch

                    Function MReg_b(Var LGSMatrix_da_e      : tmatrix_da_e;
                                    Var ErgebnisMatrix_da_e : tmatrix_da_e)
                                   : Boolean;
                             //Fhrt eine multivariate lineare Regression durch,
                             //wobei die Regressormatrix mit ihrer eigenen
                             //transponierten multipliziert angegeben werden
                             //muss, sowie die Absolutglieder des linearen
                             //gleichungssystems als Produkt der transponierten
                             //Regressormatrix und der Regressandenmatrix als
                             //Spalten an LGSMatrix_da_e anzuhngen sind.
                             //Es handelt sich im Prinzip um ein Modul zur Lsung
                             //linearer Gleichungssyste nach Gau fr einen
                             //ganzen Satz von Absolutgliedern

                    Function RegressInterpolation_b
                             (Var ISubstanz        : TSubstanz;
                              Var ZuBestAufbSignal : TAufbSignal;
                              Var InterpAufbSignal : TAufbSignal;
                              Var VarVektor_da_e   : TVektor_da_e;
                              Var R2Vektor_da_e    : TVektor_da_e;
                              Var VIntervallVektor_da_e : TVektor_da_e;
                              Var WahrIntensVektor_da_e : TVektor_da_e; 
                                  Dimension_i      : Integer;
                                  Statistik_b      : Boolean;
                                  Filtern_b        : Boolean) : Boolean;
                             //Fhrt die Interpolation eines Signals anhand von
                             //in der Datenbank gespeicherten Signalen mittels
                             //multivariater linearer Regression durch.

                    Procedure VarRedInfo(    SubstDatname_s   : String;
                                         Var ZuBestAufbSignal : TAufbSignal);

                    Function ZuAehnlich_b(Var Substanz         : TSubstanz;
                                          Var ZuBestAufbSignal : TAufbSignal)
                                          : Boolean;

                    Procedure AufbSignAusStringArray
                              (    welches_i        : Integer;
                                   signale          : TSignale;
                               Var ZuBestAufbSignal : TAufbSignal;
                               Var GewVektor_da_e   : TVektor_da_e);
                              //Liest das gewnschte Signal aus den in "Sigale"
                              //vorhandenen StringArrays aus. Signale enthlt
                              //alle Daten, die durch die Signalbestimmung bzw.
                              //Signalintegration von Spektrograph gewonnen wur-
                              //den. TAufbSignal ist das Format, im welchen eine
                              //Substanzbestimmung mglich ist (aufbereitetes
                              //Signal im Gegensatz zu GespSignal (auf der
                              //Platte, wenig Platzbedarf) oder Signale
                              //(leicht sichtbar zu machen in einem
                              //"StringGrid")).

                    Function Signalbestimmung(Var ZuBestAufbSignal   : TAufbSignal;
                                              Var InterpolAufbSignal : TAufbSignal;
                                              Var Distanzen          : TDistanzen;
                                              Var GewVektor_da_e     : TVektor_da_e;
                                                  ZEInfo_b           : Boolean;
                                              Var Ergebnis_s         : String) : Boolean;
                                              //Zuordnung eines Signals zu einem
                                              //Datensatz anhand des hnlich-
                                              //keitsvergleiches mit interpo-
                                              //lierten Signalen

                    Procedure ResourcenFrei;

                    Function SignalSpeichernSpr(welches_i : Integer;
                                                signale   : TSignale;
                                                pfad_s    : String) : TSpr;

                    Function SubstanzLaden_b
                                   (Var FileOFGespSignal : TFileOFGespSignal;
                                    Var Substanz         : TSubstanz) : Boolean;

                    Procedure InkompatibelMeldung(signal_s : String);

                    Public

                      Constructor create;
                      Destructor  destroy; Override;

                      Function EinstAendern(ChromBLZ_s,
                                            ChromMesszahl_s,
                                            ChromNull_s,
                                            ChromSpektrGlaettung_s,
                                            LinNamen_s              : String;
                                            LinZahl_i               : Integer;
                                            EStandardNormLin_s      : String;
                                            ChromGlaettungsGrad_i   : Integer)
                                            : Integer;
                      //ndern der Einstellungen fr die Datenbank: Ruft das
                      //Fenster "DBEinstellungsForm" auf.

                      Function DBInfoCheck(welches_i : Integer;
                                           signale   : TSignale) : Boolean;
                      //Kann das Signal verarbeitet werden?

                      Procedure InSignale(welches_i : Integer;
                                          signale   : TSignale);
                      //Signale in die Datenbank aufnehmen

                      Procedure OutInterpolation
                                        (Var ZuBestAufbSignal   : TAufbSignal;
                                         Var InterpolAufbSignal : TAufbSignal;
                                         Var Linien_a_s         : TLinien_a_s;
                                             SubstDatName_s     : String;
                                         Var VerwSignSubstanz   : TSubstanz;
                                             VerwSign_b         : Boolean;
                                             Statistik_b        : Boolean;
                                             VReduktion_b       : Boolean);

                      Procedure OutSubstanzen(Welches_i : Integer;
                                              signale   : TSignale;
                                              ZInfo_b   : Boolean);
                      //Substanzbestimmung bei gemessenen Signalen

                      Procedure DBOutSubstanzen(Welches_i       : Integer;
                                                SubstDatName_s  : String;
                                                Schwellenwert_e : Extended);
                      //Substanzbestimmung bei Signalen aus der Datenbank

                      Procedure OutSubstanzvergleich(SubstDatName1_s : String;
                                                     SubstDatName2_s : String;
                                                     Robust_b        : Boolean);
                                //

                      Function laden_b : Boolean;

                      Property DBVorhanden_b_prop : Boolean Read DBVorhanden_b;

                  End;




Var datenbank : tdatenbank;



implementation




Function tdatenbank.VektorDistanz_e(AVektor_da_e,
                                    BVektor_da_e  : TVektor_da_e) : Extended;

Var i : Integer;

Begin
  Result := 0;
  For i := 0 To High(AVektor_da_e) Do
      Result := Result + Sqr(AVektor_da_e[i] - BVektor_da_e[i]);
  Result := Sqrt(Result)
End;




Function tdatenbank.VektorLaenge_e(Vektor_da_e : TVektor_da_e) : Extended;

Var i : Integer;

Begin  //tdatenbank.VektorLaenge_e
  Result := 0;
  For i := 0 To High(Vektor_da_e) Do
      Result := Result + Sqr(Vektor_da_e[i]);
  Result := Sqrt(Result)
End;




Function tdatenbank.DifferenzVektor_da_e(AVektor_da_e,
                                         BVektor_da_e : TVektor_da_e)
                                        : TVektor_da_e;

Var i : Integer;

Begin
  Try SetLength(Result, Succ(High(AVektor_da_e)));
      For i := 0 To High(AVektor_da_e) Do
          Result[i] := BVektor_da_e[i] - AVektor_da_e[i]
  Except Result := Nil
  End
End;




Procedure tdatenbank.Schwerpunkt(Var Substanz         : TSubstanz;
                                 Var Schwerpunkt_da_e : TVektor_da_e);

Var i, j : Integer;

Begin
  Try SetLength(Schwerpunkt_da_e, Succ(High(Substanz[0].KParam_da_e)));
      For i := 0 To High(Schwerpunkt_da_e) Do Schwerpunkt_da_e[i] := 0;
      For i := 0 To High(Substanz) Do
          For j := 0 To High(Substanz[i].KParam_da_e) Do
              Schwerpunkt_da_e[j] :=   Schwerpunkt_da_e[j]
                                     + Substanz[i].KParam_da_e[j];
      For i := 0 To High(Schwerpunkt_da_e) Do
          Schwerpunkt_da_e[i] := Schwerpunkt_da_e[i] / Succ(High(substanz));
  Except Schwerpunkt_da_e := Nil
  End
End;




Function tdatenbank.SQX_e(Var ISubstanz   : TSubstanz;
                              Regressor_i : Integer) : Extended;

Var i : Integer;

Begin //SQX_e = Quadratsumme der Differenz aus Regressormittelwert und Regressor
  Result := 0;
  For i := 0 To High(ISubstanz) Do
      Result := Result + ISubstanz[i].KParam_da_e[Regressor_i];
  Result := -1 * Power(Result, 2) / Length(ISubstanz);
  For i := 0 To High(ISubstanz) Do
      Result := Result + Power(ISubstanz[i].KParam_da_e[Regressor_i],2);
End;




Function tdatenbank.regression_b(regressormatrix_da_e : tmatrix_da_e;
                                 signalvektor_da_e    : tvektor_da_e;
                                 ergebnisvektor_da_e  : tvektor_da_e) : Boolean;

//X^(T)Xb(opt.) = X^(T)y
//X       = regressormatrix_da_e
//y       = signalvektor_da_e
//b(opt.) = ergebnisvektor_da_e
//X^(T)X  = Koeffizientenmatrix des LGS und X^(T)y  = lgsergebnisvektor_da_e;
//          beides zusammen ergibt die komplette lgsmatrix_da_e

Var lgsmatrix_da_e         : tmatrix_da_e;
    lgsergebnisvektor_da_e : tvektor_da_e;
    z                      : Integer;

Begin
  lgsmatrix_da_e         := TransMalMatrix_da_e(regressormatrix_da_e);
  lgsergebnisvektor_da_e := tmatrix_mal_vektor(regressormatrix_da_e,
                                               signalvektor_da_e);
  For z := 0 To High(lgsmatrix_da_e) Do
      Begin
        SetLength(lgsmatrix_da_e[z], High(lgsmatrix_da_e[z]) + 2);
        lgsmatrix_da_e[z, High(lgsmatrix_da_e[z])] := lgsergebnisvektor_da_e[z]
      End;
  If LgsLoesen_b(lgsmatrix_da_e, ergebnisvektor_da_e) Then Result := True
     Else Result := False;
  lgsmatrix_da_e         := Nil;
  lgsergebnisvektor_da_e := Nil
End;



Function tdatenbank.tmatrix_mal_vektor(matrix_da_e : tmatrix_da_e;
                                       vektor_da_e : tvektor_da_e):tvektor_da_e;
                                       //die transponierte Matrix wird mit einem
Var z, s : Integer;                    //Vektor multipliziert

Begin
  SetLength(Result, Succ(High(matrix_da_e[0])));
  For z := 0 To High(Result) Do
      Begin
        Result[z] := 0;
        For s := 0 To High(vektor_da_e) Do
            Result[z] := Result[z] + matrix_da_e[s, z] * vektor_da_e[s]
      End
End;



Function tdatenbank.LgsLoesen_b(Var lgs_da_e     : tmatrix_da_e;
                                Var loesung_da_e : tvektor_da_e) : Boolean;

//Lst ein lineares Gleichungssystem nach dem Gau-Verfahren

Var eliminiert_bis_i, koeffizient_i, i, j : Integer;

Function nullen_voran_i(Var lgs_da_e      : tmatrix_da_e;
                            koeffizient_i : Integer) : Integer;

//Hier werden die Zeilen nach vorne getauscht, bei denen der aktuelle
//Koeffizient bereits Null ist.

Var i                 : Integer;
    PufferVektor_da_e : TVektor_da_e;

Begin //nullen_voran_i
  Result := -1;
  For i := 0 To High(lgs_da_e) - koeffizient_i Do
      If lgs_da_e[i, koeffizient_i] = 0 Then
         Begin //Tauschen der Gleichungen
           Inc(Result);
           PufferVektor_da_e := lgs_da_e[i];
           lgs_da_e[i]       := lgs_da_e[Result];
           lgs_da_e[Result]  := PufferVektor_da_e
          End
End;

Procedure subtraktion(    teillgs_da_e     : tmatrix_da_e;
                          koeffizient_i    : Integer;
                      Var eliminiert_bis_i : Integer);

//Hier geschieht die eigentliche Eliminierung

Var i                : Integer;
    faktor0, faktor1 : Extended;

Begin //subtraktion
  faktor0 := teillgs_da_e[0, koeffizient_i];
  faktor1 := teillgs_da_e[1, koeffizient_i];
  For i := koeffizient_i To High(teillgs_da_e[0]) Do
      Begin
        teillgs_da_e[0, i] := faktor1 * teillgs_da_e[0, i];
        teillgs_da_e[1, i] := faktor0 * teillgs_da_e[1, i];
      End;
  For i := koeffizient_i To High(teillgs_da_e[0]) Do
      teillgs_da_e[0, i] := teillgs_da_e[0, i] - teillgs_da_e[1, i];
  If teillgs_da_e[1, koeffizient_i] = 0 Then Inc(eliminiert_bis_i, 2)
     Else Inc(eliminiert_bis_i, 1)
End;

Begin //lgs_loesen_b
  koeffizient_i    := -1;
  Result           := True;

  Try //-----------------------Geschtzter Block: Anfang------------------------

  While Not(koeffizient_i = (High(lgs_da_e[0]) - 2)) And (Result = True) Do
        Begin   //alle Koefizienten werden durchgegangen, solange kein Fehler
          Inc(koeffizient_i); //auftritt

          eliminiert_bis_i := -1; //bis zu dieser Zeile wurde eliminiert (-1
                                  //bedeutet, dass keine Zeile eliminiert wurde)
          eliminiert_bis_i := nullen_voran_i(lgs_da_e, koeffizient_i);
                              //alle Zeilen, deren Koeffizient bereits Null ist,
                              //werden vorangestellt, da mit diesen Zeilen
                              //keine Rechenoperation zur Eliminierung mehr
                              //durchgefhrt werden muss.

          While Not(eliminiert_bis_i = Pred(High(lgs_da_e) - koeffizient_i)) AND
                Not(eliminiert_bis_i = (High(lgs_da_e) - koeffizient_i))     Do
                //Es darf nur so weit eliminiert werden, dass die Koeffizienten-
                //Matrix zur Dreiecksmatrix wird; ist das LGS nicht lsbar, so
                //kann es passieren, dass eine Gleichung zuviel eliminiert wird.
                //Sptestens dann wird die Eliminierung abgebrochen, da es sonst
                //zu einer Zugriffverletzung kommen kann, wenn man versucht mehr
                //Gleichungen zu eliminieren, als die Matrix enthlt.
                subtraktion(Copy(lgs_da_e,Succ(eliminiert_bis_i),2),
                            koeffizient_i, eliminiert_bis_i);
                            //Eliminierung nach dem Subtraktionsverfahren

          If (eliminiert_bis_i = High(lgs_da_e) - koeffizient_i) Then
             Result := False //Wurde eine Gleichung zuviel eliminiert, ist das
                             //Lgs nicht lsbar und das Ergebnis der Funktion
                             //False
        End;

  Inc(koeffizient_i); //Ist das LGS in der Dreiecksform, so knnen die
                      //Koeffizienten nacheinander berechnet werden;
                      //Treten Divisionen durch Null auf, so ist das LGS
                      //ebenfalls nicht lsbar. Probleme knnen auch berlufe
                      //von Variablen verursachen.
  If Result Then
     For i := 0 To Pred(High(lgs_da_e[0])) Do
         Begin
           loesung_da_e[koeffizient_i] := lgs_da_e[i, High(lgs_da_e[0])];
           For j := Succ(koeffizient_i) To Pred(High(lgs_da_e[0])) Do
               loesung_da_e[koeffizient_i] :=   loesung_da_e[koeffizient_i]
                                              - (  loesung_da_e[j]
                                                 * lgs_da_e[i, j]);
           loesung_da_e[koeffizient_i] :=   loesung_da_e[koeffizient_i]
                                          / lgs_da_e[i, koeffizient_i];
           Dec(koeffizient_i);
         End;

  Except //-----------------------Geschtzter Block: Ende-----------------------

  Result := False

  End  //-----------------------Fehlerbehandlung: Ende--------------------------
End;



 


Function tdatenbank.Determinante_e(Var Matrix_da_e : tmatrix_da_e) : Extended;

//Bestimmt eine Determinante ber eine Diagonalisierung nach Gau, wodurch
//die Entwicklung nach Laplace nur noch einen sehr geringen Aufwand darstellt.

Function NullenNachUnten_i(Var Matrix_da_e : tmatrix_da_e;
                               zs_i        : Integer;
                           VAr det_e       : Extended) : Integer;

//Hier werden die Zeilen nach unten getauscht, bei denen der aktuelle
//Koeffizient bereits Null ist.

Var i                 : Integer;
    PufferVektor_da_e : TVektor_da_e;

Begin //NullenNachUnten_i
  Result := Succ(High(Matrix_da_e));

  For i := High(Matrix_da_e) Downto zs_i Do
      If Matrix_da_e[i, zs_i] = 0 Then
         Begin  //Tauschen der Zeilen
           Dec(Result);
           If Not(Matrix_da_e[i] = Matrix_da_e[Result]) Then
              Begin
                PufferVektor_da_e   := Matrix_da_e[i];
                Matrix_da_e[i]      := Matrix_da_e[Result];
                Matrix_da_e[Result] := PufferVektor_da_e;
                Det_e := Det_e * -1
              End
         End;
End;

Procedure subtraktion(VAR Matrix_da_e : tmatrix_da_e;
                          zs_i        : Integer;
                      Var EBis_i      : Integer);

//Hier geschieht die eigentliche Eliminierung

Var i              : Integer;
    MatrixEBisZS_e : Extended;

Begin //subtraktion
  Dec(EBis_i);
  MatrixEBisZS_e := Matrix_da_e[EBis_i, zs_i];
  For i := zs_i To High(Matrix_da_e[zs_i]) Do
      Matrix_da_e[EBis_i, i] := Matrix_da_e[EBis_i, i] -   Matrix_da_e[zs_i, i]
                                                         * MatrixEBisZS_e
                                                         / Matrix_da_e[zs_i, zs_i];
End;

Var EliminiertBis_i, zs_i, i : Integer;

Begin //lgs_loesen_b
  zs_i   := -1; //= Koordinate des Diagonalenelementes, bis zu dem eliminiert
                //  werden soll
  Result := 1;

  While Not(zs_i = High(matrix_da_e)) And Not(Result = 0) Do
        Begin //solange die Matrix nicht diagonalisiert oder die Determinante
              //Null geworden ist...
          Inc(zs_i);

          //Bis zu der Zeile "EliminiertBis_i" wurde eliminiert; ist
          //"EliminiertBis_i" grer als der hchste Matrix_da_e-Index,
          //so wurde keine Zeile eliminiert
          EliminiertBis_i := NullenNachUnten_i(Matrix_da_e, zs_i, Result);
                              //alle Zeilen, deren Koeffizient bereits Null ist,
                              //werden nach unten gestellt, da mit diesen Zeilen
                              //keine Rechenoperation zur Eliminierung mehr
                              //durchgefhrt werden muss.

          If EliminiertBis_i = zs_i Then //Falls eine Zeile zu viel eliminiert
             Result := 0                 //worden ist, ist die Determinante Null.
             Else
             While Not(EliminiertBis_i = Succ(zs_i)) Do
                   subtraktion(Matrix_da_e, zs_i, EliminiertBis_i);
                   //Eliminierungung nach dem Subtraktionsverfahren:
                   //die Zeile z wird mit dem entsprechenden Faktoren multipli-
                   //ziert und von den anderen Zeilen abgezogen
        End;

  //Entwicklung nach Laplace
  If Not(Result = 0) Then
     For i := 0 To High(Matrix_da_e) Do
         Result := Result * Matrix_da_e[i, i];
End;




Function tdatenbank.MReg_b(Var LGSMatrix_da_e      : tmatrix_da_e;
                           Var ErgebnisMatrix_da_e : tmatrix_da_e) : Boolean;

//Fhrt den eintscheidnenen Rechenschritt bei einer multivariate lineare
//Regression durch: Lsung eines linearen Gleichungssystems nach Gau fr
//einen ganzen Satz an Absolutgliedern

Var z, s, i, HighLGS_i : Integer;

Begin //tdatenbank.MReg_b
  If Determinante_e(LGSMatrix_da_e) = 0 Then Result := False
  //berprgung auf Lsbarkeit (die Determinante der Koeffizientenmatrix darf
  //nicht Null werden); da die Bestimmung der Determinante ber eine Diago-
  //nalisierung nach Gau erfolgt, ist das lineare Gleichungssystem nach der
  //Determinantenbestimmung in der Dreiecksform
     Else
     Begin
       Result := True;
       Setlength(ErgebnisMatrix_da_e, Length(LGSMatrix_da_e),
                 Length(LGSMatrix_da_e[0]) - Length(LGSMatrix_da_e));
       HighLGS_i := High(LGSMatrix_da_e);
       For s := 0 To High(ErgebnisMatrix_da_e[0]) Do
           Begin
             For z := HighLGS_i DownTo 0 Do
                 Begin
                   ErgebnisMatrix_da_e[z, s] := LGSMatrix_da_e[z, Succ(HighLGS_i) + s];

                   For i := HighLGS_i DownTo Succ(z) Do
                       ErgebnisMatrix_da_e[z, s] :=   ErgebnisMatrix_da_e[z, s]
                                                    -   ErgebnisMatrix_da_e[i, s]
                                                      * LGSMatrix_da_e[z, i];

                   ErgebnisMatrix_da_e[z, s] :=   ErgebnisMatrix_da_e[z, s]
                                                / LGSMatrix_da_e[z, z];
                 End;
           End;
     End;
End;





Function tdatenbank.TransMalMatrix_da_e(matrix_da_e : tmatrix_da_e) : tmatrix_da_e;

Var z, s, i : Integer;

Begin
  SetLength(Result, Succ(high(matrix_da_e[0])), Succ(high(matrix_da_e[0])));
  For z := 0 To High(matrix_da_e[0]) Do
      For s := 0 To High(matrix_da_e[0]) Do
          Begin
            Result[z, s] := 0;
            For i := 0 To High(matrix_da_e) Do
                Result[z, s] := Result[z, s] +   matrix_da_e[i, z]
                                               * matrix_da_e[i, s]
          End
End;







Procedure tdatenbank.ResourcenFrei;
Begin
  With VerwSubst Do
       Begin
         namen_da_s := Nil;
         pfade_da_s := Nil
       End;
End;



Constructor tdatenbank.create;
Begin
  DBVorhanden_b := False;
  AWStil.MaxInt_b := False
End;



Destructor tdatenbank.destroy;
Begin
  ResourcenFrei;
  Inherited destroy
End;



Function tdatenbank.EinstAendern(ChromBLZ_s,
                                 ChromMesszahl_s,
                                 ChromNull_s,
                                 ChromSpektrGlaettung_s,
                                 LinNamen_s              : String;
                                 LinZahl_i               : Integer;
                                 EStandardNormLin_s      : String;
                                 ChromGlaettungsgrad_i   : Integer) : Integer;
Begin
  Result := DBEinstForm.ShowModal(ChromBLZ_s,
                                  ChromMesszahl_s,
                                  ChromNull_s,
                                  ChromSpektrGlaettung_s,
                                  LinNamen_s,
                                  LinZahl_i,
                                  EStandardNormLin_s,
                                  ChromGlaettungsgrad_i);
  laden_b
End;




Procedure tdatenbank.AufbSignAusStringArray(    welches_i        : Integer;
                                                signale          : TSignale;
                                            Var ZuBestAufbSignal : TAufbSignal;
                                            Var GewVektor_da_e   : TVektor_da_e);

Var linie_i, laenge_i : Integer;

Begin  //tdatenbank.AufbSignAusStringArray_b
  linie_i  := 1;
  laenge_i := 0;
  With ZuBestAufbSignal, AWStil, Signale Do
       Begin
         While Not(linie_i = Succ(DBInfo.lz_i)) Do
               Begin
                 If Not(LinienGew_a_i[linie_i] = 0         ) And
                    Not(Linie_i                = PrimSign_i) And
                    Not(Linie_i                = Offset_i  ) Then
                    Begin
                      SetLength(Intens_da_e,    Succ(laenge_i));
                      SetLength(GewVektor_da_e, Succ(laenge_i));
                      If MaxInt_b Then
                         With MaxIntStringArray Do
                              Intens_da_e[laenge_i] := FloatRead_e(linie_i,
                                                                   welches_i)
                         Else
                         With IntegrStringArray Do
                              Intens_da_e[laenge_i] := FloatRead_e(linie_i,
                                                                   welches_i);
                         GewVektor_da_e[High(GewVektor_da_e)]
                                                      := LinienGew_a_i[linie_i];
                      Inc(laenge_i)
                    End;
                 Inc(linie_i)
               End;

         SetLength(KParam_da_e, 5);
         If MaxInt_b Then
            With MaxIntStringArray Do
                 Begin
                   KParam_da_e[0] := FloatRead_e(PrimSign_i, welches_i);
                   KParam_da_e[1] := FloatRead_e(Offset_i,   welches_i);
                 End
            Else
            With IntegrStringArray Do
                 Begin
                   KParam_da_e[0] := FloatRead_e(PrimSign_i, welches_i);
                   KParam_da_e[1] := FloatRead_e(Offset_i,   welches_i);
                 End;

         With OffsetStringArray Do
              KParam_da_e[2] := FloatRead_e(Offset_i, welches_i);
         With HWBStringArray Do
              KParam_da_e[3] := FloatRead_e(PrimSign_i, welches_i);
         With DeformStringArray Do
              KParam_da_e[4] := FloatRead_e(PrimSign_i, welches_i)
       End
End;



Function TDatenbank.ZuAehnlich_b(Var Substanz         : TSubstanz;
                                 Var ZuBestAufbSignal : TAufbSignal) : Boolean;

Var i, j                     : Integer;
    MaxDiff_a_e              : TA_e;
    GrossGenug_b             : Boolean;

Function MaxDifferenz_e(Param_i : Integer) : Extended;
//...bestimmt die Differenz des maximalen und minimalen Wertes eines
//Klassifizierungsparameters innerhalb einer Substanz einschlielich des zur
//Bestimmung vorgesehenen Signals.

Var max_i, min_i, i : Integer;
    max_e, min_e    : Extended;

Begin //MaxDifferenz_e
  Max_i := 0;
  Min_i := 0;
  For i := 0 To High(Substanz) Do
      With Substanz[i] Do
           Begin
             If KParam_da_e[Param_i] < Substanz[Min_i].KParam_da_e[Param_i] Then
                Min_i := i;
             If KParam_da_e[Param_i] > Substanz[Max_i].KParam_da_e[Param_i] Then
                Max_i := i
           End;
  If Length(substanz) = 0 Then  //Verhindert Zugriffsverletzung
     Begin
       Max_e := 0;
       Min_e := 0
     End
     Else  //Dies ist der Normalfall:
     Begin
       Max_e := Substanz[Max_i].KParam_da_e[Param_i];
       Min_e := Substanz[Min_i].KParam_da_e[Param_i]
     End;
  With ZuBestAufbSignal Do
       Begin
         If Max_e < KParam_da_e[Param_i] Then Max_e := KParam_da_e[Param_i];
         If Min_e > KParam_da_e[Param_i] Then Min_e := KParam_da_e[Param_i]
       End;
  Result := Max_e - Min_e
End;

Begin  //TDatenbank.ZuAehnlich_b
  Result := False;

  With ZuBestAufbSignal Do
       Begin
         //Die Differenz zwischen dem hchsten und niedrigsten Wert wird fr
         //jeden Klassifizierungsparameter bestimmt
         For i := 0 To High(KParam_da_e) Do MaxDiff_a_e[i] := MaxDifferenz_e(i);

         //Alle Klassifizierungsparameter werden fr jedes Signal der Substanz
         //auf ihre Abweichung zu denen des Signals, welches in die Datenbank
         //aufgenommen werden soll, berprft. Ist diese fr ein Signal fr alle
         //Klassifizierungsparameter kleiner, als durch "AWStil.MinAbw_e" vor-
         //gegeben, dann existiert in der Datenbank ein zu hliches Sigal, als
         //das neue Signal in die Datenbank aufgenommen werden sollte.
         For j := 0 To High(Substanz) Do
             Begin
               GrossGenug_b := False;
               For i := 0 To High(KParam_da_e) Do
                   If Abs(  KParam_da_e[i]
                          - Substanz[j].KParam_da_e[i]) >   MaxDiff_a_e[i]
                                                          * AWStil.MinAbw_e Then
                      GrossGenug_b := True;
               If Not(GrossGenug_b) Then Result := True
             End;
       End
End;




Function tdatenbank.DBInfoCheck(welches_i : Integer;
                                signale   : TSignale) : Boolean;

Var welcheglaettung_i : Integer;

{StrWrite(0,  0, 'Bezeichnung');
         StrWrite(1,  0, 'Von');
         StrWrite(2,  0, 'Bis');
         StrWrite(3,  0, 'Null-von');
         StrWrite(4,  0, 'Null-bis');
         StrWrite(5,  0, 'Chromatogramm Datum');
         StrWrite(6,  0, 'Chromatogramm Uhrzeit');
         StrWrite(7,  0, 'Belichtungszeit');
         StrWrite(8,  0, 'Wiederholmessungen');
         StrWrite(9,  0, 'Glttungen des Spektrums');
         StrWrite(10, 0, 'Nullabgleich im Spektrum');
         StrWrite(11, 0, 'Signalbestimmung Datum');
         StrWrite(12, 0, 'Signalbestimmung Uhrzeit');
         StrWrite(13, 0, 'Normierung');
         StrWrite(14, 0, 'Ext. Standard Datum');
         StrWrite(15, 0, 'Ext. Standard Uhrzeit');
         StrWrite(16, 0, 'Ext. St. Offset Datum');
         StrWrite(17, 0, 'Ext. St. Offset Uhrzeit');
         StrWrite(18, 0, 'Dreipunkteglttung');
         StrWrite(19, 0, 'Fnfpunkteglttung');
         StrWrite(20, 0, 'Siebenpunkteglttung');
         StrWrite(21, 0, 'Basislinienkorekturen');
         StrWrite(22, 0, 'Ableitungen');
         StrWrite(23, 0, 'Protokoll-Liste der '+
                                'Chromatorgrammmodifikationen')}

Begin
  Result := True;
  With Signale.HistoryStringArray, DBInfo Do
       Begin
         //Belichtungszeit und Anzahl der Wiederholmessungen prfen:
         If Not(IntRead_i(7, welches_i) = blz_i) Then Result := False;
         If Not(IntRead_i(8, welches_i) = dlz_i) Then Result := False;

         //berprfung der Glaettung im Spektrum:
         If (StrRead_s(9, welches_i) = 'Nein') Then welcheglaettung_i := 1
            Else
            If StrRead_s(9, welches_i) = 'Ja, ber 3 Punkte' Then
               welcheglaettung_i := 3
               Else
               If StrRead_s(9, welches_i) = 'Ja, ber 5 Punkte' Then
                  welcheglaettung_i := 5
                  Else
                  If StrRead_s(9, welches_i) = 'Ja, Mittelwert' Then
                     welcheglaettung_i := 7;
         If Not(welcheglaettung_i = SpGlaettung_i) Then Result := False;

         If Not((StrRead_s(10, welches_i) = 'Ja') = nullspek_b) Then
            Result := False; //Wurde im Spektrum ein Nullabgleich durchgefhrt?

         If Not(StrRead_s(13, welches_i) =   'Ja ('
                                           + IntToStr(EStandardNormLin_i)
                                           + ')'                         ) Then
            Result := False; //Es muss normiert werden, und dass bei iden-
                             //tischer Normierung des externen Standards

         If IntRead_i(18, welches_i) > 1 Then Result := False;//Nur eine Glt-
         If IntRead_i(19, welches_i) > 1 Then Result := False;//tung des Chroma-
         If IntRead_i(20, welches_i) > 1 Then Result := False;//togrammes ist
         If Not((IntRead_i(18, welches_i) = 0)  And           //erlaubt.
                (IntRead_i(19, welches_i) = 0)  And
                (IntRead_i(20, welches_i) = 0)) Then
            If Not((IntRead_i(18, welches_i) = 1) XOR
                   (IntRead_i(19, welches_i) = 1) XOR
                   (IntRead_i(20, welches_i) = 1)) Then Result := False;
         //Stimmt die Anzahl der Punkte, ber die geglaettet wurde?
          If (IntRead_i(18, welches_i) = 0) And
             (IntRead_i(19, welches_i) = 0) And
             (IntRead_i(20, welches_i) = 0) Then
             If Not(glaettung_i = 1) Then Result := False;
          If (IntRead_i(18, welches_i) = 1) Then
             If Not(glaettung_i = 3) Then Result := False;
          If (IntRead_i(19, welches_i) = 1) Then
             If Not(glaettung_i = 5) Then Result := False;
          If (IntRead_i(20, welches_i) = 1) Then
             If Not(glaettung_i = 7) Then Result := False;

         If Not(IntRead_i(22, welches_i) = 0) Then  //keine Ableitung!
            Result := False;
       End;
End;



Function tdatenbank.SignalSpeichernSpr(welches_i : Integer;
                                       signale   : TSignale;
                                       pfad_s    : String) : TSpr;

Var FileOFGespSignal   : TFileOfGespSignal;
    GespSignal         : TGespSignal;
    SignalVorhanden_b  : Boolean;
    ZuBestAufbSignal   : TAufbSignal;
    Substanz           : TSubstanz;
    SignalName_s       : String;
    Ok_b               : Boolean;

Procedure ZuSpeicherndesSignAusStringArray(    welches_i    : Integer;
                                               Signale      : TSignale;
                                           Var GespSignal   : TGespSignal;
                                           Var SignalName_s : String);

Var s : Integer;

Begin //ZuSpeicherndesSignAusStringArray
  With GespSignal Do  //GespSignal ist eine Variable in dem Format, wie die
                      //Signale in der DB auf Platte gespeichert werden. In
                      //diese Variable werden nun alle wichtigen Parameter des
                      //in die Datenbank aufzunehmenden Signals eingelesen.
       Begin
         With Signale.HistoryStringArray Do //Einslesen von Datum und Uhrzeit
              Begin
                SignalName_s  := StrRead_s(0, welches_i);
                ChromDateTime :=   StrToDate(StrRead_s(5,  welches_i))
                                 + StrToTime(StrRead_s(6,  welches_i));
                PeakDateTime  :=   StrToDate(StrRead_s(11, welches_i))
                                 + StrToTime(StrRead_s(12, welches_i))
              End;

         //Einlesen der Klassifizierungsparameter und aller Intensittswerte

         For s := 1 To Signale.MaxIntStringArray.SpaltenFuellstatus_i(0) Do
             Begin
               With Signale.MaxIntStringArray Do
                    MaxIntPack_a_si[s] := FloatRead_e(s, welches_i);
               With Signale.IntegrStringArray Do
                    IntegrPack_a_si[s] := FloatRead_e(s, welches_i);
               With Signale.OffsetStringArray Do
                    OffsetPack_a_si[s] := FloatRead_e(s, welches_i);
               With Signale.HwbStringArray Do
                    HWBPack_a_si[s]    := FloatRead_e(s, welches_i);
               With Signale.DeformStringArray Do
                    DeformPack_a_si[s] := FloatRead_e(s,welches_i)
             End;

         //Markierung, nach wie vielen Intesittswerten das Einlesen zu Ende ist
         With Signale.MaxIntStringArray Do
              If Not(SpaltenFuellstatus_i(0) = MAXLINZAHL) Then
                 MaxIntPack_a_si[Succ(SpaltenFuellstatus_i(0))] := -200000
       End;
End;

Var NotUsed_da_e : TVektor_da_e;

Begin //tdatenbank.SignalSpeichern_b

  AufbSignAusStringArray(welches_i, signale, ZuBestAufbSignal, NotUsed_da_e);
  NotUsed_da_e := Nil;
  //Zunchst wird das Signal zwecks eines hnlichkeistvergleichs aus den
  //StringArrays von "Signale" geladen...
  ZuSpeicherndesSignAusStringArray(welches_i,
                                   Signale,
                                   GespSignal,
                                   SignalName_s);
  //...und zustzlich das Signal in dem Format, in dem es auch auf die Fest-
  //platte gespeichert wird, sowie der Name des Signals.

  If FileExists(pfad_s) Then //Anhngen an eine existierende Datei...
     Try AssignFile(FileOfGespSignal, pfad_s);
         Reset(FileOfGespSignal);
         ok_b := True;
     Except ok_b := False
     End
     Else                    //...oder eine neue Datei erzeugen, falls keine
     Try AssignFile(FileOfGespSignal, pfad_s); //vorhanden ist
         Rewrite(FileOfGespSignal);
         ok_b := True;
     Except ok_b := False
     End;

  If ok_b Then ok_b := SubstanzLaden_b(FileOFGespSignal, Substanz);
  //Laden der Substanz von der Festplatte zwecks des hnlichkeitsvergleiches

  If ok_b Then
     Begin
       //Ist in der Datenbank ein Signal vorhanden, welches dem neuen Siganl zu
       //hnlich ist?
       SignalVorhanden_b := ZuAehnlich_b(Substanz, ZuBestAufbSignal);

       //Anhngen des neuen Signals, falls es allen andern nicht zu hnlich ist:
       If Not(SignalVorhanden_b) Then
          Begin
            Seek(FileOfGespSignal, FileSize(FileOfGespSignal));
            Write(FileOfGespSignal, GespSignal)
          End;
       End
       Else SignalVorhanden_b := False;

  Try CloseFile(FileOfGespSignal);
      Except ok_b := False
      End;

  If SignalVorhanden_b Then Result := sprZuAehnlich
                       Else If ok_b Then Result := sprOK
                                    Else Result := sprFehler
End;



Procedure tdatenbank.InkompatibelMeldung(signal_s : String);
Begin
  MessageBeep(MB_ICONSTOP);
  MessageDlg(  signal_s
             + ': Die Signale der Datenbank wurden unter '
             + 'nicht kompatiblen Bedingungen aufgezeichnet oder ausgewertet!',
             mtError, [mbOK], 0                                                )
End;




Procedure tdatenbank.InSignale(welches_i : Integer;
                               signale   : TSignale);

Procedure ZuAehnlichMeldung(signal_s : String);
Begin
  MessageBeep(MB_ICONSTOP);
  MessageDlg(  signal_s
             + ': Das selbe oder ein hnliches Signal ist bereits '
             + 'in der Datenbank!',
             mtError, [mbOK], 0                                    )
End;

Procedure DateifehlerMeldung(signal_s : String);
Begin
  MessageBeep(MB_ICONSTOP);
  MessageDlg(  signal_s
             + 'Fehler beim Speichern des Sigals!',
             mtError, [mbOK], 0                    )
End;

Var Zuordnung_s : String;
    i, j        : Integer;
    ModalResult : TModalResult;
    Spr         : TSpr;         //Erfolg des Signalspeicherns

Begin //tDatenbank.InSignale
  If Not(DBVorhanden_b) Then laden_b;
  //Falls keine Datenbank geladen ist, wird dies hiermit nachgeholt.
  If DBVorhanden_b Then ModalResult := mrOK
                   Else ModalResult := mrNone;
  //Falls keine Datenbank geladen werden konnte, wird der Vorgabewert von
  //ModalResult so gesetzt, dass kein Signal eingelesen werden kann.

  If welches_i = 0 Then
     Begin
       i := 0;
       FehlerSammlungForm.Reset;
       While Not(i = signale.HistoryStringArray.ZeilenFuellstatus_i(1)) And
             (ModalResult = mrOk)                                       Do
             Begin
               ModalResult := ZuordnungForm.ModalAnzeigen(Succ(i),
                                                          signale,
                                                          VerwSubst,
                                                          Zuordnung_s);
               If ModalResult = mrOK Then
                  If DBInfoCheck(Succ(i), signale) Then
                     SignalSpeichernSpr(Succ(i), signale, Zuordnung_s)
                     Else With signale.HistoryStringArray Do
                               InkompatibelMeldung(StrRead_s(0, Succ(i)))
                  Else
                  If ModalResult = mrAll Then
                     With signale.HistoryStringArray Do
                          For j := i To Pred(ZeilenFuellstatus_i(1)) Do
                              If DBInfoCheck(Succ(j), signale) Then
                                 Begin
                                   Spr := SignalSpeichernSpr(Succ(j),
                                                             signale,
                                                             Zuordnung_s);
                                   If Spr = SprZuAehnlich Then
                                      FehlerSammlungForm.
                                      InFehler(StrRead_s(0, Succ(j)),
                                                           'hnliches oder glei'
                                                         + 'ches Signal schon '
                                                         + 'vorhanden')
                                      Else
                                      If Spr = SprFehler Then
                                         FehlerSammlungForm.
                                         InFehler(StrRead_s(0, Succ(j)),
                                                  'Dateifehler');
                                 End
                                 Else With signale.HistoryStringArray Do
                                           FehlerSammlungForm.
                                           InFehler(StrRead_s(0, Succ(j)),
                                                    'Inkompatiblitt');
               Inc(i)
             End;
       If ModalResult = mrAll Then
          FehlerSammlungForm.FehlerAnzeigen
     End
     Else
     If DBInfoCheck(welches_i, signale) Then
        Begin
          With ZuordnungForm Do
               If Not(ModalAnzeigen(welches_i,
                                    signale,
                                    VerwSubst,
                                    Zuordnung_s) = mrCancel) Then
                  Begin
                    Spr := SignalSpeichernSpr(welches_i, signale, Zuordnung_s);
                    If Spr = sprZuAehnlich Then
                       ZuAehnlichMeldung(signale.HistoryStringArray.
                                         StrRead_s(0, welches_i))
                       Else If Spr = sprFehler Then
                               DateifehlerMeldung(signale.HistoryStringArray.
                                                  StrRead_s(0, welches_i))
                  End;
        End
        Else With signale.HistoryStringArray Do
                  InkompatibelMeldung(StrRead_s(0, welches_i));
End;



Function TDatenBank.SubstanzLaden_b(Var FileOFGespSignal : TFileOFGespSignal;
                                    Var Substanz         : TSubstanz) : Boolean;

Var GespSignal                : TGespSignal;
    linie_i, sign_i, laenge_i : Integer;


Begin  //TDatenBank.SubstanzLaden_b
  SetLength(Substanz, FileSize(FileOfGespSignal));
  Try For sign_i := 0 To Pred(FileSize(FileOfGespSignal)) Do
      Begin
        Seek(FileOfGespSignal, sign_i);
        Read(FileOfGespSignal, GespSignal);
        linie_i  := 1;
        laenge_i := 0;
        With Substanz[sign_i], GespSignal, AWStil Do
             Begin
               While Not(linie_i = Succ(DBInfo.lz_i)) Do
                     Begin
                       If Not(LinienGew_a_i[linie_i] = 0)                 And
                          Not((Linie_i=PrimSign_i) Or (Linie_i=Offset_i)) Then
                          Begin
                            SetLength(Intens_da_e, Succ(laenge_i));
                            If MaxInt_b Then
                               Intens_da_e[laenge_i] := MaxIntPack_a_si[linie_i]
                               Else
                               Intens_da_e[laenge_i] := IntegrPack_a_si[linie_i];
                            Inc(laenge_i)
                          End;
                       Inc(linie_i)
                     End;

               SetLength(KParam_da_e, 5);
               If MaxInt_b Then
                  Begin
                    KParam_da_e[0] := MaxIntPack_a_si[PrimSign_i];
                    KParam_da_e[1] := MaxIntPack_a_si[Offset_i];
                  End
                  Else
                  Begin
                    KParam_da_e[0] := IntegrPack_a_si[PrimSign_i];
                    KParam_da_e[1] := IntegrPack_a_si[Offset_i];
                  End;
               KParam_da_e[2] := OffsetPack_a_si[Offset_i];
               KParam_da_e[3] := HWBPack_a_si[PrimSign_i];
               KParam_da_e[4] := DeformPack_a_si[PrimSign_i]
             End
      End;
      Result := True;
  Except Result := False
  End
End;



Procedure SubstanzFreigeben(Var substanz : TSubstanz);

Var i : Integer;

Begin    //SubstanzFreigeben
  For i := 0 To High(substanz) Do
      With Substanz[i] Do
           Begin
             KParam_da_e := Nil;
             intens_da_e := Nil
           End;
  Substanz := Nil
End;



Procedure ZuBestAufbSignalFreigeben(Var ZuBestAufbSignal : TAufbSignal);
Begin   //ZuBestAufbSignalFreigeben
  With ZuBestAufbSignal Do
       Begin
         KParam_da_e := Nil;
         intens_da_e := Nil
       End
End;




Procedure TDatenbank.ASortieren(Var Substanz : TSubstanz);

Var PAufbSignal    : TAufbSignal;
    bis_i, k, i, j : Integer;

begin //ASortieren
  If High(Substanz) = 1 Then
     If Substanz[0].Abstand_e > Substanz[1].Abstand_e Then
        Begin
          PAufbSignal := Substanz[0];
          Substanz[0] := Substanz[1];
          Substanz[1] := PAufbSignal
        End;
  bis_i := High(Substanz);
  k     := bis_i SHR 1;  //entspricht Div 2
  While k > 0 Do
        Begin
          For i := 0 To bis_i - k Do
              Begin
                j := i;
                While (j >= 0) And (  Substanz[j].    Abstand_e
                                    > Substanz[j + k].Abstand_e) Do
                      Begin //Zeiger tauschen
                        PAufbSignal     := Substanz[j];
                        Substanz[j]     := Substanz[j + k];
                        Substanz[j + k] := PAufbSignal;
                        If j > k Then Dec(j, k) Else j := 0
                      End
              End;
          k := k Shr 1; //entspricht Div 2
        End
End;




Procedure TDatenbank.Filtern(Var ISubstanz        : TSubstanz;
                                 ZuBestAufbSignal : TAufbSignal);

Procedure Sortieren(Var Substanz : TSubstanz;
                        Param_e  : Extended;
                        Param_i  : Integer);

Var PAufbSignal    : TAufbSignal;
    bis_i, k, i, j : Integer;

begin //Sortieren
  If High(Substanz) = 1 Then
     If   Abs(Substanz[0].KParam_da_e[Param_i] - Param_e)
        > Abs(Substanz[1].KParam_da_e[param_i] - Param_e)    Then
        Begin
          PAufbSignal := Substanz[0];
          Substanz[0] := Substanz[1];
          Substanz[1] := PAufbSignal
        End;
  bis_i := High(Substanz);
  k     := bis_i SHR 1;  //entspricht Div 2
  While k > 0 Do
        Begin
          For i := 0 To bis_i - k Do
              Begin
                j := i;
                While (j >= 0)
                      And
                      (  Abs(Substanz[j].KParam_da_e[param_i]     - Param_e)
                       > Abs(Substanz[j + k].KParam_da_e[param_i] - Param_e))
                      Do
                      Begin //Zeiger tauschen
                        PAufbSignal     := Substanz[j];
                        Substanz[j]     := Substanz[j + k];
                        Substanz[j + k] := PAufbSignal;
                        If j > k Then Dec(j, k) Else j := 0
                      End
              End;
          k := k Shr 1; //entspricht Div 2
        End
End;

Var param_i, i, weg_i : Integer;

Begin //TDatenbank.Filtern
  For i := 0 To High(ISubstanz) Do ISubstanz[i].Abstand_e := 0;
  For param_i := 0 To High(ZuBestAufbSignal.KParam_da_e) Do
      Begin
        Sortieren(ISubstanz, ZuBestAufbSignal.KParam_da_e[param_i], param_i);
        For i := 0 To High(ISubstanz) Do
            ISubstanz[i].Abstand_e :=   ISubstanz[i].Abstand_e
                                      + Power((Succ(i) * AWStil.SGewicht_a_e[Param_i]), 2);
      End;
  ASortieren(ISubstanz);

  Weg_i := Round(Length(ISubstanz) * AWStil.RAnteil_e);
  For i := Succ(weg_i) To High(ISubstanz) Do
      Begin
        ISubstanz[i].KParam_da_e := Nil;
        ISubstanz[i].Intens_da_e := Nil
      End;
  SetLength(ISubstanz, weg_i);
End;




Procedure TDatenbank.LinienSchreiben(Var Clipboard_s : String;
                                         LinZahl_i   : Integer);

Var s, z : Integer;

Begin //LinenSchreiben
  z := 0;
  For s := 0 To LinZahl_i Do
      Begin
        While AWStil.LinienGew_a_i[z] = 0 Do Inc(z);
              Clipboard_s := Clipboard_s + DBInfo.Linien_a_s[z] + Chr(9);
        Inc(z)
     End;
  Clipboard_s[Length(Clipboard_s)] := Chr(13);
End;




Function TDatenbank.RegressInterpolation_b
(Var ISubstanz             : TSubstanz;
 Var ZuBestAufbSignal      : TAufbSignal;
 Var InterpAufbSignal      : TAufbSignal;
 Var VarVektor_da_e        : TVektor_da_e;
 Var R2Vektor_da_e         : TVektor_da_e; //Multible Bestimmtheitsmae
 Var VIntervallVektor_da_e : TVektor_da_e; //Vertrauensintervalle bzw. zunchst
                                           //Standardabweichungen
 Var WahrIntensVektor_da_e : TVektor_da_e; //Vertrauensintervalle bzw. zunchst
                                           //standardabweichungen fr den wahren
                                           //Intensittswert
     Dimension_i           : Integer;
     Statistik_b           : Boolean;
     Filtern_b             : Boolean     ) : Boolean;

Function Inversion_da_e(Var matrix_da_e  : tmatrix_da_e) : TMatrix_da_e;

Var teilloesung_da_e : tvektor_da_e;
    lgs_da_e         : tmatrix_da_e;
    i, z, s          : Integer;

Begin //Inversion_da_e
  SetLength(LGS_da_e, Length(matrix_da_e), Succ(Length(matrix_da_e)));
  SetLength(Result, Length(matrix_da_e), Length(matrix_da_e));
  SetLength(teilloesung_da_e, Length(matrix_da_e));
  For i := 0 To High(Matrix_da_e) Do
      Begin
        For z := 0 To High(matrix_da_e) Do
            For s := 0 To High(matrix_da_e) Do
                LGS_da_e[z, s] := matrix_da_e[z, s];
        For z := 0 To High(LGS_da_e) Do
            LGS_da_e[z, High(LGS_da_e[z])] := 0;
        LGS_da_e[i, High(LGS_da_e[i])] := 1;
        LGSLoesen_b(LGS_da_e, teilloesung_da_e);
        For z := 0 To High(teilloesung_da_e) Do
            Result[z, i] := teilloesung_da_e[z];
      End;
  SetLength(LGS_da_e, 0, 0);
  SetLength(teilloesung_da_e, 0);
End;

Function FQS_e(Var ISubstanz           : TSubstanz;
                   r                   : Integer;   //= FQS zu welcher Zielgre
                                                    //  bzw. welchem
                                                    //  Regressandenvektor
               Var ErgebnisMatrix_da_e : TMatrix_da_e) : Extended;

Var i, j      : Integer;
    IIntens_e : Extended;

Begin //FQS_e  = Fehlerquadratsumme
  Result := 0;
  For i := 0 To High(ISubstanz) Do
      Begin
        IIntens_e := ErgebnisMatrix_da_e[0, r];
        For j := 1 To High(ErgebnisMatrix_da_e) Do
            IIntens_e :=   IIntens_e
                         + ErgebnisMatrix_da_e[j, r] * ISubstanz[i].KParam_da_e[Pred(j)];
        Result :=   Result
                  + Power(ISubstanz[i].Intens_da_e[r] - IIntens_e, 2);
      End;
End;

Function R2_e(Var ISubstanz           : TSubstanz;
              Var ErgebnisMatrix_da_e : TMatrix_da_e;
                  r                   : Integer) : Extended;

//Multibler Korrelationskoeffizient zu der Zielgre bzw. dem Regressanden-
//vektor k

Var i : Integer;

Begin //R2_e
  Result := 0;
  For i := 0 To High(ISubstanz) Do
      Result := Result + ISubstanz[i].Intens_da_e[r];
  Result := -1 * Power(Result, 2) / Length(ISubstanz);
  For i := 0 To High(ISubstanz) Do
      Result := Result + Power(ISubstanz[i].Intens_da_e[r],2);
  Result := 1 - FQS_e(ISubstanz, r, ErgebnisMatrix_da_e) / Result
End;

Procedure MatrixSchreiben(    Beschriftung_s : String;
                          Var Matrix_da_e    : TMatrix_da_e;
                          Var Clipboard_s    : String);

Var z, s : Integer;

Begin //MatrixSchreiben
  Clipboard_s :=   Clipboard_s
                 + Chr(13) + Chr(13) + Chr(13)
                 + Beschriftung_s
                 + Chr(13) + Chr(13);
  LinienSchreiben(Clipboard_s, High(Matrix_da_e[0]));
  For z := 0 To High(Matrix_da_e) Do
      Begin
        For s := 0 To High(Matrix_da_e[z]) Do
            Clipboard_s :=   Clipboard_s
                           + FloatToStr(Matrix_da_e[z, s])
                           + Chr(9);
        Clipboard_s[Length(Clipboard_s)] := Chr(13);
      End;
End;

Procedure MatrixSchreiben2(    Beschriftung_s : String;
                           Var Matrix_da_e    : TMatrix_da_e;
                           Var Clipboard_s    : String);

Var z, s : Integer;

Begin //MatrixSchreiben
  Clipboard_s :=   Clipboard_s
                 + Chr(13) + Chr(13) + Chr(13)
                 + Beschriftung_s
                 + Chr(13) + Chr(13);
  For z := 0 To High(Matrix_da_e) Do
      Begin
        For s := 0 To High(Matrix_da_e[z]) Do
            Clipboard_s :=   Clipboard_s
                           + FloatToStr(Matrix_da_e[z, s])
                           + Chr(9);
        Clipboard_s[Length(Clipboard_s)] := Chr(13);
      End;
End;

Procedure VektorSchreiben(    Beschriftung_s : String;
                              Faktor_e       : Extended;
                          Var Vektor_da_e    : TVektor_da_e;
                          Var Clipboard_s    : String);

Var z : Integer;

Begin //VektorSchreiben
  Clipboard_s :=   Clipboard_s
                 + Chr(13) + Chr(13) + Chr(13)
                 + Beschriftung_s
                 + Chr(13) + Chr(13);
  LinienSchreiben(Clipboard_s, High(Vektor_da_e));
  For z := 0 To High(Vektor_da_e) Do
      Clipboard_s := Clipboard_s + FloatToStr(Vektor_da_e[z]*Faktor_e) + Chr(9);
  Clipboard_s[Length(Clipboard_s)] := Chr(13);
End;

Procedure StatistikInZWAblage(Var  ErgebnisMatrix_da_e  : TMatrix_da_e;
                              Var TErgebnisMatrix_da_e  : TMatrix_da_e;
                              Var VAnalyseMatrix_da_e   : TMatrix_da_e;
                              Var IVAnalyseMatrix_da_e  : TMatrix_da_e;
                              Var VIntervallVektor_da_e : TVektor_da_e;
                              Var WahrIntensVektor_da_e : TVektor_da_e;
                              Var BIVektor_da_e         : TVektor_da_e;
                              Var R2Vektor_da_e         : TVektor_da_e;
                              Var FQSVektor_da_e        : TVektor_da_e;
                              Var det_e                 : Extended);

Var Clipboard_s : String;
    z, s, t     : Integer;
    AClipboard  : TClipboard;
    zahl_e      : Extended;

Begin //StatistikSpeichern_b
  AClipboard := Clipboard;
  Clipboard_s := 'Statistik' + Chr(13);

  MatrixSchreiben('Regressionskoeffizienten', ErgebnisMatrix_da_e,  Clipboard_s);
  MatrixSchreiben('t-Statistik',              TErgebnisMatrix_da_e, Clipboard_s);

  VektorSchreiben('Fehlerquadratsummen = Quadratsummen der Residuen', 1,
                  FQSVektor_da_e, Clipboard_s);

  VektorSchreiben(  'Standardabweichungen der Interpolationsergebnisse = Standa'
                  + 'rdabweichungen des Schtzwertes fr zuknfige Messungen', 1,
                  VIntervallVektor_da_e, ClipBoard_s);
  VektorSchreiben(  'Vertrauensintervalle der Interpolationsergebnisse fr ein '
                  + 'Wahrscheinlichkeitsniveau von 95%', 1.960,
                  VIntervallVektor_da_e, ClipBoard_s);
  VektorSchreiben(  'Vertrauensintervalle der Interpolationsergebnisse fr ein '
                  + 'Wahrscheinlichkeitsniveau von 99%', 2.576,
                  VIntervallVektor_da_e, ClipBoard_s);

  VektorSchreiben('Standardabweichungen der Schtzung der wahren Werte ', 1,
                  WahrIntensVektor_da_e, ClipBoard_s);
  VektorSchreiben(  'Vertrauensintervalle der Schtzung der wahren Werte '
                  + 'fr ein Wahrscheinlichkeitsniveau von 95%', 1.960,
                  WahrIntensVektor_da_e, ClipBoard_s);
  VektorSchreiben(  'Vertrauensintervalle der Schtzung der wahren Werte '
                  + 'fr ein Wahrscheinlichkeitsniveau von 99%', 2.576,
                  WahrIntensVektor_da_e, ClipBoard_s);

  VektorSchreiben('Multible Bestimmtheitsmae (R^2)', 1,
                  R2Vektor_da_e, Clipboard_s);

  Clipboard_s :=   Clipboard_s
                 + Chr(13) + Chr(13) + Chr(13)
                 + 'Innere Bestimmtheitsmae der Regressoren'
                 + Chr(13) + Chr(13);
  For z := 0 To High(BIVektor_da_e) Do
      Clipboard_s :=   Clipboard_s
                     + FloatToStr(BIVektor_da_e[z])
                     + Chr(9);
  SetLength(ClipBoard_s, Pred(Length(ClipBoard_s)));

  MatrixSchreiben2(  'Koeffizientenmatrix fr das zur linearen Regre'
                   + 'ssion verwendete LGS',  VAnalyseMatrix_da_e, Clipboard_s);
  MatrixSchreiben2(  'Invertierte Koeffizientenmatrix fr das zur linearen Regre'
                   + 'ssion verwendete LGS', IVAnalyseMatrix_da_e, Clipboard_s);

  Clipboard_s :=   Clipboard_s
                 + Chr(13) + Chr(13) + Chr(13)
                 + 'berprfung ob Ursprungsmatrix mal invertierer '
                 + 'Matrix die Einheitsmatrix egibt'
                 + Chr(13) + Chr(13);
  For z := 0 To High(IVAnalyseMatrix_da_e) Do
      Begin
        For s := 0 To High(IVAnalyseMatrix_da_e[z]) Do
            Begin
              zahl_e := 0;
              For t := 0 To High(IVAnalyseMatrix_da_e[z]) Do
                  zahl_e :=   Zahl_e
                            + VAnalyseMatrix_da_e[z, t]*IVAnalyseMatrix_da_e[t, s];
              Clipboard_s :=   Clipboard_s
                             + FloatToStr(zahl_e)
                             + Chr(9);
            End;
        Clipboard_s[Length(Clipboard_s)] := Chr(13);
      End;

  Clipboard_s :=   Clipboard_s
                 + Chr(13) + Chr(13) + Chr(13)
                 + 'Determinante der Koeffizientenmatrix'
                 + Chr(13) + Chr(13)
                 + FloatToStr(det_e);

  AClipboard.Clear;
  AClipboard.AsText := Clipboard_s
End;

Var regressormatrix_da_e  : tmatrix_da_e;
    signalvektor_da_e     : tvektor_da_e;
    ErgebnisMatrix_da_e   : TMatrix_da_e;
    TMVektor_da_e         : TVektor_da_e;
    VAnalyseMatrix_da_e   : TMatrix_da_e; //Regressormatrix mal transponierter
                                          //Regressormatrix
    LGSMatrix_da_e        : TMatrix_da_e; //Regressormatrix mal transponierter
                                          //Regressormatrix fr die lineare
                                          //Regression
    IVAnalyseMatrix_da_e  : TMatrix_da_e;
    TErgebnisMatrix_da_e  : TMatrix_da_e; //t-Statistik
    KParamVektor_da_e     : TVektor_da_e; //...fr die Vertrauensintervalle be-
                                          //ntigt
    BIVektor_da_e         : TVektor_da_e; //innere Bestimmtheitsmae
    i, j, s, z            : Integer;
    puffer_e              : Extended;
    FQSVektor_da_e        : TVektor_da_e; //Fehlerquadratsummen
    Det_e                 : Extended;     //Determinante von Regressormatrix mal
                                          //transponierter Regressormatrix

Begin //tDaten.RegressInterpolation_b

  //Die passenden Signale herausfiltern
  If Filtern_b Then Filtern(ISubstanz, ZuBestAufbSignal);

  //Die Procedure kann ohne eine Mindestanzahl an Daten keine Ergebnisse
  //liefern!
  If (Length(ISubstanz)                < Succ(Dimension_i)) Or
     (Length(ISubstanz[0].Intens_da_e) = 0                ) Then
     Begin
       Result := False;
       Exit
     End;

  //Speicher bereitstellen, Variablen initialisieren
  SetLength(RegressorMatrix_da_e, Length(ISubstanz), Succ(Dimension_i));
  SetLength(SignalVektor_da_e, Length(ISubstanz));
  SetLength(InterpAufbSignal.Intens_da_e, Length(ISubstanz[0].Intens_da_e));
  SetLength(InterpAufbSignal.KParam_da_e, Length(ISubstanz[0].KParam_da_e));

  //Erstellen der Regressormatrix und Ermittlung des Produktes aus
  //Regressormatrix und transponierter Regressormatrix
  For z := 0 To High(ISubstanz) Do
      Begin
        RegressorMatrix_da_e[z, 0] := 1;
        For s := 1 To High(RegressorMatrix_da_e[0]) Do
        RegressorMatrix_da_e[z, s] := ISubstanz[z].KParam_da_e[Pred(s)];
      End;
  VAnalyseMatrix_da_e  := TransMalMatrix_da_e(RegressorMatrix_da_e);

  //Bestimmung angeforderter statistischen Kenngren zur Regressionsrechnung:
  //Speicher bereitstellen, Variablen initialisieren, einige Kenngren
  //ermitteln...

  If Not(VarVektor_da_e = Nil) Then
     SetLength(FQSVektor_da_e, Length(VarVektor_da_e));
     //Die Residuenvarianz wird aus der Resiuenquadratsumme berechnet

  //Sollen statistische Informationen in die Zwischenablage kopiert werden
  If Statistik_b Then //werden folgende Variablen bentigt:
     Begin
       SetLength(TErgebnisMatrix_da_e,  Succ(Dimension_i),
                                        Length(ISubstanz[0].Intens_da_e));
       SetLength(VIntervallVektor_da_e, Length(ISubstanz[0].Intens_da_e));
       SetLength(WahrIntensVektor_da_e, Length(ISubstanz[0].Intens_da_e));
       SetLength(KParamVektor_da_e,     Succ(Dimension_i));
       SetLength(VarVektor_da_e,        Length(ISubstanz[0].Intens_da_e));
       SetLength(R2Vektor_da_e,         Length(ISubstanz[0].Intens_da_e));
       SetLength(FQSVektor_da_e,        Length(ISubstanz[0].Intens_da_e));

       IVAnalyseMatrix_da_e := Inversion_da_e(VAnalyseMatrix_da_e);

       //Determinante der Koeffizientenmatrix des linaren Gleichungssystems
       SetLength(LGSMatrix_da_e, Length(VAnalyseMatrix_da_e),
                                 Length(VAnalyseMatrix_da_e));
       For z := 0 To High(VAnalyseMatrix_da_e) Do
           For s := 0 To High(VAnalyseMatrix_da_e) Do
               LGSMatrix_da_e[z, s] := VAnalyseMatrix_da_e[z, s];
       det_e := Determinante_e(LGSMatrix_da_e);

       //inneres Bestimmtheitsma
       SetLength(BIVektor_da_e, Dimension_i);
       For z := 0 To High(BIVektor_da_e) Do
           BIVektor_da_e[z] := 1 - 1 / IVAnalyseMatrix_da_e[Succ(z), Succ(z)]
                                     / SQX_e(ISubstanz, z);
     End
     Else  //Falls die Standardabweichungen von Schtzwert und wahren Wert
     If Not(WahrIntensVektor_da_e = Nil) And   //angefordert worden sind:
        Not(VIntervallVektor_da_e = Nil) And
        Not(VarVektor_da_e        = Nil) Then
        Begin
          SetLength(KParamVektor_da_e, Succ(Dimension_i));
          IVAnalyseMatrix_da_e := Inversion_da_e(VAnalyseMatrix_da_e);
        End;

  //////////////////////////////////////////////////////////////////////////////

  //Multivariate lineare Regression:
  //(X(T)X)^(-1)B(opt.) = X(T)Y  kann als lineares Gleichungssystem aufgefasst
  //                             werden, welches sich gut in Matrixform
  //                             (LGSMatrix_da_e) darstellen lt.
  //                             (X(T) steht fr die transponierte Matrix X)
  //X       = Regressormatrix_da_e
  //Y       = Regressandenmatrix bestehend aus einen Regressandenvektor fr
  //          jede Zielgre der Regressions (Zielgre = Intensitt einer
  //          bestimmten Linie oder Bande
  //B(opt.) = Regressionskoeffizientenmatrix = ErgebnisMatrix_da_e
  //X^(T)X  = Koeffizientenmatrix des LGS und X^(T)X  = LGSMatrix_da_e.
  //X(T)Y   = Absolutglieder des LGS: sie werden als zustzliche Spalten an die
  //          LGSMatrix_da_e angehngt wodurch LGSMatrix_da_e kompettiert wird.

  SetLength(LGSMatrix_da_e, Length(VAnalyseMatrix_da_e),
                              Length(VAnalyseMatrix_da_e)
                            + Length(ISubstanz[0].Intens_da_e));
  For z := 0 To High(VAnalyseMatrix_da_e) Do
            For s := 0 To High(VAnalyseMatrix_da_e) Do
                LGSMatrix_da_e[z, s] := VAnalyseMatrix_da_e[z, s];
  For s := Succ(High(LGSMatrix_da_e)) To High(LGSMatrix_da_e[0]) Do
      Begin
        For z := 0 To High(ISubstanz) Do
            SignalVektor_da_e[z]
                 := ISubstanz[z].Intens_da_e[s - Succ(High(LGSMatrix_da_e))];
        TMVektor_da_e := tmatrix_mal_vektor(regressormatrix_da_e,
                                            signalvektor_da_e);
        For z := 0 To High(TMVektor_da_e) Do
            LGSMatrix_da_e[z, s] := TMVektor_da_e[z];
        TMVektor_da_e := Nil;
      End;
  Result := MReg_b(LGSMatrix_da_e, ErgebnisMatrix_da_e);

  //Multivariate lineare Regression Ende
  //////////////////////////////////////////////////////////////////////////////

  If Result Then
     Begin

       /////////////////////////////////////////////////////////////////////////
       //Statistische Zusatzinformationen sammeln, falls angefordert

       //Falls multible Bestimmtheitsmae bentigt werden
       If Not(R2Vektor_da_e = Nil) Then
          For i := 0 To High(ISubstanz[0].Intens_da_e) Do
              R2Vektor_da_e[i] := R2_e(ISubstanz, ErgebnisMatrix_da_e, i);
       //Falls die Varianzen bentigt werden
       If Not(VarVektor_da_e = Nil) Then
          For i := 0 To High(ISubstanz[0].Intens_da_e) Do
              Begin
                //Fehlerquadratsummen
                FQSVektor_da_e[i] := FQS_e(ISubstanz, i, ErgebnisMatrix_da_e);
                //Varianz = Fehlerquadratsumme / Freiheitsgrade
                VarVektor_da_e[i] :=   FQSVektor_da_e[i]
                                     / (High(ISubstanz) - Dimension_i);
              End;
       //Falls Standardabweichungen von Schtzwert und wahren Wert bentigt 
       //werden (fr die Vertrauensintervalle)
       If Not(WahrIntensVektor_da_e = Nil) And
          Not(VIntervallVektor_da_e = Nil) And
          Not(VarVektor_da_e        = Nil) Then
          For i := 0 To High(ISubstanz[0].Intens_da_e) Do
              Begin
                VIntervallVektor_da_e[i] := 0;
                KParamVektor_da_e[0]     := 1;
                For z := 1 To High(KParamVektor_da_e) Do
                    KParamVektor_da_e[z] := ZuBestAufbSignal.KParam_da_e[Pred(z)];
                For z := 0 To High(IVAnalyseMatrix_da_e) Do
                    For s := 0 To High(IVAnalyseMatrix_da_e) Do
                        VIntervallVektor_da_e[i] :=   VIntervallVektor_da_e[i]
                                                    +   IVAnalyseMatrix_da_e[z, s]
                                                      * KParamVektor_da_e[z]
                                                      * KParamVektor_da_e[s];
                WahrIntensVektor_da_e[i] := SQRT(VIntervallVektor_da_e[i]);
                VIntervallVektor_da_e[i] := SQRT(VIntervallVektor_da_e[i] + 1);
                VIntervallVektor_da_e[i] :=   VIntervallVektor_da_e[i]
                                            * SQRT(VarVektor_da_e[i]);
                WahrIntensVektor_da_e[i] :=   WahrIntensVektor_da_e[i]
                                            * SQRT(VarVektor_da_e[i]);
              End;

       //t-Statistik
       If Statistik_b Then
          For i := 0 To High(ISubstanz[0].Intens_da_e) Do
              For z := 0 To High(TErgebnisMatrix_da_e) Do
                  TErgebnisMatrix_da_e[z, i] :=
                                         Abs(ErgebnisMatrix_da_e[z, i])
                                       * Sqrt(  (High(ISubstanz) - Dimension_i)
                                              / (  FQSVektor_da_e[i]
                                                 * IVAnalyseMatrix_da_e[z, z]));

       //Statistische Zusatzinformationen sammeln, falls angefordert Ende
       /////////////////////////////////////////////////////////////////////////

       /////////////////////////////////////////////////////////////////////////
       //Das Signal wird interpoliert
       With InterpAufbSignal Do
            Begin
              For i := 0 To High(KParam_da_e) Do
                  KParam_da_e[i] := ZuBestAufbSignal.KParam_da_e[i];
              Try For z := 0 To High(Intens_da_e) Do
                      Begin
                        Intens_da_e[z] := ErgebnisMatrix_da_e[0, z];
                        For s := 1 To High(RegressorMatrix_da_e[0]) Do
                            Intens_da_e[z] :=   Intens_da_e[z]
                                              + (  ErgebnisMatrix_da_e[s, z]
                                                 * Kparam_da_e[Pred(s)]     )
                      End;
              Except Result := False
                     End;
            End;
       //Interpolation Ende
       /////////////////////////////////////////////////////////////////////////

       /////////////////////////////////////////////////////////////////////////
       //Die Ergebnisse der Regressoranalyse werden ausgegeben
       If Statistik_b And Result Then
          StatistikInZWAblage(ErgebnisMatrix_da_e, TErgebnisMatrix_da_e,
                              VAnalyseMatrix_da_e, IVAnalyseMatrix_da_e,
                              VIntervallVektor_da_e,
                              WahrIntensVektor_da_e,
                              BIVektor_da_e,
                              R2Vektor_da_e,
                              FQSVektor_da_e,
                              det_e);
       //Ende
       /////////////////////////////////////////////////////////////////////////
     End;

  //////////////////////////////////////////////////////////////////////////////
  //Speicher wieder freigeben
  SetLength(RegressorMatrix_da_e, 0, 0);
  SetLength( VAnalyseMatrix_da_e, 0, 0);
  SetLength(IVAnalyseMatrix_da_e, 0, 0);
  SetLength( ErgebnisMatrix_da_e, 0, 0);
  KParamVektor_da_e := Nil;
  SignalVektor_da_e := Nil;
  FQSVektor_da_e    := Nil;
  If Not(Result) Then
     Begin
       InterpAufbSignal.KParam_da_e := Nil;
       InterpAufbSignal.Intens_da_e := Nil
     End;
  If Statistik_b Then
     Begin
       R2Vektor_da_e         := Nil;
       VarVektor_da_e        := Nil;
       BIVektor_da_e         := Nil;
       VIntervallVektor_da_e := Nil;
       WahrIntensVektor_da_e := Nil;
       SetLength(TErgebnisMatrix_da_e, 0, 0);
     End;
  //Speicher freigeben Ende
  //////////////////////////////////////////////////////////////////////////////
End;




Procedure tDatenbank.VarRedInfo(    SubstDatname_s   : String;
                                Var ZuBestAufbSignal : TAufbSignal);

Procedure LinNamenSchreiben(Var Clipboard_s : String;
                                LinZahl_i   : Integer);

Var s, z, i : Integer;

Begin //LinNamenSchreiben
  Clipboard_s := 'Variablenreduktionsanalyse' + Chr(13) + Chr(13);
  Clipboard_s := Clipboard_s + 'Benutzte Klassifizierungsparameter';
  For i := 1 To 5 Do Clipboard_s := Clipboard_s + Chr(9);
  Clipboard_s := Clipboard_s + 'Varianzen';
  For i := 0 To LinZahl_i Do Clipboard_s := Clipboard_s + Chr(9);
  Clipboard_s :=   Clipboard_s
                 + 'Multible Bestimmtheitsmae R^2'
                 + Chr(13) + Chr(13);
  For s := 1 To 5 Do Clipboard_s := Clipboard_s + IntToStr(s) + Chr(9);
  For i := 0 To 1 Do
      Begin
        z := 0;
        For s := 0 To LinZahl_i Do
            Begin
              While AWStil.LinienGew_a_i[z] = 0 Do Inc(z);
              Clipboard_s := Clipboard_s + DBInfo.Linien_a_s[z] + Chr(9);
              Inc(z)
            End;
      End;
  Clipboard_s := Clipboard_s + 'Klassifizierungsparameter';
  Clipboard_s := Clipboard_s + Chr(13);
End;

type TPermutation_a_b = Array[0..30, 0..4] of Boolean;

Const Permutation_a_b: TPermutation_a_b = ((False, False, False, False, False),

                                           (True,  True,  True,  True,  False),
                                           (True,  True,  True,  False, True ),
                                           (True,  True,  False, True,  True ),
                                           (True,  False, True,  True,  True ),
                                           (False, True,  True,  True,  True ),

                                           (True,  True,  True,  False, False),
                                           (True,  True,  False, False, True ),
                                           (True,  False, False, True,  True ),
                                           (False, False, True,  True,  True ),
                                           (False, True,  False, True,  True ),
                                           (True,  False, True,  False, True ),
                                           (True,  True,  False, True,  False),
                                           (False, True,  True,  False, True ),
                                           (True,  False, True,  True,  False),
                                           (False, True,  True,  True,  False),

                                           (False, False, False, True,  True ),
                                           (False, False, True,  True,  False),
                                           (False, True,  True,  False, False),
                                           (True,  True,  False, False, False),
                                           (True,  False, True,  False, False),
                                           (False, True,  False, True,  False),
                                           (False, False, True,  False, True ),
                                           (True,  False, False, True,  False),
                                           (False, True,  False, False, True ),
                                           (True,  False, False, False, True ),

                                           (False, False, False, False, True ),
                                           (False, False, False, True,  False),
                                           (False, False, True,  False, False),
                                           (False, True,  False, False, False),
                                           (True,  False, False, False, False));

Var FileOfGespSignal      : TFileOfGespSignal;
    Ok_b                  : Boolean;
    Substanz              : TSubstanz;
    z, s, i, j            : Integer;
    R2Vektor_da_e         : TVektor_da_e;
    VarVektor_da_e        : TVektor_da_e;
    VIntervallVektor_da_e : TVektor_da_e;
    WahrIntensVektor_da_e : TVektor_da_e;
    ErgAufbSignal         : TAufbSignal;
    Clipboard_s           : String;
    AClipboard            : TClipboard;
    RedZuBestAufbSignal   : TAufbSignal;

Begin
  AClipboard := Clipboard;

  If Not(DBVorhanden_b) Then laden_b; //Die Datenbank laden, falls dies noch
                                      //nicht geschehen ist

  Ok_b := True;

  If DBVorhanden_b  And Ok_b Then
     For z := 0 To 30 Do
         Begin
           Try AssignFile(FileOfGespSignal,SubstDatName_s);
               Reset(FileOfGespSignal);
               ok_b := True;
           Except ok_b := False
                  End;
           If ok_b Then
              ok_b := SubstanzLaden_b(FileOFGespSignal, Substanz);
           Try CloseFile(FileOfGespSignal);
           Except ok_b := False
                  End;
           If Length(Substanz) = 0 Then ok_b := False;

           If ok_b Then
              Begin
                Filtern(Substanz, ZuBestAufbSignal);
                SetLength(RedZuBestAufbSignal.KParam_da_e,
                          Length(ZuBestAufbSignal.KParam_da_e));
                For s := 0 To High(ZuBestAufbSignal.KParam_da_e) Do
                    RedZuBestAufbSignal.KParam_da_e[s] := ZuBestAufbSignal.KParam_da_e[s];
                If Length(VarVektor_da_e) = 0 Then
                   Begin
                     SetLength(VarVektor_da_e, Length(Substanz[0].Intens_da_e));
                     SetLength(R2Vektor_da_e,  Length(Substanz[0].Intens_da_e));
                     LinNamenSchreiben(Clipboard_s, High(Substanz[0].Intens_da_e));
                   End;

                For s := 4 Downto 0 Do
                    If Permutation_a_b[z, s] Then
                       Begin
                         For j := 0 To High(Substanz) Do
                             With Substanz[j] Do
                                  Begin
                                    For i := Succ(s) To High(KParam_da_e) Do
                                        KParam_da_e[Pred(i)]:= KParam_da_e[i];
                                    SetLength(KParam_da_e, Pred(Length(KParam_da_e)))
                                  End;
                         With RedZuBestAufbSignal Do
                              Begin
                                For i := Succ(s) To High(KParam_da_e) Do
                                    KParam_da_e[Pred(i)]:= KParam_da_e[i];
                                SetLength(KParam_da_e, Pred(Length(KParam_da_e)))
                              End;
                       End;

                ok_b := RegressInterpolation_b(Substanz,
                                               RedZuBestAufbSignal,
                                               ErgAufbSignal,
                                               VarVektor_da_e,
                                               R2Vektor_da_e,
                                               VIntervallVektor_da_e,
                                               WahrIntensVektor_da_e,
                                               Length(Substanz[0].KParam_da_e),
                                               False, False);
                If Ok_b Then
                   Begin
                     For s := 0 To 4 Do
                         If Permutation_a_b[z, s] Then Clipboard_s :=   Clipboard_s
                                                                      + '-'
                                                                      + Chr(9)
                                                  Else Clipboard_s :=   Clipboard_s
                                                                      + '+'
                                                                      + Chr(9);
                     For s := 0 To High(VarVektor_da_e) Do
                         Clipboard_s :=   Clipboard_s
                                        + FloatToStr(VarVektor_da_e[s])
                                        + Chr(9);
                     For s := 0 To High(VarVektor_da_e) Do
                         Clipboard_s :=   Clipboard_s
                                        + FloatToStr(R2Vektor_da_e[s])
                                        + Chr(9);
                     For s := 0 To High(RedZuBestAufbSignal.KParam_da_e) Do
                         Clipboard_s :=   Clipboard_s
                                        + FloatToStr(RedZuBestAufbSignal.KParam_da_e[s])
                                        + Chr(9);
                     Clipboard_s[Length(Clipboard_s)] := Chr(13);
                   End;
              End;
         End;
  VarVektor_da_e := Nil;
  R2Vektor_da_e  := Nil;
  AClipboard.Clear;
  AClipboard.AsText := Clipboard_s;
End;




Procedure tDatenbank.OutSubstanzvergleich(SubstDatName1_s : String;
                                          SubstDatName2_s : String;
                                          Robust_b        : Boolean);

Procedure LinNamenSchreiben(Var Clipboard_s : String;
                                LinZahl_i   : Integer);

Var s, z : Integer;

Begin //LinNamenSchreiben
  For s := 1 To AWStil.Unabhaengige_i Do Clipboard_s := Clipboard_s + Chr(9);
  z := 0;
  For s := 0 To LinZahl_i Do
      Begin
        While AWStil.LinienGew_a_i[z] = 0 Do Inc(z);
        Clipboard_s := Clipboard_s + DBInfo.Linien_a_s[z] + Chr(9);
        Inc(z)
      End;
  Clipboard_s[Length(Clipboard_s)] := Chr(13);
End;

Procedure SubstanzSchreiben(Var Clipboard_s : String;
                            Var Substanz    : TSubstanz);

Var s, z : Integer;


Begin //SubstanzSchreiben
  For z := 0 To High(Substanz) Do
      Begin
        For s := 0 To Pred(AWStil.Unabhaengige_i) Do
            Clipboard_s :=   Clipboard_s
                           + FloatToStr(Substanz[z].KParam_da_e[s])
                           + Chr(9);
        For s := 0 To High(Substanz[z].Intens_da_e) Do
            Clipboard_s :=   Clipboard_s
                            + FloatToStr(Substanz[z].Intens_da_e[s])
                            + Chr(9);
        Clipboard_s[Length(Clipboard_s)] := Chr(13);
      End;
End;

Procedure MatrixSchreiben(Var Clipboard_s    : String;
                          //Var InterpSubstanz : TSubstanz;
                          Var Matrix_da_e    : TMatrix_da_e;
                              Text_s         : String;
                              Mittelwert_b   : Boolean);

Var s, z         : Integer;
    SVektor_da_e : TVektor_da_e;

Begin //MatrixSchreiben
  Clipboard_s :=   Clipboard_s
                 + Chr(13) + Chr(13)
                 + Text_s
                 + Chr(13) + Chr(13);
  SetLength(SVektor_da_e, Length(Matrix_da_e[0]));
  LinNamenSchreiben(Clipboard_s, High(Matrix_da_e[0]));
  For s := 0 To High(SVektor_da_e) Do SVektor_da_e[s] := 0;
  For z := 0 To High(Matrix_da_e) Do
      Begin
        For s := 0 To Pred(AWStil.Unabhaengige_i) Do
            Clipboard_s := Clipboard_s + Chr(9);
        For s := 0 To High(Matrix_da_e[z]) Do
            Begin
              Clipboard_s :=   Clipboard_s
                              + FloatToStr(Matrix_da_e[z, s])
                              + Chr(9);
              SVektor_da_e[s] := SVektor_da_e[s] + Matrix_da_e[z, s];
            End;
        Clipboard_s[Length(Clipboard_s)] := Chr(13);
      End;
  If Mittelwert_b Then
     Begin
       For s := 0 To AWStil.Unabhaengige_i - 2 Do Clipboard_s := Clipboard_s + Chr(9);
       Clipboard_s := Clipboard_s + 'Mittelwert:' + Chr(9);
       For s := 0 To High(SVektor_da_e) Do
           Clipboard_s :=   Clipboard_s
                          + FloatToStr(SVektor_da_e[s] / Length(Matrix_da_e))
                          + Chr(9);
     End;
  SetLength(Clipboard_s, Pred(Length(Clipboard_s)));
  SVektor_da_e := Nil;
End;

Function Mittelwert_e(Var Substanz    : TSubstanz;
                          Regressor_i : Integer) : Extended;

Var i : Integer;

Begin //Mittelwert_e
  Result := 0;
  If Length(Substanz) > 0 Then
     Begin
       For i := 0 To High(Substanz) Do
           Result := Result + Substanz[i].KParam_da_e[Regressor_i];
       Result := Result / Length(Substanz);
     End;
End;

Procedure Standardisieren(Var Substanz1 : TSubstanz;
                          Var Substanz2 : TSubstanz);

//Substanz1 und Substanz2 werden auf die Klassifzierungsparameter von Substanz1
//standardisiert.

Var i, k   : Integer;
    WSQX_e : Extended; //Wurzel der Abweichungsquadratsumme von den Mittelwerten
    //MW_e   : Extended; //Mittelwert

Begin  //Normieren
  For i := 0 To 4 Do
      Begin
        WSQX_e := SQRT(SQX_e(Substanz1, i));
        //MW_e   := Mittelwert_e(Substanz1, i);
        For k := 0 To High(Substanz1) Do
            Substanz1[k].KParam_da_e[i] :=   (Substanz1[k].KParam_da_e[i]{ - MW_e})
                                           / WSQX_e;
        For k := 0 To High(Substanz2) Do
            Substanz2[k].KParam_da_e[i] :=   (Substanz2[k].KParam_da_e[i]{ - MW_e})
                                           / WSQX_e;
      End;
End;

Function VLaenge_e(Var Vektor_da_e : TVektor_da_e) : Extended;

Var i : Integer;

Begin  //tdatenbank.VektorLaenge_e
  Result := 0;
  For i := 0 To High(Vektor_da_e) Do
      If Not(AWSTil.SGewicht_a_e[i] = 0) Then Result := Result + Sqr(Vektor_da_e[i]);
  Result := Sqrt(Result)
End;

Procedure AllgInZwischenablage(Var Clipboard_s : String;
                               Var InterpSubstanz   : TSubstanz;
                                   AnzMessungen_i, Freiheitsgrade_i : Integer );

Var z : Integer;

Begin
  //Fr welche Substanz wurden die Schtzwerte bestimmt
  Clipboard_s := Clipboard_s + 'Schtzwerte fr:' + Chr(9) + SubstDatName2_s;
  If Not(SubstDatName1_s = SubstDatName2_s) Then
     Clipboard_s :=   Clipboard_s
                    + CHr(13)
                    + 'Schtzwerte auf Basis der Klassifizierungsparameter von:'
                    + Chr(9)
                    + SubstDatName1_s;
  Clipboard_s := Clipboard_s + Chr(13) + Chr(13);

  Clipboard_s :=   Clipboard_s
                 + 'Anzahl der Messungen:' + Chr(9)
                 + IntToStr(AnzMessungen_i)
                 + Chr(13);
  Clipboard_s :=   Clipboard_s
                 + 'Anzahl der Freiheitsgrade:' + Chr(9)
                 + IntToStr(Freiheitsgrade_i)
                 + Chr(13);
  Clipboard_s :=   Clipboard_s
                 + 'Anzahl der Unabhngigen:' + Chr(9)
                 + IntToStr(AWStil.Unabhaengige_i)
                 + Chr(13);
  Clipboard_s :=   Clipboard_s
                 + 'Gewichtung bei der Filterung der Signale vor der Regression:'
                 + Chr(9);
  For z := 0 To 4 Do
      Clipboard_s := Clipboard_s + FloatToStr(AWStil.SGewicht_a_e[z]*100) + Chr(9);
  Clipboard_s :=   Clipboard_s
                 + 'Anteil der Signale, die fr die Regressions'
                 + 'rechnung verwendet worden sind:'
                 + Chr(9)
                 + FloatToStr(AWStil.RAnteil_e * 100);
  Clipboard_s := Clipboard_s + Chr(13) + Chr(13) + Chr(13);

  Clipboard_s := Clipboard_s + 'Schtzwerte' + Chr(13) + Chr(13);
  Clipboard_s := Clipboard_s + 'Klassifizierungsparameter';
  LinNamenSchreiben(Clipboard_s, High(InterpSubstanz[0].Intens_da_e));
  SubstanzSchreiben(Clipboard_s, InterpSubstanz);
End;

Procedure VergleichswerteInZwischenablage(Var Clipboard_s                      : String;
                                          Var Substanz1                        : TSubstanz;
                                              SubstDatName1_s, SubstDatName2_s : String);
Begin
  //Nicht interpolierte Signalflchen ausgeben = Die Signalflchen, die
  //bei den verwendeten Klassifizierungsparametern gemessen worden sind
  Clipboard_s :=   Clipboard_s + Chr(13) + Chr(13);
  If SubstDatName1_s = SubstDatName2_s Then Clipboard_s :=   Clipboard_s
                                                          + 'Orginalwerte'
                                       Else Clipboard_s :=   Clipboard_s
                                                          + 'Vergleichswerte';
  Clipboard_s := Clipboard_s + Chr(13) + Chr(13) + 'Klassifizierungsparameter';
  LinNamenSchreiben(Clipboard_s, High(Substanz1[0].Intens_da_e));
  SubstanzSchreiben(Clipboard_s, Substanz1);
End;

Procedure DistanzenInZwischenablage(Var Clipboard_s                      : String;
                                    Var Substanz1, Substanz2,
                                        InterpSubstanz                   : TSubstanz;
                                        SubstDatName1_s, SubstDatName2_s : String);

Var z, s, k : Integer;
    min_i   : Integer;

Begin  //DistanzenInZwischenablage
  If Not(SubstDatName1_s = SubstDatName2_s) Then
     Begin
       Clipboard_s :=   Clipboard_s
                      + Chr(13) + Chr(13) + Chr(13)
                      + 'Distanzen (Standardisierter Vektor) zu den dichtesten '
                      + 'Regressorvektor im eigenen Datensatz:';
       Clipboard_s :=   Clipboard_s
                      + Chr(9)
                      + 'Standardisierte Klassifizierungsparameter der '
                      + 'interpolierten Signale:';
       For s := 0 To 4 Do Clipboard_s := Clipboard_s + Chr(9);
       Clipboard_s :=   Clipboard_s
                      + 'Standardisierte Klassifizierungsparameter des '
                      + 'Orginalsignals mit dem gerinsten Abstand:';
       For s := 0 To 4 Do Clipboard_s := Clipboard_s + Chr(9);
       Clipboard_s :=   Clipboard_s
                      + 'Distanz im Verhltnis zur Gesamtvetorlnge:';

       Standardisieren(Substanz1, Substanz2);
       For k := 0 To High(InterpSubstanz) Do
           Begin
             min_i := 0;
             For s := 0 To High(Substanz2) Do
                 With Substanz2[s] Do
                      Begin
                        //Bestimmung des absoluten Abstandes
                        Abstand_e := 0;
                        For z := 0 To High(KParam_da_e) Do
                            If Not(AWStil.SGewicht_a_e[z] = 0) Then
                               Abstand_e := Abstand_e + SQR(  Substanz1[k].KParam_da_e[z]
                                                            - Substanz2[s].KParam_da_e[z]);
                        Abstand_e := SQRT(Abstand_e);
                        If Abstand_e < Substanz2[min_i].Abstand_e Then min_i := s;
                      End;
             InterpSubstanz[k].Abstand_e := Substanz2[min_i].Abstand_e;

             Clipboard_s :=   Clipboard_s
                            + Chr(13)
                            + FloatToStr(Substanz2[min_i].Abstand_e);
             For s := 0 To High(Substanz1[k].KParam_da_e) Do
                 Clipboard_s :=   Clipboard_s
                                + Chr(9)
                                + FloatToStr(Substanz1[k].KParam_da_e[s]);
             For s := 0 To High(Substanz2[min_i].KParam_da_e) Do
                   Clipboard_s :=   Clipboard_s
                                  + Chr(9)
                                  + FloatToStr(Substanz2[min_i].KParam_da_e[s]);
             //Klassifizierungsparameter relativ zur Vektorlnge
             Clipboard_s :=   Clipboard_s
                            + Chr(9)
                            + FloatToStr(  Substanz2[min_i].Abstand_e
                                         / VLaenge_e(Substanz1[k].KParam_da_e));

           End;
     End;
End;

Procedure InZwischenablage(Var Substanz1, Substanz2, InterpSubstanz   : TSubstanz;
                           Var VarMatrix_da_e, R2Matrix_da_e          : TMatrix_da_e;
                           Var StabwSWMatrix_da_e, StabwWWMatrix_da_e : TMatrix_da_e;
                               SubstDatName1_s, SubstDatName2_s       : String;
                               Freiheitsgrade_i                       : Integer;
                               AnzMessungen_i                         : Integer);

Var Clipboard_s      : String;
    z, s, k          : Integer;
    AClipboard       : TClipboard;
    zahl_e           : Extended;
    min_i            : Integer;
    PQuant_i, PDec_i : Integer;
    NQuant_i, NDec_i : Integer;
    PQuart_e, PDec_e : Extended;
    NQuart_e, NDec_e : Extended;
    QDMatrix_da_e    : TMatrix_da_e;
    ASubstanz        : TSubstanz;


Begin //InZwischenablage
  AClipboard := Clipboard;

  AllgInZwischenablage(Clipboard_s, InterpSubstanz, AnzMessungen_i, Freiheitsgrade_i);

  MatrixSchreiben(Clipboard_s, VarMatrix_da_e, 'Varianzen', True);
  MatrixSchreiben(Clipboard_s, R2Matrix_da_e,  'Multible Bestimmtheitsmae R^2',
                  True);
  MatrixSchreiben(Clipboard_s, StabwSWMatrix_da_e,
                  'Standardabweichung der Schtzwerte', True);
  MatrixSchreiben(Clipboard_s, StabwWWMatrix_da_e,
                  'Standardabweichung der wahren Werte', True);

  VergleichswerteInZwischenablage(Clipboard_s, Substanz1,
                                  SubstDatName1_s, SubstDatName2_s);

  DistanzenInZwischenablage(Clipboard_s, Substanz1, Substanz2, InterpSubstanz,
                            SubstDatName1_s, SubstDatName2_s);

  AClipboard.Clear;
  AClipboard.AsText := Clipboard_s;
End;

Procedure RobustInZwischenablage(Var Substanz1, Substanz2, InterpSubstanz : TSubstanz;
                                     SubstDatName1_s, SubstDatName2_s      : String;
                                     Freiheitsgrade_i                       : Integer;
                                     AnzMessungen_i                         : Integer);

Var Clipboard_s      : String;
    z, s, k          : Integer;
    AClipboard       : TClipboard;
    zahl_e           : Extended;
    min_i            : Integer;
    PQuant_i, PDec_i : Integer;
    NQuant_i, NDec_i : Integer;
    PQuart_e, PDec_e : Extended;
    NQuart_e, NDec_e : Extended;
    QDMatrix_da_e    : TMatrix_da_e;
    ASubstanz        : TSubstanz;


Begin //InZwischenablage
  AClipboard := Clipboard;

  AllgInZwischenablage(Clipboard_s, InterpSubstanz, AnzMessungen_i, Freiheitsgrade_i);
  VergleichswerteInZwischenablage(Clipboard_s, Substanz1,
                                  SubstDatName1_s, SubstDatName2_s);

  //Differenz zwischen gemessenen und interpolierten Wert
  Clipboard_s :=   Clipboard_s + Chr(13) + Chr(13);
  Clipboard_s :=   Clipboard_s + 'Differenz zwischen gemessenen und interpolierten Werten';
  Clipboard_s := Clipboard_s + Chr(13) + Chr(13) + 'Klassifizierungsparameter';
  LinNamenSchreiben(Clipboard_s, High(Substanz1[0].Intens_da_e));
  For z := 0 To High(Substanz1) Do
      Begin
        For s := 0 To Pred(AWStil.Unabhaengige_i) Do
            Clipboard_s :=   Clipboard_s
                           + FloatToStr(Substanz1[z].KParam_da_e[s])
                           + Chr(9);
        For s := 0 To High(Substanz1[z].Intens_da_e) Do
            Clipboard_s :=   Clipboard_s
                            + FloatToStr(  Substanz1[z]     .Intens_da_e[s]
                                         - InterpSubstanz[z].Intens_da_e[s])
                            + Chr(9);
        Clipboard_s[Length(Clipboard_s)] := Chr(13);
      End;

  //Quartile und Dezile
  SetLength(QDMatrix_da_e, 78, Length(Substanz1[0].Intens_da_e));
  SetLength(ASubstanz, Length(Substanz1));
  For s := 0 To High(Substanz1[0].Intens_da_e) Do
      Begin
        For z := 0 To High(Substanz1) Do
            ASubstanz[z].Abstand_e :=   Substanz1[z].     Intens_da_e[s]
                                      - InterpSubstanz[z].Intens_da_e[s];
        ASortieren(ASubstanz);

        For z := 0 To 4 Do
            QDMatrix_da_e[z,      s] := ASubstanz[Round(High(ASubstanz) * 0.25  * z)].
                                        Abstand_e;
        For z := 0 To 10 Do
            QDMatrix_da_e[z +  5, s] := ASubstanz[Round(High(ASubstanz) * 0.1   * z)].
                                        Abstand_e;
        For z := 0 To 20 Do
            QDMatrix_da_e[z + 16, s] := ASubstanz[Round(High(ASubstanz) * 0.05  * z)].
                                        Abstand_e;
        For z := 0 To 40 Do
            QDMatrix_da_e[z + 37, s] := ASubstanz[Round(High(ASubstanz) * 0.025 * z)].
                                        Abstand_e;
      End;
  MatrixSchreiben(Clipboard_s, QDMatrix_da_e, 'Quartile, Decile, ...', False);
  SetLength(QDMatrix_da_e, 0, 0);
  SetLength(ASubstanz, 0);

  DistanzenInZwischenablage(Clipboard_s, Substanz1, Substanz2, InterpSubstanz,
                            SubstDatName1_s, SubstDatName2_s);

  AClipboard.Clear;
  AClipboard.AsText := Clipboard_s;
End;

Var FileOfGespSignal     : TFileOfGespSignal;
    ok_b                 : Boolean;
    i, j                 : Integer;
    Substanz1, Substanz2 : TSubstanz;
    InterpSubstanz       : TSubstanz;
    Freiheitsgrade_i     : Integer;
    AnzMessungen_i       : Integer;
    VarVektor_da_e       : TVektor_da_e;
    VarMatrix_da_e       : TMatrix_da_e;
    R2Vektor_da_e        : TVektor_da_e;
    R2Matrix_da_e        : TMatrix_da_e;
    StAbwSWVektor_da_e   : TVektor_da_e; //Standardabweichung Schtzwert
    StAbwSWMatrix_da_e   : TMatrix_da_e;
    StAbwWWVektor_da_e   : TVektor_da_e; //Standardaweichung wahrer Wert
    StAbwWWMatrix_da_e   : TMatrix_da_e;

Begin //OutSubstanzvergleich
  If Not(DBVorhanden_b) Then laden_b; //Die Datenbank laden, falls dies noch
                                      //nicht geschehen ist

  If DBVorhanden_b Then
     Begin
       Try AssignFile(FileOfGespSignal,SubstDatName1_s);
           Reset(FileOfGespSignal);
           ok_b := True;
       Except ok_b := False
              End;
       If ok_b Then
          ok_b := SubstanzLaden_b(FileOFGespSignal, InterpSubstanz);
       Try CloseFile(FileOfGespSignal);
       Except ok_b := False
              End;

       Try AssignFile(FileOfGespSignal,SubstDatName1_s);
           Reset(FileOfGespSignal);
           ok_b := True;
       Except ok_b := False
              End;
       If ok_b Then
          ok_b := SubstanzLaden_b(FileOFGespSignal, Substanz1);
       Try CloseFile(FileOfGespSignal);
       Except ok_b := False
              End;
       If Length(InterpSubstanz) = 0 Then Ok_b := False;
       If ok_b Then
          Begin
            If Not(Robust_b) Then
               Begin
                 SetLength(VarVektor_da_e,     Length(InterpSubstanz[0].Intens_da_e));
                 SetLength(R2Vektor_da_e,      Length(InterpSubstanz[0].Intens_da_e));
                 SetLength(StAbwSWVektor_da_e, Length(InterpSubstanz[0].Intens_da_e));
                 SetLength(StAbwWWVektor_da_e, Length(InterpSubstanz[0].Intens_da_e));

                 SetLength(VarMatrix_da_e,     Length(InterpSubstanz),
                                               Length(InterpSubstanz[0].Intens_da_e));
                 SetLength(R2Matrix_da_e,      Length(InterpSubstanz),
                                               Length(InterpSubstanz[0].Intens_da_e));
                 SetLength(StAbwSWMatrix_da_e, Length(InterpSubstanz),
                                               Length(InterpSubstanz[0].Intens_da_e));
                 SetLength(StAbwWWMatrix_da_e, Length(InterpSubstanz),
                                               Length(InterpSubstanz[0].Intens_da_e));
               End;
            For i := 0 To High(InterpSubstanz) Do
                Begin
                  Try AssignFile(FileOfGespSignal,SubstDatName2_s);
                      Reset(FileOfGespSignal);
                      ok_b := True;
                  Except ok_b := False
                         End;
                  If ok_b Then
                     ok_b := SubstanzLaden_b(FileOFGespSignal, Substanz2);
                  Try CloseFile(FileOfGespSignal);
                  Except ok_b := False
                         End;

                  If ok_b Then
                     ok_b := RegressInterpolation_b(Substanz2,
                                                    Substanz1[i],
                                                    InterpSubstanz[i],
                                                    VarVektor_da_e,
                                                    R2Vektor_da_e,
                                                    StAbwSWVektor_da_e,
                                                    StAbwWWVektor_da_e,
                                                    AWStil.Unabhaengige_i,
                                                    False, True);
                  If i = 0 Then
                     Begin
                       Freiheitsgrade_i :=   High(Substanz2)
                                           - AWStil.Unabhaengige_i;
                       AnzMessungen_i   := Length(Substanz2);
                     End;
                  If Not(Robust_b) Then
                     For j := 0 To High(VarVektor_da_e) Do
                         Begin
                           VarMatrix_da_e[i, j]     := VarVektor_da_e[j];
                           R2Matrix_da_e[i, j]      := R2Vektor_da_e[j];
                           StAbwSWMatrix_da_e[i, j] := StAbwSWVektor_da_e[j];
                           StAbwWWMatrix_da_e[i, j] := StAbwWWVektor_da_e[j];
                         End;
                End;
            VarVektor_da_e     := Nil;
            R2Vektor_da_e      := Nil;
            StAbwSWVektor_da_e := Nil;
            StAbwWWVektor_da_e := Nil;
          End;
     End;
  Try AssignFile(FileOfGespSignal,SubstDatName2_s);
      Reset(FileOfGespSignal);
      ok_b := True;
  Except ok_b := False
         End;
  If ok_b Then
     ok_b := SubstanzLaden_b(FileOFGespSignal, Substanz2);
  Try CloseFile(FileOfGespSignal);
  Except ok_b := False
         End;

  If ok_b Then
     If Robust_b Then RobustInZwischenablage(Substanz1,
                                             Substanz2,
                                             InterpSubstanz,
                                             SubstDatName1_s,
                                             SubstDatName2_s,
                                             Freiheitsgrade_i,
                                             AnzMessungen_i)
               Else         InZwischenablage(Substanz1,
                                             Substanz2,
                                             InterpSubstanz,
                                             VarMatrix_da_e,
                                             R2Matrix_da_e,
                                             StAbwSWMatrix_da_e,
                                             StAbwWWMatrix_da_e,
                                             SubstDatName1_s,
                                             SubstDatName2_s,
                                             Freiheitsgrade_i,
                                             AnzMessungen_i);

  SetLength(VarMatrix_da_e,      0, 0);
  SetLength(R2Matrix_da_e,       0, 0);
  SetLength(StAbwSWMatrix_da_e,  0, 0);
  SetLength(StAbwWWMatrix_da_e,  0, 0);
  SubstanzFreigeben(Substanz1);
  SubstanzFreigeben(Substanz2);
  SubstanzFreigeben(InterpSubstanz);
End;



Procedure tdatenbank.OutInterpolation(Var ZuBestAufbSignal   : TAufbSignal;
                                      Var InterpolAufbSignal : TAufbSignal;
                                      Var Linien_a_s         : TLinien_a_s;
                                          SubstDatName_s     : String;
                                      Var VerwSignSubstanz   : TSubstanz;
                                          VerwSign_b         : Boolean;
                                          Statistik_b        : Boolean;
                                          VReduktion_b       : Boolean);

Var FileOfGespSignal      : TFileOfGespSignal;
    ok_b                  : Boolean;
    i, j                  : Integer;
    VarVektor_da_e        : TVektor_da_e;
    R2Vektor_da_e         : TVektor_da_e;
    VIntervallVektor_da_e : TVektor_da_e;
    WahrIntensVektor_da_e : TVektor_da_e;

Begin //tdatenbank.OutInterpolation
  If Not(DBVorhanden_b) Then laden_b; //Die Datenbank laden, falls dies noch
                                      //nicht geschehen ist

  j := 1;                   //Bezeichnungen der Linien bergeben
  For i := 1 To 60 Do
      Begin
        Linien_a_s[i] := '';
        If Not(AWStil.LinienGew_a_i[i] = 0                ) And
           Not(i                       = AWStil.PrimSign_i) And
           Not(i                       = AWStil.Offset_i  ) Then
           Begin
             Linien_a_s[j] := DBInfo.linien_a_s[i];
             Inc(j)
           End
      End;

  If DBVorhanden_b Then
     Begin
       Try AssignFile(FileOfGespSignal,SubstDatName_s);
           Reset(FileOfGespSignal);
           ok_b := True;
       Except ok_b := False
              End;

       If ok_b Then
          ok_b := SubstanzLaden_b(FileOFGespSignal, Substanz);

       If ok_b And Not(Substanz = Nil) Then
          ok_b := RegressInterpolation_b(Substanz,
                                         ZuBestAufbSignal,
                                         InterpolAufbSignal,
                                         VarVektor_da_e,
                                         R2Vektor_da_e,
                                         VIntervallVektor_da_e,
                                         WahrIntensVektor_da_e,
                                         AWStil.Unabhaengige_i,
                                         Statistik_b, True);

       Try CloseFile(FileOfGespSignal);
           Except ok_b := False
           End;
       If VerwSign_b Then
          Begin
            VerwSignSubstanz := Substanz;
            Substanz         := Nil;
          End
          Else
          SubstanzFreigeben(Substanz)
     End;
  If VReduktion_b Then VarRedInfo(SubstDatName_s, ZuBestAufbSignal);
  ZuBestAufbSignalFreigeben(ZuBestAufbSignal);
  //Speicher Freigeben
End;




Function tdatenbank.Signalbestimmung(Var ZuBestAufbSignal   : TAufbSignal;
                                     Var InterpolAufbSignal : TAufbSignal;
                                     Var Distanzen          : TDistanzen;
                                     Var GewVektor_da_e     : TVektor_da_e;
                                         ZEInfo_b           : Boolean;
                                     Var Ergebnis_s         : String) : Boolean;

Type
     TDiffVektoren_da_e = Array Of TVektor_da_e;
     Ta_i               = Array[0..4] Of Integer;

Function Wertebereich_b(Var Substanz         : TSubstanz;
                        Var ZuBestAufbSignal : TAufbSignal) : Boolean;

//Liegen die Elemente der Klassifizierungsparametervektors des zu bestimmenden
//Signals berhaupt innerhalb des Wertebereichs der Vektorelemente der jeweili-
//gen Substanz?

Var Max_e, Min_e : Extended;
    i, param_i   : Integer;

Begin //Wertebereich_b
  Result := True;
  For Param_i := 0 To High(Substanz[0].KParam_da_e) Do
      If AWStil.Wertebereiche_s[Succ(Param_i)] = '0' Then
         Begin
           Max_e := Substanz[0].KParam_da_e[param_i];
           Min_e := Substanz[0].KParam_da_e[param_i];
           For i := 1 To High(Substanz) Do
               Begin
                 If Substanz[i].KParam_da_e[param_i] > max_e Then
                    max_e := Substanz[i].KParam_da_e[param_i];
                 If Substanz[i].KParam_da_e[param_i] < min_e Then
                    min_e := Substanz[i].KParam_da_e[param_i];
               End;
           If Not(    (ZuBestAufbSignal.KParam_da_e[param_i] > min_e)
                  And (ZuBestAufbSignal.KParam_da_e[param_i] < max_e)) Then
              Result := False;
         End;
End;

Procedure DistanzenSortieren(Var Distanzen : TDistanzen); //Sortieren der Sub-
                            //stanzen nach hnlichkeit im Shell-Sort-Algorithmus
Var bis_i, i, j, k : Integer;
    PufferDist    : TDist;

begin //DistanzenSortieren
  If High(Distanzen) = 1 Then
     If Distanzen[0].Distanz_e > Distanzen[1].Distanz_e Then
        Begin
          PufferDist   := Distanzen[0];
          Distanzen[0] := Distanzen[1];
          Distanzen[1] := PufferDist
        End;
  bis_i := High(Distanzen);
  k     := bis_i SHR 1;  //entspricht Div 2
  While k > 0 Do
        Begin
          For i := 0 To bis_i - k Do
              Begin
                j := i;
                While (j >= 0)                                               And
                      (Distanzen[j].distanz_e > Distanzen[j + k].distanz_e) Do
                      Begin //Zeiger tauschen
                        PufferDist       := Distanzen[j];
                        Distanzen[j]     := Distanzen[j + k];
                        Distanzen[j + k] := PufferDist;
                        If j > k Then Dec(j, k) Else j := 0
                      End
              End;
          k := k Shr 1; //entspricht Div 2
        End
End;

Procedure DistanzBestimmung(Var Distanzen                : TDistanzen;
                            Var AAufbSignal, BAufbSignal : TAufbSignal;
                                Index_i                  : Integer);
Begin //DistanzBestimmung
  Distanzen[index_i].Distanz_e := VektorDistanz_e(AAufbSignal.Intens_da_e,
                                                  BAufbSignal.Intens_da_e);
  Distanzen[index_i].Wertebereich_b := Wertebereich_b(Substanz, AAufbSignal);
End;

Procedure InZwischenablage(ZuBestAufbSignal   : TAufbSignal;
                           InterpolErgebnis_s : String;
                           MinDistSign_s      : String;
                           Ergebnis_s         : String);

Var Clipboard_s    : String;
    z, s, i, bis_i : Integer;
    AClipboard     : TClipboard;

Begin
  AClipboard := Clipboard;

  Clipboard_s :=   'Substanz wurde identifiziert als'
                 + Chr(9)
                 + Ergebnis_s
                 + Chr(13) + Chr(13) + Chr(13);

  Clipboard_s := Clipboard_s + 'Klassifizierungsparameter = Regressoren' + Chr(13);
  With ZuBestAufbSignal Do
       For s := 0 To High(KParam_da_e) Do
           Clipboard_s := Clipboard_s + FloatToStr(KParam_da_e[s]) + Chr(9);
  Clipboard_s[Length(Clipboard_s)] := Chr(13);
  Clipboard_s :=   Clipboard_s + Chr(13)
                 + 'Signal' + Chr(9)
                 + 'Wertebereich eingehalten' + Chr(9);
  LinienSchreiben(Clipboard_s, High(ZuBestAufbSignal.Intens_da_e));

  Clipboard_s :=   Clipboard_s
                 + 'Untersuchtes Signal' + Chr(9)
                 + 'nicht verfgbar'     + Chr(9);
  For s := 0 To High(ZuBestAufbSignal.Intens_da_e) Do
      Clipboard_s :=   Clipboard_s
                     + FloatToStr(ZuBestAufbSignal.Intens_da_e[s])
                     + Chr(9);
  Clipboard_s[Length(Clipboard_s)] := Chr(13);

  Clipboard_s := Clipboard_s + InterpolErgebnis_s;

  Clipboard_s :=   Clipboard_s
                 + Chr(13) + Chr(13)
                 + 'hnlichste Klassifizierungsparameterstze'
                 + Chr(13)
                 + MinDistSign_s;

  AClipboard.Clear;
  AClipboard.AsText := Clipboard_s;
End;

Var GewZuBestAufbSignal   : TAufbSignal;  //Signale mit gewichteten Intensitten
    GewInterpolAufbSignal : TAufbSignal;  //u. U. Intensittsverhltnisse
    VarVektor_da_e        : TVektor_da_e;
    R2Vektor_da_e         : TVektor_da_e;
    VIntervallVektor_da_e : TVektor_da_e;
    WahrIntensVektor_da_e : TVektor_da_e;
    i, k, l               : Integer;
    SignZahl_i            : Integer;
    FileOfGespSignal      : TFileOFGespSignal; //Datei des Typs TGespSignal
                                               //(gepackter Record, der weniger
                                               //Platz braucht)
    InterpolErgebnis_s    : String;
    MinDistSign_s         : String;
    MinDist_s             : String;

Begin //TDatenbank.Signalbestimmung
  SetLength(GewZuBestAufbSignal.Intens_da_e,
            Length(ZuBestAufbSignal.Intens_da_e));
  SetLength(GewInterpolAufbSignal.Intens_da_e,
            Length(ZuBestAufbSignal.Intens_da_e));
  InterpolErgebnis_s := '';

  For i := 0 To High(VerwSubst.pfade_da_s) Do
      Begin
        Try AssignFile(FileOfGespSignal, VerwSubst.pfade_da_s[i]);
            Reset(FileOfGespSignal);
            Result := True;
        Except Result := False
        End;

        If Result Then
           Result := SubstanzLaden_b(FileOFGespSignal, Substanz);
        If Result Then
           Begin
             Distanzen[i].SubstNr_i := i;
             If RegressInterpolation_b(Substanz,
                                       ZuBestAufbSignal,
                                       InterpolAufbSignal,
                                       VarVektor_da_e,
                                       R2Vektor_da_e,
                                       VIntervallVektor_da_e,
                                       WahrIntensVektor_da_e,
                                       AWStil.Unabhaengige_i,
                                       False, True) Then
                Begin
                  //Gewichtung
                  With GewZuBestAufbSignal Do
                       Begin
                         For k := 0 To High(Intens_da_e) Do
                             Intens_da_e[k] :=   ZuBestAufbSignal.Intens_da_e[k]
                                               * GewVektor_da_e[k];
                         KParam_da_e := ZuBestAufbSignal.KParam_da_e
                       End;
                  With GewInterpolAufbSignal Do
                       Begin
                         For k := 0 To High(Intens_da_e) Do
                             Intens_da_e[k] :=  InterpolAufbSignal.Intens_da_e[k]
                                               *GewVektor_da_e[k];
                         KParam_da_e := ZuBestAufbSignal.KParam_da_e
                       End;

                  //Falls statt Intensitten Intensittsverhltnisse
                  //zur Abstandsbestimmung verwendet werden sollen:
                  If Not(AWStil.AbstandIntens_b) Then
                     Begin
                       With GewZuBestAufbSignal Do
                            For k := 0 To High(Intens_da_e) Do
                                Intens_da_e[k] := Intens_da_e[k] / KParam_da_e[0];
                       With GewInterpolAufbSignal Do
                            For k := 0 To High(Intens_da_e) Do
                                Intens_da_e[k] := Intens_da_e[k] / KParam_da_e[0];

                              End;
                       DistanzBestimmung(Distanzen,
                                         GewZuBestAufbSignal,
                                         GewInterpolAufbSignal,
                                         i);

                       //Speichern von Informationen fr die Zwischenablage
                       If ZEInfo_b Then
                          Begin
                            If High(Substanz) < 4 Then
                                   SignZahl_i := High(Substanz)
                                   Else
                                   SignZahl_i := 4;
                            MinDistSign_s :=   MinDistSign_s
                                             + Chr(13)
                                             + VerwSubst.Namen_da_s[i];
                            For k := 0 To SignZahl_i Do
                                With Substanz[k] Do
                                     Begin
                                       MinDistSign_s := MinDistSign_s + Chr(13);
                                       For l := 0 To High(KParam_da_e) Do
                                           MinDistSign_s :=   MinDistSign_s
                                                            + FloatToStr(KParam_da_e[l])
                                                            + Chr(9);
                                       SetLength(MinDistSign_s,
                                                 Pred(Length(MinDistSign_s)));
                                     End;

                            InterpolErgebnis_s :=   InterpolErgebnis_s
                                                  + VerwSubst.Namen_da_s[i]
                                                  + Chr(9);
                            If Distanzen[i].Wertebereich_b Then
                               InterpolErgebnis_s :=   InterpolErgebnis_s
                                                     + 'Ja'   + Chr(9)
                               Else
                               InterpolErgebnis_s :=   InterpolErgebnis_s
                                                     + 'Nein' + Chr(9);
                            With InterpolAufbSignal Do
                                 For k := 0 To High(Intens_da_e) Do
                                     InterpolErgebnis_s :=   InterpolErgebnis_s
                                                           + FloatToStr(Intens_da_e[k])
                                                           + Chr(9);
                            InterpolErgebnis_s[Length(InterpolErgebnis_s)] := Chr(13)
                          End;
                End
                Else
                Begin
                  Distanzen[i].Distanz_e      := -1;
                  Distanzen[i].Wertebereich_b := False
                End
           End;

        Try CloseFile(FileOfGespSignal);
        Except Result := False
        End;
        If Not(Result) Then
           Begin
             Distanzen[i].Distanz_e      := -1;
             Distanzen[i].Wertebereich_b := False
           End;
        SubstanzFreigeben(Substanz)
      End;

  DistanzenSortieren(Distanzen);

  //Auswerteergebnis in Ergebnis_s festhalten:
  i :=  0;
  Ergebnis_s   := '';
  While (i <= High(Distanzen))                                              And
        ((Distanzen[i].Distanz_e = -1) Or Not(Distanzen[i].Wertebereich_b)) Do
        Begin
          If Not(Distanzen[i].Wertebereich_b) Then
             With Distanzen[i] Do
                  Ergebnis_s :=   Ergebnis_s
                                + '(' + VerwSubst.namen_da_s[SubstNr_i] + ') ';
          Inc(i)
        End;
  If i <= High(Distanzen) Then
     Ergebnis_s := Ergebnis_s + VerwSubst.namen_da_s[Distanzen[i].SubstNr_i];

  
  If ZEInfo_b Then
     //Speichern von Detailinfos fr Einzelsignalbestimmugen
     //in der Zwischenablage
     InZwischenablage(ZuBestAufbSignal,
                      InterpolErgebnis_s,
                      MinDistSign_s,
                      Ergebnis_s);

  //Variablen freigeben
  GewZuBestAufbSignal.  KParam_da_e := Nil;
  GewZuBestAufbSignal.  Intens_da_e := Nil;
  GewInterpolAufbSignal.KParam_da_e := Nil;
  GewInterpolAufbSignal.Intens_da_e := Nil;
End;




Procedure tdatenbank.OutSubstanzen(welches_i : Integer;
                                   signale   : TSignale;
                                   ZInfo_b   : Boolean);


Procedure KParamFitInZwischenablage(Var KParamFit_s : String);

Var AClipboard  : TClipboard;

Begin //KParamFitInZwischenablage
  AClipboard := Clipboard;
  AClipboard.Clear;
  AClipboard.AsText := KParamFit_s;
End;

Var Ergebnis_s            : String;
    GewZuBestAufbSignal   : TAufbSignal;  //Signale mit gewichteten Intensitten
    GewInterpolAufbSignal : TAufbSignal;  //u. U. Intensittsverhltnisse
    GewVektor_da_e        : TVektor_da_e; //Gewichtungen der einzelnen Linien
    MinDistSign_s         : String;
    InterpolErgebnis_s    : String;
    KParamFit_s           : String;
    SignZahl_i            : Integer;
    ZEInfo_b              : Boolean;      //Zusatzinfos zur Einzelsignalbe-
                                          //stimmung in die Zwischenablage?
    i, k, SignZaehler_i   : Integer;
    FileOFGespSignal      : TFileOFGespSignal; //Datei des Typs TGespSignal
                                               //(gepackter Record, der weniger
                                               //Platz braucht
    ZuBestAufbSignal            : tAufbSignal;  //Zu bestimmendes Signal
    InterpolAufbSignal          : tAufbSignal;  //Simuliertes Siganl

    KParam_da_e                 : Extended;     //Distanz vom Simulierten und
                                                //zu bestimmenden Signal
    Distanzen                   : TDistanzen;   //Die gesammleten Distanzen
                                                //des zu bestimmenden bezglich
                                                //der aus allen Substanzen
                                                //simmulierten Signale

    von_i, bis_i : Integer;      //Signal von_i bis Signal bis_i
                                 //sollen bestimmt werden

Begin //TDatenbankKlasse.OutSignale
  If Not(DBVorhanden_b) Then laden_b; //Die Datenbank laden, fall dies noch
                                      //nicht geschehen ist

  If DBVorhanden_b Then
     If Welches_i = 0 Then //von_i und bis_i bestimmen, welche Signale
        Begin              //Substanzen zugeordent werden.
          von_i := 1; //Alle Signale falls welches_i Null ist
          bis_i := Signale.HistoryStringArray.ZeilenFuellstatus_i(1)
        End
        Else
        Begin  //Nur das durch welches_i angegebene Signal
          von_i := welches_i;
          bis_i := welches_i;
        End
     Else
     Begin  //Gar kein Signal, falls keine Datenbank geladen werden konnte
       von_i := 1;
       bis_i := 0
     End;

  SetLength(distanzen, Succ(High(VerwSubst.pfade_da_s)));

  //Informationen ber ein Einzelsignal oder mehrere Signale
  //in die Zwischenablage?
  ZEInfo_b := ZInfo_b And Not(Welches_i = 0);
  If ZInfo_b And Not(ZEInfo_b) Then
     KParamFit_s :=   'Anzahl an Datenstzen, die die '
                    + 'Wertebereichskontrolle bestanden haben';

  FehlerSammlungForm.Reset;
  For signzaehler_i := von_i To bis_i Do
      If DBInfoCheck(signzaehler_i, signale) Then
         Begin
           AufbSignAusStringArray(signzaehler_i,
                                  signale,
                                  ZuBestAufbSignal,
                                  GewVektor_da_e);

           Signalbestimmung(ZuBestAufbSignal, InterpolAufbSignal,
                            Distanzen, GewVektor_da_e, ZEInfo_b, Ergebnis_s);

           If ZInfo_b And Not(ZEInfo_b) Then
              Begin
                k := 0;
                For i := 0 To High(Distanzen) Do
                    If Distanzen[i].Wertebereich_b Then Inc(k);
                KParamFit_s := KParamFit_s + Chr(13) + IntToStr(k);
              End;

           //Auswerteergebnisse in das entsprechende String-Array ablegen:
           With Signale.IdentStringArray Do
                Begin //Auswerteergebnis in das Stringgitter
                  StrWrite(2, SignZaehler_i, Ergebnis_s);
                  StrWrite(1, SignZaehler_i, DateToStr(Date)+'/'+TimeToStr(Time))
                End;
         End
         Else
         With signale.HistoryStringArray Do
              If von_i = bis_i Then
                 InkompatibelMeldung(StrRead_s(0, SignZaehler_i))
                 Else
                 FehlerSammlungForm.InFehler(StrRead_s(0, SignZaehler_i),
                                             'Inkompatiblitt');

  If ZInfo_b And Not(ZEInfo_b) Then
     KParamFitInZwischenablage(KParamFit_s);
     //Speichern der Anzahl an Datenstzen, die die Wertebereichs-
     //kontrolle berstanden haben in die Zwischenablage

  FehlerSammlungForm.FehlerAnzeigen;

  //Resourcen freigeben
  ZuBestAufbSignalFreigeben(ZuBestAufbSignal);
  InterpolAufbSignal.KParam_da_e := Nil;
  InterpolAufbSignal.intens_da_e := Nil;
  Distanzen                      := Nil;
  GewVektor_da_e                 := Nil;
End;




Procedure tdatenbank.DBOutSubstanzen(welches_i       : Integer;
                                     SubstDatName_s  : String;
                                     Schwellenwert_e : Extended);

Procedure InZwischenablage(Var InterpolErgebnis_s : String);

Var AClipboard  : TClipboard; //  Var datei_txt : TextFile;

Begin //KParamFitInZwischenablage
  AClipboard := Clipboard;
  AClipboard.Clear;
  AClipboard.AsText := InterpolErgebnis_s; 
  {Assignfile(datei_txt, SubstDatName_s + '.txt');
  Rewrite(datei_txt);
  Write(datei_txt, InterpolErgebnis_s);   
  Close(datei_txt); }
End;

Var Ergebnis_s            : String;
    GewVektor_da_e        : TVektor_da_e; //Gewichtungen der einzelnen Linien
    MinDistSign_s         : String;
    InterpolErgebnis_s    : String;
    OK_B                  : Boolean;
    ZEInfo_b              : Boolean;
    i, k, SignZaehler_i   : Integer;
    von_i, bis_i          : Integer;           //Signal von_i bis Signal bis_i
                                               //sollen bestimmt werden
    FileOFGespSignal      : TFileOFGespSignal; //Datei des Typs TGespSignal
                                               //(gepackter Record, der weniger
                                               //Platz braucht)

    Substanz              : TSubstanz;    //Alle Signale, die zu einer
                                          //Substanz gehren
    ZuBestAufbSignal      : tAufbSignal;  //Zu bestimmendes Signal
    InterpolAufbSignal    : tAufbSignal;  //Simuliertes Siganl

    KParam_da_e           : Extended;
    Distanzen             : TDistanzen;   //Distanzen vom interpolierten und
                                          //zu bestimmenden Signal
    MinKParam_da_e        : Extended;     //Minimale Distanz

    ErkanntAls_da_i       : Array Of Integer;  //Protokollierung wie
    VErkanntAls_da_i      : Array Of Integer;  //oft die Substanz richtig
    ErkanntAlsSW_da_i     : Array Of Integer;  //wiedererkannt werden konnte
    VErkanntAlsSW_da_i    : Array Of Integer;  //wobei "SW" bedeutet, dass
    ErkanntAls_s          : String;            //nur Signale hher als der
                                               //Schwellenwert verwendet werden

Begin //TDatenbankKlasse.OutSignale
  If Not(DBVorhanden_b) Then laden_b; //Die Datenbank laden, fall dies noch
                                      //nicht geschehen ist

  If DBVorhanden_b Then
     Begin
       Try AssignFile(FileOfGespSignal,SubstDatName_s);
           Reset(FileOfGespSignal);
           ok_b := True;
       Except ok_b := False
              End;
       If ok_b Then
          ok_b := SubstanzLaden_b(FileOFGespSignal, Substanz);
       Try CloseFile(FileOfGespSignal);
       Except ok_b := False
              End;

       Try AssignFile(FileOfGespSignal, SubstDatName_s);
           Reset(FileOfGespSignal);
           ok_b := True;
       Except ok_b := False
              End;
       If ok_b Then
          ok_b := SubstanzLaden_b(FileOFGespSignal, Substanz);
       Try CloseFile(FileOfGespSignal);
       Except ok_b := False
              End;
       If Length(Substanz) = 0 Then Ok_b := False;
       If ok_b Then
          Begin
            If Welches_i = -1 Then //von_i und bis_i bestimmen, welche Signale
               Begin              //Substanzen zugeordent werden.
                 von_i := 0; //Alle Signale falls welches_i Null ist
                 bis_i := High(Substanz)
               End
               Else
               Begin  //Nur das durch welches_i angegebene Signal
                 von_i := welches_i;
                 bis_i := welches_i;
               End;

            SetLength(distanzen, Succ(High(VerwSubst.pfade_da_s)));

            //Informationen ber ein Einzelsignal oder mehrere Signale
            //in die Zwischenablage?
            ZEInfo_b := Not(Welches_i = -1);
            If Not(ZEInfo_b) Then
               Begin
                 InterpolErgebnis_s := SubstDatName_s + Chr(13) + Chr(13);
                 For i := 0 To High(Substanz[0].KParam_da_e) Do
                     InterpolErgebnis_s := InterpolErgebnis_s + CHr(9);
                 InterpolErgebnis_s := InterpolErgebnis_s + 'Orginalwerte';
                 For i := 0 To High(Substanz[0].Intens_da_e) Do
                     InterpolErgebnis_s := InterpolErgebnis_s + CHr(9);
                 InterpolErgebnis_s := InterpolErgebnis_s + 'Interpolierte Werte';
                 InterpolErgebnis_s := InterpolErgebnis_s + CHr(13);
                 InterpolErgebnis_s := InterpolErgebnis_s + 'Klassifizierungsparameter';
                 For i := 0 To High(Substanz[0].KParam_da_e) Do
                     InterpolErgebnis_s := InterpolErgebnis_s + CHr(9);
                 LinienSchreiben(InterpolErgebnis_s, High(Substanz[0].Intens_da_e));
                 InterpolErgebnis_s[Length(InterpolErgebnis_s)] := CHR(9);
                 LinienSchreiben(InterpolErgebnis_s, High(Substanz[0].Intens_da_e));
                 InterpolErgebnis_s[Length(InterpolErgebnis_s)] := CHR(9);
                 InterpolErgebnis_s :=   InterpolErgebnis_s
                                       + 'Anzahl an Datenstzen, die die Werte'
                                       + 'bereichskontrolle bestanden haben'
                                       + Chr(9)
                                       + 'Interpolationsergebnis';
                 SetLength(ErkanntAls_da_i, Length(VerwSubst.namen_da_s));
                 For i := 0 To High(ErkanntAls_da_i) Do ErkanntAls_da_i[i] := 0;
                 SetLength(VErkanntAls_da_i, Length(VerwSubst.namen_da_s));
                 For i := 0 To High(VErkanntAls_da_i) Do VErkanntAls_da_i[i] := 0;
                 SetLength(ErkanntAlsSW_da_i, Length(VerwSubst.namen_da_s));
                 For i := 0 To High(ErkanntAlsSW_da_i) Do ErkanntAlsSW_da_i[i] := 0;
                 SetLength(VErkanntAlsSW_da_i, Length(VerwSubst.namen_da_s));
                 For i := 0 To High(VErkanntAlsSW_da_i) Do VErkanntAlsSW_da_i[i] := 0;
               End;

            //Gewichtungsvektor fr die Signalflchen oder -Hhen
            SetLength(GewVektor_da_e, Length(Substanz[0].Intens_da_e));
            k := 1;
            For i := 0 To High(GewVektor_da_e) Do
                Begin
                  With AWStil Do
                       While (LinienGew_a_i[k] = 0)          Or
                             (k                = PrimSign_i) Or
                             (k                = Offset_i  ) Do  Inc(k);
                  GewVektor_da_e[i] := AWStil.LinienGew_a_i[k];
                End;

            For signzaehler_i := von_i To bis_i Do
                Begin
                  ZUBestAufbSignal := Substanz[signzaehler_i];

                  Signalbestimmung(ZuBestAufbSignal, InterpolAufbSignal,
                                   Distanzen, GewVektor_da_e, ZEInfo_b,
                                   Ergebnis_s);

                  If Not(ZEInfo_b) Then
                     Begin
                       InterpolErgebnis_s := InterpolErgebnis_s + Chr(13);
                       With ZuBestAufbSignal Do
                            Begin
                              For i := 0 To High(KParam_da_e) Do
                                  InterpolErgebnis_s :=   InterpolErgebnis_s
                                                        + FloatToStr(KParam_da_e[i])
                                                        + CHr(9);
                              For i := 0 To High(Intens_da_e) Do
                                  InterpolErgebnis_s :=   InterpolErgebnis_s
                                                        + FloatToStr(Intens_da_e[i])
                                                        + Chr(9);
                            End;
                       With InterpolAufbSignal Do
                            For i := 0 To High(Intens_da_e) Do
                                InterpolErgebnis_s :=   InterpolErgebnis_s
                                                      + FloatToStr(Intens_da_e[i])
                                                      + Chr(9);
                       k := 0;
                       For i := 0 To High(Distanzen) Do
                           If Distanzen[i].Wertebereich_b Then Inc(k);
                       InterpolErgebnis_s := InterpolErgebnis_s + IntToStr(k) + Chr(9);

                       //Auswerteergebnisse in das entsprechende String-Array ablegen:
                       InterpolErgebnis_s := InterpolErgebnis_s + Ergebnis_s;

                       For i := 0 To High(VerwSubst.namen_da_s) Do
                           Begin
                             If (VerwSubst.namen_da_s[i] = Ergebnis_s) Then
                                Begin
                                  Inc(ErkanntAls_da_i[i]);
                                  With ZuBestAufbSignal Do
                                       If KParam_da_e[0] > Schwellenwert_e Then
                                          Inc(ErkanntAlsSW_da_i[i]);
                                End;
                            If (Pos(VerwSubst.namen_da_s[i], Ergebnis_s) = 2)              And
                               (Length(Ergebnis_s) >= Length(VerwSubst.namen_da_s[i]) + 2) And
                               (Ergebnis_s[Length(VerwSubst.namen_da_s[i]) + 2] = ')')     Then
                               Begin
                                 Inc(VErkanntAls_da_i[i]);
                                 With ZuBestAufbSignal Do
                                      If KParam_da_e[0] > Schwellenwert_e Then
                                         Inc(VErkanntAlsSW_da_i[i]);
                               End;
                           End;
                     End;
                End;
          End;

       If Not(ZEInfo_b) Then
          Begin
            ErkanntAls_s := 'Alle Signale' + CHR(13) + Chr(13) + 'Sicher erkannt:';
            For i := 0 To High(VerwSubst.namen_da_s) Do
                ErkanntAls_s := ErkanntAls_s + Chr(9);
            ErkanntAls_s := ErkanntAls_s + 'Erkannt, aber Probleme mit den Wertebereich:';
            For i := 0 To High(VerwSubst.namen_da_s) Do
                ErkanntAls_s := ErkanntAls_s + Chr(9);
            ErkanntAls_s[Length(ErkanntAls_s)] := CHR(13);
            For i := 0 To High(VerwSubst.namen_da_s) Do
                ErkanntAls_s := ErkanntAls_s + VerwSubst.namen_da_s[i] + Chr(9);
            For i := 0 To High(VerwSubst.namen_da_s) Do
                ErkanntAls_s := ErkanntAls_s + VerwSubst.namen_da_s[i] + Chr(9);
            ErkanntAls_s[Length(ErkanntAls_s)] := CHR(13);
            For i := 0 To High(ErkanntAls_da_i) Do
                ErkanntAls_s := ErkanntAls_s + IntToStr(ErkanntAls_da_i[i]) + Chr(9);
            For i := 0 To High(VErkanntAls_da_i) Do
                ErkanntAls_s := ErkanntAls_s + IntToStr(VErkanntAls_da_i[i]) + Chr(9);

            ErkanntAls_s :=   ErkanntAls_s + CHR(13) + Chr(13)
                            + 'Signale grer als ' + FloatToStr(Schwellenwert_e)
                       + CHR(13) + Chr(13) + 'Sicher erkannt:';
            For i := 0 To High(VerwSubst.namen_da_s) Do
                ErkanntAls_s := ErkanntAls_s + Chr(9);
            ErkanntAls_s := ErkanntAls_s + 'Erkannt, aber Probleme mit den Wertebereich:';
            For i := 0 To High(VerwSubst.namen_da_s) Do
                ErkanntAls_s := ErkanntAls_s + Chr(9);
            ErkanntAls_s[Length(ErkanntAls_s)] := CHR(13);
            For i := 0 To High(VerwSubst.namen_da_s) Do
                ErkanntAls_s := ErkanntAls_s + VerwSubst.namen_da_s[i] + Chr(9);
            For i := 0 To High(VerwSubst.namen_da_s) Do
                ErkanntAls_s := ErkanntAls_s + VerwSubst.namen_da_s[i] + Chr(9);
            ErkanntAls_s[Length(ErkanntAls_s)] := CHR(13);
            For i := 0 To High(ErkanntAlsSW_da_i) Do
                ErkanntAls_s := ErkanntAls_s + IntToStr(ErkanntAlsSW_da_i[i]) + Chr(9);
            For i := 0 To High(VErkanntAlsSW_da_i) Do
                ErkanntAls_s := ErkanntAls_s + IntToStr(VErkanntAlsSW_da_i[i]) + Chr(9);

            InterpolErgebnis_s :=   InterpolErgebnis_s
                                  + Chr(13) + Chr(13) + Chr(13)
                                  + ErkanntAls_s;
            If Not(ZEInfo_b) Then InZwischenablage(InterpolErgebnis_s);
          End;
          
     End;

  //Resourcen freigeben
  ZuBestAufbSignalFreigeben(ZuBestAufbSignal);
  InterpolAufbSignal.KParam_da_e := Nil;
  InterpolAufbSignal.intens_da_e := Nil;
  Distanzen                      := Nil;
  GewVektor_da_e                 := Nil;
  ErkanntAls_da_i                := Nil;
  VErkanntAls_da_i               := Nil;
  ErkanntAlsSW_da_i              := Nil;
  VErkanntAlsSW_da_i             := Nil;
  SubstanzFreigeben(Substanz);
End;



Function tdatenbank.laden_b : Boolean;

Var datei_txt : TextFile;
    puffer_s  : String;
    i         : Integer;

Begin
  Try AssignFile(datei_txt, DBEinstForm.OutDBPfad_s);
      Reset(datei_txt);
      Result := True;
  Except Result := False;
  End;
  Try With DBInfo Do
           Begin
             For i := 0 To 20 Do ReadLn(datei_txt);
             ReadLn(datei_txt, blz_i);
             ReadLn(datei_txt, dlz_i);
             ReadLn(datei_txt, puffer_s);
             nullspek_b := (puffer_s = 'TRUE');
             ReadLn(datei_txt, glaettung_i);
             ReadLn(datei_txt, SpGlaettung_i);
             ReadLn(datei_txt, EStandardNormLin_i);
             lz_i := 0;
             For i := 1 To DBMAXLINZAHL Do
                 Begin
                   ReadLn(datei_txt, Linien_a_s[i]);
                   If Not(Linien_a_s[i] = '') Then Inc(lz_i)
                 End;
           End;
      With AWStil Do
           Begin
             For i := 1 To DBMAXLINZAHL Do
                 Begin
                   ReadLn(datei_txt, puffer_s);
                   LinienGew_a_i[i] := StrToInt(puffer_s)
                 End;
             ReadLn(datei_txt, puffer_s);
             AWStil.AbstandIntens_b := (Puffer_s = 'TRUE');
             ReadLn(datei_txt, PrimSign_i);
             Inc(PrimSign_i);
             ReadLn(datei_txt, Offset_i);
             Inc(Offset_i);
             ReadLn(datei_txt, Puffer_s);
             AWStil.MaxInt_b := (Puffer_s = 'TRUE');
             For i := 0 To 4 Do
                 Begin
                   ReadLn(datei_txt, SGewicht_a_e[i]);
                   SGewicht_a_e[i] := SGewicht_a_e[i] / 100
                 End;
             ReadLn(datei_txt, Unabhaengige_i);
             ReadLn(datei_txt, Wertebereiche_s);
             If Length(Wertebereiche_s) = 7 Then puffer_s :=   Wertebereiche_s[6]
                                                             + Wertebereiche_s[7]
                Else If Length(Wertebereiche_s) = 6 Then puffer_s := Wertebereiche_s[6]
                     Else puffer_s := '100';
             SetLength(wertebereiche_s, 5);
             AWStil.RAnteil_e := StrToFloat(puffer_s) / 100;
             ReadLn(datei_txt, MinAbw_e);
             MinAbw_e := MinAbw_e / 1000
           End;
      i := 0;
      While Not(EOF(datei_txt)) Do
            With VerwSubst Do
                 Begin
                   Inc(i);
                   SetLength(namen_da_s, i);
                   SetLength(pfade_da_s, i);
                   ReadLn(datei_txt, namen_da_s[Pred(i)]);
                   ReadLn(datei_txt, pfade_da_s[Pred(i)]);
                   pfade_da_s[Pred(i)] := Copy(pfade_da_s[Pred(i)],
                                               1,
                                               Length(pfade_da_s[Pred(i)]) - 3)
                                          + 'SSD'
                  End;
      Result := True;
  Except Result:= False
  End;
  Try CloseFile(datei_txt);
       Except Result := False
       End;
  DBVorhanden_b := Result;
  IF Not(Result) Then
     Begin
       Application.MessageBox('Fehler beim Laden der Datenbank!',
                              'Fehlermeldung', Mb_Ok + MB_ICONSTOP);
       ResourcenFrei
     End;
End;




Procedure DBBearbeiten;
Begin
End;



Initialization



end.
