unit Datenbankformular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, ComCtrls, SignaleKlasse, datenbankklasse,
  NStringGridKomponente, DatenKlasse, FilternFormular, Menus, Interpolformular;

type

  TDatenbankForm = class(TForm)
    SubstanzComboBox: TComboBox;
    SubstanzLabel: TLabel;
    OKBitBtn: TBitBtn;
    AbbrechenBitBtn: TBitBtn;
    PageControl: TPageControl;
    HistoryTabSheet: TTabSheet;
    IntegraleTabSheet: TTabSheet;
    MaxIntTabSheet: TTabSheet;
    HWBTabSheet: TTabSheet;
    DeformTabSheet: TTabSheet;
    OffsetTabSheet: TTabSheet;
    SimulationBitBtn: TBitBtn;
    HistoryNStringGrid: TNStringGrid;
    IntegraleNStringGrid: TNStringGrid;
    MaxIntNStringGrid: TNStringGrid;
    HWBNStringGrid: TNStringGrid;
    DeformNStringGrid: TNStringGrid;
    OffsetNStringGrid: TNStringGrid;
    FilternBitBtn: TBitBtn;
    VergleichBitBtn: TBitBtn;
    AInterpolBitBtn: TBitBtn;
    VSubstanzComboBox: TComboBox;
    VSubstanzLabel: TLabel;
    PopupMenu: TPopupMenu;
    ExportZwischenablage1: TMenuItem;
    RVergleichBitBtn: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure SimulationBitBtnClick(Sender: TObject);
    procedure SubstanzComboBoxChange(Sender: TObject);
    procedure SpeedButton1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure HWBNStringGridMouseWheelDown(Sender: TObject;
      Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
    procedure HistoryNStringGridTopLeftChanged(Sender: TObject);
    procedure IntegraleNStringGridTopLeftChanged(Sender: TObject);
    procedure MaxIntNStringGridTopLeftChanged(Sender: TObject);
    procedure HWBNStringGridTopLeftChanged(Sender: TObject);
    procedure DeformNStringGridTopLeftChanged(Sender: TObject);
    procedure OffsetNStringGridTopLeftChanged(Sender: TObject);
    procedure FilternBitBtnClick(Sender: TObject);
    procedure AInterpolBitBtnClick(Sender: TObject);
    procedure VergleichBitBtnClick(Sender: TObject);
    procedure LoeschenBitBtnClick(Sender: TObject);
    procedure ExportZwischenablage1Click(Sender: TObject);
    procedure RVergleichBitBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
    veraendert_b : Boolean;
    VorhPfad_s   : String;
    Signale      : TSignale;
    SubstNr_i    : Integer;
    pfade_da_s   : Array Of String;
    daten        : TDaten;

    Procedure SGSyncron(NStringGrid : TNStringGrid);
    Procedure NStringGridZuruecksetzen;
    Function DBLaden_b     : Boolean;
    Function SubstLaden_b : Boolean;
    Function SubstSpeichern_b(vorherig_b : Boolean) : Boolean;
  public
    { Public-Deklarationen }
    //Procedure ModalAnzeigen(DBName_s, DBMethode_s : String;
    Function ShowModal(Var GDaten : TDaten) : Integer; Overload;

  end;

var
  DatenbankForm: TDatenbankForm;

implementation

uses SimulationsFormular, DBEinstellungsformular;

{$R *.DFM}



procedure TDatenbankForm.FormCreate(Sender: TObject);
begin
  SubstNr_i := 0;
  With HistoryNStringGrid Do
       Begin
         StrWrite(0, 0, 'Signalnummer');
         StrWrite(1, 0, 'Chromatogramm: Datum');
         StrWrite(2, 0, 'Chromatogramm: Uhrzeit');
         StrWrite(3, 0, 'Signalbestimmung: Datum');
         StrWrite(4, 0, 'Signalbestimmung: Uhrzeit');
       End;

  {With SubstanzStringGitter Do
       Begin
         str_einlesen(0, 0, 'Durchgefhrte Modifikationen am Chromatogramm');
         str_einlesen(1, 0, 'Hhe');
         str_einlesen(2, 0, 'Halbwertsbreite');
         str_einlesen(3, 0, 'Deformationsfaktor')
       End    }
end;



procedure TDatenbankForm.SimulationBitBtnClick(Sender: TObject);
begin
  SimulationsForm.ShowModal(daten,
                            pfade_da_s[SubstanzComboBox.ItemIndex],
                            SubstanzComboBox.Text)
end;



Function TDatenbankForm.DBLaden_b : Boolean;

Type TLinien_a_s = Array[1..DBMAXLINZAHL] Of String;

Var datei_txt         : TextFile;
    puffer_s          : String;
    i, j, glaettung_i : Integer;
    Linien_a_s        : TLinien_a_s;
    namen_da_s        : Array Of String;

Function lz_i(Var Linien_a_s : TLinien_a_s) : Integer;

Var i : Integer;

Begin
  Result := 0;
  For i := 1 To MAXLINZAHL Do If Not(linien_a_s[i] = '') Then Inc(Result)
End;

Procedure LinBezInNStringGrid(Var NStringGrid : TNStringGrid);

Var i : Integer;

Begin
  With NStringGrid Do
       Begin
         ColCount := Succ(lz_i(linien_a_s));
         StrWrite(0, 0, 'Signalnummer');
         For i := 1 To Pred(ColCount) Do StrWrite(i, 0, linien_a_s[i])
       End;
End;

Begin
  Try AssignFile(datei_txt, DBEinstForm.OutDBPfad_s);
      Reset(datei_txt);
      Flush(datei_txt);
      Result := True;
  Except Result := False;
  End;
  Try For i := 1 To 27 Do ReadLn(datei_txt);
      For i := 1 To DBMAXLINZAHL Do ReadLn(datei_txt, Linien_a_s[i]);
      For i := 1 To DBMAXLINZAHL Do ReadLn(datei_txt);
      For i := 1 To 12 Do ReadLn(datei_txt);
      i := 0;
      While Not(EOF(datei_txt)) Do
            Begin
              Inc(i);
              SetLength(namen_da_s, i);
              SetLength(pfade_da_s, i);
              ReadLn(datei_txt, namen_da_s[Pred(i)]);
              ReadLn(datei_txt, pfade_da_s[Pred(i)]);
              pfade_da_s[Pred(i)] := Copy(pfade_da_s[Pred(i)],
                                       1, Length(pfade_da_s[Pred(i)])-3) + 'SSD'
            End;
      With SubstanzComboBox.Items Do
           Begin
              Clear;
              For i := 0 To High(namen_da_s) Do Add(namen_da_s[i])
           End;
      SubstanzComboBox.ItemIndex := 0;
      With VSubstanzComboBox.Items Do
           Begin
              Clear;
              For i := 0 To High(namen_da_s) Do Add(namen_da_s[i])
           End;
      VSubstanzComboBox.ItemIndex := 0;

      VorhPfad_s                 := pfade_da_s[0];

      LinBezInNStringGrid(MaxIntNStringGrid);
      LinBezInNStringGrid(IntegraleNStringGrid);
      LinBezInNStringGrid(HWBNStringGrid);
      LinBezInNStringGrid(DeformNStringGrid);
      LinBezInNStringGrid(OffsetNStringGrid);

      Result := True;
  Except Result:= False
  End;
  Try CloseFile(datei_txt);
       Except Result := False
       End;
  //DBVorhanden_b := Result;
  IF Not(Result) Then
     Begin
       Application.MessageBox('Fehler beim Laden der Datenbank!',
                              'Fehlermeldung', Mb_Ok + MB_ICONSTOP);
       //ResourcenFrei
     End;
  Namen_da_s := Nil
End;



Procedure TDatenbankForm.NStringGridZuruecksetzen;

Procedure NStringGridZuruecksetzprocedure(Var NStringGrid : TNStringGrid);

Var i : Integer;

Begin
  With NStringGrid Do
       Begin
         RowCount := 2;
         For i := 0 To Pred(ColCount) Do StrWrite(i, 1, '')
       End
End;

Begin
  NStringGridZuruecksetzprocedure(HistoryNStringGrid);
  NStringGridZuruecksetzprocedure(MaxIntNStringGrid);
  NStringGridZuruecksetzprocedure(IntegraleNStringGrid);
  NStringGridZuruecksetzprocedure(HWBNStringGrid);
  NStringGridZuruecksetzprocedure(DeformNStringGrid);
  NStringGridZuruecksetzprocedure(OffsetNStringGrid)
End;



Function TDatenbankForm.SubstLaden_b : Boolean;

Var GespSignal                   : TGespSignal;
    linie_i, sign_i, laenge_i, i : Integer;
    LinZahl_i                    : Integer;
    FileOfGespSignal             : File Of TGespSignal;

Begin
  Try AssignFile(FileOfGespSignal, pfade_da_s[SubstanzComboBox.ItemIndex]);
      Reset(FileOfGespSignal);
      Result := True;
  Except Result := False
  End;

  NStringGridZuruecksetzen ;

  If Result Then
     Begin
       Try For sign_i := 0 To Pred(FileSize(FileOfGespSignal)) Do
               Begin
                 Seek(FileOfGespSignal, sign_i);
                 Read(FileOfGespSignal, GespSignal);
                 With HistoryNStringGrid, GespSignal Do
                      Begin
                        RowCount := Succ(Succ(sign_i));
                        IntWrite(0, Succ(sign_i), Succ(sign_i));
                        StrWrite(1, Succ(sign_i), DateToStr(ChromDateTime));
                        StrWrite(2, Succ(sign_i), TimeToStr(ChromDateTime));
                        StrWrite(3, Succ(sign_i), DateToStr(PeakDateTime));
                        StrWrite(4, Succ(sign_i), TimeToStr(PeakDateTime));
                      End;
                 With MaxIntNStringGrid, GespSignal Do
                      Begin
                        RowCount := Succ(Succ(sign_i));
                        IntWrite(0, Succ(sign_i), Succ(sign_i));
                        For i := 1 To Pred(ColCount) Do
                            FloatWrite(i, Succ(sign_i), MaxIntPack_a_si[i])
                      End;
                 With IntegraleNStringGrid, GespSignal Do
                      Begin
                        RowCount := Succ(Succ(sign_i));
                        IntWrite(0, Succ(sign_i), Succ(sign_i));
                        For i := 1 To Pred(ColCount) Do
                            FloatWrite(i, Succ(sign_i), IntegrPack_a_si[i])
                      End;
                 With HWBNStringGrid, GespSignal Do
                      Begin
                        RowCount := Succ(Succ(sign_i));
                        IntWrite(0, Succ(sign_i), Succ(sign_i));
                        For i := 1 To Pred(ColCount) Do
                            FloatWrite(i, Succ(sign_i), HwbPack_a_si[i])
                      End;
                 With DeformNStringGrid, GespSignal Do
                      Begin
                        RowCount := Succ(Succ(sign_i));
                        IntWrite(0, Succ(sign_i), Succ(sign_i));
                        For i := 1 To Pred(ColCount) Do
                            FloatWrite(i, Succ(sign_i), DeformPack_a_si[i])
                      End;
                 With OffsetNStringGrid, GespSignal Do
                      Begin
                        RowCount := Succ(Succ(sign_i));
                        IntWrite(0, Succ(sign_i), Succ(sign_i));
                        For i := 1 To Pred(ColCount) Do
                            FloatWrite(i, Succ(sign_i), OffsetPack_a_si[i])
                      End;
               End;
       MaxIntNStringGrid   .FixedRows := 1;
       IntegraleNStringGrid.FixedRows := 1;
       HistoryNStringGrid  .FixedRows := 1;
       DeformNStringGrid   .FixedRows := 1;
       OffsetNStringGrid   .FixedRows := 1;
       HWBNStringGrid      .FixedRows := 1;
       Except Result := False
       End
     End;
  Try CloseFile(FileOfGespSignal);
  Except Result := False
  End
End;



Function TDatenbankForm.SubstSpeichern_b(vorherig_b : Boolean) : Boolean;

Type TFileOfGespSignal = File Of TGespSignal;

Var linie_i, sign_i, laenge_i, i : Integer;
    LinZahl_i                    : Integer;
    FileOfGespSignal             : TFileOfGespSignal;
    pfad_s                       : String;

Function SignaleSpeichern_b(Var FileOfGespSignal : TFileOfGespSignal) : Boolean;

Var GespSignal        : TGespSignal;
    SignNr_i, lin_i   : Integer;

Begin //TSignaleSpeichern_b
  Result   := True;
  SignNr_i := 1;
  While Result                                      And
        Not(HistoryNStringGrid.RowCount = SignNr_i) Do
        With GespSignal Do
             Begin
               With HistoryNStringGrid Do
                    Begin
                      ChromDateTime :=   StrToDate(StrRead_s(1,SignNr_i))
                                       + StrToTime(StrRead_s(2,SignNr_i));
                      PeakDateTime  :=   StrToDate(StrRead_s(3,SignNr_i))
                                       + StrToTime(StrRead_s(4,SignNr_i))
                    End;
               lin_i := 1;
               While Not(lin_i = Succ(MAXLINZAHL))                And
                     Not(HwbNStringGrid.StrRead_s(lin_i, 1) = '') Do
                     Begin
                       With MaxIntNStringGrid Do
                         MaxIntPack_a_si[lin_i] := FloatRead_e(Lin_i, SignNr_i);
                       With IntegraleNStringGrid Do
                         IntegrPack_a_si[lin_i] := FloatRead_e(Lin_i, SignNr_i);
                       With HwbNStringGrid Do
                         HWBPack_a_si[lin_i]    := FloatRead_e(Lin_i, SignNr_i);
                       With DeformNStringGrid Do
                         DeformPack_a_si[lin_i] := FloatRead_e(Lin_i, SignNr_i);
                       With OffsetNStringGrid Do
                         OffsetPack_a_si[lin_i] := FloatRead_e(Lin_i, SignNr_i);
                       Inc(lin_i)
                     End;
               If Not(lin_i = MAXLINZAHL) Then
                  MaxIntPack_a_si[Succ(lin_i)] := -200000;

               Try Seek(FileOfGespSignal, FileSize(FileOfGespSignal));
                   Write(FileOfGespSignal, GespSignal)
               Except Result := False
               End;
               Inc(SignNr_i)
             End
End;

Begin
  If vorherig_b Then pfad_s := VorhPfad_s
                Else pfad_s := pfade_da_s[SubstanzComboBox.ItemIndex];

  If Not(HistoryNStringGrid.StrRead_s(1, 1) = '') Then
     Begin
       Try AssignFile(FileOfGespSignal, Pfad_s);
           Rewrite(FileOfGespSignal);
           Result := True;
       Except Result := False
       End;

       If Result Then
          Result := SignaleSpeichern_b(FileOfGespSignal);

       Try CloseFile(FileOfGespSignal);
       Except Result := False
       End;
       If Not(Result) Then
          Begin
            MessageBeep(MB_ICONHAND);
            MessageDlg('Fehler beim Speichern der Substanzdaten!',
                       mtError, [mbOk], 0)
          End;
     End
     Else
     Begin
       Try If FileExists(pfad_s) Then DeleteFile(pfad_s);
       Except
         MessageBeep(MB_ICONHAND);
         MessageDlg('Fehler beim Entfernen der Substanzdaten!',
                    mtError, [mbOk], 0);
         Result := False
       End
     End
End;



Function TDatenbankForm.ShowModal(Var gdaten : TDaten) : Integer;
Begin
  veraendert_b  := False;
  //NameEdit.Text := DBEinstForm.OutDBName_s;
  daten         := gdaten;
  //Signale.Initialisieren
  If DBLaden_b And SubstLaden_b Then
     If ShowModal = mrOK Then SubstSpeichern_b(False);
  //Signale.Destroy;
  pfade_da_s := Nil
End;



procedure TDatenbankForm.SubstanzComboBoxChange(Sender: TObject);
begin
  If veraendert_b Then
     Begin
       MessageBeep(MB_ICONQUESTION);
       If MessageDlg('Vernderungen speichern?',
                     mtConfirmation, [mbYes, mbNo], 0) = mrYES Then
          SubstSpeichern_b(True);
       veraendert_b := False
     End;
  SubstLaden_b;
  VorhPfad_s := Pfade_da_s[SubstanzComboBox.ItemIndex]
end;



procedure TDatenbankForm.SpeedButton1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

Procedure freigeben(Var NStringGrid : TNStringGrid);
Begin
  With NStringGrid Do
       Begin
         Sperrbereich_Prop.Aktiviert_b_prop := False;
         Options := Options + [goEditing]
       End;
End;

begin
  If (Shift = [ssShift, ssCtrl..ssLeft])                           And
     (MessageDlg('Manipulationen an der Datenbank zu ' +
                 'Testzwecken -> Daten knnen ' +
                 'zerstrt werden! Wirklich fortfahren?',
                 mtWarning, [mbYes, mbNo], 0)             = mrYES) Then
     If MessageDlg('Drcken sie OK um die Daten zur ' +
                   'Vernderung freizugeben.',
                    mtCustom, mbOKCancel, 0)              = mrOK Then
        Begin
          Freigeben(IntegraleNStringGrid);
          Freigeben(MaxIntNStringGrid);
          Freigeben(HWBNStringGrid);
          Freigeben(DeformNStringGrid);
          Freigeben(OffsetNStringGrid);
          veraendert_b := True
        End
end;



procedure TDatenbankForm.HWBNStringGridMouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
  MessageBeep(mb_ok)
end;



Procedure TDatenbankForm.SGSyncron(NStringGrid : TNStringGrid);
Begin
  With NStringGrid Do
       Begin
         HistoryNStringGrid  .TopRow  := TopRow;
         IntegraleNStringGrid.TopRow  := TopRow;
         MaxIntNStringGrid   .TopRow  := TopRow;
         HWBNStringGrid      .TopRow  := TopRow;
         DeformNStringGrid   .TopRow  := TopRow;
         OffsetNStringGrid   .TopRow  := TopRow;
         HistoryNStringGrid  .LeftCol := LeftCol;
         IntegraleNStringGrid.LeftCol := LeftCol;
         MaxIntNStringGrid   .LeftCol := LeftCol;
         HWBNStringGrid      .LeftCol := LeftCol;
         DeformNStringGrid   .LeftCol := LeftCol;
         OffsetNStringGrid   .LeftCol := LeftCol;
       End;
End;



procedure TDatenbankForm.HistoryNStringGridTopLeftChanged(Sender: TObject);
begin
  SGSyncron(HistoryNStringGrid)
end;

procedure TDatenbankForm.IntegraleNStringGridTopLeftChanged(
  Sender: TObject);
begin
  SgSyncron(IntegraleNStringGrid);
end;

procedure TDatenbankForm.MaxIntNStringGridTopLeftChanged(Sender: TObject);
begin
  SGSyncron(MaxIntNStringGrid)
end;

procedure TDatenbankForm.HWBNStringGridTopLeftChanged(Sender: TObject);
begin
  SGSyncron(HWBNStringGrid)
end;

procedure TDatenbankForm.DeformNStringGridTopLeftChanged(Sender: TObject);
begin
  SGSyncron(DeformNStringGrid)
end;

procedure TDatenbankForm.OffsetNStringGridTopLeftChanged(Sender: TObject);
begin
  SGSyncron(OffsetNStringGrid)
end;




procedure TDatenbankForm.FilternBitBtnClick(Sender: TObject);
begin
  If FilternForm.ShowModal(HistoryNStringGrid, IntegraleNStringGrid,
                           MaxIntNStringGrid, HWBNStringGrid,
                           DeformNStringGrid, OffsetNStringGrid) = MROk Then
     Veraendert_b := True
end;




procedure TDatenbankForm.AInterpolBitBtnClick(Sender: TObject);

Var Schwellenwert_e : Extended;
    Einzelsignal_b  : Boolean;

Function welches_i : Integer;
Begin  //Welches_i
  With pagecontrol Do    //Es gilt der Focus auf dem NStringGrid
       Begin             //der gerade aktiven Seite des PageControl
         If ActivePage = IntegraleTabSheet Then Result := IntegraleNStringGrid.Row;
         If ActivePage = MaxIntTabSheet    Then Result := MaxIntNStringGrid.Row;
         If ActivePage = HWBTabSheet       Then Result := HWBNStringGrid.Row;
         If ActivePage = HistoryTabSheet   Then Result := HistoryNStringGrid.Row;
         If ActivePage = DeformTabSheet    Then Result := DeformNStringGrid.Row;
         If ActivePage = OffsetTabSheet    Then Result := OffsetNStringGrid.Row;
       End;
  Dec(Result);
End;

begin //TDatenbankForm.AInterpolBitBtnClick
  Screen.Cursor := crHourGlass;
  If InterpolForm.ShowModal(Schwellenwert_e, Einzelsignal_b) = mrOK Then
     If Einzelsignal_b Then
        daten.DBOutSubstanzen(welches_i, pfade_da_s[SubstanzComboBox.ItemIndex],
                              Schwellenwert_e)
        Else
        daten.DBOutSubstanzen(-1,        pfade_da_s[SubstanzComboBox.ItemIndex],
                              Schwellenwert_e);
  {For i := 0 To High(pfade_da_s) Do
      daten.DBOutSubstanzen(0, pfade_da_s[i], 50);
  //////////////////////////////// }
  Screen.Cursor := crDefault
end;



procedure TDatenbankForm.VergleichBitBtnClick(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  daten.DBOutSubstanzvergleich(pfade_da_s[VSubstanzComboBox.ItemIndex],
                               pfade_da_s[ SubstanzComboBox.ItemIndex],
                               False);
  Screen.Cursor := crDefault
end;



procedure TDatenbankForm.LoeschenBitBtnClick(Sender: TObject);

Procedure loeschen(Var NStringGrid : TNStringGrid);

Var Row_i : Integer;

Begin
  With NStringGrid Do
       If Not((Row = 1) And (RowCount = 2)) Then
          Begin
            Row_i := Row;
            IntegraleNStringGrid.DeleteRow(Row_i);
            MaxIntNStringGrid.   DeleteRow(Row_i);
            HWBNStringGrid.      DeleteRow(Row_i);
            HistoryNStringGrid.  DeleteRow(Row_i);
            DeformNStringGrid.   DeleteRow(Row_i);
            OffsetNStringGrid.   DeleteRow(Row_i);
            If Row_i = Succ(RowCount) Then Row := RowCount
                                      Else Row := Row_i;
            veraendert_b := True
          End
End;

begin
  With pagecontrol Do    //Es gilt der Focus auf dem NStringGrid
       Begin             //der gerade aktiven Seite des PageControl
         If ActivePage = IntegraleTabSheet Then loeschen(IntegraleNStringGrid);
         If ActivePage = MaxIntTabSheet    Then loeschen(MaxIntNStringGrid);
         If ActivePage = HWBTabSheet       Then loeschen(HWBNStringGrid);
         If ActivePage = HistoryTabSheet   Then loeschen(HistoryNStringGrid);
         If ActivePage = DeformTabSheet    Then loeschen(DeformNStringGrid);
         If ActivePage = OffsetTabSheet    Then loeschen(OffsetNStringGrid)
       End
end;




procedure TDatenbankForm.ExportZwischenablage1Click(Sender: TObject);
begin
  With pagecontrol Do    //Es gilt der Focus auf dem NStringGrid
       Begin             //der gerade aktiven Seite des PageControl
         If ActivePage = IntegraleTabSheet Then IntegraleNStringGrid.InClipboard;
         If ActivePage = MaxIntTabSheet    Then MaxIntNStringGrid.InClipboard;
         If ActivePage = HWBTabSheet       Then HWBNStringGrid.InClipboard;
         If ActivePage = HistoryTabSheet   Then HistoryNStringGrid.InClipboard;
         If ActivePage = DeformTabSheet    Then DeformNStringGrid.InClipboard;
         If ActivePage = OffsetTabSheet    Then OffsetNStringGrid.InClipboard
       End
end;




procedure TDatenbankForm.RVergleichBitBtnClick(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  daten.DBOutSubstanzvergleich(pfade_da_s[VSubstanzComboBox.ItemIndex],
                               pfade_da_s[ SubstanzComboBox.ItemIndex],
                               True);
  Screen.Cursor := crDefault
end;



end.
