unit ExtStandardFormular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Buttons, Mask, DatenKlasse, NStringGridKomponente, Menus,
  ExtCtrls;

type
  TExtStandardForm = class(TForm)
    WannLabel: TLabel;
    IntensitaetenLabel: TLabel;
    OKBitBtn: TBitBtn;
    IntensitaetenBitBtn: TBitBtn;
    OffsetBitBtn: TBitBtn;
    AbbruchBitBtn: TBitBtn;
    BezugBitBtn: TBitBtn;
    BezugZuruecksetzenBitBtn: TBitBtn;
    EStandardNStringGrid: TNStringGrid;
    ExportPopupMenu: TPopupMenu;
    KopierenMenueItem: TMenuItem;
    WannNStringGrid: TNStringGrid;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure IntensitaetenBitBtnClick(Sender: TObject);
    procedure OffsetBitBtnClick(Sender: TObject);
    procedure OKBitBtnClick(Sender: TObject);
    procedure AbbruchBitBtnClick(Sender: TObject);
    procedure BezugZuruecksetzenBitBtnClick(Sender: TObject);
    procedure BezugBitBtnClick(Sender: TObject);
    procedure KopierenMenueItemClick(Sender: TObject);

  private
    { Private-Deklarationen }

    daten : TDaten;

    Procedure BezugOKBitBtnClick(Sender: TObject);

  public
    { Public-Deklarationen }

    Procedure ModalZeigen(Hdaten : TDaten);

  end;

var
  ExtStandardForm: TExtStandardForm;

implementation

uses BezugFormular;

{$R *.DFM}



Procedure TExtStandardForm.ModalZeigen(Hdaten : TDaten);
Begin
  daten := Hdaten;
  Daten.EStandardLaden(EStandardNStringGrid, WannNStringGrid);
  ShowModal
End;



procedure TExtStandardForm.BezugOKBitBtnClick(Sender: TObject);

Var AufWelcheLinie_i : Integer;

Begin
  With BezugForm Do
       Begin
         //Hide;
         Try AufWelcheLinie_i := StrToInt(BezugEdit.Text); //Eingabe auslesen
         Except AufWelcheLinie_i := 0
         End;
         With EStandardNStringGrid Do
              If (AufWelchelinie_i > 0)      And
                 (AufWelchelinie_i <= 60)    And
                 Not(StrRead_s(4, row) = '') Then
                 Daten.EStandardBezugAendern(Row, AufWelcheLinie_i,
                                             EStandardNStringGrid,
                                             WannNStringGrid)
                 Else Application.MessageBox('Ungltige Eingabe!',
                                             'Fehlermeldung',MB_OK)
       End
End;



procedure TExtStandardForm.FormCreate(Sender: TObject);
begin
  BezugForm.OKBitBtn.onClick := BezugOKBitBtnClick;
end;



procedure TExtStandardForm.IntensitaetenBitBtnClick(Sender: TObject);
begin
  daten.extstandardbestimmen_b(False, EStandardNStringGrid, WannNStringGrid);
end;



procedure TExtStandardForm.OffsetBitBtnClick(Sender: TObject);
begin
  daten.extstandardbestimmen_b(True, EStandardNStringGrid, WannNStringGrid)
end;



procedure TExtStandardForm.OKBitBtnClick(Sender: TObject);
begin
  Daten.EStandardSpeichern
end;



procedure TExtStandardForm.AbbruchBitBtnClick(Sender: TObject);
begin
  daten.EStandardLaden(EStandardNStringGrid, WannNStringGrid)
end;



procedure TExtStandardForm.BezugZuruecksetzenBitBtnClick(Sender: TObject);

Var i : Integer;

begin
  Daten.EStandardResetBezug(EStandardNStringGrid, WannNStringGrid)
end;



procedure TExtStandardForm.BezugBitBtnClick(Sender: TObject);
begin
  BezugForm.Show
end;



procedure TExtStandardForm.KopierenMenueItemClick(Sender: TObject);
begin
  EStandardNStringGrid.InClipboard
end;




end.
