unit ExtStandardKlasse;




interface




Uses Forms, Dialogs, Windows, Sysutils, StringArrayKlasse,
     NStringGridKomponente;


Type TExtStandard = Class (TObject) // Enthlt die Chromatogramme,
                                    //die integriert werden sollen

                    Private

                      Pfad_s               : String;

                      linnamen_s           : String;

                      WannStringArray      : TStringArray;

                    Public { Public-Deklarationen }

                      EStandardStringArray : TStringArray;

                      Constructor create;

                      Destructor destroy; Override;

                      Procedure LinNamenSetzen(NeuLinNamen_s : String;
                                               Offset_b      : Boolean);

                      Procedure SetDateTime(Datum_s   : String;
                                            Uhrzeit_s : String;
                                            Offset_b  : Boolean);

                      Procedure Differenz;
                      Procedure laden;
                      Procedure speichern;
                      Procedure bezugzuruecksetzen;
                      Procedure BezugAendern(Linie_i, Auf_i : Integer);

                      Procedure OutDaten
                                (Var EStandardNStringGrid : TNStringGrid;
                                 Var WannNStringGrid      : TNStringGrid);

                      Property LinNamen_s_Prop : String Read LinNamen_s;
                      Property WannStringArray_prop : TStringArray
                               Read WannStringArray;
           End;


implementation



Constructor TExtStandard.Create;

Var i : Integer;

Begin
  EStandardStringArray := TStringArray.Create(6, 61, 3);
  WannStringArray      := TStringArray.Create(3,  3, 3);
  With WannStringArray Do
       Begin
         StrWrite(0, 1, 'Intensitten');
         StrWrite(0, 2, 'Nullabgleich');
         StrWrite(1, 0, 'Datum');
         StrWrite(2, 0, 'Uhrzeit');
       End;
  With EStandardStringArray Do
       Begin
         StrWrite(0,0, 'Nr.');
         StrWrite(1,0, 'Bezeichnung');
         StrWrite(2,0, 'Intensitt');
         StrWrite(3,0, 'Offset');
         StrWrite(4,0, 'Differenz');
         StrWrite(5,0, 'Bezug');
         For i := 1 To 60 Do IntWrite(0, i, i)
       End;
  pfad_s := ExtractFilePath(ParamStr(0));
  laden
End;



Destructor TExtStandard.Destroy;
Begin
  EStandardStringArray.Destroy;
  WannStringArray.     Destroy;
  Inherited Destroy
End;



Procedure TExtStandard.laden;

Var datei_txt : TextFile;
    fehler_b  : Boolean;
    s, z      : Integer;
    puffer_s  : String;

Begin
  Try AssignFile(datei_txt, pfad_s + '\datenbankkal.spg');
      Reset(datei_txt);
      fehler_b := False;
  Except fehler_b := True;
  End;
  If Not(fehler_b) Then
     Begin
       Try ReadLn(datei_txt, LinNamen_s);
           With WannStringArray Do
                For s := 1 To 2 Do
                    For z := 1 To 2 Do
                        Begin
                          ReadLn(datei_txt, puffer_s);
                          StrWrite(s, z, puffer_s)
                        End;
           With EStandardStringArray Do
                For s := 1 To 5 Do
                    For z := 1 To 60 Do
                        Begin
                          ReadLn(datei_txt, puffer_s);
                          StrWrite(s,z, puffer_s)
                        End;
       Except fehler_b := True;
       End;
       Try CloseFile(datei_txt);
       Except fehler_b := True;
       End
     End;
  If fehler_b Then
     Application.MessageBox('Informationen zum externen Standard konnten ' +
                            'geladen werden!',
                            'Fehlermeldung', Mb_Ok)
End;



Procedure TExtStandard.speichern;

Var datei_txt : TextFile;
    fehler_b  : Boolean;
    z, s      : Integer;

Begin
  Try AssignFile(datei_txt, pfad_s + '\datenbankkal.spg');
      Rewrite(datei_txt);
      fehler_b := False;
  Except fehler_b := True;
  End;
  If Not(fehler_b) Then
     Begin
       Try WriteLn(datei_txt, LinNamen_s);
           With WannStringArray Do
                For s := 1 To 2 Do
                    For z := 1 To 2 Do
                        WriteLn(datei_txt, StrRead_s(s, z));
           With EStandardStringArray Do
                For s := 1 To 5 Do
                    For z := 1 To 60 Do WriteLn(datei_txt, StrRead_s(s, z));
       Except fehler_b := True;
       End;
       Try CloseFile(datei_txt);
       Except fehler_b := True
       End
     End;
  If fehler_b Then
    Application.MessageBox('Fehler beim Speichern von Kalibrationsdaten' +
                           'bezglich des externen Standards!',
                           'Fehlermeldung', Mb_OK);
end;



Procedure TExtStandard.LinNamenSetzen(NeuLinNamen_s : String;
                                      Offset_b      : Boolean);

Procedure linnameneinlesen;

Var i, linnummer_i : Integer;
    puffer_s       : String;

Begin //linnameneinlesen;
  i           := 1;
  linnummer_i := 0;
  While Not(i = Succ(Length(LinNamen_s))) Do
        Begin
          puffer_s := '';
          While Not(LinNamen_s[i]=';') And Not(i = Succ(Length(LinNamen_s))) Do
                Begin
                  puffer_s := puffer_s + LinNamen_s[i];
                  Inc(i)
                End;
          If LinNamen_s[i] = ';' Then INC(i);
          Inc(linnummer_i);
          EStandardStringArray.StrWrite(1, linnummer_i, puffer_s)
        End;
  For i := Succ(linnummer_i) To 60 Do
      EStandardStringArray.StrWrite(1, i, '')
End;

Var i, s, s2, z : Integer;

Begin
  //Wurde die Offset- oder Intensittenspalte gendert? s bezeichnet die
  //genderte Spalte...
  If Offset_b Then s := 3
              Else s := 2;
  //...und s2 die nicht genderte Spalte
  If s = 3 Then s2 := 2
           Else s2 := 3;
  If Not(NeuLinNamen_s = '') And Not(linnamen_s = NeuLinNamen_s) Then
     Begin
       For i := 1 To 60 Do
           With EStandardStringArray Do          //Bei einem neuen Liniensatz
                Begin                            //mssen je nach dem der Offset
                  StrWrite(s2, i, '');           //bzw. die Intensitstwerte,
                  IntWrite( 5, i, IntRead_i(0,i))//sowie die Bezge zurckge-
                End;                             //setz werden.
       linnamen_s := NeuLinNamen_s;
       LinNamenEinlesen
     End
     Else
     With EStandardStringArray Do    
          For z := 1 To 60 Do
              If Not(StrRead_s(0, z) = StrRead_s(5, z)) Then
                 For s := 2 To 4 Do StrWrite(s, z, StrRead_s(s,IntRead_i(5, z)))
End;



Procedure TExtStandard.SetDateTime(Datum_s   : String;
                                   Uhrzeit_s : String;
                                   Offset_b  : Boolean);

Var z : Integer;

Begin
  If Offset_b Then z := 2
              Else z := 1;
  With WannStringArray Do
       Begin
         StrWrite(1, z, Datum_s);
         StrWrite(2, z, Uhrzeit_s)
       End
End;



Procedure TExtStandard.differenz;

Var i           : Integer;
    differenz_e : Extended;

Begin
  With EStandardStringArray Do
        For i := 1 To 60 Do
            If (StrRead_s(3, i) = '') Or (StrRead_s(2, i) = '') Then
               StrWrite(4, i, '')
               Else
               Begin
                 differenz_e := FloatRead_e(2, i) - FloatRead_e(3, i);
                 If differenz_e = 0 Then differenz_e := 1;
                    //Ansonsten Division durch Null mglich!
                 FloatWrite(4, i, differenz_e)
               End
End;



Procedure TExtStandard.OutDaten(Var EStandardNStringGrid : TNStringGrid;
                                Var WannNStringGrid      : TNStringGrid);

Var s, z : Integer;

Begin
  With EStandardNStringGrid Do
       For s := 0 To ColCount Do
           For z := 0 To RowCount Do
               StrWrite(s, z, EStandardStringArray.StrRead_s(s, z));
  With WannNStringGrid Do
       For s := 0 To ColCount Do
           For z := 0 To RowCount Do
               StrWrite(s, z, WannStringArray.StrRead_s(s, z))
End;



Procedure TExtStandard.bezugzuruecksetzen;

Var i : Integer;

Begin
  With EStandardStringArray Do
       For i := 1 To 60 Do IntWrite(5, i, IntRead_i(0, i))
End;



Procedure TExtStandard.BezugAendern(Linie_i, Auf_i : Integer);

Var z, s : Integer;

Begin
  With EStandardStringArray Do
       Begin
         IntWrite(5, Linie_i, Auf_i);
         For z := 1 To 60 Do
             If Not(IntRead_i(0, z) = IntRead_i(5, z)) Then
                For s := 2 To 4 Do
                    FloatWrite(s, z, FloatRead_e(s, IntRead_i(5, z)))
       End
End;



end.
