unit FilternFormular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, NStringGridKomponente, ExtCtrls,
  NEditKomponente;

type
  TZuFiltern = Array Of Record
                          Bezeichnung_s : String;
                          NStringGrid   : TNStringGrid
                        End;

  TFilternForm = class(TForm)
    FilternNStringGrid: TNStringGrid;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    AlleEinePanel: TPanel;
    AlleRadioButton: TRadioButton;
    GewaehltRadioButton: TRadioButton;
    BeschreibungNEdit: TNEdit;
    Label1: TLabel;
    IdentLabel: TLabel;
    IdentNEdit: TNEdit;
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
    Alt_s : String;
    Procedure BezeichnungenInNStringGrid(Var ZuFiltern : TZuFiltern;
                                             Anzahl_i  : Integer);
    Function Filtern(Var ZuFiltern : TZuFiltern) : Integer;
  public
    { Public-Deklarationen }
    Function ShowModal(HistoryNStringGrid   : TNStringGrid;
                       RetZeitNStringGrid   : TNStringGrid;
                       IntegraleNStringGrid : TNStringGrid;
                       MaxIntNStringGrid    : TNStringGrid;
                       HWBNStringGrid       : TNStringGrid;
                       MaxStgNStringGrid    : TNStringGrid;
                       MinStgNStringGrid    : TNStringGrid;
                       DeformNStringGrid    : TNStringGrid;
                       OffsetNStringGrid    : TNStringGrid;
                       IdentNStringGrid     : TNStringGrid) : Integer; Overload;

    Function ShowModal(HistoryNStringGrid   : TNStringGrid;
                       IntegraleNStringGrid : TNStringGrid;
                       MaxIntNStringGrid    : TNStringGrid;
                       HWBNStringGrid       : TNStringGrid;
                       DeformNStringGrid    : TNStringGrid;
                       OffsetNStringGrid    : TNStringGrid) : Integer; Overload;
  end;

var
  FilternForm: TFilternForm;

implementation

{$R *.DFM}



procedure TFilternForm.FormCreate(Sender: TObject);
begin
  AlleRadioButton.Checked     := True;
  GewaehltRadioButton.Checked := False;
  With FilternNStringGrid Do
       Begin
         //StrWrite(0, 0, 'Signalparameter');
         StrWrite(1, 0, 'Von');
         StrWrite(2, 0, 'Bis');
       End;
end;                             



Function TFilternForm.ShowModal(HistoryNStringGrid   : TNStringGrid;
                                RetZeitNStringGrid   : TNStringGrid;
                                IntegraleNStringGrid : TNStringGrid;
                                MaxIntNStringGrid    : TNStringGrid;
                                HWBNStringGrid       : TNStringGrid;
                                MaxStgNStringGrid    : TNStringGrid;
                                MinStgNStringGrid    : TNStringGrid;
                                DeformNStringGrid    : TNStringGrid;
                                OffsetNStringGrid    : TNStringGrid;
                                IdentNStringGrid     : TNStringGrid) : Integer;

Var ZuFiltern      : TZuFiltern;

Begin //ShowModal

  IdentNEdit.Enabled := True;
  IdentLabel.Enabled := True;

  SetLength(ZuFiltern, 10);

  ZuFiltern[0].NStringGrid := HistoryNStringGrid;
  ZuFiltern[1].NStringGrid := RetZeitNStringGrid;
  ZuFiltern[2].NStringGrid := IntegraleNStringGrid;
  ZuFiltern[3].NStringGrid := MaxIntNStringGrid;
  ZuFiltern[4].NStringGrid := HWBNStringGrid;
  ZuFiltern[5].NStringGrid := MaxStgNStringGrid;
  ZuFiltern[6].NStringGrid := MinStgNStringGrid;
  ZuFiltern[7].NStringGrid := DeformNStringGrid;
  ZuFiltern[8].NStringGrid := OffsetNStringGrid;
  ZuFiltern[9].NStringGrid := IdentNStringGrid;

  ZuFiltern[1].Bezeichnung_s := 'Retentionszeit';
  ZuFiltern[2].Bezeichnung_s := 'Integral';
  ZuFiltern[3].Bezeichnung_s := 'Maximale Intensitt';
  ZuFiltern[4].Bezeichnung_s := 'Halbwertsbreite';
  ZuFiltern[5].Bezeichnung_s := 'Maximale Steigung';
  ZuFiltern[6].Bezeichnung_s := 'Minimale Steigung';
  ZuFiltern[7].Bezeichnung_s := 'Signaldeformation';
  ZuFiltern[8].Bezeichnung_s := 'Offset';
  ZuFiltern[9].Bezeichnung_s := 'Substanzidentifikation';

  BezeichnungenInNStringGrid(ZuFiltern, Pred(High(ZuFiltern)));

  Result := Filtern(ZuFiltern);

  ZuFiltern := Nil
End;



Procedure TFilternForm.BezeichnungenInNStringGrid(Var ZuFiltern : TZuFiltern;
                                                      Anzahl_i  : Integer);

Var i : Integer;

Begin
  FilternNStringGrid.RowCount := Succ(Anzahl_i);
  For i := 1 To Anzahl_i Do
      FilternNStringGrid.StrWrite(0, i, ZuFiltern[i].Bezeichnung_s)
End;



Function TFilternForm.Filtern(Var ZuFiltern : TZuFiltern) : Integer;

Var i, r, k     : Integer;
    ok_b        : Boolean;
    Betroffen_b : Boolean;

Function SignalBetroffen_b(NStringGrid  : TNStringGrid;
                           Signal_i     : Integer;
                           von_e, bis_e : Extended) : Boolean;

Var wert_e                 : Extended;
    i                      : Integer;
    LinieVon_i, LinieBis_i : Integer;

Begin
  Result := False;
  With NStringGrid Do
       Begin
         If GewaehltRadioButton.Checked Then
            Begin
              LinieVon_i := Col;
              LinieBis_i := Col;
              If LinieBis_i = 0 Then
                 Begin
                   Inc(LinieBis_i);
                   Inc(LinieVon_i)
                 End
            End
            Else
            Begin
              LinieVon_i := 1;
              LinieBis_i := 60;
              For i := 60 DownTo 1 Do
                  If StrRead_s(i, Signal_i) = '' Then Dec(LinieBis_i)
            End;
         For i := LinieVon_i to LinieBis_i Do
             Begin
               wert_e := NStringGrid.FloatRead_e(i, Signal_i);
               If (ExecStatus_b_Prop) And
                  (wert_e >= von_e)   And
                  (wert_e <= bis_e)   Then Result := True
             End
       End
End;

Procedure NEditPruefung(Var NStringGrid : TNStringGrid;
                        Var ZuFiltern   : TZuFiltern;
                        Var NEdit       : TNEdit);

Var i, k : Integer;

Begin //NEditPruefung
  i := 0;
  While Not(i = Pred(NStringGrid.RowCount)) Do
        Begin
          Inc(i);
          With NStringGrid Do
               If NEdit.Text = StrRead_s(Col, i) Then
                  Begin
                    If RowCount = 2 Then
                       For k := 0 To High(ZuFiltern) Do
                             ZuFiltern[k].NStringGrid.ClearRow(i)
                       Else
                       Begin
                         For k := 0 To High(ZuFiltern) Do
                             ZuFiltern[k].NStringGrid.DeleteRow(i);
                         Dec(i)
                       End
                  End
        End;
End;

Begin  //TFilternForm.Filtern
  Repeat
    Result := ShowModal;
    If Result = mrOK Then  //berprfung der Eingabe
       Begin
         With FilternNStringGrid Do
              For i := 1 To Pred(RowCount) Do
                  If Not((StrRead_s(1, i) = '') And (StrRead_s(2, i) = '')) Then
                     Begin
                       FilternNStringGrid.FloatRead_e(1, i);
                       FilternNStringGrid.FloatRead_e(2, i)
                     End;
         ok_b := FilternNStringGrid.ExecStatus_b_Prop
       End
       Else
       ok_b := True;

    If ok_b And (Result = mrOK) Then
       Begin
         //Signalbeschreibung filtern
         NEditPruefung(ZuFiltern[0].NStringGrid, ZuFiltern, BeschreibungNEdit);

         //Alle Linien- bzw. Bandeneigenschaften (Breite, Retentionszeit, etc.)
         //filtern
         i := 0;
         While Not(i = Pred(ZuFiltern[0].NStringGrid.RowCount)) Do
               Begin
                 Inc(i);
                 r := 0;
                 Betroffen_b := False;
                 With FilternNStringGrid Do
                      While Not(Betroffen_b Or (r = Pred(RowCount))) Do
                            Begin
                              Inc(r);
                              If Not(StrRead_s(1, r) = '') Then
                                 If SignalBetroffen_b(ZuFiltern[r].NStringGrid,
                                                      i,
                                                      FloatRead_e(1, r),
                                                      FloatRead_e(2, r))
                                    Then
                                    If ZuFiltern[0].NStringGrid.RowCount = 2
                                       Then
                                       For k := 0 To High(ZuFiltern) Do
                                           With ZuFiltern[k].NStringGrid Do
                                                ClearRow(i)
                                           Else
                                           Begin
                                             For k := 0 To High(ZuFiltern) Do
                                                With ZuFiltern[k].NStringGrid Do
                                                     DeleteRow(i);
                                             Dec(i);
                                             Betroffen_b := True
                                           End;
                            End;

               End;

         //Nach identifizierten Signalen filtern
         If ZuFiltern[High(ZuFiltern)].Bezeichnung_s = 'Substanzidentifikation'
            Then
            NEditPruefung(ZuFiltern[High(ZuFiltern)].NStringGrid,
                          ZuFiltern,
                          IdentNEdit);
       End
       Else If Not(ok_b) Then
               Begin
                 MessageBeep(MB_ICONSTOP);
                 MessageDlg('Fehlerhafte Eingabe!', mtError, [mbOK], 0)
               End;

  Until ok_b;
End;



Function TFilternForm.ShowModal(HistoryNStringGrid   : TNStringGrid;
                                IntegraleNStringGrid : TNStringGrid;
                                MaxIntNStringGrid    : TNStringGrid;
                                HWBNStringGrid       : TNStringGrid;
                                DeformNStringGrid    : TNStringGrid;
                                OffsetNStringGrid    : TNStringGrid) : Integer;



Var ZuFiltern : TZuFiltern;

Begin //ShowModal
  IdentNEdit.Enabled := False;
  IdentLabel.Enabled := False;

  //Stringgrids zur besseren Handhabbarkeit in ein dynamisches Array
  SetLength(ZuFiltern, 6);

  ZuFiltern[0].NStringGrid   := HistoryNStringGrid;
  ZuFiltern[1].NStringGrid   := IntegraleNStringGrid;
  ZuFiltern[2].NStringGrid   := MaxIntNStringGrid;
  ZuFiltern[3].NStringGrid   := HWBNStringGrid;
  ZuFiltern[4].NStringGrid   := DeformNStringGrid;
  ZuFiltern[5].NStringGrid   := OffsetNStringGrid;

  ZuFiltern[1].Bezeichnung_s := 'Integral';
  ZuFiltern[2].Bezeichnung_s := 'Maximale Intensitt';
  ZuFiltern[3].Bezeichnung_s := 'Halbwertsbreite';
  ZuFiltern[4].Bezeichnung_s := 'Signaldeformation';
  ZuFiltern[5].Bezeichnung_s := 'Offset';

  BezeichnungenInNStringGrid(ZuFiltern, High(ZuFiltern));

  Result := Filtern(ZuFiltern);

  ZuFiltern := Nil
End;



end.
