unit LinienAuswahlFormular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, NStringGridKomponente, StdCtrls, Buttons, Einstellungsformular,
  Menus, LinienUmbenennenFormular;

type
  TChosenLines_a_s = Array[0..Pred(MAXLINZAHL_I)] Of String;
  TChosenLines_a_b = Array[0..Pred(MAXLINZAHL_I)] Of Boolean;
  TPosVorher_a_i   = Array[0..Pred(MAXLINZAHL_I)] Of Integer;

  TLinienAuswahlForm = class(TForm)
    LinienNStringGrid: TNStringGrid;
    OKBitBtn: TBitBtn;
    AbbrechenBitBtn: TBitBtn;
    PopupMenu: TPopupMenu;
    UmbenennnenMenueItem: TMenuItem;
    procedure LinienNStringGridDblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure UmbenennnenMenueItemClick(Sender: TObject);
  private
    { Private-Deklarationen }
    Function Auswahl(Var ChosenLines_a_b : TChosenLines_a_b;
                         LinNamen_s      : String) : Integer;
  public
    { Public-Deklarationen }

    Function ShowModal(Var ChosenLines_a_b : TChosenLines_a_b;
                           LinNamen_s      : String) : Integer; Overload;

    Function ShowModal(Var ChosenLines_a_b : TChosenLines_a_b;
                       Var ChosenLines_a_s : TChosenLines_a_s;
                           LinNamen_s      : String;
                       Var NeuLinNamen_s   : String;
                       Var PosVorher_a_i   : TPosVorher_a_i): Integer; Overload;
  end;

var
  LinienAuswahlForm: TLinienAuswahlForm;

implementation



{$R *.DFM}

procedure TLinienAuswahlForm.LinienNStringGridDblClick(Sender: TObject);
begin
  With LinienNStringGrid Do
       If StrRead_s(3, Row) = 'Nein' Then Cells[3, Row] := 'Ja'
                                     Else Cells[3, Row] := 'Nein'
end;



procedure TLinienAuswahlForm.FormCreate(Sender: TObject);

Var i : Integer;

begin
  With LinienNStringGrid Do
       Begin
         StrWrite(1, 0, 'Nr.');
         StrWrite(2, 0, 'Signal');
         StrWrite(3, 0, 'Anzeigen?')
       End
end;



Function TLinienAuswahlForm.Auswahl(Var ChosenLines_a_b : TChosenLines_a_b;
                                        LinNamen_s      : String) : Integer;
Const TRENNZEICHEN = ';';

Var i, j : Integer;

Begin
  With LinienNStringGrid Do
       Begin
         RowCount := 2;
         j := 1;
         StrWrite(2, j, '');
         For i := 1 To Length(LinNamen_s) Do
             If LinNamen_s[i] = TRENNZEICHEN Then
                Begin
                  Inc(j);
                  RowCount := Succ(j);
                  StrWrite(2, j, '')
                End
                Else StrWrite(2, j, StrRead_s(2, j) + LinNamen_s[i]);

         For i := 1 To Pred(RowCount) Do
             Begin
               StrWrite(1, i, IntToStr(i));
               If ChosenLines_a_b[Pred(i)] Then StrWrite(3, i, 'Ja')
                                           Else StrWrite(3, i, 'Nein');
             End
       End;
  Result := ShowModal;
  If Result = mrOK Then
     With LinienNStringGrid Do
          For i := 1 To Pred(RowCount) Do
              ChosenLines_a_b[Pred(i)] := (StrRead_s(3, i) = 'Ja');
End;



Function TLinienAuswahlForm.
         ShowModal(Var ChosenLines_a_b : TChosenLines_a_b;
                   Var ChosenLines_a_s : TChosenLines_a_s;
                       LinNamen_s      : String;
                   Var NeuLinNamen_s   : String;
                   Var PosVorher_a_i   : TPosVorher_a_i) : Integer;

Var i, lz_i : Integer;

Begin
  LinienAuswahlForm.Caption := 'Linien lschen und umbenennen';
  With LinienNStringGrid Do
       Begin
         StrWrite(3, 0, 'Lschen?');
         Options := Options + [goRowMoving];
         PopupMenu.AutoPopup := True
       End;
  MessageBeep(MB_ICONHAND);
  If MessageDlg(  'Das Lschen, Verschieben oder Umbenennen von Linien kann '
                + 'nicht rckgngig gemacht werden! '
                + 'Trotzdem fortfahren?',
                mtWarning, [mbYes, mbNo], 0            ) = mrYES Then
     Result := Auswahl(ChosenLines_a_b, LinNamen_s)
     Else
     Result := mrCancel;
  If Result = mrOK Then
     Begin
       NeuLinNamen_s := '';
       lz_i          := -1;
       For i := 1 To Pred(LinienNStringGrid.RowCount) Do
           If Not(ChosenLines_a_b[Pred(i)]) Then
              Begin
                Inc(lz_i);
                NeuLinNamen_s :=   NeuLinNamen_s
                                 + LinienNStringGrid.StrRead_s(2, i) + ';';
                ChosenLines_a_s[lz_i] := LinienNStringGrid.StrRead_s(2, i);
                //Wohin wurde die Linie verschoben?
                PosVorher_a_i[Pred(i)]
                           := Pred(StrToInt(LinienNStringGrid.StrRead_s(1, i)));
              End;
       If Not(NeuLinNamen_s = '') Then
          If NeuLinNamen_s[Length(NeuLinNamen_s)] = ';' Then
             SetLength(NeuLinNamen_s, Pred(Length(NeuLinNamen_s)))
     End
     Else NeuLinNamen_s := LinNamen_s
End;



Function TLinienAuswahlForm.
         ShowModal(Var ChosenLines_a_b : TChosenLines_a_b;
                       LinNamen_s      : String) : Integer;

Const Trennzeichen = ';';

Var i, j : Integer;

Begin
  LinienAuswahlForm.Caption := 'Sichtbare Linien';
  With LinienNStringGrid Do
       Begin
         LinienNStringGrid.StrWrite(3, 0, 'Anzeigen');
         Options := Options - [goRowMoving];
         PopupMenu.AutoPopup := False
       End;
  Result := Auswahl(ChosenLines_a_b, LinNamen_s)
End;




procedure TLinienAuswahlForm.UmbenennnenMenueItemClick(Sender: TObject);

Var Lines_a_s : TLines_a_s;
    i         : Integer;

begin
  With LinienNStringGrid Do
       For i := 1 To Pred(RowCount) Do Lines_a_s[i] := StrRead_s(2, i);
  LinienUmbenennenForm.ShowModal(Lines_a_s);
  With LinienNStringGrid Do
       For i := 1 To Pred(RowCount) Do StrWrite(2, i, Lines_a_s[i]);
end;




end.
