unit SignaleKlasse;

interface



Uses StringArrayKlasse, Sysutils;



Const MAXLINZAHL = 60;



Type

TSignale = Class (TObject)

Private
  MaxSignZahl_i : Integer;
  Procedure StringArraysFreigeben;
  Function GetMaxLinZahl_i : Integer;

Public
  IntegrStringArray  : TStringArray;
  RetZeitStringArray : TStringArray;
  MaxIntStringArray  : TStringArray;
  HwbStringArray     : TStringArray;
  MaxStgStringArray  : TStringArray;
  MinStgStringArray  : TStringArray;
  DeformStringArray  : TStringArray;
  OffsetStringArray  : TStringArray;
  HistoryStringArray : TStringArray;
  IdentStringArray   : TStringArray;
  Constructor Create(EMaxSignZahl_i :Integer);
  Destructor Destroy; Override;
  Procedure initialisieren;
  Property MaxLinZahl_i_prop : Integer Read GetMaxLinZahl_i;
  Property MaxSignZahl_i_prop : Integer Read MaxSignZahl_i;
End;




implementation



Procedure tSignale.Initialisieren;
Begin
  //Die vorigen Daten werden vernichtet
  HistoryStringArray.leeren;
  IntegrStringArray. leeren;
  RetZeitStringArray.leeren;
  MaxIntStringArray. leeren;
  HWBStringArray.    leeren;
  MaxStgStringArray. leeren;
  MinStgStringArray. leeren;
  DeformStringArray. leeren;
  OffsetStringArray. leeren;
  IdentStringArray.  leeren;
  //In die String-Arrays wird die Beschreibung der einzelnen Signalparameter
  //eingelesen (=Legende der Tabellen in "signaleform" Unit signaleformular
  IntegrStringArray. StrWrite(0 , 0, 'Bezeichnung');
  RetZeitStringArray.StrWrite(0 , 0, 'Bezeichnung');
  MaxIntStringArray. StrWrite(0 , 0, 'Bezeichnung');
  HWBStringArray.    StrWrite(0 , 0, 'Bezeichnung');
  MaxStgStringArray. StrWrite(0 , 0, 'Bezeichnung');
  MinStgStringArray. StrWrite(0 , 0, 'Bezeichnung');
  DeformStringArray. StrWrite(0 , 0, 'Bezeichnung');
  OffsetStringArray. StrWrite(0 , 0, 'Bezeichnung');
  With HistoryStringArray Do
       Begin
         StrWrite(0,  0, 'Bezeichnung');
         StrWrite(1,  0, 'Von');
         StrWrite(2,  0, 'Bis');
         StrWrite(3,  0, 'Null-von');
         StrWrite(4,  0, 'Null-bis');
         StrWrite(5,  0, 'Chromatogramm Datum');
         StrWrite(6,  0, 'Chromatogramm Uhrzeit');
         StrWrite(7,  0, 'Belichtungszeit');
         StrWrite(8,  0, 'Wiederholmessungen');
         StrWrite(9,  0, 'Glttungen des Spektrums');
         StrWrite(10, 0, 'Nullabgleich im Spektrum');
         StrWrite(11, 0, 'Signalbestimmung Datum');
         StrWrite(12, 0, 'Signalbestimmung Uhrzeit');
         StrWrite(13, 0, 'Normierung (Ext. St. Linie)');
         StrWrite(14, 0, 'Ext. Standard Datum');
         StrWrite(15, 0, 'Ext. Standard Uhrzeit');
         StrWrite(16, 0, 'Ext. St. Offset Datum');
         StrWrite(17, 0, 'Ext. St. Offset Uhrzeit');
         StrWrite(18, 0, 'Dreipunkteglttung');
         StrWrite(19, 0, 'Fnfpunkteglttung');
         StrWrite(20, 0, 'Siebenpunkteglttung');
         StrWrite(21, 0, 'Basislinienkorekturen');
         StrWrite(22, 0, 'Ableitungen');
         StrWrite(23, 0, 'Protokoll-Liste der '+
                                'Chromatorgrammmodifikationen')
       End;
  IdentStringArray.StrWrite(0, 0, 'Bezeichnung');
  IdentStringArray.StrWrite(1, 0, 'Datum/Uhrzeit');
  IdentStringArray.StrWrite(2, 0, 'Ergebnis der Substanzerkennung')
End;



Procedure tSignale.StringArraysFreigeben;
Begin
  IntegrStringArray.Free;
  RetZeitStringArray.Free;
  MaxIntStringArray.Free;
  HwbStringArray.Free;
  MaxStgStringArray.Free;
  MinStgStringArray.Free;
  DeformStringArray.Free;
  OffsetStringArray.Free;
  HistoryStringArray.Free;
  IdentStringArray.Free
End;



Constructor tSignale.create(EMaxSignZahl_i : Integer);
Begin
  //Die String-Arrays fr die chromatographschen Signale werden erzeugt
  Try IntegrStringArray  := TStringArray.Create(MAXLINZAHL, EMaxSignZahl_i, 3);
      RetZeitStringArray := TStringArray.Create(MAXLINZAHL, EMaxSignZahl_i, 3);
      MaxIntStringArray  := TStringArray.Create(MAXLINZAHL, EMaxSignZahl_i, 3);
      HwbStringArray     := TStringArray.Create(MAXLINZAHL, EMaxSignZahl_i, 3);
      MaxStgStringArray  := TStringArray.Create(MAXLINZAHL, EMaxSignZahl_i, 3);
      MinStgStringArray  := TStringArray.Create(MAXLINZAHL, EMaxSignZahl_i, 3);
      DeformStringArray  := TStringArray.Create(MAXLINZAHL, EMaxSignZahl_i, 3);
      OffsetStringArray  := TStringArray.Create(MAXLINZAHL, EMaxSignZahl_i, 3);
      HistoryStringArray := TStringArray.Create(23, EMaxSignZahl_i, 3);
      IdentStringArray   := TStringArray.Create(3,  EMaxSignZahl_i, 3);
      MaxSignZahl_i := EMaxSignZahl_i;
  Except IntegrStringArray. Free;
         RetZeitStringArray.Free;
         MaxIntStringArray. Free;
         HwbStringArray.    Free;
         MaxStgStringArray. Free;
         MinStgStringArray. Free;
         DeformStringArray. Free;
         OffsetStringArray. Free;
         HistoryStringArray.Free;
         IdentStringArray.  Free;
         Raise
  End
End;



Destructor TSignale.Destroy;
Begin
  StringArraysFreigeben;
  Inherited Destroy
End;



Function TSignale.GetMaxLinZahl_i : Integer;
Begin
  Result := MAXLINZAHL
End;



end.
