unit SimulationsFormular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, NStringGridKomponente, NEditKomponente,
  DatenKlasse, DatenbankKlasse, Menus, ExtCtrls;

type
  TSimulationsForm = class(TForm)
    HoeheLabel: TLabel;
    BreiteLabel: TLabel;
    DeformationsLabel: TLabel;
    ErgebnisLabel: TLabel;
    SimulationBitBtn: TBitBtn;
    BeendenBitBtn: TBitBtn;
    ErgebnisNStringGrid: TNStringGrid;
    HoeheNEdit: TNEdit;
    BreiteNEdit: TNEdit;
    DeformNEdit: TNEdit;
    OffsetLabel: TLabel;
    OffsetNEdit: TNEdit;
    SubstanzLabel: TLabel;
    SubstanzNEdit: TNEdit;
    CopyPopupMenu: TPopupMenu;
    KopierenMenuItem: TMenuItem;
    IntensOffsetLabel: TLabel;
    IntensONEdit: TNEdit;
    Panel1: TPanel;
    VerwendeteSignaleCheckBox: TCheckBox;
    KParameterLabel: TLabel;
    StatistikLabel: TLabel;
    StatKeineRadioButton: TRadioButton;
    StatRechnungRadioButton: TRadioButton;
    StatVarRedRadioButton: TRadioButton;
    procedure SimulationBitBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ErgebnisNStringGridMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure KopierenMenuItemClick(Sender: TObject);
  private
    { Private-Deklarationen }
    daten          : TDaten;
    SubstDatName_s : String;
  public
    { Public-Deklarationen }
    Function ShowModal(Var GDaten          : TDaten;
                           GSubstDatName_s : String;
                           GSubstanzName_s : String) : Integer; Overload;
  end;

var
  SimulationsForm: TSimulationsForm;

implementation

{$R *.DFM}


Function TSimulationsForm.ShowModal(Var GDaten          : TDaten;
                                        GSubstDatName_s : String;
                                        GSubstanzName_s : String) : Integer;
Begin
  Daten              := GDaten;
  SubstanzNEdit.Text := GSubstanzName_s;
  SubstDatName_s     := GSubstDatName_s;
  Result             := ShowModal
End;


procedure TSimulationsForm.SimulationBitBtnClick(Sender: TObject);

Var ZuBestAufbSignal   : TAufbSignal;
    InterpolAufbSignal : TAufbSignal;
    VerwSignSubstanz   : TSubstanz;
    i, s, z            : Integer;
    Linien_a_s         : TLinien_a_s;

begin
  With ZuBestAufbSignal Do
        Begin
          SetLength(KParam_da_e, 5);
          KParam_da_e[0] := HoeheNEdit.  FloatRead_e;
          KParam_da_e[1] := IntensONEdit.FloatRead_e;
          KParam_da_e[2] := OffsetNEdit. FloatRead_e;
          KParam_da_e[3] := BreiteNEdit. FloatRead_e;
          KParam_da_e[4] := DeformNEdit. FloatRead_e
        End;
  Daten.DBSimulation(ZuBestAufbSignal, InterpolAufbSignal, Linien_a_s,
                     SubstDatName_s, VerwSignSubstanz,
                     VerwendeteSignaleCheckBox.Checked,
                     StatRechnungRadioButton.Checked,
                     StatVarRedRadioButton.Checked);
  With ErgebnisNStringGrid Do
       If Length(InterpolAufbSignal.Intens_da_e) = 0 Then
          ClearAll
          Else
          Begin
            RowCount := Succ(Length(InterpolAufbSignal.Intens_da_e));
            ClearAll;

            If Not(VerwSignSubstanz = Nil) Then
               Begin
                 With InterpolAufbSignal Do
                      If Length(VerwSignSubstanz) > Length(Intens_da_e) Then
                         Begin
                           RowCount := Succ(Length(VerwSignSubstanz));
                           ClearAll;
                         End;
                 ColCount := 7 + Length(VerwSignSubstanz[0].Intens_da_e);
                 StrWrite(2, 0, 'Intensitt');
                 StrWrite(3, 0, 'Intensitt der Offsetbande');
                 StrWrite(4, 0, 'Offset');
                 StrWrite(5, 0, 'Halbwertsbreite');
                 StrWrite(6, 0, 'Signaldeformation');
                 For s := 7 To Pred(ColCount) Do
                     StrWrite(s, 0, Linien_a_s[s - 6]);
                 For z := 1 To Length(VerwSignSubstanz) Do
                     With VerwSignSubstanz[Pred(z)] Do
                          Begin
                            For s := 2 To 6 Do
                                StrWrite(s, z, FloatToStr(KParam_da_e[s-2]));
                            For s := 7 To Pred(ColCount) Do
                                StrWrite(s, z, FloatToStr(Intens_da_e[s-7]));
                          End;
                 For i := 0 To High(VerwSignSubstanz) Do
                     Begin
                       VerwSignSubstanz[i].KParam_da_e := Nil;
                       VerwSignSubstanz[i].intens_da_e := Nil
                     End;
                 VerwSignSubstanz := Nil
               End
               Else
               ColCount := 2;
          End;
  With InterpolAufbSignal Do
       For i := 0 To High(Intens_da_e) Do
           Begin
             ErgebnisNStringGrid.FloatWrite(1, Succ(i), Intens_da_e[i]);
             ErgebnisNStringGrid.  StrWrite(0, Succ(i), Linien_a_s[Succ(i)])
           End;
  ZuBestAufbSignal.KParam_da_e   := Nil;
  InterpolAufbSignal.KParam_da_e := Nil;
  InterpolAufbSignal.intens_da_e := Nil
end;



procedure TSimulationsForm.FormCreate(Sender: TObject);
begin
  With ErgebnisNStringGrid Do
       Begin
         StrWrite(0, 0, 'Bande bzw. Linie');
         StrWrite(1, 0, 'Intensitt der Bande bzw. Linie')
       End;
  StatKeineRadioButton.Checked := True;
end;




procedure TSimulationsForm.ErgebnisNStringGridMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  If Button = mBRight Then CopyPopupMenu.Popup(x + Left +
                                               ErgebnisNStringGrid.Left + 7,
                                               y + Top  +
                                               ErgebnisNStringGrid.Top + 25)
end;


procedure TSimulationsForm.KopierenMenuItemClick(Sender: TObject);
begin
  ErgebnisNStringGrid.InClipboard
end;



end.
