unit StAVerzeichnisFormular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, FileCtrl;

type
  TStAVerzeichnisForm = class(TForm)
    StAVerzeichnisLabel: TLabel;
    OKBitBtn: TBitBtn;
    AbbruchBitBtn: TBitBtn;
    SAVDirectoryListBox: TDirectoryListBox;
    SAVDriveComboBox: TDriveComboBox;
    SAVDirLabel: TLabel;
    AktSAVEdit: TEdit;
    AktSAVLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure SAVDirectoryListBoxDblClick(Sender: TObject);
    procedure SAVDirectoryListBoxChange(Sender: TObject);
  private
    { Private-Deklarationen }
    Standardarbeitsverzeichnis_s : String;
    Programmverzeichnis_s        : String;
  public
    { Public-Deklarationen }
    Function ShowModal(Var StAVerzeichnis_s : String) : Integer; Overload;
    Property StAVerzeichnis_s_prop : String Read Standardarbeitsverzeichnis_s;
  end;

var
  StAVerzeichnisForm: TStAVerzeichnisForm;

implementation

{$R *.DFM}


Function TStAVerzeichnisForm.ShowModal(Var StAVerzeichnis_s : String) : Integer;

Var Datei_txt : TextFile;
    OK_b      : Boolean;

Begin
  Result := ShowModal;
  If Result = mrOK Then
     Begin
       Standardarbeitsverzeichnis_s := AktSAVEdit.Text;
       StAVerzeichnis_s             := Standardarbeitsverzeichnis_s;
       Try AssignFile(datei_txt, Programmverzeichnis_s  + '\SAVerzeichnis.SPD');
           Rewrite(datei_txt);
           ok_b := True;
       Except ok_b := False;
       End;
       If ok_b Then
          Begin
            Try Write(datei_txt, Standardarbeitsverzeichnis_s);
            Except ok_b := False;
            End;
            Try CloseFile(datei_txt);
            Except ok_b := False
            End
          End;
       If Not(ok_b) Then
          Begin
            MessageBeep(MB_ICONSTOP);
            MessageDlg(  'Fehler beim Speichern des Standardarbeitsverzeichnis!'
                       + ' ("StArbeistsverzeichnis.SPD")',
                       mtError, [mbOK], 0                                     )
          End
     End
End;


procedure TStAVerzeichnisForm.FormCreate(Sender: TObject);


Var Datei_txt : TextFile;
    OK_b      : Boolean;

begin
  GetDir(0, Programmverzeichnis_s);
  Try AssignFile(datei_txt, Programmverzeichnis_s  + '\SAVerzeichnis.SPD');
      Reset(datei_txt);
      ok_b := True;
  Except ok_b := False;
  End;
  If ok_b Then
     Begin
       Try Read(datei_txt, Standardarbeitsverzeichnis_s);
       Except ok_b := False;
       End;
       Try CloseFile(datei_txt);
       Except ok_b := False
       End
     End;
  If Not(ok_b) Then
     Begin
       MessageBeep(MB_ICONSTOP);
       MessageDlg(  'Fehler beim Laden des Standardarbeitsverzeichnis! '
                  + '("StArbeistsverzeichnis.SPD")',
                  mtError, [mbOK], 0                                      );
       GetDir(0, StandardArbeitsverzeichnis_s)
     End;
  AktSAVEdit.Text := StandardArbeitsverzeichnis_s
end;



procedure TStAVerzeichnisForm.SAVDirectoryListBoxDblClick(Sender: TObject);
begin
  AktSAVEdit.Text := SAVDirLabel.Caption
end;



procedure TStAVerzeichnisForm.SAVDirectoryListBoxChange(Sender: TObject);
begin
  AktSAVEdit.Text := SAVDirLabel.Caption
end;

end.
