unit integralformular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Buttons, ComCtrls, EinstellungsFormular, StringGitter,
  ExtCtrls, datenbankobjekt, wellenkalformular;

type
  tint_wert_a_i = Array[1..60] Of Integer;
  tzeiten       = Array[1..60] Of Single;
  tmodus        = (moChrom, moSpektr);

  TIntegralForm = class(TForm)
    IntegraleStringGitter: TStringGitter;
    ok       : TBitBtn;
    Abbruch  : TBitBtn;
    loeschen : TBitBtn;
    PageControl: TPageControl;
    IntegraleTabSheet: TTabSheet;
    RetZeitTabSheet: TTabSheet;
    MaxIntTabSheet: TTabSheet;
    HWBTabSheet: TTabSheet;
    RetZeitStringGitter: TStringGitter;
    MaxIntStringGitter: TStringGitter;
    HWBStringGitter: TStringGitter;
    uebernehmen: TBitBtn;               //in das Linienformular uebernehemn
    wellenlaengenkalibration: TBitBtn;
    MaxStgTabSheet: TTabSheet;
    MinStgTabSheet: TTabSheet;
    MaxStgStringGitter: TStringGitter;
    MinStgStringGitter: TStringGitter;
    InDatenbankBitBtn: TBitBtn;
    BestimmungBitBtn: TBitBtn;
    Panel1: TPanel;
    AllesRadioButton: TRadioButton;
    NurRadioButton: TRadioButton;
    HistoryTabSheet: TTabSheet;
    HistoryStringGitter: TStringGitter;
    SubstBestTabSheet: TTabSheet;
    IdentStringGitter: TStringGitter;
    procedure FormCreate(Sender: TObject);
    procedure AbbruchClick(Sender: TObject);
    procedure loeschenClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure uebernehmenClick(Sender: TObject);
    procedure wellenlaengenkalibrationClick(Sender: TObject);
    procedure IntegraleStringGitterSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure InDatenbankBitBtnClick(Sender: TObject);
    procedure RetZeitStringGitterSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure MaxIntStringGitterSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure HWBStringGitterSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure MaxStgStringGitterSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure MinStgStringGitterSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure IdentStringGitterSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure HistoryStringGitterSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure BestimmungBitBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
    puffer_s : String;//Puffer fr die Eingabe, falls jemand versucht Integrale
                      //und nicht deren Bezeichungen zu editieren

    v_modus  : tmodus;

    spiegel  : Record //Enthlt den Spiegel des StringGitters zur Wiederher-
                 integrale_a_s : Array[0..64,1..50] Of String;//stellung
                 retzeit_a_s   : Array[0..64,1..50] Of String;//falls
                 max_int_a_s   : Array[0..64,1..50] Of String;//Abbre-
                 hwb_a_s       : Array[0..64,1..50] Of String;//chen
                 maxstg_a_s    : Array[0..64,1..50] Of String;//gewhlt
                 minstg_a_s    : Array[0..64,1..50] Of String;//wurde
                 history_a_s   : Array[0..1, 1..50] Of String;
                 ident_a_s     : Array[0..20,1..50] Of String;
                 anzahl_i      : Integer
               End;

    Procedure SetEditText(StringGitter : TStringGitter; //Sorgt fr die Ver-
                          Col_i, Row_i : Integer;       //nderung des Bezeich-
                          Value_s      : String);       //nungsstrings in
                                                        //allen Stringgittern

    Procedure bereiche_einlesen(    bezeichnung_s   : String; //Einlesen der
                                    von_si, bis_si,           //Integrations-
                                    blankvon_si,              //bereiche in das
                                    blankbis_si     : Single; //StringGitter
                                    nummer_i        : Integer;
                                Var StringGitter      : tStringGitter);

    Procedure setmodus(value : tmodus);

    Function gewaehltes_signal_i : Integer;

    Function signalzahl_i : Integer;

  public
    { Public-Deklarationen }
    veraendert_b  : Boolean;

    peak_anzahl_i : Integer;  //Anzahl der Integrale

    Procedure peaks_einlesen(bezeichnung_s            : String;
                             von_si, bis_si,
                             blankvon_si, blankbis_si : Single;
                             int_wert_a_i             : tint_wert_a_i;
                             maximas_a_si             : tzeiten;
                             maximas_a_i              : tint_wert_a_i;
                             hwb_a_si                 : tzeiten;
                             maxstg_a_i               : tint_wert_a_i;
                             minstg_a_i               : tint_wert_a_i;
                             lz_i                     : Integer;
                             history_s                : String);
                           //Einlesen aller relevanten Daten eines Integrations-
                           //vorgangs in das StringGitter

    Procedure peaks_einlesen_i(     bezeichnung_s   : String;
                                    von_si, bis_si,
                                    blankvon_si,
                                    blankbis_si   : Single;
                                    lz_i          : Integer;
                                    nummer_i      : Integer;
                                    werte_a_i     : tint_wert_a_i;
                                Var StringGitter    : tStringGitter);
                              //Einlesen von Intensittswerten in das anzugebene
                              //StringGitter

    Procedure peaks_einlesen_si(     bezeichnung_s   : String;
                                     von_si, bis_si,
                                     blankvon_si,
                                     blankbis_si   : Single;
                                     lz_i          : Integer;
                                     nummer_i      : Integer;
                                     werte_a_si    : tzeiten;
                                 Var StringGitter    : tStringGitter);
                              //Einlesen von Zeiten in das anzugebene
                              //StringGitter, also Halbwertsbreiten in hwb oder
                              //Retentionszeiten in maximas

    Procedure peaks_einlesen_history(bezeichnung_s : String;
                                     peak_anzahl_i : Integer;
                                     history_s     : String);
              //Einlesen einer Liste, welche die mit dem Chromatogramm
              //durchgefhten Aufbereitungsoperationen wie Gltten, Basislinien-
              //abgleich, etc. enthlt

    Procedure peaks_einlesen_Ident(bezeichnung_s : String;
                                   peak_anzahl_i : Integer);
              //Einlesen der Ergebnisse der Substanzartbestimmung

    Procedure peakanzahl_setzen(anzahl_i : Integer);

    Procedure lin_bez_einlesen(nummer_i : Integer; p_lin_nahm_s : String);
              //Einlesen der Linienbezeichnungen in das StringGitter

    Function zellen_auslesen(    zeile_i, lz_i : Integer;
                             Var StringGitter    : TStringGitter) : String;
                             //Gibt eine komplette Zeile des StringGitters zurck,
                             //also Daten der Integrale, Maximas und Halbwerts-
                             //breiten

    Function zuviele : Boolean;  //Zu viele Integrale? (Mehr als 50 = max?)

    Function peakanzahl_i : Integer;  //int_anzahl_i zurckgeben

    Procedure zuruecksetzen; //Leeren des Stringrids und peak_anzahl_i zurck-
                             //setzen

    Procedure spiegeln; //des StringGitters

  Published
    Property modus : tmodus Read v_modus Write setmodus;
  end;

var
  IntegralForm: TIntegralForm;

implementation

{$R *.DFM}



Procedure TIntegralForm.setmodus(value : tmodus);
Begin
  If value = moChrom Then
     Begin
       With uebernehmen Do Visible := False;
       With wellenlaengenkalibration Do Visible := False;
       With RetZeitTabSheet Do Caption := 'Retentionszeiten';
       With RetZeitStringGitter Do
            Hint := 'Intensittsmaximum nach der angegebene Zeit in Sekunden|' +
                    'Retentionszeiten in Sekunden';
       With HWBStringGitter Do
            Hint := 'Signalbreite auf halber Hhe in Sekunden|' +
                    'Halbwertsbreiten in Sekunden'
     End
     Else
     Begin
       With uebernehmen Do Visible := True;
       With wellenlaengenkalibration Do Visible := True;
       With RetZeitTabSheet Do Caption := 'Maxima bei...';
       With RetZeitStringGitter Do
            Hint := 'Intensittsmaximum bei der angegebene Wellenlnge in nm|' +
                    'Maximum bei...';
       With HWBStringGitter Do
            Hint := 'Signalbreite auf halber Hhe in nm|' +
                    'Halbwertsbreiten in nm'
     End;
  v_modus := Value;
End;



Procedure TIntegralForm.spiegeln;  //Das StringGitter wird gespiegelt

Var z, s : Integer;

Begin
  With spiegel Do
       Begin
         anzahl_i  := peak_anzahl_i;
         For z := 1 To 50 Do
             Begin
               For s := 0 To Pred(IntegraleStringGitter.ColCount) Do
                 Begin
                   integrale_a_s[s, z] := IntegraleStringGitter.cells[s, z];
                   RetZeit_a_s[s, z]   := RetZeitStringGitter.cells[s, z];
                   max_int_a_s[s, z]   := MaxIntStringGitter.cells[s,z];
                   hwb_a_s[s, z]       := HWBStringGitter.cells[s, z];
                   maxstg_a_s[s, z]    := MaxStgStringGitter.cells[s, z];
                   minstg_a_s[s, z]    := MinStgStringGitter.cells[s, z]
                 End;
               For s := 0 To 1 Do
                 history_a_s[s, z] := HistoryStringGitter.str_auslesen_s(s, z);
               For s := 0 To 2 Do
                   ident_a_s[s, z] := IdentStringGitter.str_auslesen_s(s, z);
             End
       End
End;




Procedure TIntegralForm.zuruecksetzen;  //Leeren des StringGitters und
                                            //und Zurcksetzen von peak_anzahl_i
Begin
  IntegraleStringGitter.leeren;
  RetZeitStringGitter.leeren;
  MaxIntStringGitter.leeren;
  HWBStringGitter.leeren;
  MaxStgStringGitter.leeren;
  MinStgStringGitter.leeren;
  historyStringGitter.leeren;
  IdentStringGitter.leeren;
  peak_anzahl_i := 0
End;



Function TIntegralForm.peakanzahl_i : Integer;
Begin
  Result := peak_anzahl_i
End;



Function TIntegralForm.zellen_auslesen(    zeile_i, lz_i : Integer;
                                           Var StringGitter  : TStringGitter)
                                           : String;

Const trennzeichen = ';';

Var i : Integer;

Begin
  Result := '';
  With StringGitter Do
       Begin
         For i := 0 To lz_i + 3 Do Result := Result + Cells[i, zeile_i] +
                                             trennzeichen;
         Result := Result + Cells[lz_i + 4, zeile_i]
       End
End;



Function TIntegralForm.zuviele : Boolean;  //Stellt fest, ob die maximale
Begin                                          //Anzahl an Integralen erreicht
  If peak_anzahl_i = 50 Then Result := True     //ist
     Else Result := False
End;



Procedure TIntegralForm.lin_bez_einlesen(nummer_i     : Integer;
                                         p_lin_nahm_s : String);
Begin  //Liest die Linienbezeichnungen in das StringGitter
  With IntegraleStringGitter Do Cells[5 + nummer_i, 0] := p_lin_nahm_s;
  With RetZeitStringGitter   Do Cells[5 + nummer_i, 0] := p_lin_nahm_s;
  With MaxIntStringGitter    Do Cells[5 + nummer_i, 0] := p_lin_nahm_s;
  With HWBStringGitter       Do Cells[5 + nummer_i, 0] := p_lin_nahm_s;
  With MaxStgStringGitter    Do Cells[5 + nummer_i, 0] := p_lin_nahm_s;
  With MinStgStringGitter    Do Cells[5 + nummer_i, 0] := p_lin_nahm_s
End;



Procedure TIntegralForm.bereiche_einlesen(    bezeichnung_s : String;
                                                  von_si,
                                                  bis_si,
                                                  blankvon_si,
                                                  blankbis_si   : Single;
                                                  nummer_i      : Integer;
                                              Var StringGitter  :tStringGitter);
//Liest die Integrationsbereiche in das angegebene StringGitter
Begin
  With StringGitter Do
       Begin
         Cells[0, nummer_i] := bezeichnung_s;
         float_einlesen(1, nummer_i, von_si);
         float_einlesen(2, nummer_i, bis_si);
         float_einlesen(3, nummer_i, blankvon_si);
         float_einlesen(4, nummer_i, blankbis_si)
       End
End;



Procedure TIntegralForm.peaks_einlesen_i(     bezeichnung_s : String;
                                                  von_si,
                                                  bis_si,
                                                  blankvon_si,
                                                  blankbis_si   : Single;
                                                  lz_i          : Integer;
                                                  nummer_i      : Integer;
                                                  werte_a_i     : tint_wert_a_i;
                                              Var StringGitter : tStringGitter);

Var i : Integer;

Begin
  bereiche_einlesen(bezeichnung_s, von_si, bis_si, blankvon_si, blankbis_si,
                    nummer_i, StringGitter);
                    //Integrationsbereiche in das StringGitter lesen

  With StringGitter Do//Bei dem Integrationsvorgang wichtige Intensittsparame-
       For i := 1 To lz_i Do //ter dem dafr vorgesehenen StringGitter bergeben
           int_einlesen(i + 4, nummer_i, werte_a_i[i]);
End;



Procedure TIntegralForm.peaks_einlesen_si(     bezeichnung_s : String;
                                                   von_si,
                                                   bis_si,
                                                   blankvon_si,
                                                   blankbis_si   : Single;
                                                   lz_i          : Integer;
                                                   nummer_i      : Integer;
                                                   werte_a_si    : tzeiten;
                                               Var StringGitter: tStringGitter);

Var i : Integer;

Begin
  bereiche_einlesen(bezeichnung_s, von_si, bis_si, blankvon_si, blankbis_si,
                    nummer_i, StringGitter);
                    //Integrationsbereiche in das StringGitter lesen

  With StringGitter Do  //Bei dem Integrationsvorgang wichtige Zeitparameter
       For i := 1 To lz_i Do  //dem dafr vorgesehenen StringGitter bergeben
           Float_einlesen(i + 4, nummer_i, werte_a_si[i])
End;



Procedure TIntegralForm.peaks_einlesen_history(bezeichnung_s : String;
                                                   peak_anzahl_i : Integer;
                                                   history_s     : String);
Begin
  With HistoryStringGitter Do
       Begin
         Str_einlesen(0, peak_anzahl_i, bezeichnung_s);
         Str_einlesen(1, peak_anzahl_i, history_s)
       End
End;



Procedure TIntegralForm.peaks_einlesen_Ident(bezeichnung_s : String;
                                                 peak_anzahl_i : Integer);
Begin
  With IdentStringGitter Do
       Begin
         Str_einlesen(0, peak_anzahl_i, bezeichnung_s);
       End
End;



Procedure TIntegralForm.peaks_einlesen(bezeichnung_s   : String;
                                           von_si, bis_si,
                                           blankvon_si,
                                           blankbis_si     : Single;
                                           int_wert_a_i    : tint_wert_a_i;
                                           maximas_a_si    : tzeiten;
                                           maximas_a_i     : tint_wert_a_i;
                                           hwb_a_si        : tzeiten;
                                           maxstg_a_i      : tint_wert_a_i;
                                           minstg_a_i      : tint_wert_a_i;
                                           lz_i            : Integer;
                                           history_s       : String);

//Einlesen der Integrale und aller weiteren Signalparameter das StringGitter

Var i : Integer;

Begin
  Inc(peak_anzahl_i);

  //Einlesen der Integrationsdaten in die einzelnen StringGitters
  peaks_einlesen_i(bezeichnung_s, von_si, bis_si, blankvon_si, blankbis_si,
                   lz_i, peak_anzahl_i, int_wert_a_i, IntegraleStringGitter);
  peaks_einlesen_si(bezeichnung_s, von_si, bis_si, blankvon_si, blankbis_si,
                    lz_i, peak_anzahl_i, maximas_a_si, RetZeitStringGitter);
  peaks_einlesen_i(bezeichnung_s, von_si, bis_si, blankvon_si, blankbis_si,
                   lz_i, peak_anzahl_i, maximas_a_i, MaxIntStringGitter);
  peaks_einlesen_si(bezeichnung_s, von_si, bis_si, blankvon_si, blankbis_si,
                    lz_i, peak_anzahl_i, hwb_a_si, HWBStringGitter);
  peaks_einlesen_i(bezeichnung_s, von_si, bis_si, blankvon_si, blankbis_si,
                   lz_i, peak_anzahl_i, maxstg_a_i, MaxStgStringGitter);
  peaks_einlesen_i(bezeichnung_s, von_si, bis_si, blankvon_si, blankbis_si,
                   lz_i, peak_anzahl_i, minstg_a_i, MinStgStringGitter);
  peaks_einlesen_history(bezeichnung_s, peak_anzahl_i, history_s);
  peaks_einlesen_ident(bezeichnung_s, peak_anzahl_i);
End;



Procedure TIntegralForm.peakanzahl_setzen(anzahl_i : Integer);
BEgin
  peak_anzahl_i := anzahl_i
End;



procedure TIntegralForm.FormCreate(Sender: TObject);

Type tzellen_a_s = Array[0..64,0..50] Of String;

Var zellen_a_s : tzellen_a_s;
    i, j       : Integer;

Procedure fuellen(Var StringGitter : tStringGitter);
Begin
  With StringGitter Do
       Begin
         str_einlesen(0, 0, 'Bezeichung');
         str_einlesen(1, 0, 'Von');
         str_einlesen(2, 0, 'Bis');
         str_einlesen(3, 0, 'Null-von');
         str_einlesen(4, 0, 'Null-bis')
       End;
  With NurRadioButton   Do Checked := True;
  With AllesRadioButton Do Checked := False
End;

begin
  fuellen(IntegraleStringGitter);
  fuellen(RetZeitStringGitter);
  fuellen(MaxIntStringGitter);
  fuellen(HWBStringGitter);
  fuellen(MaxStgStringGitter);
  fuellen(MinStgStringGitter);
  HistoryStringGitter.str_einlesen(0 , 0, 'Bezeichnung');
  HistoryStringGitter.str_einlesen(1 , 0,
                        'Bereits durchgefhrte Vernderungen am Chromatogramm');
  IdentStringGitter.str_einlesen(0, 0, 'Bezeichnung');
  IdentStringGitter.str_einlesen(1, 0, 'Datenbankoperation');
  IdentStringGitter.str_einlesen(2, 0, 'Ergebnis der Substanzerkennung');
  peak_anzahl_i := 0
end;



procedure TIntegralForm.AbbruchClick(Sender: TObject);

Var s, z : Integer;

begin
  With spiegel Do
       Begin
         peak_anzahl_i := anzahl_i;
         veraendert_b  := False;
         For z := 1 To 50 Do
             Begin
               For s := 0 To Pred(IntegraleStringGitter.ColCount) Do
                   Begin
                     IntegraleStringGitter.str_einlesen(s,z,integrale_a_s[s,z]);
                     RetZeitStringGitter.str_einlesen(s, z, retzeit_a_s[s, z]);
                     MaxIntStringGitter.str_einlesen(s, z, max_int_a_s[s, z]);
                     HWBStringGitter.str_einlesen(s, z, hwb_a_s[s, z]);
                     MaxStgStringGitter.str_einlesen(s, z, maxstg_a_s[s, z]);
                     MinStgStringGitter.str_einlesen(s, z, minstg_a_s[s, z]);
                   End;
               For s := 0 To 2 Do
                   IdentStringGitter.str_einlesen(s, z, ident_a_s[s, z]);
               For s := 0 To 1 Do
                   historyStringGitter.str_einlesen(s, z, history_a_s[s, z])
             end
       End
end;



procedure TIntegralForm.loeschenClick(Sender: TObject); //einer Zeile
                                                            //in allen
Procedure einzelloeschen(    gewaehlt_i   : Integer;        //Stringgittern
                         Var StringGitter : TStringGitter);

Var s, z : Integer;

Begin
  With StringGitter Do
       Begin
         zeile_loeschen(gewaehlt_i);
         If gewaehlt_i <= peak_anzahl_i Then
            Begin
              Dec(peak_anzahl_i);
              veraendert_b := True
            End
       End
End;

Procedure loeschen(Var StringGitter : tStringGitter);

Var gewaehlt_i : Integer;

Begin
  With StringGitter Do gewaehlt_i := Row;
  einzelloeschen(gewaehlt_i, IntegraleStringGitter);
  einzelloeschen(gewaehlt_i, RetZeitStringGitter);
  einzelloeschen(gewaehlt_i, MaxIntStringGitter);
  einzelloeschen(gewaehlt_i, HWBStringGitter);
  einzelloeschen(gewaehlt_i, MaxStgStringGitter);
  einzelloeschen(gewaehlt_i, MinStgStringGitter);
  einzelloeschen(gewaehlt_i, IdentStringGitter);
  einzelloeschen(gewaehlt_i, HistoryStringGitter)
End;

begin //TIntegralformular.loeschenClick
  With pagecontrol Do    //Es gilt der Focus auf dem Stringgitter
       Begin             //der gerade aktiven Seite des PageControl
         If ActivePage = IntegraleTabSheet
                                           Then loeschen(IntegraleStringGitter);
         If ActivePage = RetZeitTabSheet   Then loeschen(RetZeitStringGitter);
         If ActivePage = MaxIntTabSheet    Then loeschen(MaxIntStringGitter);
         If ActivePage = HWBTabSheet       Then loeschen(HWBStringGitter);
         IF ActivePage = MaxStgTabSheet    Then loeschen(MaxStgStringGitter);
         IF ActivePage = MinStgTabSheet    Then loeschen(MinStgStringGitter);
         IF ActivePage = SubstBestTabSheet Then loeschen(IdentStringGitter);
         If ActivePage = HistoryTabSheet   Then loeschen(HistoryStringGitter)
       End
end;



procedure TIntegralForm.FormShow(Sender: TObject);
begin
  veraendert_b := False;
  spiegeln;
end;



procedure TIntegralForm.uebernehmenClick(Sender: TObject); //...in das
                                                               //Linienformular
Var woher_i, i,
    mittelwert_i, differenz_i, blankvon_i, blankbis_i : Integer;
    swicht_b                                          : Boolean;

begin
  With IntegraleStringGitter Do
       Begin
         woher_i := 1;
         While Not(str_auslesen_s(0, woher_i) = '') And Not(woher_i = 51) Do
               Begin
                 mittelwert_i := (int_auslesen_i(4, woher_i) +
                                  int_auslesen_i(3, woher_i))
                                 Div 2;
                 differenz_i := int_auslesen_i(2, woher_i) -
                                int_auslesen_i(1, woher_i);
                 swicht_b   := True;
                 blankvon_i := mittelwert_i;
                 blankbis_i := mittelwert_i;
                 While Not(differenz_i = (blankbis_i - blankvon_i)) Do
                       Begin
                         If swicht_b Then Dec(blankvon_i)
                            Else Inc(blankbis_i);
                         Inc(swicht_b)
                       End;
                 With EinstForm Do
                      daten_uebernehmen(str_auslesen_s(0, woher_i),
                                        str_auslesen_s(1, woher_i),
                                        str_auslesen_s(2, woher_i),
                                        blankvon_i, blankbis_i);
                 Inc(woher_i)
               End
       End;
  With EinstForm Do ModalAnzeigen(False)
end;



procedure TIntegralForm.wellenlaengenkalibrationClick(Sender: TObject);

Var woher_i : Integer;

begin
  woher_i := 1;
  With RetZeitStringGitter Do
       While Not(str_auslesen_s(5, woher_i) = '') And Not(woher_i = 51) Do
             Begin
               WellenKalForm.uebernehmen(IntegraleStringGitter.str_auslesen_s(0,
                                                                       woher_i),
                                         str_auslesen_s(5, woher_i));
               Inc(woher_i)
             End;
  With WellenKalForm Do
       Begin
         speichern;
         ShowModal
       End;
end;



Procedure TIntegralForm.SetEditText(StringGitter : TStringGitter;
                                    Col_i, Row_i : Integer;
                                    Value_s      : String);
Begin
  With StringGitter Do
       Begin
         If Not(StringGitter = RetZeitStringGitter) Then
            RetZeitStringGitter.str_einlesen(Col_i, Row_i, Value_s);
         If Not(StringGitter = MaxIntStringGitter) Then
            MaxIntStringGitter.str_einlesen(Col_i, Row_i, Value_s);
         If Not(StringGitter = HWBStringGitter) Then
            HWBStringGitter.str_einlesen(Col_i, Row_i, Value_s);
         If Not(StringGitter = MaxStgStringGitter) Then
            MaxStgStringGitter.str_einlesen(Col_i, Row_i, Value_s);
         If Not(StringGitter = MinStgStringGitter) Then
            MinStgStringGitter.str_einlesen(Col_i, Row_i, Value_s);
         If Not(StringGitter = IdentStringGitter) Then
            IdentStringGitter.str_einlesen(Col_i, Row_i, Value_s);
         If Not(StringGitter = HistoryStringGitter) Then
            HistoryStringGitter.str_einlesen(Col_i, Row_i, Value_s);
         If Not(StringGitter = IntegraleStringGitter) Then
            IntegraleStringGitter.str_einlesen(Col_i, Row_i, Value_s)
       End;
End;



procedure TIntegralForm.RetZeitStringGitterSetEditText(Sender: TObject;
  ACol, ARow: Integer; const Value: String);
begin
  SetEditText(RetZeitStringGitter, ACol, ARow, Value);
end;



procedure TIntegralForm.MaxIntStringGitterSetEditText(Sender: TObject;
  ACol, ARow: Integer; const Value: String);
begin
  SetEditText(MaxIntStringGitter, ACol, ARow, Value);
end;



procedure TIntegralForm.HWBStringGitterSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  SetEditText(HWBStringGitter, ACol, ARow, Value);
end;



procedure TIntegralForm.MaxStgStringGitterSetEditText(Sender: TObject;
  ACol, ARow: Integer; const Value: String);
begin
  SetEditText(MaxStgStringGitter, ACol, ARow, Value);
end;



procedure TIntegralForm.MinStgStringGitterSetEditText(Sender: TObject;
  ACol, ARow: Integer; const Value: String);
begin
  SetEditText(MinStgStringGitter, ACol, ARow, Value);
end;



procedure TIntegralForm.IdentStringGitterSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  SetEditText(IntegraleStringGitter, ACol, ARow, Value);
end;



procedure TIntegralForm.HistoryStringGitterSetEditText(Sender: TObject;
  ACol, ARow: Integer; const Value: String);
begin
  SetEditText(HistoryStringGitter, ACol, ARow, Value);
end;



procedure TIntegralForm.IntegraleStringGitterSetEditText(Sender: TObject;
  ACol, ARow: Integer; const Value: String);
begin
  SetEditText(IntegraleStringGitter, ACol, ARow, Value);
end;



Function TIntegralForm.gewaehltes_signal_i : Integer;
Begin
  If NurRadioButton.Checked Then
     Begin
       With PageControl Do
            Begin
              If ActivePage = IntegraleTabSheet
                                       Then Result := IntegraleStringGitter.Row;
              If ActivePage = RetZeitTabSheet
                                       Then Result := RetZeitStringGitter.Row;
              If ActivePage = MaxIntTabSheet
                                       Then Result := MaxIntStringGitter.Row;
              If ActivePage = HWBTabSheet
                                       Then Result := HWBStringGitter.Row;
              IF ActivePage = MaxStgTabSheet
                                       Then Result := MaxStgStringGitter.Row;
              IF ActivePage = MinStgTabSheet
                                       Then Result := MinStgStringGitter.Row;
              IF ActivePage = SubstBestTabSheet
                                       Then Result := IdentStringGitter.Row;
              If ActivePage = HistoryTabSheet
                                       Then Result := HistoryStringGitter.Row
            End
     End
     Else Result := 0
End;



Function TIntegralform.signalzahl_i : Integer;
Begin
  Result := 0;
  While Not(HWBStringGitter.str_auslesen_s(1, Result) = '') Do Inc(Result)
End;



procedure TIntegralForm.InDatenbankBitBtnClick(Sender: TObject);

Var i : Integer;

begin
  If gewaehltes_signal_i = 0 Then
     Begin
       For i := 1 To signalzahl_i Do datenbank.in_signal(i,
                                                         MaxIntStringGitter,
                                                         HWBStringGitter,
                                                         MaxStgStringGitter,
                                                         MinStgStringGitter,
                                                         HistoryStringGitter)
     End
     Else If gewaehltes_signal_i <= signalzahl_i Then
             With datenbank Do in_signal(gewaehltes_signal_i,
                                         MaxIntStringGitter,
                                         HWBStringGitter,
                                         MaxStgStringGitter,
                                         MinStgStringGitter,
                                         HistoryStringGitter)
end;



procedure TIntegralForm.BestimmungBitBtnClick(Sender: TObject);

Var i : Integer;

begin
  If gewaehltes_signal_i = 0 Then
     Begin
       For i := 1 To signalzahl_i Do datenbank.out_substanz(i,
                                                            MaxIntStringGitter,
                                                            HWBStringGitter,
                                                            MaxStgStringGitter,
                                                            MinStgStringGitter,
                                                            HistoryStringGitter,
                                                            IdentStringGitter)
     End
     Else If gewaehltes_signal_i <= signalzahl_i Then
             With datenbank Do out_substanz(gewaehltes_signal_i,
                                            MaxIntStringGitter,
                                            HWBStringGitter,
                                            MaxStgStringGitter,
                                            MinStgStringGitter,
                                            HistoryStringGitter,
                                            IdentStringGitter) 
end;



end.
