unit signaleformular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Buttons, ComCtrls, EinstellungsFormular, ExtCtrls,
  datenbankklasse, wellenkalformular, SignaleKlasse, StringArrayKlasse,
  NStringGridKomponente, FilternFormular, Menus;

type

  tint_wert_a_i = Array[1..60] Of Integer;
  tmodus        = (moChrom, moSpektr);

  TSignaleForm = class(TForm)
    ok       : TBitBtn;
    Abbruch  : TBitBtn;
    loeschen : TBitBtn;
    PageControl: TPageControl;
    IntegraleTabSheet: TTabSheet;
    RetZeitTabSheet: TTabSheet;
    MaxIntTabSheet: TTabSheet;
    HWBTabSheet: TTabSheet;               //in das Linienformular uebernehemn
    wellenlaengenkalibration: TBitBtn;
    MaxStgTabSheet: TTabSheet;
    MinStgTabSheet: TTabSheet;
    InDatenbankBitBtn: TBitBtn;
    BestimmungBitBtn: TBitBtn;
    AllesGewaehltPanel: TPanel;
    AllesRadioButton: TRadioButton;
    NurRadioButton: TRadioButton;
    HistoryTabSheet: TTabSheet;
    SubstBestTabSheet: TTabSheet;
    OffsetTabSheet: TTabSheet;
    DeformTabSheet: TTabSheet;
    HistoryNStringGrid: TNStringGrid;
    RetZeitNStringGrid: TNStringGrid;
    IntegraleNStringGrid: TNStringGrid;
    MaxIntNStringGrid: TNStringGrid;
    HWBNStringGrid: TNStringGrid;
    DeformNStringGrid: TNStringGrid;
    OffsetNStringGrid: TNStringGrid;
    MaxStgNStringGrid: TNStringGrid;
    MinStgNStringGrid: TNStringGrid;
    IdentNStringGrid: TNStringGrid;
    FilternBitBtn: TBitBtn;
    PopupMenu: TPopupMenu;
    KopierenMenuItem: TMenuItem;
    uebernehmen: TBitBtn;
    InfoPanel: TPanel;
    InfoCheckBox: TCheckBox;
    InfoLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure loeschenClick(Sender: TObject);
    procedure uebernehmenClick(Sender: TObject);
    procedure wellenlaengenkalibrationClick(Sender: TObject);
    procedure InDatenbankBitBtnClick(Sender: TObject);
    procedure BestimmungBitBtnClick(Sender: TObject);
    procedure AllesGewaehltPanelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure IdentNStringGridSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure OffsetNStringGridSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure IntegraleNStringGridSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure RetZeitNStringGridSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure HistoryNStringGridSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure MaxStgNStringGridSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure MinStgNStringGridSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure DeformNStringGridSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure MaxIntNStringGridSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure HWBNStringGridSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure FilternBitBtnClick(Sender: TObject);
    procedure NStringGridTopLeftChanged(Sender: TObject);
    procedure KopierenMenuItemClick(Sender: TObject);
    procedure NStringGridContextPopup(Sender: TObject;
                                      MousePos: TPoint; var Handled: Boolean);
  private
    { Private-Deklarationen }

    v_modus   : tmodus;

    datenbank : TDatenbank;

    AktNStringGrid : TNStringGrid;

    Veraendert_b   : Boolean;   //Gelscht? Gefiltert?
    DBVeraendert_b : Boolean;   //Das Durchfhren von Datenbankfunktionen
                                //macht Vernderungen permanent.

    Procedure SetEditText(Var NStringGrid  : TNStringGrid;//Sorgt fr die Ver-
                              Col_i, Row_i : Integer;     //nderung des Be-
                              Value_s      : String);     //zeichnungsstrings
                                                          //in allen NStrinGrids

    Procedure zuruecksetzen; //Leeren der Stringrids

    Procedure setmodus(value : tmodus);

    Function gewaehltes_signal_i : Integer;

    Function signalzahl_i : Integer;

    Procedure SignaleInStringArray(Var Signale : TSignale);

    Procedure SignaleInStringGitter(Var Signale : TSignale);

  public
    { Public-Deklarationen }

    Function ShowModal(Var signale       : TSignale;
                       Var GDatenbank    : TDatenbank;
                       Var SVeraendert_b : Boolean) : Integer; Overload;

  Published
    Property modus : tmodus Read v_modus Write setmodus;
  end;

var
  SignaleForm: TSignaleForm;

implementation

{$R *.DFM}



Procedure TSignaleForm.setmodus(value : tmodus);
Begin
  If value = moChrom Then
     Begin
       With uebernehmen Do Visible := False;
       With wellenlaengenkalibration Do Visible := False;
       With RetZeitTabSheet Do Caption := 'Retentionszeiten';
       With RetZeitNStringGrid Do
            Hint := 'Intensittsmaximum nach der angegebene Zeit in Sekunden|' +
                    'Retentionszeiten in Sekunden';
       With HWBNStringGrid Do
            Hint := 'Signalbreite auf halber Hhe in Sekunden|' +
                    'Halbwertsbreiten in Sekunden'
     End
     Else
     Begin
       With uebernehmen Do Visible := True;
       With wellenlaengenkalibration Do Visible := True;
       With RetZeitTabSheet Do Caption := 'Maxima bei...';
       With RetZeitNStringGrid Do
            Hint := 'Intensittsmaximum bei der angegebene Wellenlnge in nm|' +
                    'Maximum bei...';
       With HWBNStringGrid Do
            Hint := 'Signalbreite auf halber Hhe in nm|' +
                    'Halbwertsbreiten in nm'
     End;
  v_modus := Value;
End;




Procedure TSignaleForm.zuruecksetzen;  //Leeren der StringGitter
Begin
  IntegraleNStringGrid.ClearAll;
  RetZeitNStringGrid.  ClearAll;
  MaxIntNStringGrid.   ClearAll;
  HWBNStringGrid.      ClearAll;
  MaxStgNStringGrid.   ClearAll;
  MinStgNStringGrid.   ClearAll;
  HistoryNStringGrid.  ClearAll;
  IdentNStringGrid.    ClearAll;
  DeformNStringGrid.   ClearAll;
  OffsetNStringGrid.   ClearAll
End;



procedure TSignaleForm.FormCreate(Sender: TObject);
begin
  NurRadioButton.Checked := True
end;



procedure TSignaleForm.loeschenClick(Sender: TObject); //einer Zeile in allen
                                                       //Stringgittern lschen

Procedure loeschen(Var NStringGrid : tNStringGrid);

Var gewaehlt_i : Integer;

Begin //lschen
  With NStringGrid Do gewaehlt_i := Row;
  IntegraleNStringGrid.ClearRow(gewaehlt_i);
  RetZeitNStringGrid.  ClearRow(gewaehlt_i);
  MaxIntNStringGrid.   ClearRow(gewaehlt_i);
  HWBNStringGrid.      ClearRow(gewaehlt_i);
  MaxStgNStringGrid.   ClearRow(gewaehlt_i);
  MinStgNStringGrid.   ClearRow(gewaehlt_i);
  IdentNStringGrid.    ClearRow(gewaehlt_i);
  HistoryNStringGrid.  ClearRow(gewaehlt_i);
  DeformNStringGrid.   ClearRow(gewaehlt_i);
  OffsetNStringGrid.   ClearRow(gewaehlt_i)
End;

begin //TIntegralformular.loeschenClick
  Veraendert_b := True;
  If NurRadioButton.Checked Then
     With pagecontrol Do    //Es gilt der Focus auf dem Stringgitter
        Begin             //der gerade aktiven Seite des PageControl
          If ActivePage = IntegraleTabSheet Then loeschen(IntegraleNStringGrid);
          If ActivePage = RetZeitTabSheet   Then loeschen(RetZeitNStringGrid);
          If ActivePage = MaxIntTabSheet    Then loeschen(MaxIntNStringGrid);
          If ActivePage = HWBTabSheet       Then loeschen(HWBNStringGrid);
          IF ActivePage = MaxStgTabSheet    Then loeschen(MaxStgNStringGrid);
          IF ActivePage = MinStgTabSheet    Then loeschen(MinStgNStringGrid);
          IF ActivePage = SubstBestTabSheet Then loeschen(IdentNStringGrid);
          If ActivePage = HistoryTabSheet   Then loeschen(HistoryNStringGrid);
          If ActivePage = DeformTabSheet    Then loeschen(DeformNStringGrid);
          If ActivePage = OffsetTabSheet    Then loeschen(OffsetNStringGrid);
        End
     Else
     Begin
       MessageBeep(MB_ICONHAND);
       If MessageDlg('Wirklich alle Signale lschen?',
                     mtWarning, [mbYes, mbNo], 0       ) = mrYES Then
          Begin
            IntegraleNStringGrid.ClearAll;
            RetZeitNStringGrid.  ClearAll;
            MaxIntNStringGrid.   ClearAll;
            HWBNStringGrid.      ClearAll;
            MaxStgNStringGrid.   ClearAll;
            MinStgNStringGrid.   ClearAll;
            IdentNStringGrid.    ClearAll;
            HistoryNStringGrid.  ClearAll;
            DeformNStringGrid.   ClearAll;
            OffsetNStringGrid.   ClearAll
          End
     End
end;



procedure TSignaleForm.uebernehmenClick(Sender: TObject); //...in das
                                                          //Linienformular
Var woher_i : Integer;

begin
  With HistoryNStringGrid, EinstForm Do
       Begin
         woher_i := 1;
         While Not(StrRead_s(1, woher_i) = '')             And
               Not(woher_i               = Succ(RowCount)) Do
               Begin
                 InLinien(StrRead_s(0, woher_i),
                          StrRead_s(1, woher_i),
                          StrRead_s(2, woher_i),
                          StrRead_s(2, woher_i),
                          StrRead_s(2, woher_i));
                 Inc(woher_i)
               End
       End;
  With EinstForm Do ShowModal
end;



procedure TSignaleForm.wellenlaengenkalibrationClick(Sender: TObject);

Var woher_i : Integer;

begin
  woher_i := 1;
  With RetZeitNStringGrid Do
       While Not(StrRead_s(1,woher_i) = '') And Not(woher_i = Succ(RowCount)) Do
             Begin
               With WellenKalForm Do
                    uebernehmen(IntegraleNStringGrid.StrRead_s(0, woher_i),
                                StrRead_s(1, woher_i));
               Inc(woher_i)
             End;
  With WellenKalForm Do
       Begin
         speichern;
         ShowModal
       End;
end;



Procedure TSignaleForm.SetEditText(Var NStringGrid     : TNStringGrid;
                                       Col_i, Row_i    : Integer;
                                       Value_s         : String);
Begin
  With NStringGrid Do
       Begin
         If Not(NStringGrid = RetZeitNStringGrid) Then
            RetZeitNStringGrid.StrWrite(Col_i, Row_i, Value_s);
         If Not(NStringGrid = MaxIntNStringGrid) Then
            MaxIntNStringGrid.StrWrite(Col_i, Row_i, Value_s);
         If Not(NStringGrid = HWBNStringGrid) Then
            HWBNStringGrid.StrWrite(Col_i, Row_i, Value_s);
         If Not(NStringGrid = MaxStgNStringGrid) Then
            MaxStgNStringGrid.StrWrite(Col_i, Row_i, Value_s);
         If Not(NStringGrid = MinStgNStringGrid) Then
            MinStgNStringGrid.StrWrite(Col_i, Row_i, Value_s);
         If Not(NStringGrid = IdentNStringGrid) Then
            IdentNStringGrid.StrWrite(Col_i, Row_i, Value_s);
         If Not(NStringGrid = HistoryNStringGrid) Then
            HistoryNStringGrid.StrWrite(Col_i, Row_i, Value_s);
         If Not(NStringGrid = IntegraleNStringGrid) Then
            IntegraleNStringGrid.StrWrite(Col_i, Row_i, Value_s);
         If Not(NStringGrid = DeformNStringGrid) Then
            DeformNStringGrid.StrWrite(Col_i, Row_i, Value_s);
         If Not(NStringGrid = OffsetNStringGrid) Then
            OffsetNStringGrid.StrWrite(Col_i, Row_i, Value_s)
       End;
End;



procedure TSignaleForm.IdentNStringGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  SetEditText(IdentNStringGrid, ACol, ARow, Value);
end;

procedure TSignaleForm.OffsetNStringGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  SetEditText(OffsetNStringGrid, ACol, ARow, Value);
end;

procedure TSignaleForm.IntegraleNStringGridSetEditText(Sender: TObject;
  ACol, ARow: Integer; const Value: String);
begin
  SetEditText(IntegraleNStringGrid, ACol, ARow, Value);
end;

procedure TSignaleForm.RetZeitNStringGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  SetEditText(RetZeitNStringGrid, ACol, ARow, Value);
end;

procedure TSignaleForm.HistoryNStringGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  SetEditText(HistoryNStringGrid, ACol, ARow, Value);
end;

procedure TSignaleForm.MaxStgNStringGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  SetEditText(MaxStgNStringGrid, ACol, ARow, Value);
end;

procedure TSignaleForm.MinStgNStringGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  SetEditText(MinStgNStringGrid, ACol, ARow, Value);
end;

procedure TSignaleForm.DeformNStringGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  SetEditText(DeformNStringGrid, ACol, ARow, Value);
end;

procedure TSignaleForm.MaxIntNStringGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  SetEditText(MaxIntNStringGrid, ACol, ARow, Value);
end;

procedure TSignaleForm.HWBNStringGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  SetEditText(HWBNStringGrid, ACol, ARow, Value);
end;



Function TSignaleForm.gewaehltes_signal_i : Integer;
Begin
  If NurRadioButton.Checked Then
     Begin
       With PageControl Do
            Begin
              If ActivePage = IntegraleTabSheet
                                       Then Result := IntegraleNStringGrid.Row;
              If ActivePage = RetZeitTabSheet
                                       Then Result := RetZeitNStringGrid.Row;
              If ActivePage = MaxIntTabSheet
                                       Then Result := MaxIntNStringGrid.Row;
              If ActivePage = HWBTabSheet
                                       Then Result := HWBNStringGrid.Row;
              IF ActivePage = MaxStgTabSheet
                                       Then Result := MaxStgNStringGrid.Row;
              IF ActivePage = MinStgTabSheet
                                       Then Result := MinStgNStringGrid.Row;
              IF ActivePage = SubstBestTabSheet
                                       Then Result := IdentNStringGrid.Row;
              If ActivePage = HistoryTabSheet
                                       Then Result := HistoryNStringGrid.Row;
              If ActivePage = DeformTabSheet
                                       Then Result := DeformNStringGrid.Row;
              If ActivePage = OffsetTabSheet
                                       Then Result := OffsetNStringGrid.Row
            End
     End
     Else Result := 0
End;



Function TSignaleForm.signalzahl_i : Integer;
Begin
  Result := 0;
  While Not(HWBNStringGrid.StrRead_s(1, Result) = '') Do Inc(Result)
End;



procedure TSignaleForm.InDatenbankBitBtnClick(Sender: TObject);

Var DatenbankSignale : TSignale;

begin
  DBVeraendert_b := Veraendert_b;
  DatenbankSignale := TSignale.Create(700);
  SignaleInStringArray(DatenbankSignale);
  datenbank.InSignale(gewaehltes_signal_i, DatenbankSignale);
  SignaleInStringGitter(DatenbankSignale);
  DatenbankSignale.Free
end;



procedure TSignaleForm.BestimmungBitBtnClick(Sender: TObject);

Var DatenbankSignale : TSignale;

begin
  Screen.Cursor := crHourGlass;
  DBVeraendert_b := Veraendert_b;
  DatenbankSignale := TSignale.Create(700);
  SignaleInStringArray(DatenbankSignale);
  datenbank.OutSubstanzen(gewaehltes_signal_i, DatenbankSignale,
                          InfoCheckBox.Checked);
  SignaleInStringGitter(DatenbankSignale);
  DatenbankSignale.Free;
  Screen.Cursor := crDefault
end;



Procedure TSignaleForm.SignaleInStringArray(Var Signale : TSignale);

Procedure InStringArrayKopieren(    StringArray : TStringArray;
                                Var NStringGrid : TNStringGrid);

Var s, z : Integer;

Begin //InStringArrayKopieren
  With StringArray Do
       For s := 0 To spalten_i_prop Do
             For z := 0 To Pred(NStringGrid.RowCount) Do
                 StrWrite(s, z, NStringGrid.StrRead_s(s, z))
End;

Begin  //TSignalForm.SignaleAusNStringGrid
  With signale Do
       Begin
         Initialisieren;
         InStringArrayKopieren(HistoryStringArray, HistoryNStringGrid);
         InStringArrayKopieren(IntegrStringArray,  IntegraleNStringGrid);
         InStringArrayKopieren(MaxIntStringArray,  MaxIntNStringGrid);
         InStringArrayKopieren(RetZeitStringArray, RetzeitNStringGrid);
         InStringArrayKopieren(HWBStringArray,     HWBNStringGrid);
         InStringArrayKopieren(MaxStgStringArray,  MaxStgNStringGrid);
         InStringArrayKopieren(MinStgStringArray,  MinStgNStringGrid);
         InStringArrayKopieren(DeformStringArray,  DeformNStringGrid);
         InStringArrayKopieren(OffsetStringArray,  OffsetNStringGrid);
         InStringArrayKopieren(IdentStringArray,   IdentNStringGrid);
       End
End;



Procedure TSignaleForm.SignaleInStringGitter(Var Signale : TSignale);

Procedure InGitterKopieren(    StringArray : TStringArray;
                           Var NStringGrid : TNStringGrid);

Var s, z : Integer;

Begin //InGitterKopieren
  With NStringGrid Do
       Begin
         RowCount := Succ(Signale.HistoryStringArray.ZeilenFuellstatus_i(1));
         If RowCount = 1 Then
            Begin
              RowCount  := 2;
              FixedRows := 1
            end;
         For s := 0 To StringArray.spalten_i_prop Do
             For z := 0 To RowCount Do
                 StrWrite(s, z, StringArray.StrRead_s(s, z))
       End
End;

Begin //TSignaleForm.SignaleInNStringGrid
  With signale Do
       Begin
         InGitterKopieren(HistoryStringArray, HistoryNStringGrid);
         InGitterKopieren(IntegrStringArray,  IntegraleNStringGrid);
         InGitterKopieren(MaxIntStringArray,  MaxIntNStringGrid);
         InGitterKopieren(RetZeitStringArray, RetzeitNStringGrid);
         InGitterKopieren(HWBStringArray,     HWBNStringGrid);
         InGitterKopieren(MaxStgStringArray,  MaxStgNStringGrid);
         InGitterKopieren(MinStgStringArray,  MinStgNStringGrid);
         InGitterKopieren(DeformStringArray,  DeformNStringGrid);
         InGitterKopieren(OffsetStringArray,  OffsetNStringGrid);
         InGitterKopieren(IdentStringArray,   IdentNStringGrid)
       End;
End;



Function TSignaleForm.ShowModal(Var signale       : TSignale;
                                Var GDatenbank    : TDatenbank;
                                Var SVeraendert_b : Boolean) : Integer;


Begin //TSignaleForm.zeigen
  Veraendert_b   := False;
  DBVeraendert_b := False;
  Datenbank := GDatenbank;
  //zuruecksetzen;
  SignaleInStringGitter(signale);
  Result := ShowModal;
  If Result = MROK Then
     Begin
       SignaleInStringArray(signale);
       SVeraendert_b := Veraendert_b
     End
     Else
     SVeraendert_b := DBVeraendert_b
End;




procedure TSignaleForm.AllesGewaehltPanelMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

begin
  If (Shift = [ssShift, ssCtrl..ssLeft])                           And
     (MessageDlg('Manipulationen an der Datenbank zu ' +
                 'Testzwecken -> Daten knnen ' +
                 'zerstrt werden! Wirklich fortfahren?',
                 mtWarning, [mbYes, mbNo], 0)             = mrYES) Then
     If MessageDlg('Drcken sie OK um die Daten zur ' +
                   'Vernderung freizugeben.',
                    mtCustom, mbOKCancel, 0)              = mrOK Then
        Begin
          IntegraleNStringGrid.Sperrbereich_Prop.Aktiviert_b_prop := False;
          MaxIntNStringGrid.   Sperrbereich_Prop.Aktiviert_b_prop := False;
          HWBNStringGrid.      Sperrbereich_Prop.Aktiviert_b_prop := False;
          DeformNStringGrid.   Sperrbereich_Prop.Aktiviert_b_prop := False;
          OffsetNStringGrid.   Sperrbereich_Prop.Aktiviert_b_prop := False;
        End
end;




procedure TSignaleForm.FilternBitBtnClick(Sender: TObject);
begin // TSignaleForm.FilternBitBtnClick
  If FilternForm.ShowModal(HistoryNStringGrid,
                           RetZeitNStringGrid,
                           IntegraleNStringGrid,
                           MaxIntNStringGrid,
                           HWBNStringGrid,
                           MaxStgNStringGrid,
                           MinStgNStringGrid,
                           DeformNStringGrid,
                           OffsetNStringGrid,
                           IdentNStringGrid)  = mrOK Then Veraendert_b := True
end;




procedure TSignaleForm.NStringGridTopLeftChanged(Sender: TObject);
begin
  Veraendert_b := True;
  With TNStringGrid(Sender) Do
       Begin
         HistoryNStringGrid  .TopRow  := TopRow;
         IntegraleNStringGrid.TopRow  := TopRow;
         MaxIntNStringGrid   .TopRow  := TopRow;
         HWBNStringGrid      .TopRow  := TopRow;
         DeformNStringGrid   .TopRow  := TopRow;
         OffsetNStringGrid   .TopRow  := TopRow;
         RetZeitNStringGrid  .TopRow  := TopRow;
         MaxStgNStringGrid   .TopRow  := TopRow;
         MinStgNStringGrid   .TopRow  := TopRow;
         IdentNStringGrid    .TopRow  := TopRow;
         HistoryNStringGrid  .LeftCol := LeftCol;
         IntegraleNStringGrid.LeftCol := LeftCol;
         MaxIntNStringGrid   .LeftCol := LeftCol;
         HWBNStringGrid      .LeftCol := LeftCol;
         DeformNStringGrid   .LeftCol := LeftCol;
         OffsetNStringGrid   .LeftCol := LeftCol;
         RetZeitNStringGrid  .LeftCol := LeftCol;
         MaxStgNStringGrid   .LeftCol := LeftCol;
         MinStgNStringGrid   .LeftCol := LeftCol;
         IdentNStringGrid    .LeftCol := LeftCol
       End
End;





procedure TSignaleForm.KopierenMenuItemClick(Sender: TObject);
begin
   //AktNStringGrid ist das Stringgitter, welches das Popup-Menue aufgerufen
   //hat.
   AktNStringGrid.InClipboard
end;




procedure TSignaleForm.NStringGridContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
  //Wenn das Popup-Menue aufgerufen wird, wird das aktuell angezeigte String-
  //gitter in AktNStringGrid eingelesen, damit jede durch das Popup-
  //Menue ausgelste Aktion auch das richtige Stringgitter betrifft
  AktNStringGrid := TNStringGrid(Sender)
end;



end.
